/* Plug.c generated by valac 0.56.17, the Vala compiler
 * generated from Plug.vala, do not modify */

/*
 * SPDX-License-Identifier: LGPL-3.0-or-later
 * SPDX-FileCopyrightText: 2014-2023 elementary, Inc. (https://elementary.io)
 * Authored by: Corentin Noël <tintou@mailoo.org>
 */

#include "security-privacy.h"
#include <gtk/gtk.h>
#include <switchboard.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gee.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <gmodule.h>

#define SECURITY_PRIVACY_PLUG_FIREWALL "firewall"
#define SECURITY_PRIVACY_PLUG_HOUSEKEEPING "housekeeping"
#define SECURITY_PRIVACY_PLUG_HISTORY "tracking"
#define SECURITY_PRIVACY_PLUG_LOCKING "locking"
#define SECURITY_PRIVACY_PLUG_LOCATION "location"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SECURITY_PRIVACY_PLUG_0_PROPERTY,
	SECURITY_PRIVACY_PLUG_NUM_PROPERTIES
};
static GParamSpec* security_privacy_plug_properties[SECURITY_PRIVACY_PLUG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _SecurityPrivacyPlugSearchData SecurityPrivacyPlugSearchData;

struct _SecurityPrivacyPlugPrivate {
	GtkPaned* paned;
	GtkStack* stack;
};

struct _SecurityPrivacyPlugSearchData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SecurityPrivacyPlug* self;
	gchar* search;
	GeeTreeMap* result;
	GeeTreeMap* map;
	GeeTreeMap* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	const gchar* _tmp25_;
	const gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	const gchar* _tmp29_;
	const gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	const gchar* _tmp33_;
	const gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	const gchar* _tmp37_;
	const gchar* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	const gchar* _tmp41_;
	const gchar* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	const gchar* _tmp45_;
	const gchar* _tmp46_;
	gchar* _tmp47_;
	gchar* _tmp48_;
};

static gint SecurityPrivacyPlug_private_offset;
static gpointer security_privacy_plug_parent_class = NULL;

static GtkWidget* security_privacy_plug_real_get_widget (SwitchboardPlug* base);
static void security_privacy_plug_real_shown (SwitchboardPlug* base);
static void security_privacy_plug_real_hidden (SwitchboardPlug* base);
static void security_privacy_plug_real_search_callback (SwitchboardPlug* base,
                                                 const gchar* location);
static void security_privacy_plug_real_search_data_free (gpointer _data);
static void security_privacy_plug_real_search (SwitchboardPlug* base,
                                        const gchar* search,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_);
static gboolean security_privacy_plug_real_search_co (SecurityPrivacyPlugSearchData* _data_);
static void security_privacy_plug_finalize (GObject * obj);
static GType security_privacy_plug_get_type_once (void);

static inline gpointer
security_privacy_plug_get_instance_private (SecurityPrivacyPlug* self)
{
	return G_STRUCT_MEMBER_P (self, SecurityPrivacyPlug_private_offset);
}

SecurityPrivacyPlug*
security_privacy_plug_construct (GType object_type)
{
	SecurityPrivacyPlug * self = NULL;
	GeeTreeMap* _tmp0_;
	GeeTreeMap* _tmp1_;
	GeeTreeMap* _tmp2_;
	GeeTreeMap* _tmp3_;
	GeeTreeMap* _tmp4_;
	GeeTreeMap* _tmp5_;
	GeeTreeMap* _tmp6_;
	GeeTreeMap* _tmp7_;
	GeeTreeMap* _tmp8_;
	GeeTreeMap* _tmp9_;
	GeeTreeMap* _tmp10_;
	GeeTreeMap* _tmp11_;
	GeeTreeMap* _tmp12_;
	GeeTreeMap* _tmp13_;
	GeeTreeMap* _tmp14_;
	GeeTreeMap* _tmp15_;
	GeeTreeMap* _tmp16_;
	GeeTreeMap* _tmp17_;
	GeeTreeMap* _tmp18_;
	GeeTreeMap* _tmp19_;
	GeeTreeMap* _tmp20_;
	GeeTreeMap* _tmp21_;
#line 18 "../src/Plug.vala"
	bindtextdomain (BUILD_GETTEXT_PACKAGE, BUILD_LOCALEDIR);
#line 19 "../src/Plug.vala"
	bind_textdomain_codeset (BUILD_GETTEXT_PACKAGE, "UTF-8");
#line 21 "../src/Plug.vala"
	_tmp0_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 21 "../src/Plug.vala"
	_tmp1_ = _tmp0_;
#line 21 "../src/Plug.vala"
	self = (SecurityPrivacyPlug*) g_object_new (object_type, "category", SWITCHBOARD_PLUG_CATEGORY_PERSONAL, "code-name", "io.elementary.settings.security-privacy", "display-name", _ ("Security & Privacy"), "description", _ ("Configure firewall, screen lock, and activity information"), "icon", "preferences-system-privacy", "supported-settings", _tmp1_, NULL);
#line 21 "../src/Plug.vala"
	_g_object_unref0 (_tmp1_);
#line 28 "../src/Plug.vala"
	_tmp2_ = switchboard_plug_get_supported_settings ((SwitchboardPlug*) self);
#line 28 "../src/Plug.vala"
	_tmp3_ = _tmp2_;
#line 28 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp3_, "privacy", SECURITY_PRIVACY_PLUG_HISTORY);
#line 29 "../src/Plug.vala"
	_tmp4_ = switchboard_plug_get_supported_settings ((SwitchboardPlug*) self);
#line 29 "../src/Plug.vala"
	_tmp5_ = _tmp4_;
#line 29 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp5_, "privacy/location", SECURITY_PRIVACY_PLUG_LOCATION);
#line 30 "../src/Plug.vala"
	_tmp6_ = switchboard_plug_get_supported_settings ((SwitchboardPlug*) self);
#line 30 "../src/Plug.vala"
	_tmp7_ = _tmp6_;
#line 30 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp7_, "privacy/trash", SECURITY_PRIVACY_PLUG_HOUSEKEEPING);
#line 31 "../src/Plug.vala"
	_tmp8_ = switchboard_plug_get_supported_settings ((SwitchboardPlug*) self);
#line 31 "../src/Plug.vala"
	_tmp9_ = _tmp8_;
#line 31 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp9_, "security/firewall", SECURITY_PRIVACY_PLUG_FIREWALL);
#line 32 "../src/Plug.vala"
	_tmp10_ = switchboard_plug_get_supported_settings ((SwitchboardPlug*) self);
#line 32 "../src/Plug.vala"
	_tmp11_ = _tmp10_;
#line 32 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp11_, "security/locking", SECURITY_PRIVACY_PLUG_LOCKING);
#line 33 "../src/Plug.vala"
	_tmp12_ = switchboard_plug_get_supported_settings ((SwitchboardPlug*) self);
#line 33 "../src/Plug.vala"
	_tmp13_ = _tmp12_;
#line 33 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp13_, "security", NULL);
#line 36 "../src/Plug.vala"
	_tmp14_ = switchboard_plug_get_supported_settings ((SwitchboardPlug*) self);
#line 36 "../src/Plug.vala"
	_tmp15_ = _tmp14_;
#line 36 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp15_, "security/housekeeping", SECURITY_PRIVACY_PLUG_HOUSEKEEPING);
#line 37 "../src/Plug.vala"
	_tmp16_ = switchboard_plug_get_supported_settings ((SwitchboardPlug*) self);
#line 37 "../src/Plug.vala"
	_tmp17_ = _tmp16_;
#line 37 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp17_, "security/privacy", SECURITY_PRIVACY_PLUG_HISTORY);
#line 38 "../src/Plug.vala"
	_tmp18_ = switchboard_plug_get_supported_settings ((SwitchboardPlug*) self);
#line 38 "../src/Plug.vala"
	_tmp19_ = _tmp18_;
#line 38 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp19_, "security/privacy/location", SECURITY_PRIVACY_PLUG_LOCATION);
#line 39 "../src/Plug.vala"
	_tmp20_ = switchboard_plug_get_supported_settings ((SwitchboardPlug*) self);
#line 39 "../src/Plug.vala"
	_tmp21_ = _tmp20_;
#line 39 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp21_, "security/screensaver", SECURITY_PRIVACY_PLUG_LOCKING);
#line 17 "../src/Plug.vala"
	return self;
#line 234 "Plug.c"
}

SecurityPrivacyPlug*
security_privacy_plug_new (void)
{
#line 17 "../src/Plug.vala"
	return security_privacy_plug_construct (SECURITY_PRIVACY_TYPE_PLUG);
#line 242 "Plug.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 61 "../src/Plug.vala"
	return self ? g_object_ref (self) : NULL;
#line 250 "Plug.c"
}

static GtkWidget*
security_privacy_plug_real_get_widget (SwitchboardPlug* base)
{
	SecurityPrivacyPlug * self;
	GtkPaned* _tmp0_;
	GtkPaned* _tmp24_;
	GtkWidget* _tmp25_;
	GtkWidget* result;
#line 42 "../src/Plug.vala"
	self = (SecurityPrivacyPlug*) base;
#line 43 "../src/Plug.vala"
	_tmp0_ = self->priv->paned;
#line 43 "../src/Plug.vala"
	if (_tmp0_ == NULL) {
#line 267 "Plug.c"
		SecurityPrivacyTrackPanel* tracking = NULL;
		SecurityPrivacyTrackPanel* _tmp1_;
		SecurityPrivacyLockPanel* locking = NULL;
		SecurityPrivacyLockPanel* _tmp2_;
		SecurityPrivacyFirewallPanel* firewall = NULL;
		SecurityPrivacyFirewallPanel* _tmp3_;
		SecurityPrivacyHouseKeepingPanel* housekeeping = NULL;
		SecurityPrivacyHouseKeepingPanel* _tmp4_;
		SecurityPrivacyLocationPanel* location = NULL;
		SecurityPrivacyLocationPanel* _tmp5_;
		GtkStack* _tmp6_;
		GtkStack* _tmp7_;
		SecurityPrivacyTrackPanel* _tmp8_;
		GtkStack* _tmp9_;
		SecurityPrivacyLockPanel* _tmp10_;
		GtkStack* _tmp11_;
		SecurityPrivacyFirewallPanel* _tmp12_;
		GtkStack* _tmp13_;
		SecurityPrivacyHouseKeepingPanel* _tmp14_;
		GtkStack* _tmp15_;
		SecurityPrivacyLocationPanel* _tmp16_;
		SwitchboardSettingsSidebar* settings_sidebar = NULL;
		GtkStack* _tmp17_;
		SwitchboardSettingsSidebar* _tmp18_ = NULL;
		SwitchboardSettingsSidebar* _tmp19_;
		GtkWidget* _tmp20_;
		GtkStack* _tmp21_;
		GtkWidget* _tmp22_;
		GtkPaned* _tmp23_ = NULL;
#line 44 "../src/Plug.vala"
		_tmp1_ = security_privacy_track_panel_new ();
#line 44 "../src/Plug.vala"
		g_object_ref_sink (_tmp1_);
#line 44 "../src/Plug.vala"
		tracking = _tmp1_;
#line 45 "../src/Plug.vala"
		_tmp2_ = security_privacy_lock_panel_new ();
#line 45 "../src/Plug.vala"
		g_object_ref_sink (_tmp2_);
#line 45 "../src/Plug.vala"
		locking = _tmp2_;
#line 46 "../src/Plug.vala"
		_tmp3_ = security_privacy_firewall_panel_new ();
#line 46 "../src/Plug.vala"
		g_object_ref_sink (_tmp3_);
#line 46 "../src/Plug.vala"
		firewall = _tmp3_;
#line 47 "../src/Plug.vala"
		_tmp4_ = security_privacy_house_keeping_panel_new ();
#line 47 "../src/Plug.vala"
		g_object_ref_sink (_tmp4_);
#line 47 "../src/Plug.vala"
		housekeeping = _tmp4_;
#line 48 "../src/Plug.vala"
		_tmp5_ = security_privacy_location_panel_new ();
#line 48 "../src/Plug.vala"
		g_object_ref_sink (_tmp5_);
#line 48 "../src/Plug.vala"
		location = _tmp5_;
#line 50 "../src/Plug.vala"
		_tmp6_ = (GtkStack*) gtk_stack_new ();
#line 50 "../src/Plug.vala"
		g_object_ref_sink (_tmp6_);
#line 50 "../src/Plug.vala"
		_g_object_unref0 (self->priv->stack);
#line 50 "../src/Plug.vala"
		self->priv->stack = _tmp6_;
#line 51 "../src/Plug.vala"
		_tmp7_ = self->priv->stack;
#line 51 "../src/Plug.vala"
		_tmp8_ = tracking;
#line 51 "../src/Plug.vala"
		gtk_stack_add_titled (_tmp7_, (GtkWidget*) _tmp8_, SECURITY_PRIVACY_PLUG_HISTORY, _ ("Privacy"));
#line 52 "../src/Plug.vala"
		_tmp9_ = self->priv->stack;
#line 52 "../src/Plug.vala"
		_tmp10_ = locking;
#line 52 "../src/Plug.vala"
		gtk_stack_add_titled (_tmp9_, (GtkWidget*) _tmp10_, SECURITY_PRIVACY_PLUG_LOCKING, _ ("Locking"));
#line 53 "../src/Plug.vala"
		_tmp11_ = self->priv->stack;
#line 53 "../src/Plug.vala"
		_tmp12_ = firewall;
#line 53 "../src/Plug.vala"
		gtk_stack_add_titled (_tmp11_, (GtkWidget*) _tmp12_, SECURITY_PRIVACY_PLUG_FIREWALL, _ ("Firewall"));
#line 54 "../src/Plug.vala"
		_tmp13_ = self->priv->stack;
#line 54 "../src/Plug.vala"
		_tmp14_ = housekeeping;
#line 54 "../src/Plug.vala"
		gtk_stack_add_titled (_tmp13_, (GtkWidget*) _tmp14_, SECURITY_PRIVACY_PLUG_HOUSEKEEPING, _ ("Housekeeping"));
#line 55 "../src/Plug.vala"
		_tmp15_ = self->priv->stack;
#line 55 "../src/Plug.vala"
		_tmp16_ = location;
#line 55 "../src/Plug.vala"
		gtk_stack_add_titled (_tmp15_, (GtkWidget*) _tmp16_, SECURITY_PRIVACY_PLUG_LOCATION, _ ("Location Services"));
#line 57 "../src/Plug.vala"
		_tmp17_ = self->priv->stack;
#line 57 "../src/Plug.vala"
		_tmp18_ = switchboard_settings_sidebar_new (_tmp17_);
#line 57 "../src/Plug.vala"
		switchboard_settings_sidebar_set_show_title_buttons (_tmp18_, TRUE);
#line 57 "../src/Plug.vala"
		g_object_ref_sink (_tmp18_);
#line 57 "../src/Plug.vala"
		settings_sidebar = _tmp18_;
#line 61 "../src/Plug.vala"
		_tmp19_ = settings_sidebar;
#line 61 "../src/Plug.vala"
		_tmp20_ = _g_object_ref0 ((GtkWidget*) _tmp19_);
#line 61 "../src/Plug.vala"
		_tmp21_ = self->priv->stack;
#line 61 "../src/Plug.vala"
		_tmp22_ = _g_object_ref0 ((GtkWidget*) _tmp21_);
#line 61 "../src/Plug.vala"
		_tmp23_ = (GtkPaned*) gtk_paned_new (GTK_ORIENTATION_HORIZONTAL);
#line 61 "../src/Plug.vala"
		gtk_paned_set_start_child (_tmp23_, _tmp20_);
#line 61 "../src/Plug.vala"
		_g_object_unref0 (_tmp20_);
#line 61 "../src/Plug.vala"
		gtk_paned_set_end_child (_tmp23_, _tmp22_);
#line 61 "../src/Plug.vala"
		_g_object_unref0 (_tmp22_);
#line 61 "../src/Plug.vala"
		gtk_paned_set_shrink_start_child (_tmp23_, FALSE);
#line 61 "../src/Plug.vala"
		gtk_paned_set_shrink_end_child (_tmp23_, FALSE);
#line 61 "../src/Plug.vala"
		gtk_paned_set_resize_start_child (_tmp23_, FALSE);
#line 61 "../src/Plug.vala"
		g_object_ref_sink (_tmp23_);
#line 61 "../src/Plug.vala"
		_g_object_unref0 (self->priv->paned);
#line 61 "../src/Plug.vala"
		self->priv->paned = _tmp23_;
#line 43 "../src/Plug.vala"
		_g_object_unref0 (settings_sidebar);
#line 43 "../src/Plug.vala"
		_g_object_unref0 (location);
#line 43 "../src/Plug.vala"
		_g_object_unref0 (housekeeping);
#line 43 "../src/Plug.vala"
		_g_object_unref0 (firewall);
#line 43 "../src/Plug.vala"
		_g_object_unref0 (locking);
#line 43 "../src/Plug.vala"
		_g_object_unref0 (tracking);
#line 417 "Plug.c"
	}
#line 70 "../src/Plug.vala"
	_tmp24_ = self->priv->paned;
#line 70 "../src/Plug.vala"
	_tmp25_ = _g_object_ref0 ((GtkWidget*) _tmp24_);
#line 70 "../src/Plug.vala"
	result = _tmp25_;
#line 70 "../src/Plug.vala"
	return result;
#line 427 "Plug.c"
}

static void
security_privacy_plug_real_shown (SwitchboardPlug* base)
{
	SecurityPrivacyPlug * self;
#line 73 "../src/Plug.vala"
	self = (SecurityPrivacyPlug*) base;
#line 436 "Plug.c"
}

static void
security_privacy_plug_real_hidden (SwitchboardPlug* base)
{
	SecurityPrivacyPlug * self;
#line 75 "../src/Plug.vala"
	self = (SecurityPrivacyPlug*) base;
#line 445 "Plug.c"
}

static void
security_privacy_plug_real_search_callback (SwitchboardPlug* base,
                                            const gchar* location)
{
	SecurityPrivacyPlug * self;
	GtkStack* _tmp0_;
#line 77 "../src/Plug.vala"
	self = (SecurityPrivacyPlug*) base;
#line 77 "../src/Plug.vala"
	g_return_if_fail (location != NULL);
#line 78 "../src/Plug.vala"
	_tmp0_ = self->priv->stack;
#line 78 "../src/Plug.vala"
	gtk_stack_set_visible_child_name (_tmp0_, location);
#line 462 "Plug.c"
}

static void
security_privacy_plug_real_search_data_free (gpointer _data)
{
	SecurityPrivacyPlugSearchData* _data_;
	_data_ = _data;
#line 7 "../src/Plug.vala"
	_g_free0 (_data_->search);
#line 7 "../src/Plug.vala"
	_g_object_unref0 (_data_->result);
#line 7 "../src/Plug.vala"
	_g_object_unref0 (_data_->self);
#line 7 "../src/Plug.vala"
	g_slice_free (SecurityPrivacyPlugSearchData, _data_);
#line 478 "Plug.c"
}

static void
security_privacy_plug_real_search (SwitchboardPlug* base,
                                   const gchar* search,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_)
{
	SecurityPrivacyPlug * self;
	SecurityPrivacyPlugSearchData* _data_;
	SecurityPrivacyPlug* _tmp0_;
	gchar* _tmp1_;
#line 7 "../src/Plug.vala"
	g_return_if_fail (search != NULL);
#line 7 "../src/Plug.vala"
	self = (SecurityPrivacyPlug*) base;
#line 7 "../src/Plug.vala"
	_data_ = g_slice_new0 (SecurityPrivacyPlugSearchData);
#line 7 "../src/Plug.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 7 "../src/Plug.vala"
	g_task_set_task_data (_data_->_async_result, _data_, security_privacy_plug_real_search_data_free);
#line 7 "../src/Plug.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 7 "../src/Plug.vala"
	_data_->self = _tmp0_;
#line 7 "../src/Plug.vala"
	_tmp1_ = g_strdup (search);
#line 7 "../src/Plug.vala"
	_g_free0 (_data_->search);
#line 7 "../src/Plug.vala"
	_data_->search = _tmp1_;
#line 7 "../src/Plug.vala"
	security_privacy_plug_real_search_co (_data_);
#line 513 "Plug.c"
}

static GeeTreeMap*
security_privacy_plug_search_finish (SwitchboardPlug* base,
                                     GAsyncResult* _res_)
{
	GeeTreeMap* result;
	SecurityPrivacyPlugSearchData* _data_;
#line 7 "../src/Plug.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 7 "../src/Plug.vala"
	result = _data_->result;
#line 7 "../src/Plug.vala"
	_data_->result = NULL;
#line 7 "../src/Plug.vala"
	return result;
#line 530 "Plug.c"
}

static gboolean
security_privacy_plug_real_search_co (SecurityPrivacyPlugSearchData* _data_)
{
#line 82 "../src/Plug.vala"
	switch (_data_->_state_) {
#line 82 "../src/Plug.vala"
		case 0:
#line 540 "Plug.c"
		goto _state_0;
		default:
#line 82 "../src/Plug.vala"
		g_assert_not_reached ();
#line 545 "Plug.c"
	}
	_state_0:
#line 83 "../src/Plug.vala"
	_data_->_tmp0_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 83 "../src/Plug.vala"
	_data_->map = _data_->_tmp0_;
#line 84 "../src/Plug.vala"
	_data_->_tmp1_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 84 "../src/Plug.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 84 "../src/Plug.vala"
	_data_->_tmp3_ = g_strdup_printf ("%s → %s", _data_->_tmp2_, _ ("History"));
#line 84 "../src/Plug.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 84 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->map, _data_->_tmp4_, SECURITY_PRIVACY_PLUG_HISTORY);
#line 84 "../src/Plug.vala"
	_g_free0 (_data_->_tmp4_);
#line 85 "../src/Plug.vala"
	_data_->_tmp5_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 85 "../src/Plug.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 85 "../src/Plug.vala"
	_data_->_tmp7_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp6_, _ ("History"), _ ("Clear History"));
#line 85 "../src/Plug.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 85 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->map, _data_->_tmp8_, SECURITY_PRIVACY_PLUG_HISTORY);
#line 85 "../src/Plug.vala"
	_g_free0 (_data_->_tmp8_);
#line 86 "../src/Plug.vala"
	_data_->_tmp9_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 86 "../src/Plug.vala"
	_data_->_tmp10_ = _data_->_tmp9_;
#line 86 "../src/Plug.vala"
	_data_->_tmp11_ = g_strdup_printf ("%s → %s", _data_->_tmp10_, _ ("Locking"));
#line 86 "../src/Plug.vala"
	_data_->_tmp12_ = _data_->_tmp11_;
#line 86 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->map, _data_->_tmp12_, SECURITY_PRIVACY_PLUG_LOCKING);
#line 86 "../src/Plug.vala"
	_g_free0 (_data_->_tmp12_);
#line 87 "../src/Plug.vala"
	_data_->_tmp13_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 87 "../src/Plug.vala"
	_data_->_tmp14_ = _data_->_tmp13_;
#line 87 "../src/Plug.vala"
	_data_->_tmp15_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp14_, _ ("Locking"), _ ("Lock on sleep"));
#line 87 "../src/Plug.vala"
	_data_->_tmp16_ = _data_->_tmp15_;
#line 87 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->map, _data_->_tmp16_, SECURITY_PRIVACY_PLUG_HISTORY);
#line 87 "../src/Plug.vala"
	_g_free0 (_data_->_tmp16_);
#line 88 "../src/Plug.vala"
	_data_->_tmp17_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 88 "../src/Plug.vala"
	_data_->_tmp18_ = _data_->_tmp17_;
#line 88 "../src/Plug.vala"
	_data_->_tmp19_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp18_, _ ("Locking"), _ ("Lock after sceen turns off"));
#line 88 "../src/Plug.vala"
	_data_->_tmp20_ = _data_->_tmp19_;
#line 88 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->map, _data_->_tmp20_, SECURITY_PRIVACY_PLUG_HISTORY);
#line 88 "../src/Plug.vala"
	_g_free0 (_data_->_tmp20_);
#line 89 "../src/Plug.vala"
	_data_->_tmp21_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 89 "../src/Plug.vala"
	_data_->_tmp22_ = _data_->_tmp21_;
#line 89 "../src/Plug.vala"
	_data_->_tmp23_ = g_strdup_printf ("%s → %s", _data_->_tmp22_, _ ("Firewall"));
#line 89 "../src/Plug.vala"
	_data_->_tmp24_ = _data_->_tmp23_;
#line 89 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->map, _data_->_tmp24_, SECURITY_PRIVACY_PLUG_FIREWALL);
#line 89 "../src/Plug.vala"
	_g_free0 (_data_->_tmp24_);
#line 90 "../src/Plug.vala"
	_data_->_tmp25_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 90 "../src/Plug.vala"
	_data_->_tmp26_ = _data_->_tmp25_;
#line 90 "../src/Plug.vala"
	_data_->_tmp27_ = g_strdup_printf ("%s → %s", _data_->_tmp26_, _ ("Housekeeping"));
#line 90 "../src/Plug.vala"
	_data_->_tmp28_ = _data_->_tmp27_;
#line 90 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->map, _data_->_tmp28_, SECURITY_PRIVACY_PLUG_HOUSEKEEPING);
#line 90 "../src/Plug.vala"
	_g_free0 (_data_->_tmp28_);
#line 91 "../src/Plug.vala"
	_data_->_tmp29_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 91 "../src/Plug.vala"
	_data_->_tmp30_ = _data_->_tmp29_;
#line 91 "../src/Plug.vala"
	_data_->_tmp31_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp30_, _ ("Housekeeping"), _ ("Automatically delete old temporary files"));
#line 91 "../src/Plug.vala"
	_data_->_tmp32_ = _data_->_tmp31_;
#line 91 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->map, _data_->_tmp32_, SECURITY_PRIVACY_PLUG_HOUSEKEEPING);
#line 91 "../src/Plug.vala"
	_g_free0 (_data_->_tmp32_);
#line 96 "../src/Plug.vala"
	_data_->_tmp33_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 96 "../src/Plug.vala"
	_data_->_tmp34_ = _data_->_tmp33_;
#line 96 "../src/Plug.vala"
	_data_->_tmp35_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp34_, _ ("Housekeeping"), _ ("Automatically delete old screenshot files"));
#line 96 "../src/Plug.vala"
	_data_->_tmp36_ = _data_->_tmp35_;
#line 96 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->map, _data_->_tmp36_, SECURITY_PRIVACY_PLUG_HOUSEKEEPING);
#line 96 "../src/Plug.vala"
	_g_free0 (_data_->_tmp36_);
#line 101 "../src/Plug.vala"
	_data_->_tmp37_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 101 "../src/Plug.vala"
	_data_->_tmp38_ = _data_->_tmp37_;
#line 101 "../src/Plug.vala"
	_data_->_tmp39_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp38_, _ ("Housekeeping"), _ ("Automatically delete old trashed files"));
#line 101 "../src/Plug.vala"
	_data_->_tmp40_ = _data_->_tmp39_;
#line 101 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->map, _data_->_tmp40_, SECURITY_PRIVACY_PLUG_HOUSEKEEPING);
#line 101 "../src/Plug.vala"
	_g_free0 (_data_->_tmp40_);
#line 106 "../src/Plug.vala"
	_data_->_tmp41_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 106 "../src/Plug.vala"
	_data_->_tmp42_ = _data_->_tmp41_;
#line 106 "../src/Plug.vala"
	_data_->_tmp43_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp42_, _ ("Housekeeping"), _ ("Number of days to keep trashed and temporary files"));
#line 106 "../src/Plug.vala"
	_data_->_tmp44_ = _data_->_tmp43_;
#line 106 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->map, _data_->_tmp44_, SECURITY_PRIVACY_PLUG_HOUSEKEEPING);
#line 106 "../src/Plug.vala"
	_g_free0 (_data_->_tmp44_);
#line 111 "../src/Plug.vala"
	_data_->_tmp45_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 111 "../src/Plug.vala"
	_data_->_tmp46_ = _data_->_tmp45_;
#line 111 "../src/Plug.vala"
	_data_->_tmp47_ = g_strdup_printf ("%s → %s", _data_->_tmp46_, _ ("Location Services"));
#line 111 "../src/Plug.vala"
	_data_->_tmp48_ = _data_->_tmp47_;
#line 111 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->map, _data_->_tmp48_, SECURITY_PRIVACY_PLUG_LOCATION);
#line 111 "../src/Plug.vala"
	_g_free0 (_data_->_tmp48_);
#line 112 "../src/Plug.vala"
	_data_->result = _data_->map;
#line 112 "../src/Plug.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 112 "../src/Plug.vala"
	if (_data_->_state_ != 0) {
#line 112 "../src/Plug.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 112 "../src/Plug.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 706 "Plug.c"
		}
	}
#line 112 "../src/Plug.vala"
	g_object_unref (_data_->_async_result);
#line 112 "../src/Plug.vala"
	return FALSE;
#line 713 "Plug.c"
}

static void
security_privacy_plug_class_init (SecurityPrivacyPlugClass * klass,
                                  gpointer klass_data)
{
#line 7 "../src/Plug.vala"
	security_privacy_plug_parent_class = g_type_class_peek_parent (klass);
#line 7 "../src/Plug.vala"
	g_type_class_adjust_private_offset (klass, &SecurityPrivacyPlug_private_offset);
#line 7 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->get_widget = (GtkWidget* (*) (SwitchboardPlug*)) security_privacy_plug_real_get_widget;
#line 7 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->shown = (void (*) (SwitchboardPlug*)) security_privacy_plug_real_shown;
#line 7 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->hidden = (void (*) (SwitchboardPlug*)) security_privacy_plug_real_hidden;
#line 7 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search_callback = (void (*) (SwitchboardPlug*, const gchar*)) security_privacy_plug_real_search_callback;
#line 7 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search = (void (*) (SwitchboardPlug*, const gchar*, GAsyncReadyCallback, gpointer)) security_privacy_plug_real_search;
#line 7 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search_finish = (GeeTreeMap* (*) (SwitchboardPlug*, GAsyncResult*)) security_privacy_plug_search_finish;
#line 7 "../src/Plug.vala"
	G_OBJECT_CLASS (klass)->finalize = security_privacy_plug_finalize;
#line 738 "Plug.c"
}

static void
security_privacy_plug_instance_init (SecurityPrivacyPlug * self,
                                     gpointer klass)
{
#line 7 "../src/Plug.vala"
	self->priv = security_privacy_plug_get_instance_private (self);
#line 747 "Plug.c"
}

static void
security_privacy_plug_finalize (GObject * obj)
{
	SecurityPrivacyPlug * self;
#line 7 "../src/Plug.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SECURITY_PRIVACY_TYPE_PLUG, SecurityPrivacyPlug);
#line 8 "../src/Plug.vala"
	_g_object_unref0 (self->priv->paned);
#line 9 "../src/Plug.vala"
	_g_object_unref0 (self->priv->stack);
#line 7 "../src/Plug.vala"
	G_OBJECT_CLASS (security_privacy_plug_parent_class)->finalize (obj);
#line 762 "Plug.c"
}

static GType
security_privacy_plug_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SecurityPrivacyPlugClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) security_privacy_plug_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SecurityPrivacyPlug), 0, (GInstanceInitFunc) security_privacy_plug_instance_init, NULL };
	GType security_privacy_plug_type_id;
	security_privacy_plug_type_id = g_type_register_static (SWITCHBOARD_TYPE_PLUG, "SecurityPrivacyPlug", &g_define_type_info, 0);
	SecurityPrivacyPlug_private_offset = g_type_add_instance_private (security_privacy_plug_type_id, sizeof (SecurityPrivacyPlugPrivate));
	return security_privacy_plug_type_id;
}

GType
security_privacy_plug_get_type (void)
{
	static volatile gsize security_privacy_plug_type_id__once = 0;
	if (g_once_init_enter (&security_privacy_plug_type_id__once)) {
		GType security_privacy_plug_type_id;
		security_privacy_plug_type_id = security_privacy_plug_get_type_once ();
		g_once_init_leave (&security_privacy_plug_type_id__once, security_privacy_plug_type_id);
	}
	return security_privacy_plug_type_id__once;
}

SwitchboardPlug*
get_plug (GModule* module)
{
	SecurityPrivacyPlug* plug = NULL;
	SecurityPrivacyPlug* _tmp0_;
	SwitchboardPlug* result;
#line 116 "../src/Plug.vala"
	g_return_val_if_fail (module != NULL, NULL);
#line 117 "../src/Plug.vala"
	g_debug ("Plug.vala:117: Activating Security & Privacy plug");
#line 118 "../src/Plug.vala"
	_tmp0_ = security_privacy_plug_new ();
#line 118 "../src/Plug.vala"
	plug = _tmp0_;
#line 119 "../src/Plug.vala"
	result = (SwitchboardPlug*) plug;
#line 119 "../src/Plug.vala"
	return result;
#line 805 "Plug.c"
}

