/* UFWHelpers.c generated by valac 0.56.17, the Vala compiler
 * generated from UFWHelpers.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2014 elementary LLC. (http://launchpad.net/switchboard-plug-security-privacy)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Corentin Noël <tintou@mailoo.org>
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "security-privacy.h"
#include <gee.h>
#include <glib-object.h>
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	SECURITY_PRIVACY_UFW_HELPERS_RULE_0_PROPERTY,
	SECURITY_PRIVACY_UFW_HELPERS_RULE_NUM_PROPERTIES
};
static GParamSpec* security_privacy_ufw_helpers_rule_properties[SECURITY_PRIVACY_UFW_HELPERS_RULE_NUM_PROPERTIES];
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

static gpointer security_privacy_ufw_helpers_rule_parent_class = NULL;

VALA_EXTERN gchar* security_privacy_ufw_helpers_get_helper_path (void);
static void security_privacy_ufw_helpers_rule_get_address_and_port (SecurityPrivacyUFWHelpersRule* self,
                                                             const gchar* input,
                                                             SecurityPrivacyUFWHelpersRuleVersion* version,
                                                             gchar** ports,
                                                             gchar** address);
static void security_privacy_ufw_helpers_rule_finalize (GObject * obj);
static GType security_privacy_ufw_helpers_rule_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

gchar*
security_privacy_ufw_helpers_get_helper_path (void)
{
	gchar* _tmp0_;
	gchar* result;
#line 26 "../src/UFWHelpers.vala"
	_tmp0_ = g_strdup_printf ("%s/security-privacy-plug-helper", BUILD_PKGDATADIR);
#line 26 "../src/UFWHelpers.vala"
	result = _tmp0_;
#line 26 "../src/UFWHelpers.vala"
	return result;
#line 84 "UFWHelpers.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 103 "UFWHelpers.c"
}

gboolean
security_privacy_ufw_helpers_get_status (void)
{
	gboolean _tmp7_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
	{
		gchar* standard_output = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_ = NULL;
#line 32 "../src/UFWHelpers.vala"
		_tmp0_ = security_privacy_ufw_helpers_get_helper_path ();
#line 32 "../src/UFWHelpers.vala"
		_tmp1_ = _tmp0_;
#line 32 "../src/UFWHelpers.vala"
		_tmp2_ = g_strdup_printf ("pkexec %s -4", _tmp1_);
#line 32 "../src/UFWHelpers.vala"
		_tmp3_ = _tmp2_;
#line 32 "../src/UFWHelpers.vala"
		g_spawn_command_line_sync (_tmp3_, &_tmp4_, NULL, NULL, &_inner_error0_);
#line 32 "../src/UFWHelpers.vala"
		_g_free0 (standard_output);
#line 32 "../src/UFWHelpers.vala"
		standard_output = _tmp4_;
#line 32 "../src/UFWHelpers.vala"
		_g_free0 (_tmp3_);
#line 32 "../src/UFWHelpers.vala"
		_g_free0 (_tmp1_);
#line 32 "../src/UFWHelpers.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 32 "../src/UFWHelpers.vala"
			_g_free0 (standard_output);
#line 141 "UFWHelpers.c"
			goto __catch0_g_error;
		}
#line 33 "../src/UFWHelpers.vala"
		result = string_contains (standard_output, "inactive") == FALSE;
#line 33 "../src/UFWHelpers.vala"
		_g_free0 (standard_output);
#line 33 "../src/UFWHelpers.vala"
		return result;
#line 150 "UFWHelpers.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 30 "../src/UFWHelpers.vala"
		e = _inner_error0_;
#line 30 "../src/UFWHelpers.vala"
		_inner_error0_ = NULL;
#line 35 "../src/UFWHelpers.vala"
		_tmp5_ = e;
#line 35 "../src/UFWHelpers.vala"
		_tmp6_ = _tmp5_->message;
#line 35 "../src/UFWHelpers.vala"
		g_warning ("UFWHelpers.vala:35: %s", _tmp6_);
#line 36 "../src/UFWHelpers.vala"
		result = FALSE;
#line 36 "../src/UFWHelpers.vala"
		_g_error_free0 (e);
#line 36 "../src/UFWHelpers.vala"
		return result;
#line 174 "UFWHelpers.c"
	}
	__finally0:
#line 30 "../src/UFWHelpers.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 30 "../src/UFWHelpers.vala"
	g_clear_error (&_inner_error0_);
#line 30 "../src/UFWHelpers.vala"
	return _tmp7_;
#line 183 "UFWHelpers.c"
}

void
security_privacy_ufw_helpers_set_status (gboolean status)
{
	GError* _inner_error0_ = NULL;
	{
#line 42 "../src/UFWHelpers.vala"
		if (status == TRUE) {
#line 193 "UFWHelpers.c"
			gchar* _tmp0_;
			gchar* _tmp1_;
			gchar* _tmp2_;
			gchar* _tmp3_;
#line 43 "../src/UFWHelpers.vala"
			_tmp0_ = security_privacy_ufw_helpers_get_helper_path ();
#line 43 "../src/UFWHelpers.vala"
			_tmp1_ = _tmp0_;
#line 43 "../src/UFWHelpers.vala"
			_tmp2_ = g_strdup_printf ("pkexec %s -2", _tmp1_);
#line 43 "../src/UFWHelpers.vala"
			_tmp3_ = _tmp2_;
#line 43 "../src/UFWHelpers.vala"
			g_spawn_command_line_sync (_tmp3_, NULL, NULL, NULL, &_inner_error0_);
#line 43 "../src/UFWHelpers.vala"
			_g_free0 (_tmp3_);
#line 43 "../src/UFWHelpers.vala"
			_g_free0 (_tmp1_);
#line 43 "../src/UFWHelpers.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 214 "UFWHelpers.c"
				goto __catch0_g_error;
			}
		} else {
			gchar* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
#line 45 "../src/UFWHelpers.vala"
			_tmp4_ = security_privacy_ufw_helpers_get_helper_path ();
#line 45 "../src/UFWHelpers.vala"
			_tmp5_ = _tmp4_;
#line 45 "../src/UFWHelpers.vala"
			_tmp6_ = g_strdup_printf ("pkexec %s -3", _tmp5_);
#line 45 "../src/UFWHelpers.vala"
			_tmp7_ = _tmp6_;
#line 45 "../src/UFWHelpers.vala"
			g_spawn_command_line_sync (_tmp7_, NULL, NULL, NULL, &_inner_error0_);
#line 45 "../src/UFWHelpers.vala"
			_g_free0 (_tmp7_);
#line 45 "../src/UFWHelpers.vala"
			_g_free0 (_tmp5_);
#line 45 "../src/UFWHelpers.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 238 "UFWHelpers.c"
				goto __catch0_g_error;
			}
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 41 "../src/UFWHelpers.vala"
		e = _inner_error0_;
#line 41 "../src/UFWHelpers.vala"
		_inner_error0_ = NULL;
#line 47 "../src/UFWHelpers.vala"
		_tmp8_ = e;
#line 47 "../src/UFWHelpers.vala"
		_tmp9_ = _tmp8_->message;
#line 47 "../src/UFWHelpers.vala"
		g_warning ("UFWHelpers.vala:47: %s", _tmp9_);
#line 41 "../src/UFWHelpers.vala"
		_g_error_free0 (e);
#line 261 "UFWHelpers.c"
	}
	__finally0:
#line 41 "../src/UFWHelpers.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 41 "../src/UFWHelpers.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 41 "../src/UFWHelpers.vala"
		g_clear_error (&_inner_error0_);
#line 41 "../src/UFWHelpers.vala"
		return;
#line 272 "UFWHelpers.c"
	}
}

GeeLinkedList*
security_privacy_ufw_helpers_get_rules (void)
{
	GeeLinkedList* rules = NULL;
	GeeLinkedList* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeLinkedList* result;
#line 52 "../src/UFWHelpers.vala"
	_tmp0_ = gee_linked_list_new (SECURITY_PRIVACY_UFW_HELPERS_TYPE_RULE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 52 "../src/UFWHelpers.vala"
	rules = _tmp0_;
#line 287 "UFWHelpers.c"
	{
		gchar* standard_output = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_ = NULL;
		gchar** lines = NULL;
		gchar** _tmp6_;
		gchar** _tmp7_;
		gint lines_length1;
		gint _lines_size_;
		gchar** _tmp8_;
		gint _tmp8__length1;
#line 55 "../src/UFWHelpers.vala"
		_tmp1_ = security_privacy_ufw_helpers_get_helper_path ();
#line 55 "../src/UFWHelpers.vala"
		_tmp2_ = _tmp1_;
#line 55 "../src/UFWHelpers.vala"
		_tmp3_ = g_strdup_printf ("pkexec %s -4", _tmp2_);
#line 55 "../src/UFWHelpers.vala"
		_tmp4_ = _tmp3_;
#line 55 "../src/UFWHelpers.vala"
		g_spawn_command_line_sync (_tmp4_, &_tmp5_, NULL, NULL, &_inner_error0_);
#line 55 "../src/UFWHelpers.vala"
		_g_free0 (standard_output);
#line 55 "../src/UFWHelpers.vala"
		standard_output = _tmp5_;
#line 55 "../src/UFWHelpers.vala"
		_g_free0 (_tmp4_);
#line 55 "../src/UFWHelpers.vala"
		_g_free0 (_tmp2_);
#line 55 "../src/UFWHelpers.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 55 "../src/UFWHelpers.vala"
			_g_free0 (standard_output);
#line 324 "UFWHelpers.c"
			goto __catch0_g_error;
		}
#line 56 "../src/UFWHelpers.vala"
		_tmp7_ = _tmp6_ = g_strsplit (standard_output, "\n", 0);
#line 56 "../src/UFWHelpers.vala"
		lines = _tmp7_;
#line 56 "../src/UFWHelpers.vala"
		lines_length1 = _vala_array_length (_tmp6_);
#line 56 "../src/UFWHelpers.vala"
		_lines_size_ = lines_length1;
#line 57 "../src/UFWHelpers.vala"
		_tmp8_ = lines;
#line 57 "../src/UFWHelpers.vala"
		_tmp8__length1 = lines_length1;
#line 339 "UFWHelpers.c"
		{
			gchar** line_collection = NULL;
			gint line_collection_length1 = 0;
			gint _line_collection_size_ = 0;
			gint line_it = 0;
#line 57 "../src/UFWHelpers.vala"
			line_collection = _tmp8_;
#line 57 "../src/UFWHelpers.vala"
			line_collection_length1 = _tmp8__length1;
#line 57 "../src/UFWHelpers.vala"
			for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 351 "UFWHelpers.c"
				gchar* _tmp9_;
				gchar* line = NULL;
#line 57 "../src/UFWHelpers.vala"
				_tmp9_ = g_strdup (line_collection[line_it]);
#line 57 "../src/UFWHelpers.vala"
				line = _tmp9_;
#line 358 "UFWHelpers.c"
				{
					gboolean _tmp10_ = FALSE;
					gboolean _tmp11_ = FALSE;
					gboolean _tmp12_ = FALSE;
					const gchar* _tmp13_;
#line 58 "../src/UFWHelpers.vala"
					_tmp13_ = line;
#line 58 "../src/UFWHelpers.vala"
					if (string_contains (_tmp13_, "ALLOW")) {
#line 58 "../src/UFWHelpers.vala"
						_tmp12_ = TRUE;
#line 370 "UFWHelpers.c"
					} else {
						const gchar* _tmp14_;
#line 58 "../src/UFWHelpers.vala"
						_tmp14_ = line;
#line 58 "../src/UFWHelpers.vala"
						_tmp12_ = string_contains (_tmp14_, "DENY");
#line 377 "UFWHelpers.c"
					}
#line 58 "../src/UFWHelpers.vala"
					if (_tmp12_) {
#line 58 "../src/UFWHelpers.vala"
						_tmp11_ = TRUE;
#line 383 "UFWHelpers.c"
					} else {
						const gchar* _tmp15_;
#line 58 "../src/UFWHelpers.vala"
						_tmp15_ = line;
#line 58 "../src/UFWHelpers.vala"
						_tmp11_ = string_contains (_tmp15_, "LIMIT");
#line 390 "UFWHelpers.c"
					}
#line 58 "../src/UFWHelpers.vala"
					if (_tmp11_) {
#line 58 "../src/UFWHelpers.vala"
						_tmp10_ = TRUE;
#line 396 "UFWHelpers.c"
					} else {
						const gchar* _tmp16_;
#line 58 "../src/UFWHelpers.vala"
						_tmp16_ = line;
#line 58 "../src/UFWHelpers.vala"
						_tmp10_ = string_contains (_tmp16_, "REJECT");
#line 403 "UFWHelpers.c"
					}
#line 58 "../src/UFWHelpers.vala"
					if (_tmp10_) {
#line 407 "UFWHelpers.c"
						SecurityPrivacyUFWHelpersRule* rule = NULL;
						const gchar* _tmp17_;
						SecurityPrivacyUFWHelpersRule* _tmp18_;
						SecurityPrivacyUFWHelpersRule* _tmp19_;
#line 59 "../src/UFWHelpers.vala"
						_tmp17_ = line;
#line 59 "../src/UFWHelpers.vala"
						_tmp18_ = security_privacy_ufw_helpers_rule_new_from_line (_tmp17_);
#line 59 "../src/UFWHelpers.vala"
						rule = _tmp18_;
#line 60 "../src/UFWHelpers.vala"
						_tmp19_ = rule;
#line 60 "../src/UFWHelpers.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) rules, _tmp19_);
#line 58 "../src/UFWHelpers.vala"
						_g_object_unref0 (rule);
#line 424 "UFWHelpers.c"
					}
#line 57 "../src/UFWHelpers.vala"
					_g_free0 (line);
#line 428 "UFWHelpers.c"
				}
			}
		}
#line 53 "../src/UFWHelpers.vala"
		lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 53 "../src/UFWHelpers.vala"
		_g_free0 (standard_output);
#line 436 "UFWHelpers.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp20_;
		const gchar* _tmp21_;
#line 53 "../src/UFWHelpers.vala"
		e = _inner_error0_;
#line 53 "../src/UFWHelpers.vala"
		_inner_error0_ = NULL;
#line 64 "../src/UFWHelpers.vala"
		_tmp20_ = e;
#line 64 "../src/UFWHelpers.vala"
		_tmp21_ = _tmp20_->message;
#line 64 "../src/UFWHelpers.vala"
		g_warning ("UFWHelpers.vala:64: %s", _tmp21_);
#line 53 "../src/UFWHelpers.vala"
		_g_error_free0 (e);
#line 456 "UFWHelpers.c"
	}
	__finally0:
#line 53 "../src/UFWHelpers.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 53 "../src/UFWHelpers.vala"
		_g_object_unref0 (rules);
#line 53 "../src/UFWHelpers.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 53 "../src/UFWHelpers.vala"
		g_clear_error (&_inner_error0_);
#line 53 "../src/UFWHelpers.vala"
		return NULL;
#line 469 "UFWHelpers.c"
	}
#line 66 "../src/UFWHelpers.vala"
	result = rules;
#line 66 "../src/UFWHelpers.vala"
	return result;
#line 475 "UFWHelpers.c"
}

void
security_privacy_ufw_helpers_remove_rule (SecurityPrivacyUFWHelpersRule* rule)
{
	GError* _inner_error0_ = NULL;
#line 69 "../src/UFWHelpers.vala"
	g_return_if_fail (rule != NULL);
#line 484 "UFWHelpers.c"
	{
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 71 "../src/UFWHelpers.vala"
		_tmp0_ = security_privacy_ufw_helpers_get_helper_path ();
#line 71 "../src/UFWHelpers.vala"
		_tmp1_ = _tmp0_;
#line 71 "../src/UFWHelpers.vala"
		_tmp2_ = g_strdup_printf ("pkexec %s -6 \"%d\"", _tmp1_, rule->number);
#line 71 "../src/UFWHelpers.vala"
		_tmp3_ = _tmp2_;
#line 71 "../src/UFWHelpers.vala"
		g_spawn_command_line_sync (_tmp3_, NULL, NULL, NULL, &_inner_error0_);
#line 71 "../src/UFWHelpers.vala"
		_g_free0 (_tmp3_);
#line 71 "../src/UFWHelpers.vala"
		_g_free0 (_tmp1_);
#line 71 "../src/UFWHelpers.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 506 "UFWHelpers.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 70 "../src/UFWHelpers.vala"
		e = _inner_error0_;
#line 70 "../src/UFWHelpers.vala"
		_inner_error0_ = NULL;
#line 73 "../src/UFWHelpers.vala"
		_tmp4_ = e;
#line 73 "../src/UFWHelpers.vala"
		_tmp5_ = _tmp4_->message;
#line 73 "../src/UFWHelpers.vala"
		g_warning ("UFWHelpers.vala:73: %s", _tmp5_);
#line 70 "../src/UFWHelpers.vala"
		_g_error_free0 (e);
#line 528 "UFWHelpers.c"
	}
	__finally0:
#line 70 "../src/UFWHelpers.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 70 "../src/UFWHelpers.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 70 "../src/UFWHelpers.vala"
		g_clear_error (&_inner_error0_);
#line 70 "../src/UFWHelpers.vala"
		return;
#line 539 "UFWHelpers.c"
	}
}

void
security_privacy_ufw_helpers_add_rule (SecurityPrivacyUFWHelpersRule* rule)
{
	gchar* rule_str = NULL;
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 77 "../src/UFWHelpers.vala"
	g_return_if_fail (rule != NULL);
#line 78 "../src/UFWHelpers.vala"
	_tmp0_ = g_strdup ("");
#line 78 "../src/UFWHelpers.vala"
	rule_str = _tmp0_;
#line 555 "UFWHelpers.c"
	{
		gboolean _tmp13_ = FALSE;
		const gchar* _tmp14_;
		gboolean _tmp33_ = FALSE;
		const gchar* _tmp34_;
		gchar* _tmp53_;
		gchar* _tmp54_;
		const gchar* _tmp55_;
		gchar* _tmp56_;
		gchar* _tmp57_;
#line 80 "../src/UFWHelpers.vala"
		switch (rule->action) {
#line 80 "../src/UFWHelpers.vala"
			case SECURITY_PRIVACY_UFW_HELPERS_RULE_ACTION_DENY:
#line 570 "UFWHelpers.c"
			{
				gchar* _tmp1_;
#line 82 "../src/UFWHelpers.vala"
				_tmp1_ = g_strdup ("deny");
#line 82 "../src/UFWHelpers.vala"
				_g_free0 (rule_str);
#line 82 "../src/UFWHelpers.vala"
				rule_str = _tmp1_;
#line 83 "../src/UFWHelpers.vala"
				break;
#line 581 "UFWHelpers.c"
			}
#line 80 "../src/UFWHelpers.vala"
			case SECURITY_PRIVACY_UFW_HELPERS_RULE_ACTION_REJECT:
#line 585 "UFWHelpers.c"
			{
				gchar* _tmp2_;
#line 85 "../src/UFWHelpers.vala"
				_tmp2_ = g_strdup ("reject");
#line 85 "../src/UFWHelpers.vala"
				_g_free0 (rule_str);
#line 85 "../src/UFWHelpers.vala"
				rule_str = _tmp2_;
#line 86 "../src/UFWHelpers.vala"
				break;
#line 596 "UFWHelpers.c"
			}
#line 80 "../src/UFWHelpers.vala"
			case SECURITY_PRIVACY_UFW_HELPERS_RULE_ACTION_LIMIT:
#line 600 "UFWHelpers.c"
			{
				gchar* _tmp3_;
#line 88 "../src/UFWHelpers.vala"
				_tmp3_ = g_strdup ("limit");
#line 88 "../src/UFWHelpers.vala"
				_g_free0 (rule_str);
#line 88 "../src/UFWHelpers.vala"
				rule_str = _tmp3_;
#line 89 "../src/UFWHelpers.vala"
				break;
#line 611 "UFWHelpers.c"
			}
			default:
			{
				gchar* _tmp4_;
#line 91 "../src/UFWHelpers.vala"
				_tmp4_ = g_strdup ("allow");
#line 91 "../src/UFWHelpers.vala"
				_g_free0 (rule_str);
#line 91 "../src/UFWHelpers.vala"
				rule_str = _tmp4_;
#line 92 "../src/UFWHelpers.vala"
				break;
#line 624 "UFWHelpers.c"
			}
		}
#line 95 "../src/UFWHelpers.vala"
		switch (rule->direction) {
#line 95 "../src/UFWHelpers.vala"
			case SECURITY_PRIVACY_UFW_HELPERS_RULE_DIRECTION_OUT:
#line 631 "UFWHelpers.c"
			{
				const gchar* _tmp5_;
				gchar* _tmp6_;
#line 97 "../src/UFWHelpers.vala"
				_tmp5_ = rule_str;
#line 97 "../src/UFWHelpers.vala"
				_tmp6_ = g_strdup_printf ("%s out", _tmp5_);
#line 97 "../src/UFWHelpers.vala"
				_g_free0 (rule_str);
#line 97 "../src/UFWHelpers.vala"
				rule_str = _tmp6_;
#line 98 "../src/UFWHelpers.vala"
				break;
#line 645 "UFWHelpers.c"
			}
			default:
			{
				const gchar* _tmp7_;
				gchar* _tmp8_;
#line 100 "../src/UFWHelpers.vala"
				_tmp7_ = rule_str;
#line 100 "../src/UFWHelpers.vala"
				_tmp8_ = g_strdup_printf ("%s in", _tmp7_);
#line 100 "../src/UFWHelpers.vala"
				_g_free0 (rule_str);
#line 100 "../src/UFWHelpers.vala"
				rule_str = _tmp8_;
#line 101 "../src/UFWHelpers.vala"
				break;
#line 661 "UFWHelpers.c"
			}
		}
#line 104 "../src/UFWHelpers.vala"
		switch (rule->protocol) {
#line 104 "../src/UFWHelpers.vala"
			case SECURITY_PRIVACY_UFW_HELPERS_RULE_PROTOCOL_UDP:
#line 668 "UFWHelpers.c"
			{
				const gchar* _tmp9_;
				gchar* _tmp10_;
#line 106 "../src/UFWHelpers.vala"
				_tmp9_ = rule_str;
#line 106 "../src/UFWHelpers.vala"
				_tmp10_ = g_strdup_printf ("%s proto udp", _tmp9_);
#line 106 "../src/UFWHelpers.vala"
				_g_free0 (rule_str);
#line 106 "../src/UFWHelpers.vala"
				rule_str = _tmp10_;
#line 107 "../src/UFWHelpers.vala"
				break;
#line 682 "UFWHelpers.c"
			}
#line 104 "../src/UFWHelpers.vala"
			case SECURITY_PRIVACY_UFW_HELPERS_RULE_PROTOCOL_BOTH:
#line 686 "UFWHelpers.c"
			{
#line 109 "../src/UFWHelpers.vala"
				break;
#line 690 "UFWHelpers.c"
			}
			default:
			{
				const gchar* _tmp11_;
				gchar* _tmp12_;
#line 111 "../src/UFWHelpers.vala"
				_tmp11_ = rule_str;
#line 111 "../src/UFWHelpers.vala"
				_tmp12_ = g_strdup_printf ("%s proto tcp", _tmp11_);
#line 111 "../src/UFWHelpers.vala"
				_g_free0 (rule_str);
#line 111 "../src/UFWHelpers.vala"
				rule_str = _tmp12_;
#line 112 "../src/UFWHelpers.vala"
				break;
#line 706 "UFWHelpers.c"
			}
		}
#line 115 "../src/UFWHelpers.vala"
		_tmp14_ = rule->to;
#line 115 "../src/UFWHelpers.vala"
		if (g_strcmp0 (_tmp14_, "") != 0) {
#line 713 "UFWHelpers.c"
			const gchar* _tmp15_;
#line 115 "../src/UFWHelpers.vala"
			_tmp15_ = rule->to;
#line 115 "../src/UFWHelpers.vala"
			_tmp13_ = !string_contains (_tmp15_, "Anywhere");
#line 719 "UFWHelpers.c"
		} else {
#line 115 "../src/UFWHelpers.vala"
			_tmp13_ = FALSE;
#line 723 "UFWHelpers.c"
		}
#line 115 "../src/UFWHelpers.vala"
		if (_tmp13_) {
#line 727 "UFWHelpers.c"
			const gchar* _tmp16_;
			const gchar* _tmp17_;
			gchar* _tmp18_;
			const gchar* _tmp19_;
#line 116 "../src/UFWHelpers.vala"
			_tmp16_ = rule_str;
#line 116 "../src/UFWHelpers.vala"
			_tmp17_ = rule->to;
#line 116 "../src/UFWHelpers.vala"
			_tmp18_ = g_strdup_printf ("%s to %s", _tmp16_, _tmp17_);
#line 116 "../src/UFWHelpers.vala"
			_g_free0 (rule_str);
#line 116 "../src/UFWHelpers.vala"
			rule_str = _tmp18_;
#line 117 "../src/UFWHelpers.vala"
			_tmp19_ = rule->to_ports;
#line 117 "../src/UFWHelpers.vala"
			if (g_strcmp0 (_tmp19_, "") != 0) {
#line 746 "UFWHelpers.c"
				const gchar* _tmp20_;
				const gchar* _tmp21_;
				gchar* _tmp22_;
#line 118 "../src/UFWHelpers.vala"
				_tmp20_ = rule_str;
#line 118 "../src/UFWHelpers.vala"
				_tmp21_ = rule->to_ports;
#line 118 "../src/UFWHelpers.vala"
				_tmp22_ = g_strdup_printf ("%s port %s", _tmp20_, _tmp21_);
#line 118 "../src/UFWHelpers.vala"
				_g_free0 (rule_str);
#line 118 "../src/UFWHelpers.vala"
				rule_str = _tmp22_;
#line 760 "UFWHelpers.c"
			}
		} else {
			const gchar* _tmp29_;
#line 121 "../src/UFWHelpers.vala"
			if (rule->version == SECURITY_PRIVACY_UFW_HELPERS_RULE_VERSION_BOTH) {
#line 766 "UFWHelpers.c"
				const gchar* _tmp23_;
				gchar* _tmp24_;
#line 122 "../src/UFWHelpers.vala"
				_tmp23_ = rule_str;
#line 122 "../src/UFWHelpers.vala"
				_tmp24_ = g_strdup_printf ("%s to any", _tmp23_);
#line 122 "../src/UFWHelpers.vala"
				_g_free0 (rule_str);
#line 122 "../src/UFWHelpers.vala"
				rule_str = _tmp24_;
#line 777 "UFWHelpers.c"
			} else {
#line 123 "../src/UFWHelpers.vala"
				if (rule->version == SECURITY_PRIVACY_UFW_HELPERS_RULE_VERSION_IPV6) {
#line 781 "UFWHelpers.c"
					const gchar* _tmp25_;
					gchar* _tmp26_;
#line 124 "../src/UFWHelpers.vala"
					_tmp25_ = rule_str;
#line 124 "../src/UFWHelpers.vala"
					_tmp26_ = g_strdup_printf ("%s to ::/0", _tmp25_);
#line 124 "../src/UFWHelpers.vala"
					_g_free0 (rule_str);
#line 124 "../src/UFWHelpers.vala"
					rule_str = _tmp26_;
#line 792 "UFWHelpers.c"
				} else {
#line 125 "../src/UFWHelpers.vala"
					if (rule->version == SECURITY_PRIVACY_UFW_HELPERS_RULE_VERSION_IPV4) {
#line 796 "UFWHelpers.c"
						const gchar* _tmp27_;
						gchar* _tmp28_;
#line 126 "../src/UFWHelpers.vala"
						_tmp27_ = rule_str;
#line 126 "../src/UFWHelpers.vala"
						_tmp28_ = g_strdup_printf ("%s to 0.0.0.0/0", _tmp27_);
#line 126 "../src/UFWHelpers.vala"
						_g_free0 (rule_str);
#line 126 "../src/UFWHelpers.vala"
						rule_str = _tmp28_;
#line 807 "UFWHelpers.c"
					}
				}
			}
#line 128 "../src/UFWHelpers.vala"
			_tmp29_ = rule->to_ports;
#line 128 "../src/UFWHelpers.vala"
			if (g_strcmp0 (_tmp29_, "") != 0) {
#line 815 "UFWHelpers.c"
				const gchar* _tmp30_;
				const gchar* _tmp31_;
				gchar* _tmp32_;
#line 129 "../src/UFWHelpers.vala"
				_tmp30_ = rule_str;
#line 129 "../src/UFWHelpers.vala"
				_tmp31_ = rule->to_ports;
#line 129 "../src/UFWHelpers.vala"
				_tmp32_ = g_strdup_printf ("%s port %s", _tmp30_, _tmp31_);
#line 129 "../src/UFWHelpers.vala"
				_g_free0 (rule_str);
#line 129 "../src/UFWHelpers.vala"
				rule_str = _tmp32_;
#line 829 "UFWHelpers.c"
			}
		}
#line 133 "../src/UFWHelpers.vala"
		_tmp34_ = rule->from;
#line 133 "../src/UFWHelpers.vala"
		if (g_strcmp0 (_tmp34_, "") != 0) {
#line 836 "UFWHelpers.c"
			const gchar* _tmp35_;
#line 133 "../src/UFWHelpers.vala"
			_tmp35_ = rule->from;
#line 133 "../src/UFWHelpers.vala"
			_tmp33_ = !string_contains (_tmp35_, "Anywhere");
#line 842 "UFWHelpers.c"
		} else {
#line 133 "../src/UFWHelpers.vala"
			_tmp33_ = FALSE;
#line 846 "UFWHelpers.c"
		}
#line 133 "../src/UFWHelpers.vala"
		if (_tmp33_) {
#line 850 "UFWHelpers.c"
			const gchar* _tmp36_;
			const gchar* _tmp37_;
			gchar* _tmp38_;
			const gchar* _tmp39_;
#line 134 "../src/UFWHelpers.vala"
			_tmp36_ = rule_str;
#line 134 "../src/UFWHelpers.vala"
			_tmp37_ = rule->from;
#line 134 "../src/UFWHelpers.vala"
			_tmp38_ = g_strdup_printf ("%s from %s", _tmp36_, _tmp37_);
#line 134 "../src/UFWHelpers.vala"
			_g_free0 (rule_str);
#line 134 "../src/UFWHelpers.vala"
			rule_str = _tmp38_;
#line 135 "../src/UFWHelpers.vala"
			_tmp39_ = rule->from_ports;
#line 135 "../src/UFWHelpers.vala"
			if (g_strcmp0 (_tmp39_, "") != 0) {
#line 869 "UFWHelpers.c"
				const gchar* _tmp40_;
				const gchar* _tmp41_;
				gchar* _tmp42_;
#line 136 "../src/UFWHelpers.vala"
				_tmp40_ = rule_str;
#line 136 "../src/UFWHelpers.vala"
				_tmp41_ = rule->from_ports;
#line 136 "../src/UFWHelpers.vala"
				_tmp42_ = g_strdup_printf ("%s port %s", _tmp40_, _tmp41_);
#line 136 "../src/UFWHelpers.vala"
				_g_free0 (rule_str);
#line 136 "../src/UFWHelpers.vala"
				rule_str = _tmp42_;
#line 883 "UFWHelpers.c"
			}
		} else {
			const gchar* _tmp49_;
#line 139 "../src/UFWHelpers.vala"
			if (rule->version == SECURITY_PRIVACY_UFW_HELPERS_RULE_VERSION_BOTH) {
#line 889 "UFWHelpers.c"
				const gchar* _tmp43_;
				gchar* _tmp44_;
#line 140 "../src/UFWHelpers.vala"
				_tmp43_ = rule_str;
#line 140 "../src/UFWHelpers.vala"
				_tmp44_ = g_strdup_printf ("%s from any", _tmp43_);
#line 140 "../src/UFWHelpers.vala"
				_g_free0 (rule_str);
#line 140 "../src/UFWHelpers.vala"
				rule_str = _tmp44_;
#line 900 "UFWHelpers.c"
			} else {
#line 141 "../src/UFWHelpers.vala"
				if (rule->version == SECURITY_PRIVACY_UFW_HELPERS_RULE_VERSION_IPV6) {
#line 904 "UFWHelpers.c"
					const gchar* _tmp45_;
					gchar* _tmp46_;
#line 142 "../src/UFWHelpers.vala"
					_tmp45_ = rule_str;
#line 142 "../src/UFWHelpers.vala"
					_tmp46_ = g_strdup_printf ("%s from ::/0", _tmp45_);
#line 142 "../src/UFWHelpers.vala"
					_g_free0 (rule_str);
#line 142 "../src/UFWHelpers.vala"
					rule_str = _tmp46_;
#line 915 "UFWHelpers.c"
				} else {
#line 143 "../src/UFWHelpers.vala"
					if (rule->version == SECURITY_PRIVACY_UFW_HELPERS_RULE_VERSION_IPV4) {
#line 919 "UFWHelpers.c"
						const gchar* _tmp47_;
						gchar* _tmp48_;
#line 144 "../src/UFWHelpers.vala"
						_tmp47_ = rule_str;
#line 144 "../src/UFWHelpers.vala"
						_tmp48_ = g_strdup_printf ("%s from 0.0.0.0/0", _tmp47_);
#line 144 "../src/UFWHelpers.vala"
						_g_free0 (rule_str);
#line 144 "../src/UFWHelpers.vala"
						rule_str = _tmp48_;
#line 930 "UFWHelpers.c"
					}
				}
			}
#line 146 "../src/UFWHelpers.vala"
			_tmp49_ = rule->from_ports;
#line 146 "../src/UFWHelpers.vala"
			if (g_strcmp0 (_tmp49_, "") != 0) {
#line 938 "UFWHelpers.c"
				const gchar* _tmp50_;
				const gchar* _tmp51_;
				gchar* _tmp52_;
#line 147 "../src/UFWHelpers.vala"
				_tmp50_ = rule_str;
#line 147 "../src/UFWHelpers.vala"
				_tmp51_ = rule->from_ports;
#line 147 "../src/UFWHelpers.vala"
				_tmp52_ = g_strdup_printf ("%s port %s", _tmp50_, _tmp51_);
#line 147 "../src/UFWHelpers.vala"
				_g_free0 (rule_str);
#line 147 "../src/UFWHelpers.vala"
				rule_str = _tmp52_;
#line 952 "UFWHelpers.c"
			}
		}
#line 150 "../src/UFWHelpers.vala"
		_tmp53_ = security_privacy_ufw_helpers_get_helper_path ();
#line 150 "../src/UFWHelpers.vala"
		_tmp54_ = _tmp53_;
#line 150 "../src/UFWHelpers.vala"
		_tmp55_ = rule_str;
#line 150 "../src/UFWHelpers.vala"
		_tmp56_ = g_strdup_printf ("pkexec %s -5 \"%s\"", _tmp54_, _tmp55_);
#line 150 "../src/UFWHelpers.vala"
		_tmp57_ = _tmp56_;
#line 150 "../src/UFWHelpers.vala"
		g_spawn_command_line_sync (_tmp57_, NULL, NULL, NULL, &_inner_error0_);
#line 150 "../src/UFWHelpers.vala"
		_g_free0 (_tmp57_);
#line 150 "../src/UFWHelpers.vala"
		_g_free0 (_tmp54_);
#line 150 "../src/UFWHelpers.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 973 "UFWHelpers.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp58_;
		const gchar* _tmp59_;
#line 79 "../src/UFWHelpers.vala"
		e = _inner_error0_;
#line 79 "../src/UFWHelpers.vala"
		_inner_error0_ = NULL;
#line 152 "../src/UFWHelpers.vala"
		_tmp58_ = e;
#line 152 "../src/UFWHelpers.vala"
		_tmp59_ = _tmp58_->message;
#line 152 "../src/UFWHelpers.vala"
		g_warning ("UFWHelpers.vala:152: %s", _tmp59_);
#line 79 "../src/UFWHelpers.vala"
		_g_error_free0 (e);
#line 995 "UFWHelpers.c"
	}
	__finally0:
#line 79 "../src/UFWHelpers.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 79 "../src/UFWHelpers.vala"
		_g_free0 (rule_str);
#line 79 "../src/UFWHelpers.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 79 "../src/UFWHelpers.vala"
		g_clear_error (&_inner_error0_);
#line 79 "../src/UFWHelpers.vala"
		return;
#line 1008 "UFWHelpers.c"
	}
#line 77 "../src/UFWHelpers.vala"
	_g_free0 (rule_str);
#line 1012 "UFWHelpers.c"
}

static GType
security_privacy_ufw_helpers_rule_action_get_type_once (void)
{
	static const GEnumValue values[] = {{SECURITY_PRIVACY_UFW_HELPERS_RULE_ACTION_ALLOW, "SECURITY_PRIVACY_UFW_HELPERS_RULE_ACTION_ALLOW", "allow"}, {SECURITY_PRIVACY_UFW_HELPERS_RULE_ACTION_DENY, "SECURITY_PRIVACY_UFW_HELPERS_RULE_ACTION_DENY", "deny"}, {SECURITY_PRIVACY_UFW_HELPERS_RULE_ACTION_REJECT, "SECURITY_PRIVACY_UFW_HELPERS_RULE_ACTION_REJECT", "reject"}, {SECURITY_PRIVACY_UFW_HELPERS_RULE_ACTION_LIMIT, "SECURITY_PRIVACY_UFW_HELPERS_RULE_ACTION_LIMIT", "limit"}, {0, NULL, NULL}};
	GType security_privacy_ufw_helpers_rule_action_type_id;
	security_privacy_ufw_helpers_rule_action_type_id = g_enum_register_static ("SecurityPrivacyUFWHelpersRuleAction", values);
	return security_privacy_ufw_helpers_rule_action_type_id;
}

GType
security_privacy_ufw_helpers_rule_action_get_type (void)
{
	static volatile gsize security_privacy_ufw_helpers_rule_action_type_id__once = 0;
	if (g_once_init_enter (&security_privacy_ufw_helpers_rule_action_type_id__once)) {
		GType security_privacy_ufw_helpers_rule_action_type_id;
		security_privacy_ufw_helpers_rule_action_type_id = security_privacy_ufw_helpers_rule_action_get_type_once ();
		g_once_init_leave (&security_privacy_ufw_helpers_rule_action_type_id__once, security_privacy_ufw_helpers_rule_action_type_id);
	}
	return security_privacy_ufw_helpers_rule_action_type_id__once;
}

static GType
security_privacy_ufw_helpers_rule_protocol_get_type_once (void)
{
	static const GEnumValue values[] = {{SECURITY_PRIVACY_UFW_HELPERS_RULE_PROTOCOL_UDP, "SECURITY_PRIVACY_UFW_HELPERS_RULE_PROTOCOL_UDP", "udp"}, {SECURITY_PRIVACY_UFW_HELPERS_RULE_PROTOCOL_TCP, "SECURITY_PRIVACY_UFW_HELPERS_RULE_PROTOCOL_TCP", "tcp"}, {SECURITY_PRIVACY_UFW_HELPERS_RULE_PROTOCOL_BOTH, "SECURITY_PRIVACY_UFW_HELPERS_RULE_PROTOCOL_BOTH", "both"}, {0, NULL, NULL}};
	GType security_privacy_ufw_helpers_rule_protocol_type_id;
	security_privacy_ufw_helpers_rule_protocol_type_id = g_enum_register_static ("SecurityPrivacyUFWHelpersRuleProtocol", values);
	return security_privacy_ufw_helpers_rule_protocol_type_id;
}

GType
security_privacy_ufw_helpers_rule_protocol_get_type (void)
{
	static volatile gsize security_privacy_ufw_helpers_rule_protocol_type_id__once = 0;
	if (g_once_init_enter (&security_privacy_ufw_helpers_rule_protocol_type_id__once)) {
		GType security_privacy_ufw_helpers_rule_protocol_type_id;
		security_privacy_ufw_helpers_rule_protocol_type_id = security_privacy_ufw_helpers_rule_protocol_get_type_once ();
		g_once_init_leave (&security_privacy_ufw_helpers_rule_protocol_type_id__once, security_privacy_ufw_helpers_rule_protocol_type_id);
	}
	return security_privacy_ufw_helpers_rule_protocol_type_id__once;
}

static GType
security_privacy_ufw_helpers_rule_direction_get_type_once (void)
{
	static const GEnumValue values[] = {{SECURITY_PRIVACY_UFW_HELPERS_RULE_DIRECTION_IN, "SECURITY_PRIVACY_UFW_HELPERS_RULE_DIRECTION_IN", "in"}, {SECURITY_PRIVACY_UFW_HELPERS_RULE_DIRECTION_OUT, "SECURITY_PRIVACY_UFW_HELPERS_RULE_DIRECTION_OUT", "out"}, {0, NULL, NULL}};
	GType security_privacy_ufw_helpers_rule_direction_type_id;
	security_privacy_ufw_helpers_rule_direction_type_id = g_enum_register_static ("SecurityPrivacyUFWHelpersRuleDirection", values);
	return security_privacy_ufw_helpers_rule_direction_type_id;
}

GType
security_privacy_ufw_helpers_rule_direction_get_type (void)
{
	static volatile gsize security_privacy_ufw_helpers_rule_direction_type_id__once = 0;
	if (g_once_init_enter (&security_privacy_ufw_helpers_rule_direction_type_id__once)) {
		GType security_privacy_ufw_helpers_rule_direction_type_id;
		security_privacy_ufw_helpers_rule_direction_type_id = security_privacy_ufw_helpers_rule_direction_get_type_once ();
		g_once_init_leave (&security_privacy_ufw_helpers_rule_direction_type_id__once, security_privacy_ufw_helpers_rule_direction_type_id);
	}
	return security_privacy_ufw_helpers_rule_direction_type_id__once;
}

static GType
security_privacy_ufw_helpers_rule_version_get_type_once (void)
{
	static const GEnumValue values[] = {{SECURITY_PRIVACY_UFW_HELPERS_RULE_VERSION_IPV4, "SECURITY_PRIVACY_UFW_HELPERS_RULE_VERSION_IPV4", "ipv4"}, {SECURITY_PRIVACY_UFW_HELPERS_RULE_VERSION_IPV6, "SECURITY_PRIVACY_UFW_HELPERS_RULE_VERSION_IPV6", "ipv6"}, {SECURITY_PRIVACY_UFW_HELPERS_RULE_VERSION_BOTH, "SECURITY_PRIVACY_UFW_HELPERS_RULE_VERSION_BOTH", "both"}, {0, NULL, NULL}};
	GType security_privacy_ufw_helpers_rule_version_type_id;
	security_privacy_ufw_helpers_rule_version_type_id = g_enum_register_static ("SecurityPrivacyUFWHelpersRuleVersion", values);
	return security_privacy_ufw_helpers_rule_version_type_id;
}

GType
security_privacy_ufw_helpers_rule_version_get_type (void)
{
	static volatile gsize security_privacy_ufw_helpers_rule_version_type_id__once = 0;
	if (g_once_init_enter (&security_privacy_ufw_helpers_rule_version_type_id__once)) {
		GType security_privacy_ufw_helpers_rule_version_type_id;
		security_privacy_ufw_helpers_rule_version_type_id = security_privacy_ufw_helpers_rule_version_get_type_once ();
		g_once_init_leave (&security_privacy_ufw_helpers_rule_version_type_id__once, security_privacy_ufw_helpers_rule_version_type_id);
	}
	return security_privacy_ufw_helpers_rule_version_type_id__once;
}

SecurityPrivacyUFWHelpersRule*
security_privacy_ufw_helpers_rule_construct (GType object_type)
{
	SecurityPrivacyUFWHelpersRule * self = NULL;
#line 191 "../src/UFWHelpers.vala"
	self = (SecurityPrivacyUFWHelpersRule*) g_object_new (object_type, NULL);
#line 191 "../src/UFWHelpers.vala"
	return self;
#line 1107 "UFWHelpers.c"
}

SecurityPrivacyUFWHelpersRule*
security_privacy_ufw_helpers_rule_new (void)
{
#line 191 "../src/UFWHelpers.vala"
	return security_privacy_ufw_helpers_rule_construct (SECURITY_PRIVACY_UFW_HELPERS_TYPE_RULE);
#line 1115 "UFWHelpers.c"
}

static void
security_privacy_ufw_helpers_rule_get_address_and_port (SecurityPrivacyUFWHelpersRule* self,
                                                        const gchar* input,
                                                        SecurityPrivacyUFWHelpersRuleVersion* version,
                                                        gchar** ports,
                                                        gchar** address)
{
	GError* _inner_error0_ = NULL;
#line 195 "../src/UFWHelpers.vala"
	g_return_if_fail (self != NULL);
#line 195 "../src/UFWHelpers.vala"
	g_return_if_fail (input != NULL);
#line 195 "../src/UFWHelpers.vala"
	g_return_if_fail (*ports != NULL);
#line 195 "../src/UFWHelpers.vala"
	g_return_if_fail (*address != NULL);
#line 1134 "UFWHelpers.c"
	{
		gchar** parts = NULL;
		gchar** _tmp0_;
		gchar** _tmp1_;
		gint parts_length1;
		gint _parts_size_;
		gchar** _tmp2_;
		gint _tmp2__length1;
#line 197 "../src/UFWHelpers.vala"
		_tmp1_ = _tmp0_ = g_strsplit (input, " ", 0);
#line 197 "../src/UFWHelpers.vala"
		parts = _tmp1_;
#line 197 "../src/UFWHelpers.vala"
		parts_length1 = _vala_array_length (_tmp0_);
#line 197 "../src/UFWHelpers.vala"
		_parts_size_ = parts_length1;
#line 198 "../src/UFWHelpers.vala"
		_tmp2_ = parts;
#line 198 "../src/UFWHelpers.vala"
		_tmp2__length1 = parts_length1;
#line 198 "../src/UFWHelpers.vala"
		if (_tmp2__length1 > 1) {
#line 1157 "UFWHelpers.c"
			gchar** _tmp3_;
			gint _tmp3__length1;
			const gchar* _tmp4_;
			gchar** _tmp5_;
			gchar** _tmp6_;
			gchar** _tmp7_;
			gint _tmp7__length1;
			const gchar* _tmp8_;
			gchar* _tmp9_;
			gchar** _tmp10_;
			gint _tmp10__length1;
			const gchar* _tmp11_;
			gchar* _tmp12_;
			GInetAddress* ip = NULL;
			gchar** _tmp13_;
			gint _tmp13__length1;
			const gchar* _tmp14_;
			gchar** _tmp15_;
			gchar** _tmp16_;
			gchar** _tmp17_;
			gint _tmp17__length1;
			const gchar* _tmp18_;
			GInetAddress* _tmp19_;
			GInetAddress* _tmp20_;
			GInetAddress* _tmp21_;
#line 199 "../src/UFWHelpers.vala"
			_tmp3_ = parts;
#line 199 "../src/UFWHelpers.vala"
			_tmp3__length1 = parts_length1;
#line 199 "../src/UFWHelpers.vala"
			_tmp4_ = _tmp3_[1];
#line 199 "../src/UFWHelpers.vala"
			_tmp6_ = _tmp5_ = g_strsplit (_tmp4_, "/", 0);
#line 199 "../src/UFWHelpers.vala"
			_tmp7_ = _tmp6_;
#line 199 "../src/UFWHelpers.vala"
			_tmp7__length1 = _vala_array_length (_tmp5_);
#line 199 "../src/UFWHelpers.vala"
			_tmp8_ = _tmp7_[0];
#line 199 "../src/UFWHelpers.vala"
			_tmp9_ = g_strdup (_tmp8_);
#line 199 "../src/UFWHelpers.vala"
			_g_free0 (*ports);
#line 199 "../src/UFWHelpers.vala"
			*ports = _tmp9_;
#line 199 "../src/UFWHelpers.vala"
			_tmp7_ = (_vala_array_free (_tmp7_, _tmp7__length1, (GDestroyNotify) g_free), NULL);
#line 200 "../src/UFWHelpers.vala"
			_tmp10_ = parts;
#line 200 "../src/UFWHelpers.vala"
			_tmp10__length1 = parts_length1;
#line 200 "../src/UFWHelpers.vala"
			_tmp11_ = _tmp10_[0];
#line 200 "../src/UFWHelpers.vala"
			_tmp12_ = g_strdup (_tmp11_);
#line 200 "../src/UFWHelpers.vala"
			_g_free0 (*address);
#line 200 "../src/UFWHelpers.vala"
			*address = _tmp12_;
#line 201 "../src/UFWHelpers.vala"
			_tmp13_ = parts;
#line 201 "../src/UFWHelpers.vala"
			_tmp13__length1 = parts_length1;
#line 201 "../src/UFWHelpers.vala"
			_tmp14_ = _tmp13_[0];
#line 201 "../src/UFWHelpers.vala"
			_tmp16_ = _tmp15_ = g_strsplit (_tmp14_, "/", 0);
#line 201 "../src/UFWHelpers.vala"
			_tmp17_ = _tmp16_;
#line 201 "../src/UFWHelpers.vala"
			_tmp17__length1 = _vala_array_length (_tmp15_);
#line 201 "../src/UFWHelpers.vala"
			_tmp18_ = _tmp17_[0];
#line 201 "../src/UFWHelpers.vala"
			_tmp19_ = g_inet_address_new_from_string (_tmp18_);
#line 201 "../src/UFWHelpers.vala"
			_tmp20_ = _tmp19_;
#line 201 "../src/UFWHelpers.vala"
			_tmp17_ = (_vala_array_free (_tmp17_, _tmp17__length1, (GDestroyNotify) g_free), NULL);
#line 201 "../src/UFWHelpers.vala"
			ip = _tmp20_;
#line 202 "../src/UFWHelpers.vala"
			_tmp21_ = ip;
#line 202 "../src/UFWHelpers.vala"
			if (_tmp21_ != NULL) {
#line 1243 "UFWHelpers.c"
				GInetAddress* _tmp22_;
#line 203 "../src/UFWHelpers.vala"
				_tmp22_ = ip;
#line 203 "../src/UFWHelpers.vala"
				if (g_inet_address_get_family (_tmp22_) == G_SOCKET_FAMILY_IPV6) {
#line 204 "../src/UFWHelpers.vala"
					*version = SECURITY_PRIVACY_UFW_HELPERS_RULE_VERSION_IPV6;
#line 1251 "UFWHelpers.c"
				} else {
#line 206 "../src/UFWHelpers.vala"
					*version = SECURITY_PRIVACY_UFW_HELPERS_RULE_VERSION_IPV4;
#line 1255 "UFWHelpers.c"
				}
			}
#line 198 "../src/UFWHelpers.vala"
			_g_object_unref0 (ip);
#line 1260 "UFWHelpers.c"
		} else {
			gchar** ip_parts = NULL;
			gchar** _tmp23_;
			gint _tmp23__length1;
			const gchar* _tmp24_;
			gchar** _tmp25_;
			gchar** _tmp26_;
			gint ip_parts_length1;
			gint _ip_parts_size_;
			gchar** _tmp27_;
			gint _tmp27__length1;
#line 210 "../src/UFWHelpers.vala"
			_tmp23_ = parts;
#line 210 "../src/UFWHelpers.vala"
			_tmp23__length1 = parts_length1;
#line 210 "../src/UFWHelpers.vala"
			_tmp24_ = _tmp23_[0];
#line 210 "../src/UFWHelpers.vala"
			_tmp26_ = _tmp25_ = g_strsplit (_tmp24_, "/", 0);
#line 210 "../src/UFWHelpers.vala"
			ip_parts = _tmp26_;
#line 210 "../src/UFWHelpers.vala"
			ip_parts_length1 = _vala_array_length (_tmp25_);
#line 210 "../src/UFWHelpers.vala"
			_ip_parts_size_ = ip_parts_length1;
#line 211 "../src/UFWHelpers.vala"
			_tmp27_ = ip_parts;
#line 211 "../src/UFWHelpers.vala"
			_tmp27__length1 = ip_parts_length1;
#line 211 "../src/UFWHelpers.vala"
			if (_tmp27__length1 > 1) {
#line 1292 "UFWHelpers.c"
				gboolean _tmp28_ = FALSE;
				gchar** _tmp29_;
				gint _tmp29__length1;
				const gchar* _tmp30_;
#line 212 "../src/UFWHelpers.vala"
				_tmp29_ = ip_parts;
#line 212 "../src/UFWHelpers.vala"
				_tmp29__length1 = ip_parts_length1;
#line 212 "../src/UFWHelpers.vala"
				_tmp30_ = _tmp29_[1];
#line 212 "../src/UFWHelpers.vala"
				if (g_strcmp0 (_tmp30_, "tcp") == 0) {
#line 212 "../src/UFWHelpers.vala"
					_tmp28_ = TRUE;
#line 1307 "UFWHelpers.c"
				} else {
					gchar** _tmp31_;
					gint _tmp31__length1;
					const gchar* _tmp32_;
#line 212 "../src/UFWHelpers.vala"
					_tmp31_ = ip_parts;
#line 212 "../src/UFWHelpers.vala"
					_tmp31__length1 = ip_parts_length1;
#line 212 "../src/UFWHelpers.vala"
					_tmp32_ = _tmp31_[1];
#line 212 "../src/UFWHelpers.vala"
					_tmp28_ = g_strcmp0 (_tmp32_, "udp") == 0;
#line 1320 "UFWHelpers.c"
				}
#line 212 "../src/UFWHelpers.vala"
				if (_tmp28_) {
#line 1324 "UFWHelpers.c"
					gchar** _tmp33_;
					gint _tmp33__length1;
					const gchar* _tmp34_;
					gchar* _tmp35_;
#line 213 "../src/UFWHelpers.vala"
					_tmp33_ = ip_parts;
#line 213 "../src/UFWHelpers.vala"
					_tmp33__length1 = ip_parts_length1;
#line 213 "../src/UFWHelpers.vala"
					_tmp34_ = _tmp33_[0];
#line 213 "../src/UFWHelpers.vala"
					_tmp35_ = g_strdup (_tmp34_);
#line 213 "../src/UFWHelpers.vala"
					_g_free0 (*ports);
#line 213 "../src/UFWHelpers.vala"
					*ports = _tmp35_;
#line 1341 "UFWHelpers.c"
				} else {
					gchar** _tmp36_;
					gint _tmp36__length1;
					const gchar* _tmp37_;
					gchar* _tmp38_;
					GInetAddress* ip = NULL;
					gchar** _tmp39_;
					gint _tmp39__length1;
					const gchar* _tmp40_;
					GInetAddress* _tmp41_;
					GInetAddress* _tmp42_;
#line 215 "../src/UFWHelpers.vala"
					_tmp36_ = parts;
#line 215 "../src/UFWHelpers.vala"
					_tmp36__length1 = parts_length1;
#line 215 "../src/UFWHelpers.vala"
					_tmp37_ = _tmp36_[0];
#line 215 "../src/UFWHelpers.vala"
					_tmp38_ = g_strdup (_tmp37_);
#line 215 "../src/UFWHelpers.vala"
					_g_free0 (*address);
#line 215 "../src/UFWHelpers.vala"
					*address = _tmp38_;
#line 216 "../src/UFWHelpers.vala"
					_tmp39_ = ip_parts;
#line 216 "../src/UFWHelpers.vala"
					_tmp39__length1 = ip_parts_length1;
#line 216 "../src/UFWHelpers.vala"
					_tmp40_ = _tmp39_[0];
#line 216 "../src/UFWHelpers.vala"
					_tmp41_ = g_inet_address_new_from_string (_tmp40_);
#line 216 "../src/UFWHelpers.vala"
					ip = _tmp41_;
#line 217 "../src/UFWHelpers.vala"
					_tmp42_ = ip;
#line 217 "../src/UFWHelpers.vala"
					if (_tmp42_ != NULL) {
#line 1379 "UFWHelpers.c"
						GInetAddress* _tmp43_;
#line 218 "../src/UFWHelpers.vala"
						_tmp43_ = ip;
#line 218 "../src/UFWHelpers.vala"
						if (g_inet_address_get_family (_tmp43_) == G_SOCKET_FAMILY_IPV6) {
#line 219 "../src/UFWHelpers.vala"
							*version = SECURITY_PRIVACY_UFW_HELPERS_RULE_VERSION_IPV6;
#line 1387 "UFWHelpers.c"
						} else {
#line 221 "../src/UFWHelpers.vala"
							*version = SECURITY_PRIVACY_UFW_HELPERS_RULE_VERSION_IPV4;
#line 1391 "UFWHelpers.c"
						}
					}
#line 212 "../src/UFWHelpers.vala"
					_g_object_unref0 (ip);
#line 1396 "UFWHelpers.c"
				}
			} else {
				GInetAddress* ip = NULL;
				gchar** _tmp44_;
				gint _tmp44__length1;
				const gchar* _tmp45_;
				GInetAddress* _tmp46_;
				GInetAddress* _tmp47_;
#line 226 "../src/UFWHelpers.vala"
				_tmp44_ = ip_parts;
#line 226 "../src/UFWHelpers.vala"
				_tmp44__length1 = ip_parts_length1;
#line 226 "../src/UFWHelpers.vala"
				_tmp45_ = _tmp44_[0];
#line 226 "../src/UFWHelpers.vala"
				_tmp46_ = g_inet_address_new_from_string (_tmp45_);
#line 226 "../src/UFWHelpers.vala"
				ip = _tmp46_;
#line 227 "../src/UFWHelpers.vala"
				_tmp47_ = ip;
#line 227 "../src/UFWHelpers.vala"
				if (_tmp47_ == NULL) {
#line 1419 "UFWHelpers.c"
					gchar** _tmp48_;
					gint _tmp48__length1;
					const gchar* _tmp49_;
#line 228 "../src/UFWHelpers.vala"
					_tmp48_ = ip_parts;
#line 228 "../src/UFWHelpers.vala"
					_tmp48__length1 = ip_parts_length1;
#line 228 "../src/UFWHelpers.vala"
					_tmp49_ = _tmp48_[0];
#line 228 "../src/UFWHelpers.vala"
					if (string_contains (_tmp49_, "Anywhere")) {
#line 1431 "UFWHelpers.c"
						gchar* _tmp50_;
#line 229 "../src/UFWHelpers.vala"
						_tmp50_ = g_strdup ("Anywhere");
#line 229 "../src/UFWHelpers.vala"
						_g_free0 (*address);
#line 229 "../src/UFWHelpers.vala"
						*address = _tmp50_;
#line 1439 "UFWHelpers.c"
					} else {
						gchar** _tmp51_;
						gint _tmp51__length1;
						const gchar* _tmp52_;
						gchar* _tmp53_;
#line 231 "../src/UFWHelpers.vala"
						_tmp51_ = ip_parts;
#line 231 "../src/UFWHelpers.vala"
						_tmp51__length1 = ip_parts_length1;
#line 231 "../src/UFWHelpers.vala"
						_tmp52_ = _tmp51_[0];
#line 231 "../src/UFWHelpers.vala"
						_tmp53_ = g_strdup (_tmp52_);
#line 231 "../src/UFWHelpers.vala"
						_g_free0 (*ports);
#line 231 "../src/UFWHelpers.vala"
						*ports = _tmp53_;
#line 1457 "UFWHelpers.c"
					}
				} else {
					GInetAddress* _tmp54_;
#line 233 "../src/UFWHelpers.vala"
					_tmp54_ = ip;
#line 233 "../src/UFWHelpers.vala"
					if (g_inet_address_get_family (_tmp54_) == G_SOCKET_FAMILY_IPV6) {
#line 1465 "UFWHelpers.c"
						gchar** _tmp55_;
						gint _tmp55__length1;
						const gchar* _tmp56_;
						gchar* _tmp57_;
#line 234 "../src/UFWHelpers.vala"
						_tmp55_ = ip_parts;
#line 234 "../src/UFWHelpers.vala"
						_tmp55__length1 = ip_parts_length1;
#line 234 "../src/UFWHelpers.vala"
						_tmp56_ = _tmp55_[0];
#line 234 "../src/UFWHelpers.vala"
						_tmp57_ = g_strdup (_tmp56_);
#line 234 "../src/UFWHelpers.vala"
						_g_free0 (*address);
#line 234 "../src/UFWHelpers.vala"
						*address = _tmp57_;
#line 235 "../src/UFWHelpers.vala"
						*version = SECURITY_PRIVACY_UFW_HELPERS_RULE_VERSION_IPV6;
#line 1484 "UFWHelpers.c"
					} else {
						GInetAddress* _tmp58_;
#line 236 "../src/UFWHelpers.vala"
						_tmp58_ = ip;
#line 236 "../src/UFWHelpers.vala"
						if (g_inet_address_get_family (_tmp58_) == G_SOCKET_FAMILY_IPV4) {
#line 1491 "UFWHelpers.c"
							gchar** _tmp59_;
							gint _tmp59__length1;
							const gchar* _tmp60_;
							gchar* _tmp61_;
#line 237 "../src/UFWHelpers.vala"
							_tmp59_ = ip_parts;
#line 237 "../src/UFWHelpers.vala"
							_tmp59__length1 = ip_parts_length1;
#line 237 "../src/UFWHelpers.vala"
							_tmp60_ = _tmp59_[0];
#line 237 "../src/UFWHelpers.vala"
							_tmp61_ = g_strdup (_tmp60_);
#line 237 "../src/UFWHelpers.vala"
							_g_free0 (*address);
#line 237 "../src/UFWHelpers.vala"
							*address = _tmp61_;
#line 238 "../src/UFWHelpers.vala"
							*version = SECURITY_PRIVACY_UFW_HELPERS_RULE_VERSION_IPV4;
#line 1510 "UFWHelpers.c"
						}
					}
				}
#line 211 "../src/UFWHelpers.vala"
				_g_object_unref0 (ip);
#line 1516 "UFWHelpers.c"
			}
#line 198 "../src/UFWHelpers.vala"
			ip_parts = (_vala_array_free (ip_parts, ip_parts_length1, (GDestroyNotify) g_free), NULL);
#line 1520 "UFWHelpers.c"
		}
#line 196 "../src/UFWHelpers.vala"
		parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 1524 "UFWHelpers.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		gchar* _tmp62_;
		gchar* _tmp63_;
		GError* _tmp64_;
		const gchar* _tmp65_;
#line 196 "../src/UFWHelpers.vala"
		e = _inner_error0_;
#line 196 "../src/UFWHelpers.vala"
		_inner_error0_ = NULL;
#line 243 "../src/UFWHelpers.vala"
		_tmp62_ = g_strdup_printf ("Error parsing to/from address: %s", input);
#line 243 "../src/UFWHelpers.vala"
		_tmp63_ = _tmp62_;
#line 243 "../src/UFWHelpers.vala"
		g_warning ("UFWHelpers.vala:243: %s", _tmp63_);
#line 243 "../src/UFWHelpers.vala"
		_g_free0 (_tmp63_);
#line 244 "../src/UFWHelpers.vala"
		_tmp64_ = e;
#line 244 "../src/UFWHelpers.vala"
		_tmp65_ = _tmp64_->message;
#line 244 "../src/UFWHelpers.vala"
		g_warning ("UFWHelpers.vala:244: %s", _tmp65_);
#line 196 "../src/UFWHelpers.vala"
		_g_error_free0 (e);
#line 1554 "UFWHelpers.c"
	}
	__finally0:
#line 196 "../src/UFWHelpers.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 196 "../src/UFWHelpers.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 196 "../src/UFWHelpers.vala"
		g_clear_error (&_inner_error0_);
#line 196 "../src/UFWHelpers.vala"
		return;
#line 1565 "UFWHelpers.c"
	}
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1588 "UFWHelpers.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1592 "UFWHelpers.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1598 "UFWHelpers.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1602 "UFWHelpers.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1606 "UFWHelpers.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 1614 "UFWHelpers.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1642 "UFWHelpers.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 1651 "UFWHelpers.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1665 "UFWHelpers.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 1674 "UFWHelpers.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 1688 "UFWHelpers.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1697 "UFWHelpers.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 1706 "UFWHelpers.c"
}

SecurityPrivacyUFWHelpersRule*
security_privacy_ufw_helpers_rule_construct_from_line (GType object_type,
                                                       const gchar* line)
{
	SecurityPrivacyUFWHelpersRule * self = NULL;
	GError* _inner_error0_ = NULL;
#line 248 "../src/UFWHelpers.vala"
	g_return_val_if_fail (line != NULL, NULL);
#line 248 "../src/UFWHelpers.vala"
	self = (SecurityPrivacyUFWHelpersRule*) g_object_new (object_type, NULL);
#line 249 "../src/UFWHelpers.vala"
	if (string_contains (line, "(v6)")) {
#line 250 "../src/UFWHelpers.vala"
		self->version = SECURITY_PRIVACY_UFW_HELPERS_RULE_VERSION_IPV6;
#line 1723 "UFWHelpers.c"
	} else {
#line 252 "../src/UFWHelpers.vala"
		self->version = SECURITY_PRIVACY_UFW_HELPERS_RULE_VERSION_IPV4;
#line 1727 "UFWHelpers.c"
	}
#line 255 "../src/UFWHelpers.vala"
	if (string_contains (line, "tcp")) {
#line 256 "../src/UFWHelpers.vala"
		self->protocol = SECURITY_PRIVACY_UFW_HELPERS_RULE_PROTOCOL_TCP;
#line 1733 "UFWHelpers.c"
	} else {
#line 257 "../src/UFWHelpers.vala"
		if (string_contains (line, "udp")) {
#line 258 "../src/UFWHelpers.vala"
			self->protocol = SECURITY_PRIVACY_UFW_HELPERS_RULE_PROTOCOL_UDP;
#line 1739 "UFWHelpers.c"
		} else {
#line 260 "../src/UFWHelpers.vala"
			self->protocol = SECURITY_PRIVACY_UFW_HELPERS_RULE_PROTOCOL_BOTH;
#line 1743 "UFWHelpers.c"
		}
	}
	{
		GRegex* r = NULL;
		GRegex* _tmp0_;
		GMatchInfo* info = NULL;
		GRegex* _tmp1_;
		GMatchInfo* _tmp2_ = NULL;
		GMatchInfo* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* to_match = NULL;
		GMatchInfo* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* from_match = NULL;
		GMatchInfo* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		gchar* type = NULL;
		GMatchInfo* _tmp18_;
		gchar* _tmp19_;
		const gchar* _tmp20_;
		const gchar* _tmp24_;
#line 265 "../src/UFWHelpers.vala"
		_tmp0_ = g_regex_new ("\\[\\s*(\\d+)\\]\\s{1}([A-Za-z0-9 \\(\\)/\\.:,]+?)\\s{2,}([A-Z ]+?)\\s" \
"{2,}([A-Za-z0-9 \\(\\)/\\.:,]+?)(?:\\s{2,}.*)?$", 0, 0, &_inner_error0_);
#line 265 "../src/UFWHelpers.vala"
		r = _tmp0_;
#line 265 "../src/UFWHelpers.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1780 "UFWHelpers.c"
			goto __catch0_g_error;
		}
#line 267 "../src/UFWHelpers.vala"
		_tmp1_ = r;
#line 267 "../src/UFWHelpers.vala"
		g_regex_match (_tmp1_, line, 0, &_tmp2_);
#line 267 "../src/UFWHelpers.vala"
		_g_match_info_unref0 (info);
#line 267 "../src/UFWHelpers.vala"
		info = _tmp2_;
#line 269 "../src/UFWHelpers.vala"
		_tmp3_ = info;
#line 269 "../src/UFWHelpers.vala"
		_tmp4_ = g_match_info_fetch (_tmp3_, 1);
#line 269 "../src/UFWHelpers.vala"
		_tmp5_ = _tmp4_;
#line 269 "../src/UFWHelpers.vala"
		self->number = atoi (_tmp5_);
#line 269 "../src/UFWHelpers.vala"
		_g_free0 (_tmp5_);
#line 271 "../src/UFWHelpers.vala"
		_tmp6_ = info;
#line 271 "../src/UFWHelpers.vala"
		_tmp7_ = g_match_info_fetch (_tmp6_, 2);
#line 271 "../src/UFWHelpers.vala"
		_tmp8_ = _tmp7_;
#line 271 "../src/UFWHelpers.vala"
		_tmp9_ = string_replace (_tmp8_, " (v6)", "");
#line 271 "../src/UFWHelpers.vala"
		_tmp10_ = _tmp9_;
#line 271 "../src/UFWHelpers.vala"
		_g_free0 (_tmp8_);
#line 271 "../src/UFWHelpers.vala"
		to_match = _tmp10_;
#line 272 "../src/UFWHelpers.vala"
		_tmp11_ = info;
#line 272 "../src/UFWHelpers.vala"
		_tmp12_ = g_match_info_fetch (_tmp11_, 4);
#line 272 "../src/UFWHelpers.vala"
		_tmp13_ = _tmp12_;
#line 272 "../src/UFWHelpers.vala"
		_tmp14_ = string_replace (_tmp13_, " (v6)", "");
#line 272 "../src/UFWHelpers.vala"
		_tmp15_ = _tmp14_;
#line 272 "../src/UFWHelpers.vala"
		_g_free0 (_tmp13_);
#line 272 "../src/UFWHelpers.vala"
		from_match = _tmp15_;
#line 274 "../src/UFWHelpers.vala"
		_tmp16_ = to_match;
#line 274 "../src/UFWHelpers.vala"
		security_privacy_ufw_helpers_rule_get_address_and_port (self, _tmp16_, &self->version, &self->to_ports, &self->to);
#line 275 "../src/UFWHelpers.vala"
		_tmp17_ = from_match;
#line 275 "../src/UFWHelpers.vala"
		security_privacy_ufw_helpers_rule_get_address_and_port (self, _tmp17_, &self->version, &self->from_ports, &self->from);
#line 277 "../src/UFWHelpers.vala"
		_tmp18_ = info;
#line 277 "../src/UFWHelpers.vala"
		_tmp19_ = g_match_info_fetch (_tmp18_, 3);
#line 277 "../src/UFWHelpers.vala"
		type = _tmp19_;
#line 279 "../src/UFWHelpers.vala"
		_tmp20_ = type;
#line 279 "../src/UFWHelpers.vala"
		if (string_contains (_tmp20_, "ALLOW")) {
#line 280 "../src/UFWHelpers.vala"
			self->action = SECURITY_PRIVACY_UFW_HELPERS_RULE_ACTION_ALLOW;
#line 1849 "UFWHelpers.c"
		} else {
			const gchar* _tmp21_;
#line 281 "../src/UFWHelpers.vala"
			_tmp21_ = type;
#line 281 "../src/UFWHelpers.vala"
			if (string_contains (_tmp21_, "DENY")) {
#line 282 "../src/UFWHelpers.vala"
				self->action = SECURITY_PRIVACY_UFW_HELPERS_RULE_ACTION_DENY;
#line 1858 "UFWHelpers.c"
			} else {
				const gchar* _tmp22_;
#line 283 "../src/UFWHelpers.vala"
				_tmp22_ = type;
#line 283 "../src/UFWHelpers.vala"
				if (string_contains (_tmp22_, "REJECT")) {
#line 284 "../src/UFWHelpers.vala"
					self->action = SECURITY_PRIVACY_UFW_HELPERS_RULE_ACTION_REJECT;
#line 1867 "UFWHelpers.c"
				} else {
					const gchar* _tmp23_;
#line 285 "../src/UFWHelpers.vala"
					_tmp23_ = type;
#line 285 "../src/UFWHelpers.vala"
					if (string_contains (_tmp23_, "LIMIT")) {
#line 286 "../src/UFWHelpers.vala"
						self->action = SECURITY_PRIVACY_UFW_HELPERS_RULE_ACTION_LIMIT;
#line 1876 "UFWHelpers.c"
					}
				}
			}
		}
#line 289 "../src/UFWHelpers.vala"
		_tmp24_ = type;
#line 289 "../src/UFWHelpers.vala"
		if (string_contains (_tmp24_, "IN")) {
#line 290 "../src/UFWHelpers.vala"
			self->direction = SECURITY_PRIVACY_UFW_HELPERS_RULE_DIRECTION_IN;
#line 1887 "UFWHelpers.c"
		} else {
			const gchar* _tmp25_;
#line 291 "../src/UFWHelpers.vala"
			_tmp25_ = type;
#line 291 "../src/UFWHelpers.vala"
			if (string_contains (_tmp25_, "OUT")) {
#line 292 "../src/UFWHelpers.vala"
				self->direction = SECURITY_PRIVACY_UFW_HELPERS_RULE_DIRECTION_OUT;
#line 1896 "UFWHelpers.c"
			}
		}
#line 263 "../src/UFWHelpers.vala"
		_g_free0 (type);
#line 263 "../src/UFWHelpers.vala"
		_g_free0 (from_match);
#line 263 "../src/UFWHelpers.vala"
		_g_free0 (to_match);
#line 263 "../src/UFWHelpers.vala"
		_g_match_info_unref0 (info);
#line 263 "../src/UFWHelpers.vala"
		_g_regex_unref0 (r);
#line 1909 "UFWHelpers.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 263 "../src/UFWHelpers.vala"
		g_clear_error (&_inner_error0_);
#line 295 "../src/UFWHelpers.vala"
		return self;
#line 1918 "UFWHelpers.c"
	}
	__finally0:
#line 263 "../src/UFWHelpers.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 263 "../src/UFWHelpers.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 263 "../src/UFWHelpers.vala"
		g_clear_error (&_inner_error0_);
#line 263 "../src/UFWHelpers.vala"
		return NULL;
#line 1929 "UFWHelpers.c"
	}
#line 248 "../src/UFWHelpers.vala"
	return self;
#line 1933 "UFWHelpers.c"
}

SecurityPrivacyUFWHelpersRule*
security_privacy_ufw_helpers_rule_new_from_line (const gchar* line)
{
#line 248 "../src/UFWHelpers.vala"
	return security_privacy_ufw_helpers_rule_construct_from_line (SECURITY_PRIVACY_UFW_HELPERS_TYPE_RULE, line);
#line 1941 "UFWHelpers.c"
}

static void
security_privacy_ufw_helpers_rule_class_init (SecurityPrivacyUFWHelpersRuleClass * klass,
                                              gpointer klass_data)
{
#line 156 "../src/UFWHelpers.vala"
	security_privacy_ufw_helpers_rule_parent_class = g_type_class_peek_parent (klass);
#line 156 "../src/UFWHelpers.vala"
	G_OBJECT_CLASS (klass)->finalize = security_privacy_ufw_helpers_rule_finalize;
#line 1952 "UFWHelpers.c"
}

static void
security_privacy_ufw_helpers_rule_instance_init (SecurityPrivacyUFWHelpersRule * self,
                                                 gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 184 "../src/UFWHelpers.vala"
	_tmp0_ = g_strdup ("");
#line 184 "../src/UFWHelpers.vala"
	self->to_ports = _tmp0_;
#line 185 "../src/UFWHelpers.vala"
	_tmp1_ = g_strdup ("");
#line 185 "../src/UFWHelpers.vala"
	self->from_ports = _tmp1_;
#line 186 "../src/UFWHelpers.vala"
	_tmp2_ = g_strdup ("");
#line 186 "../src/UFWHelpers.vala"
	self->to = _tmp2_;
#line 187 "../src/UFWHelpers.vala"
	_tmp3_ = g_strdup ("");
#line 187 "../src/UFWHelpers.vala"
	self->from = _tmp3_;
#line 188 "../src/UFWHelpers.vala"
	self->version = SECURITY_PRIVACY_UFW_HELPERS_RULE_VERSION_BOTH;
#line 1981 "UFWHelpers.c"
}

static void
security_privacy_ufw_helpers_rule_finalize (GObject * obj)
{
	SecurityPrivacyUFWHelpersRule * self;
#line 156 "../src/UFWHelpers.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SECURITY_PRIVACY_UFW_HELPERS_TYPE_RULE, SecurityPrivacyUFWHelpersRule);
#line 184 "../src/UFWHelpers.vala"
	_g_free0 (self->to_ports);
#line 185 "../src/UFWHelpers.vala"
	_g_free0 (self->from_ports);
#line 186 "../src/UFWHelpers.vala"
	_g_free0 (self->to);
#line 187 "../src/UFWHelpers.vala"
	_g_free0 (self->from);
#line 156 "../src/UFWHelpers.vala"
	G_OBJECT_CLASS (security_privacy_ufw_helpers_rule_parent_class)->finalize (obj);
#line 2000 "UFWHelpers.c"
}

static GType
security_privacy_ufw_helpers_rule_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SecurityPrivacyUFWHelpersRuleClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) security_privacy_ufw_helpers_rule_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SecurityPrivacyUFWHelpersRule), 0, (GInstanceInitFunc) security_privacy_ufw_helpers_rule_instance_init, NULL };
	GType security_privacy_ufw_helpers_rule_type_id;
	security_privacy_ufw_helpers_rule_type_id = g_type_register_static (G_TYPE_OBJECT, "SecurityPrivacyUFWHelpersRule", &g_define_type_info, 0);
	return security_privacy_ufw_helpers_rule_type_id;
}

GType
security_privacy_ufw_helpers_rule_get_type (void)
{
	static volatile gsize security_privacy_ufw_helpers_rule_type_id__once = 0;
	if (g_once_init_enter (&security_privacy_ufw_helpers_rule_type_id__once)) {
		GType security_privacy_ufw_helpers_rule_type_id;
		security_privacy_ufw_helpers_rule_type_id = security_privacy_ufw_helpers_rule_get_type_once ();
		g_once_init_leave (&security_privacy_ufw_helpers_rule_type_id__once, security_privacy_ufw_helpers_rule_type_id);
	}
	return security_privacy_ufw_helpers_rule_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

