/* FirewallPanel.c generated by valac 0.56.17, the Vala compiler
 * generated from FirewallPanel.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2014-2018 elementary LLC. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Corentin Noël <tintou@mailoo.org>
 */

#include "security-privacy.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <gio/gio.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <polkit/polkit.h>
#include <glib/gi18n-lib.h>
#include <granite-7.h>
#include <switchboard.h>
#include <float.h>
#include <math.h>
#include <unistd.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SECURITY_PRIVACY_FIREWALL_PANEL_0_PROPERTY,
	SECURITY_PRIVACY_FIREWALL_PANEL_NUM_PROPERTIES
};
static GParamSpec* security_privacy_firewall_panel_properties[SECURITY_PRIVACY_FIREWALL_PANEL_NUM_PROPERTIES];
typedef enum  {
	SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_ACTION,
	SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_PROTOCOL,
	SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_DIRECTION,
	SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_TO,
	SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_FROM,
	SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_V6,
	SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_ENABLED,
	SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_RULE,
	SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_N_COLUMNS
} SecurityPrivacyFirewallPanelColumns;

#define SECURITY_PRIVACY_FIREWALL_PANEL_TYPE_COLUMNS (security_privacy_firewall_panel_columns_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_iter_free0(var) ((var == NULL) ? NULL : (var = (g_variant_iter_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_variant_builder_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_builder_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _Block2Data Block2Data;
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))
typedef struct _Block3Data Block3Data;
typedef struct _Block4Data Block4Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _SecurityPrivacyFirewallPanelPrivate {
	GtkFrame* frame;
	GtkListStore* list_store;
	GtkTreeView* view;
	gboolean loading;
	GtkButton* remove_button;
	GSettings* settings;
	GeeHashMap* disabled_rules;
	PolkitPermission* permission;
};

struct _Block1Data {
	int _ref_count_;
	SecurityPrivacyFirewallPanel* self;
	SecurityPrivacyUFWHelpersRule* rule;
	gchar* ufw_hash;
};

struct _Block2Data {
	int _ref_count_;
	SecurityPrivacyFirewallPanel* self;
	GtkButton* add_button;
};

struct _Block3Data {
	int _ref_count_;
	Block2Data * _data2_;
	GtkComboBoxText* policy_combobox;
	GtkComboBoxText* protocol_combobox;
	GtkComboBoxText* version_combobox;
	GtkComboBoxText* direction_combobox;
	GtkEntry* ports_entry;
	GtkPopover* add_popover;
};

struct _Block4Data {
	int _ref_count_;
	SecurityPrivacyFirewallPanel* self;
	GtkButton* lock_button;
};

static gint SecurityPrivacyFirewallPanel_private_offset;
static gpointer security_privacy_firewall_panel_parent_class = NULL;

static GType security_privacy_firewall_panel_columns_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static void security_privacy_firewall_panel_load_disabled_rules (SecurityPrivacyFirewallPanel* self);
static gchar* security_privacy_firewall_panel_generate_hash_for_rule (SecurityPrivacyFirewallPanel* self,
                                                               SecurityPrivacyUFWHelpersRule* r);
static void security_privacy_firewall_panel_reload_rule_numbers (SecurityPrivacyFirewallPanel* self);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean ____lambda16_ (Block1Data* _data1_,
                        GtkTreeModel* model,
                        GtkTreePath* path,
                        GtkTreeIter* iter);
static gboolean _____lambda16__gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                     GtkTreePath* path,
                                                     GtkTreeIter* iter,
                                                     gpointer self);
static void security_privacy_firewall_panel_show_rules (SecurityPrivacyFirewallPanel* self);
static void security_privacy_firewall_panel_disable_rule (SecurityPrivacyFirewallPanel* self,
                                                   SecurityPrivacyUFWHelpersRule* rule);
static void security_privacy_firewall_panel_save_disabled_rules (SecurityPrivacyFirewallPanel* self,
                                                          SecurityPrivacyUFWHelpersRule* additional_rule);
static void security_privacy_firewall_panel_enable_rule (SecurityPrivacyFirewallPanel* self,
                                                  const gchar* hash);
static void security_privacy_firewall_panel_delete_disabled_rule (SecurityPrivacyFirewallPanel* self,
                                                           const gchar* hash);
static void security_privacy_firewall_panel_create_treeview (SecurityPrivacyFirewallPanel* self);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void __lambda17_ (SecurityPrivacyFirewallPanel* self,
                  const gchar* path);
static void _vala_GtkTreePath_free (GtkTreePath* self);
static void ___lambda17__gtk_cell_renderer_toggle_toggled (GtkCellRendererToggle* _sender,
                                                    const gchar* path,
                                                    gpointer self);
static void __lambda18_ (SecurityPrivacyFirewallPanel* self);
static void ___lambda18__gtk_tree_view_cursor_changed (GtkTreeView* _sender,
                                                gpointer self);
static void __lambda19_ (Block2Data* _data2_);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void __lambda20_ (Block3Data* _data3_);
static void ___lambda20__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void ___lambda19__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void __lambda21_ (SecurityPrivacyFirewallPanel* self);
static void ___lambda21__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void security_privacy_firewall_panel_update_status (SecurityPrivacyFirewallPanel* self);
static GObject * security_privacy_firewall_panel_constructor (GType type,
                                                       guint n_construct_properties,
                                                       GObjectConstructParam * construct_properties);
static void _security_privacy_firewall_panel___lambda22_ (SecurityPrivacyFirewallPanel* self);
static void __security_privacy_firewall_panel___lambda22__g_object_notify (GObject* _sender,
                                                                    GParamSpec* pspec,
                                                                    gpointer self);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void _security_privacy_firewall_panel____lambda23_ (Block4Data* _data4_);
static void __security_privacy_firewall_panel____lambda23__g_object_notify (GObject* _sender,
                                                                     GParamSpec* pspec,
                                                                     gpointer self);
static void _security_privacy_firewall_panel____lambda24_ (SecurityPrivacyFirewallPanel* self);
static void _gtk_window_destroy_gtk_dialog_response (GtkDialog* _sender,
                                              gint response_id,
                                              gpointer self);
static void __security_privacy_firewall_panel____lambda24__gtk_button_clicked (GtkButton* _sender,
                                                                        gpointer self);
static void security_privacy_firewall_panel_finalize (GObject * obj);
static GType security_privacy_firewall_panel_get_type_once (void);

static inline gpointer
security_privacy_firewall_panel_get_instance_private (SecurityPrivacyFirewallPanel* self)
{
	return G_STRUCT_MEMBER_P (self, SecurityPrivacyFirewallPanel_private_offset);
}

static GType
security_privacy_firewall_panel_columns_get_type_once (void)
{
	static const GEnumValue values[] = {{SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_ACTION, "SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_ACTION", "action"}, {SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_PROTOCOL, "SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_PROTOCOL", "protocol"}, {SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_DIRECTION, "SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_DIRECTION", "direction"}, {SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_TO, "SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_TO", "to"}, {SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_FROM, "SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_FROM", "from"}, {SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_V6, "SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_V6", "v6"}, {SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_ENABLED, "SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_ENABLED", "enabled"}, {SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_RULE, "SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_RULE", "rule"}, {SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_N_COLUMNS, "SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_N_COLUMNS", "n-columns"}, {0, NULL, NULL}};
	GType security_privacy_firewall_panel_columns_type_id;
	security_privacy_firewall_panel_columns_type_id = g_enum_register_static ("SecurityPrivacyFirewallPanelColumns", values);
	return security_privacy_firewall_panel_columns_type_id;
}

static GType
security_privacy_firewall_panel_columns_get_type (void)
{
	static volatile gsize security_privacy_firewall_panel_columns_type_id__once = 0;
	if (g_once_init_enter (&security_privacy_firewall_panel_columns_type_id__once)) {
		GType security_privacy_firewall_panel_columns_type_id;
		security_privacy_firewall_panel_columns_type_id = security_privacy_firewall_panel_columns_get_type_once ();
		g_once_init_leave (&security_privacy_firewall_panel_columns_type_id__once, security_privacy_firewall_panel_columns_type_id);
	}
	return security_privacy_firewall_panel_columns_type_id__once;
}

SecurityPrivacyFirewallPanel*
security_privacy_firewall_panel_construct (GType object_type)
{
	SecurityPrivacyFirewallPanel * self = NULL;
	GThemedIcon* _tmp0_;
	GThemedIcon* _tmp1_;
#line 46 "../src/Views/FirewallPanel.vala"
	_tmp0_ = (GThemedIcon*) g_themed_icon_new ("network-firewall");
#line 46 "../src/Views/FirewallPanel.vala"
	_tmp1_ = _tmp0_;
#line 46 "../src/Views/FirewallPanel.vala"
	self = (SecurityPrivacyFirewallPanel*) g_object_new (object_type, "activatable", TRUE, "icon", _tmp1_, "title", _ ("Firewall"), NULL);
#line 46 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (_tmp1_);
#line 45 "../src/Views/FirewallPanel.vala"
	return self;
#line 241 "FirewallPanel.c"
}

SecurityPrivacyFirewallPanel*
security_privacy_firewall_panel_new (void)
{
#line 45 "../src/Views/FirewallPanel.vala"
	return security_privacy_firewall_panel_construct (SECURITY_PRIVACY_TYPE_FIREWALL_PANEL);
#line 249 "FirewallPanel.c"
}

static void
security_privacy_firewall_panel_load_disabled_rules (SecurityPrivacyFirewallPanel* self)
{
	GeeHashMap* _tmp0_;
	gchar* to = NULL;
	gchar* _tmp1_;
	gchar* to_ports = NULL;
	gchar* _tmp2_;
	gchar* from = NULL;
	gchar* _tmp3_;
	gchar* from_ports = NULL;
	gchar* _tmp4_;
	gint action = 0;
	gint protocol = 0;
	gint direction = 0;
	gint version = 0;
	GVariant* rules = NULL;
	GSettings* _tmp5_;
	GVariant* _tmp6_;
	GVariantIter* iter = NULL;
	GVariant* _tmp7_;
	GVariantIter* _tmp8_;
#line 127 "../src/Views/FirewallPanel.vala"
	g_return_if_fail (self != NULL);
#line 128 "../src/Views/FirewallPanel.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, SECURITY_PRIVACY_UFW_HELPERS_TYPE_RULE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 128 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (self->priv->disabled_rules);
#line 128 "../src/Views/FirewallPanel.vala"
	self->priv->disabled_rules = _tmp0_;
#line 129 "../src/Views/FirewallPanel.vala"
	_tmp1_ = g_strdup ("");
#line 129 "../src/Views/FirewallPanel.vala"
	to = _tmp1_;
#line 129 "../src/Views/FirewallPanel.vala"
	_tmp2_ = g_strdup ("");
#line 129 "../src/Views/FirewallPanel.vala"
	to_ports = _tmp2_;
#line 129 "../src/Views/FirewallPanel.vala"
	_tmp3_ = g_strdup ("");
#line 129 "../src/Views/FirewallPanel.vala"
	from = _tmp3_;
#line 129 "../src/Views/FirewallPanel.vala"
	_tmp4_ = g_strdup ("");
#line 129 "../src/Views/FirewallPanel.vala"
	from_ports = _tmp4_;
#line 130 "../src/Views/FirewallPanel.vala"
	action = 0;
#line 130 "../src/Views/FirewallPanel.vala"
	protocol = 0;
#line 130 "../src/Views/FirewallPanel.vala"
	direction = 0;
#line 130 "../src/Views/FirewallPanel.vala"
	version = 0;
#line 131 "../src/Views/FirewallPanel.vala"
	_tmp5_ = self->priv->settings;
#line 131 "../src/Views/FirewallPanel.vala"
	_tmp6_ = g_settings_get_value (_tmp5_, "disabled-firewall-rules");
#line 131 "../src/Views/FirewallPanel.vala"
	rules = _tmp6_;
#line 132 "../src/Views/FirewallPanel.vala"
	_tmp7_ = rules;
#line 132 "../src/Views/FirewallPanel.vala"
	_tmp8_ = g_variant_iter_new (_tmp7_);
#line 132 "../src/Views/FirewallPanel.vala"
	iter = _tmp8_;
#line 133 "../src/Views/FirewallPanel.vala"
	while (TRUE) {
#line 320 "FirewallPanel.c"
		GVariantIter* _tmp9_;
		gboolean _tmp10_;
		SecurityPrivacyUFWHelpersRule* new_rule = NULL;
		SecurityPrivacyUFWHelpersRule* _tmp11_;
		SecurityPrivacyUFWHelpersRule* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		SecurityPrivacyUFWHelpersRule* _tmp15_;
		const gchar* _tmp16_;
		gchar* _tmp17_;
		SecurityPrivacyUFWHelpersRule* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
		SecurityPrivacyUFWHelpersRule* _tmp21_;
		const gchar* _tmp22_;
		gchar* _tmp23_;
		SecurityPrivacyUFWHelpersRule* _tmp24_;
		SecurityPrivacyUFWHelpersRule* _tmp25_;
		SecurityPrivacyUFWHelpersRule* _tmp26_;
		SecurityPrivacyUFWHelpersRule* _tmp27_;
		gchar* hash = NULL;
		SecurityPrivacyUFWHelpersRule* _tmp28_;
		gchar* _tmp29_;
		GeeHashMap* _tmp30_;
		const gchar* _tmp31_;
		SecurityPrivacyUFWHelpersRule* _tmp32_;
#line 133 "../src/Views/FirewallPanel.vala"
		_tmp9_ = iter;
#line 133 "../src/Views/FirewallPanel.vala"
		_tmp10_ = g_variant_iter_next (_tmp9_, "(ssssiiii)", &to, &to_ports, &from, &from_ports, &action, &protocol, &direction, &version, NULL);
#line 133 "../src/Views/FirewallPanel.vala"
		if (!_tmp10_) {
#line 133 "../src/Views/FirewallPanel.vala"
			break;
#line 355 "FirewallPanel.c"
		}
#line 144 "../src/Views/FirewallPanel.vala"
		_tmp11_ = security_privacy_ufw_helpers_rule_new ();
#line 144 "../src/Views/FirewallPanel.vala"
		new_rule = _tmp11_;
#line 145 "../src/Views/FirewallPanel.vala"
		_tmp12_ = new_rule;
#line 145 "../src/Views/FirewallPanel.vala"
		_tmp13_ = to;
#line 145 "../src/Views/FirewallPanel.vala"
		_tmp14_ = g_strdup (_tmp13_);
#line 145 "../src/Views/FirewallPanel.vala"
		_g_free0 (_tmp12_->to);
#line 145 "../src/Views/FirewallPanel.vala"
		_tmp12_->to = _tmp14_;
#line 146 "../src/Views/FirewallPanel.vala"
		_tmp15_ = new_rule;
#line 146 "../src/Views/FirewallPanel.vala"
		_tmp16_ = to_ports;
#line 146 "../src/Views/FirewallPanel.vala"
		_tmp17_ = g_strdup (_tmp16_);
#line 146 "../src/Views/FirewallPanel.vala"
		_g_free0 (_tmp15_->to_ports);
#line 146 "../src/Views/FirewallPanel.vala"
		_tmp15_->to_ports = _tmp17_;
#line 147 "../src/Views/FirewallPanel.vala"
		_tmp18_ = new_rule;
#line 147 "../src/Views/FirewallPanel.vala"
		_tmp19_ = from;
#line 147 "../src/Views/FirewallPanel.vala"
		_tmp20_ = g_strdup (_tmp19_);
#line 147 "../src/Views/FirewallPanel.vala"
		_g_free0 (_tmp18_->from);
#line 147 "../src/Views/FirewallPanel.vala"
		_tmp18_->from = _tmp20_;
#line 148 "../src/Views/FirewallPanel.vala"
		_tmp21_ = new_rule;
#line 148 "../src/Views/FirewallPanel.vala"
		_tmp22_ = from_ports;
#line 148 "../src/Views/FirewallPanel.vala"
		_tmp23_ = g_strdup (_tmp22_);
#line 148 "../src/Views/FirewallPanel.vala"
		_g_free0 (_tmp21_->from_ports);
#line 148 "../src/Views/FirewallPanel.vala"
		_tmp21_->from_ports = _tmp23_;
#line 149 "../src/Views/FirewallPanel.vala"
		_tmp24_ = new_rule;
#line 149 "../src/Views/FirewallPanel.vala"
		_tmp24_->action = (SecurityPrivacyUFWHelpersRuleAction) action;
#line 150 "../src/Views/FirewallPanel.vala"
		_tmp25_ = new_rule;
#line 150 "../src/Views/FirewallPanel.vala"
		_tmp25_->protocol = (SecurityPrivacyUFWHelpersRuleProtocol) protocol;
#line 151 "../src/Views/FirewallPanel.vala"
		_tmp26_ = new_rule;
#line 151 "../src/Views/FirewallPanel.vala"
		_tmp26_->direction = (SecurityPrivacyUFWHelpersRuleDirection) direction;
#line 152 "../src/Views/FirewallPanel.vala"
		_tmp27_ = new_rule;
#line 152 "../src/Views/FirewallPanel.vala"
		_tmp27_->version = (SecurityPrivacyUFWHelpersRuleVersion) version;
#line 153 "../src/Views/FirewallPanel.vala"
		_tmp28_ = new_rule;
#line 153 "../src/Views/FirewallPanel.vala"
		_tmp29_ = security_privacy_firewall_panel_generate_hash_for_rule (self, _tmp28_);
#line 153 "../src/Views/FirewallPanel.vala"
		hash = _tmp29_;
#line 154 "../src/Views/FirewallPanel.vala"
		_tmp30_ = self->priv->disabled_rules;
#line 154 "../src/Views/FirewallPanel.vala"
		_tmp31_ = hash;
#line 154 "../src/Views/FirewallPanel.vala"
		_tmp32_ = new_rule;
#line 154 "../src/Views/FirewallPanel.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp30_, _tmp31_, _tmp32_);
#line 133 "../src/Views/FirewallPanel.vala"
		_g_free0 (hash);
#line 133 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (new_rule);
#line 435 "FirewallPanel.c"
	}
#line 127 "../src/Views/FirewallPanel.vala"
	_g_variant_iter_free0 (iter);
#line 127 "../src/Views/FirewallPanel.vala"
	_g_variant_unref0 (rules);
#line 127 "../src/Views/FirewallPanel.vala"
	_g_free0 (from_ports);
#line 127 "../src/Views/FirewallPanel.vala"
	_g_free0 (from);
#line 127 "../src/Views/FirewallPanel.vala"
	_g_free0 (to_ports);
#line 127 "../src/Views/FirewallPanel.vala"
	_g_free0 (to);
#line 449 "FirewallPanel.c"
}

static gchar*
security_privacy_firewall_panel_generate_hash_for_rule (SecurityPrivacyFirewallPanel* self,
                                                        SecurityPrivacyUFWHelpersRule* r)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	GEnumValue* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	GEnumValue* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	GEnumValue* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	GEnumValue* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* result;
#line 158 "../src/Views/FirewallPanel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 158 "../src/Views/FirewallPanel.vala"
	g_return_val_if_fail (r != NULL, NULL);
#line 159 "../src/Views/FirewallPanel.vala"
	_tmp0_ = r->to;
#line 159 "../src/Views/FirewallPanel.vala"
	_tmp1_ = r->to_ports;
#line 159 "../src/Views/FirewallPanel.vala"
	_tmp2_ = g_strconcat (_tmp0_, _tmp1_, NULL);
#line 159 "../src/Views/FirewallPanel.vala"
	_tmp3_ = _tmp2_;
#line 159 "../src/Views/FirewallPanel.vala"
	_tmp4_ = r->from;
#line 159 "../src/Views/FirewallPanel.vala"
	_tmp5_ = g_strconcat (_tmp3_, _tmp4_, NULL);
#line 159 "../src/Views/FirewallPanel.vala"
	_tmp6_ = _tmp5_;
#line 159 "../src/Views/FirewallPanel.vala"
	_tmp7_ = r->from_ports;
#line 159 "../src/Views/FirewallPanel.vala"
	_tmp8_ = g_strconcat (_tmp6_, _tmp7_, NULL);
#line 159 "../src/Views/FirewallPanel.vala"
	_tmp9_ = _tmp8_;
#line 163 "../src/Views/FirewallPanel.vala"
	_tmp10_ = g_enum_get_value (g_type_class_ref (SECURITY_PRIVACY_UFW_HELPERS_RULE_TYPE_ACTION), r->action);
#line 159 "../src/Views/FirewallPanel.vala"
	_tmp11_ = g_strconcat (_tmp9_, (_tmp10_ != NULL) ? _tmp10_->value_name : NULL, NULL);
#line 159 "../src/Views/FirewallPanel.vala"
	_tmp12_ = _tmp11_;
#line 164 "../src/Views/FirewallPanel.vala"
	_tmp13_ = g_enum_get_value (g_type_class_ref (SECURITY_PRIVACY_UFW_HELPERS_RULE_TYPE_PROTOCOL), r->protocol);
#line 159 "../src/Views/FirewallPanel.vala"
	_tmp14_ = g_strconcat (_tmp12_, (_tmp13_ != NULL) ? _tmp13_->value_name : NULL, NULL);
#line 159 "../src/Views/FirewallPanel.vala"
	_tmp15_ = _tmp14_;
#line 165 "../src/Views/FirewallPanel.vala"
	_tmp16_ = g_enum_get_value (g_type_class_ref (SECURITY_PRIVACY_UFW_HELPERS_RULE_TYPE_DIRECTION), r->direction);
#line 159 "../src/Views/FirewallPanel.vala"
	_tmp17_ = g_strconcat (_tmp15_, (_tmp16_ != NULL) ? _tmp16_->value_name : NULL, NULL);
#line 159 "../src/Views/FirewallPanel.vala"
	_tmp18_ = _tmp17_;
#line 166 "../src/Views/FirewallPanel.vala"
	_tmp19_ = g_enum_get_value (g_type_class_ref (SECURITY_PRIVACY_UFW_HELPERS_RULE_TYPE_VERSION), r->version);
#line 159 "../src/Views/FirewallPanel.vala"
	_tmp20_ = g_strconcat (_tmp18_, (_tmp19_ != NULL) ? _tmp19_->value_name : NULL, NULL);
#line 159 "../src/Views/FirewallPanel.vala"
	_tmp21_ = _tmp20_;
#line 159 "../src/Views/FirewallPanel.vala"
	_g_free0 (_tmp18_);
#line 159 "../src/Views/FirewallPanel.vala"
	_g_free0 (_tmp15_);
#line 159 "../src/Views/FirewallPanel.vala"
	_g_free0 (_tmp12_);
#line 159 "../src/Views/FirewallPanel.vala"
	_g_free0 (_tmp9_);
#line 159 "../src/Views/FirewallPanel.vala"
	_g_free0 (_tmp6_);
#line 159 "../src/Views/FirewallPanel.vala"
	_g_free0 (_tmp3_);
#line 159 "../src/Views/FirewallPanel.vala"
	result = _tmp21_;
#line 159 "../src/Views/FirewallPanel.vala"
	return result;
#line 543 "FirewallPanel.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 170 "../src/Views/FirewallPanel.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 170 "../src/Views/FirewallPanel.vala"
	return _data1_;
#line 553 "FirewallPanel.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 170 "../src/Views/FirewallPanel.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 563 "FirewallPanel.c"
		SecurityPrivacyFirewallPanel* self;
#line 170 "../src/Views/FirewallPanel.vala"
		self = _data1_->self;
#line 170 "../src/Views/FirewallPanel.vala"
		_g_free0 (_data1_->ufw_hash);
#line 170 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (_data1_->rule);
#line 170 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (self);
#line 170 "../src/Views/FirewallPanel.vala"
		g_slice_free (Block1Data, _data1_);
#line 575 "FirewallPanel.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 176 "../src/Views/FirewallPanel.vala"
	return self ? g_object_ref (self) : NULL;
#line 584 "FirewallPanel.c"
}

static gboolean
____lambda16_ (Block1Data* _data1_,
               GtkTreeModel* model,
               GtkTreePath* path,
               GtkTreeIter* iter)
{
	SecurityPrivacyFirewallPanel* self;
	GValue val = {0};
	GtkListStore* _tmp0_;
	GtkTreeIter _tmp1_;
	GValue _tmp2_ = {0};
	SecurityPrivacyUFWHelpersRule* tree_rule = NULL;
	GValue _tmp3_;
	SecurityPrivacyUFWHelpersRule* _tmp4_;
	gchar* tree_hash = NULL;
	SecurityPrivacyUFWHelpersRule* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gboolean result;
#line 172 "../src/Views/FirewallPanel.vala"
	self = _data1_->self;
#line 172 "../src/Views/FirewallPanel.vala"
	g_return_val_if_fail (model != NULL, FALSE);
#line 172 "../src/Views/FirewallPanel.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 172 "../src/Views/FirewallPanel.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 175 "../src/Views/FirewallPanel.vala"
	_tmp0_ = self->priv->list_store;
#line 175 "../src/Views/FirewallPanel.vala"
	_tmp1_ = *iter;
#line 175 "../src/Views/FirewallPanel.vala"
	gtk_tree_model_get_value ((GtkTreeModel*) _tmp0_, &_tmp1_, (gint) SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_RULE, &_tmp2_);
#line 175 "../src/Views/FirewallPanel.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 175 "../src/Views/FirewallPanel.vala"
	val = _tmp2_;
#line 176 "../src/Views/FirewallPanel.vala"
	_tmp3_ = val;
#line 176 "../src/Views/FirewallPanel.vala"
	_tmp4_ = _g_object_ref0 (g_value_get_object (&_tmp3_));
#line 176 "../src/Views/FirewallPanel.vala"
	tree_rule = _tmp4_;
#line 177 "../src/Views/FirewallPanel.vala"
	_tmp5_ = tree_rule;
#line 177 "../src/Views/FirewallPanel.vala"
	_tmp6_ = security_privacy_firewall_panel_generate_hash_for_rule (self, _tmp5_);
#line 177 "../src/Views/FirewallPanel.vala"
	tree_hash = _tmp6_;
#line 178 "../src/Views/FirewallPanel.vala"
	_tmp7_ = _data1_->ufw_hash;
#line 178 "../src/Views/FirewallPanel.vala"
	_tmp8_ = tree_hash;
#line 178 "../src/Views/FirewallPanel.vala"
	if (g_strcmp0 (_tmp7_, _tmp8_) == 0) {
#line 643 "FirewallPanel.c"
		SecurityPrivacyUFWHelpersRule* _tmp9_;
		SecurityPrivacyUFWHelpersRule* _tmp10_;
		GtkListStore* _tmp11_;
		GtkTreeIter _tmp12_;
		SecurityPrivacyUFWHelpersRule* _tmp13_;
		GValue _tmp14_ = {0};
#line 179 "../src/Views/FirewallPanel.vala"
		_tmp9_ = tree_rule;
#line 179 "../src/Views/FirewallPanel.vala"
		_tmp10_ = _data1_->rule;
#line 179 "../src/Views/FirewallPanel.vala"
		_tmp9_->number = _tmp10_->number;
#line 180 "../src/Views/FirewallPanel.vala"
		_tmp11_ = self->priv->list_store;
#line 180 "../src/Views/FirewallPanel.vala"
		_tmp12_ = *iter;
#line 180 "../src/Views/FirewallPanel.vala"
		_tmp13_ = tree_rule;
#line 180 "../src/Views/FirewallPanel.vala"
		g_value_init (&_tmp14_, SECURITY_PRIVACY_UFW_HELPERS_TYPE_RULE);
#line 180 "../src/Views/FirewallPanel.vala"
		g_value_set_object (&_tmp14_, _tmp13_);
#line 180 "../src/Views/FirewallPanel.vala"
		gtk_list_store_set_value (_tmp11_, &_tmp12_, (gint) SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_RULE, &_tmp14_);
#line 180 "../src/Views/FirewallPanel.vala"
		G_IS_VALUE (&_tmp14_) ? (g_value_unset (&_tmp14_), NULL) : NULL;
#line 181 "../src/Views/FirewallPanel.vala"
		result = TRUE;
#line 181 "../src/Views/FirewallPanel.vala"
		_g_free0 (tree_hash);
#line 181 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (tree_rule);
#line 181 "../src/Views/FirewallPanel.vala"
		G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 181 "../src/Views/FirewallPanel.vala"
		return result;
#line 680 "FirewallPanel.c"
	}
#line 184 "../src/Views/FirewallPanel.vala"
	result = FALSE;
#line 184 "../src/Views/FirewallPanel.vala"
	_g_free0 (tree_hash);
#line 184 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (tree_rule);
#line 184 "../src/Views/FirewallPanel.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 184 "../src/Views/FirewallPanel.vala"
	return result;
#line 692 "FirewallPanel.c"
}

static gboolean
_____lambda16__gtk_tree_model_foreach_func (GtkTreeModel* model,
                                            GtkTreePath* path,
                                            GtkTreeIter* iter,
                                            gpointer self)
{
	gboolean result;
	result = ____lambda16_ (self, model, path, iter);
#line 172 "../src/Views/FirewallPanel.vala"
	return result;
#line 705 "FirewallPanel.c"
}

static void
security_privacy_firewall_panel_reload_rule_numbers (SecurityPrivacyFirewallPanel* self)
{
#line 169 "../src/Views/FirewallPanel.vala"
	g_return_if_fail (self != NULL);
#line 713 "FirewallPanel.c"
	{
		GeeLinkedList* _rule_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _rule_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _rule_index = 0;
#line 170 "../src/Views/FirewallPanel.vala"
		_tmp0_ = security_privacy_ufw_helpers_get_rules ();
#line 170 "../src/Views/FirewallPanel.vala"
		_rule_list = _tmp0_;
#line 170 "../src/Views/FirewallPanel.vala"
		_tmp1_ = _rule_list;
#line 170 "../src/Views/FirewallPanel.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 170 "../src/Views/FirewallPanel.vala"
		_tmp3_ = _tmp2_;
#line 170 "../src/Views/FirewallPanel.vala"
		_rule_size = _tmp3_;
#line 170 "../src/Views/FirewallPanel.vala"
		_rule_index = -1;
#line 170 "../src/Views/FirewallPanel.vala"
		while (TRUE) {
#line 738 "FirewallPanel.c"
			Block1Data* _data1_;
			gint _tmp4_;
			gint _tmp5_;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			SecurityPrivacyUFWHelpersRule* _tmp8_;
			gchar* _tmp9_;
			GtkTreeModelForeachFunc update_row = NULL;
			gpointer update_row_target;
			GDestroyNotify update_row_target_destroy_notify;
			GtkListStore* _tmp10_;
			GtkTreeModelForeachFunc _tmp11_;
			gpointer _tmp11__target;
#line 170 "../src/Views/FirewallPanel.vala"
			_data1_ = g_slice_new0 (Block1Data);
#line 170 "../src/Views/FirewallPanel.vala"
			_data1_->_ref_count_ = 1;
#line 170 "../src/Views/FirewallPanel.vala"
			_data1_->self = g_object_ref (self);
#line 170 "../src/Views/FirewallPanel.vala"
			_rule_index = _rule_index + 1;
#line 170 "../src/Views/FirewallPanel.vala"
			_tmp4_ = _rule_index;
#line 170 "../src/Views/FirewallPanel.vala"
			_tmp5_ = _rule_size;
#line 170 "../src/Views/FirewallPanel.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 170 "../src/Views/FirewallPanel.vala"
				block1_data_unref (_data1_);
#line 170 "../src/Views/FirewallPanel.vala"
				_data1_ = NULL;
#line 170 "../src/Views/FirewallPanel.vala"
				break;
#line 772 "FirewallPanel.c"
			}
#line 170 "../src/Views/FirewallPanel.vala"
			_tmp6_ = _rule_list;
#line 170 "../src/Views/FirewallPanel.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _rule_index);
#line 170 "../src/Views/FirewallPanel.vala"
			_data1_->rule = (SecurityPrivacyUFWHelpersRule*) _tmp7_;
#line 171 "../src/Views/FirewallPanel.vala"
			_tmp8_ = _data1_->rule;
#line 171 "../src/Views/FirewallPanel.vala"
			_tmp9_ = security_privacy_firewall_panel_generate_hash_for_rule (self, _tmp8_);
#line 171 "../src/Views/FirewallPanel.vala"
			_data1_->ufw_hash = _tmp9_;
#line 172 "../src/Views/FirewallPanel.vala"
			update_row = _____lambda16__gtk_tree_model_foreach_func;
#line 172 "../src/Views/FirewallPanel.vala"
			update_row_target = block1_data_ref (_data1_);
#line 172 "../src/Views/FirewallPanel.vala"
			update_row_target_destroy_notify = block1_data_unref;
#line 186 "../src/Views/FirewallPanel.vala"
			_tmp10_ = self->priv->list_store;
#line 186 "../src/Views/FirewallPanel.vala"
			_tmp11_ = update_row;
#line 186 "../src/Views/FirewallPanel.vala"
			_tmp11__target = update_row_target;
#line 186 "../src/Views/FirewallPanel.vala"
			gtk_tree_model_foreach ((GtkTreeModel*) _tmp10_, _tmp11_, _tmp11__target);
#line 170 "../src/Views/FirewallPanel.vala"
			(update_row_target_destroy_notify == NULL) ? NULL : (update_row_target_destroy_notify (update_row_target), NULL);
#line 170 "../src/Views/FirewallPanel.vala"
			update_row = NULL;
#line 170 "../src/Views/FirewallPanel.vala"
			update_row_target = NULL;
#line 170 "../src/Views/FirewallPanel.vala"
			update_row_target_destroy_notify = NULL;
#line 170 "../src/Views/FirewallPanel.vala"
			block1_data_unref (_data1_);
#line 170 "../src/Views/FirewallPanel.vala"
			_data1_ = NULL;
#line 812 "FirewallPanel.c"
		}
#line 170 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (_rule_list);
#line 816 "FirewallPanel.c"
	}
}

static void
security_privacy_firewall_panel_show_rules (SecurityPrivacyFirewallPanel* self)
{
	GtkListStore* _tmp0_;
	GtkButton* _tmp1_;
#line 190 "../src/Views/FirewallPanel.vala"
	g_return_if_fail (self != NULL);
#line 191 "../src/Views/FirewallPanel.vala"
	_tmp0_ = self->priv->list_store;
#line 191 "../src/Views/FirewallPanel.vala"
	gtk_list_store_clear (_tmp0_);
#line 192 "../src/Views/FirewallPanel.vala"
	_tmp1_ = self->priv->remove_button;
#line 192 "../src/Views/FirewallPanel.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, FALSE);
#line 835 "FirewallPanel.c"
	{
		GeeLinkedList* _rule_list = NULL;
		GeeLinkedList* _tmp2_;
		gint _rule_size = 0;
		GeeLinkedList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _rule_index = 0;
#line 193 "../src/Views/FirewallPanel.vala"
		_tmp2_ = security_privacy_ufw_helpers_get_rules ();
#line 193 "../src/Views/FirewallPanel.vala"
		_rule_list = _tmp2_;
#line 193 "../src/Views/FirewallPanel.vala"
		_tmp3_ = _rule_list;
#line 193 "../src/Views/FirewallPanel.vala"
		_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 193 "../src/Views/FirewallPanel.vala"
		_tmp5_ = _tmp4_;
#line 193 "../src/Views/FirewallPanel.vala"
		_rule_size = _tmp5_;
#line 193 "../src/Views/FirewallPanel.vala"
		_rule_index = -1;
#line 193 "../src/Views/FirewallPanel.vala"
		while (TRUE) {
#line 860 "FirewallPanel.c"
			gint _tmp6_;
			gint _tmp7_;
			SecurityPrivacyUFWHelpersRule* rule = NULL;
			GeeLinkedList* _tmp8_;
			gpointer _tmp9_;
			SecurityPrivacyUFWHelpersRule* _tmp10_;
#line 193 "../src/Views/FirewallPanel.vala"
			_rule_index = _rule_index + 1;
#line 193 "../src/Views/FirewallPanel.vala"
			_tmp6_ = _rule_index;
#line 193 "../src/Views/FirewallPanel.vala"
			_tmp7_ = _rule_size;
#line 193 "../src/Views/FirewallPanel.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 193 "../src/Views/FirewallPanel.vala"
				break;
#line 877 "FirewallPanel.c"
			}
#line 193 "../src/Views/FirewallPanel.vala"
			_tmp8_ = _rule_list;
#line 193 "../src/Views/FirewallPanel.vala"
			_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _rule_index);
#line 193 "../src/Views/FirewallPanel.vala"
			rule = (SecurityPrivacyUFWHelpersRule*) _tmp9_;
#line 194 "../src/Views/FirewallPanel.vala"
			_tmp10_ = rule;
#line 194 "../src/Views/FirewallPanel.vala"
			security_privacy_firewall_panel_add_rule (self, _tmp10_, TRUE, "");
#line 193 "../src/Views/FirewallPanel.vala"
			_g_object_unref0 (rule);
#line 891 "FirewallPanel.c"
		}
#line 193 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (_rule_list);
#line 895 "FirewallPanel.c"
	}
#line 197 "../src/Views/FirewallPanel.vala"
	security_privacy_firewall_panel_load_disabled_rules (self);
#line 899 "FirewallPanel.c"
	{
		GeeIterator* _rule_it = NULL;
		GeeHashMap* _tmp11_;
		GeeSet* _tmp12_;
		GeeSet* _tmp13_;
		GeeSet* _tmp14_;
		GeeIterator* _tmp15_;
		GeeIterator* _tmp16_;
#line 198 "../src/Views/FirewallPanel.vala"
		_tmp11_ = self->priv->disabled_rules;
#line 198 "../src/Views/FirewallPanel.vala"
		_tmp12_ = gee_abstract_map_get_entries ((GeeAbstractMap*) _tmp11_);
#line 198 "../src/Views/FirewallPanel.vala"
		_tmp13_ = _tmp12_;
#line 198 "../src/Views/FirewallPanel.vala"
		_tmp14_ = _tmp13_;
#line 198 "../src/Views/FirewallPanel.vala"
		_tmp15_ = gee_iterable_iterator ((GeeIterable*) _tmp14_);
#line 198 "../src/Views/FirewallPanel.vala"
		_tmp16_ = _tmp15_;
#line 198 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (_tmp14_);
#line 198 "../src/Views/FirewallPanel.vala"
		_rule_it = _tmp16_;
#line 198 "../src/Views/FirewallPanel.vala"
		while (TRUE) {
#line 926 "FirewallPanel.c"
			GeeIterator* _tmp17_;
			GeeMapEntry* rule = NULL;
			GeeIterator* _tmp18_;
			gpointer _tmp19_;
			GeeMapEntry* _tmp20_;
			gconstpointer _tmp21_;
			gconstpointer _tmp22_;
			GeeMapEntry* _tmp23_;
			gconstpointer _tmp24_;
			gconstpointer _tmp25_;
#line 198 "../src/Views/FirewallPanel.vala"
			_tmp17_ = _rule_it;
#line 198 "../src/Views/FirewallPanel.vala"
			if (!gee_iterator_next (_tmp17_)) {
#line 198 "../src/Views/FirewallPanel.vala"
				break;
#line 943 "FirewallPanel.c"
			}
#line 198 "../src/Views/FirewallPanel.vala"
			_tmp18_ = _rule_it;
#line 198 "../src/Views/FirewallPanel.vala"
			_tmp19_ = gee_iterator_get (_tmp18_);
#line 198 "../src/Views/FirewallPanel.vala"
			rule = (GeeMapEntry*) _tmp19_;
#line 199 "../src/Views/FirewallPanel.vala"
			_tmp20_ = rule;
#line 199 "../src/Views/FirewallPanel.vala"
			_tmp21_ = gee_map_entry_get_value (_tmp20_);
#line 199 "../src/Views/FirewallPanel.vala"
			_tmp22_ = _tmp21_;
#line 199 "../src/Views/FirewallPanel.vala"
			_tmp23_ = rule;
#line 199 "../src/Views/FirewallPanel.vala"
			_tmp24_ = gee_map_entry_get_key (_tmp23_);
#line 199 "../src/Views/FirewallPanel.vala"
			_tmp25_ = _tmp24_;
#line 199 "../src/Views/FirewallPanel.vala"
			security_privacy_firewall_panel_add_rule (self, (SecurityPrivacyUFWHelpersRule*) _tmp22_, FALSE, (const gchar*) _tmp25_);
#line 198 "../src/Views/FirewallPanel.vala"
			_g_object_unref0 (rule);
#line 967 "FirewallPanel.c"
		}
#line 198 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (_rule_it);
#line 971 "FirewallPanel.c"
	}
}

static void
security_privacy_firewall_panel_disable_rule (SecurityPrivacyFirewallPanel* self,
                                              SecurityPrivacyUFWHelpersRule* rule)
{
#line 203 "../src/Views/FirewallPanel.vala"
	g_return_if_fail (self != NULL);
#line 203 "../src/Views/FirewallPanel.vala"
	g_return_if_fail (rule != NULL);
#line 204 "../src/Views/FirewallPanel.vala"
	security_privacy_firewall_panel_save_disabled_rules (self, rule);
#line 205 "../src/Views/FirewallPanel.vala"
	security_privacy_ufw_helpers_remove_rule (rule);
#line 987 "FirewallPanel.c"
}

static void
security_privacy_firewall_panel_enable_rule (SecurityPrivacyFirewallPanel* self,
                                             const gchar* hash)
{
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	SecurityPrivacyUFWHelpersRule* _tmp2_;
#line 208 "../src/Views/FirewallPanel.vala"
	g_return_if_fail (self != NULL);
#line 208 "../src/Views/FirewallPanel.vala"
	g_return_if_fail (hash != NULL);
#line 209 "../src/Views/FirewallPanel.vala"
	_tmp0_ = self->priv->disabled_rules;
#line 209 "../src/Views/FirewallPanel.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, hash);
#line 209 "../src/Views/FirewallPanel.vala"
	_tmp2_ = (SecurityPrivacyUFWHelpersRule*) _tmp1_;
#line 209 "../src/Views/FirewallPanel.vala"
	security_privacy_ufw_helpers_add_rule (_tmp2_);
#line 209 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (_tmp2_);
#line 210 "../src/Views/FirewallPanel.vala"
	security_privacy_firewall_panel_delete_disabled_rule (self, hash);
#line 1013 "FirewallPanel.c"
}

static void
security_privacy_firewall_panel_delete_disabled_rule (SecurityPrivacyFirewallPanel* self,
                                                      const gchar* hash)
{
	GeeHashMap* _tmp0_;
#line 213 "../src/Views/FirewallPanel.vala"
	g_return_if_fail (self != NULL);
#line 213 "../src/Views/FirewallPanel.vala"
	g_return_if_fail (hash != NULL);
#line 214 "../src/Views/FirewallPanel.vala"
	_tmp0_ = self->priv->disabled_rules;
#line 214 "../src/Views/FirewallPanel.vala"
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp0_, hash, NULL);
#line 215 "../src/Views/FirewallPanel.vala"
	security_privacy_firewall_panel_save_disabled_rules (self, NULL);
#line 1031 "FirewallPanel.c"
}

static void
security_privacy_firewall_panel_save_disabled_rules (SecurityPrivacyFirewallPanel* self,
                                                     SecurityPrivacyUFWHelpersRule* additional_rule)
{
	GVariantBuilder* builder = NULL;
	GVariantType* _tmp0_;
	GVariantType* _tmp1_;
	GVariantBuilder* _tmp2_;
	GVariantBuilder* _tmp3_;
	GSettings* _tmp31_;
	GVariantBuilder* _tmp32_;
	GVariant* _tmp33_;
	GVariant* _tmp34_;
#line 218 "../src/Views/FirewallPanel.vala"
	g_return_if_fail (self != NULL);
#line 219 "../src/Views/FirewallPanel.vala"
	_tmp0_ = g_variant_type_new ("a(ssssiiii)");
#line 219 "../src/Views/FirewallPanel.vala"
	_tmp1_ = _tmp0_;
#line 219 "../src/Views/FirewallPanel.vala"
	_tmp2_ = g_variant_builder_new (_tmp1_);
#line 219 "../src/Views/FirewallPanel.vala"
	_tmp3_ = _tmp2_;
#line 219 "../src/Views/FirewallPanel.vala"
	_g_variant_type_free0 (_tmp1_);
#line 219 "../src/Views/FirewallPanel.vala"
	builder = _tmp3_;
#line 1061 "FirewallPanel.c"
	{
		GeeIterator* _existing_rule_it = NULL;
		GeeHashMap* _tmp4_;
		GeeCollection* _tmp5_;
		GeeCollection* _tmp6_;
		GeeCollection* _tmp7_;
		GeeIterator* _tmp8_;
		GeeIterator* _tmp9_;
#line 220 "../src/Views/FirewallPanel.vala"
		_tmp4_ = self->priv->disabled_rules;
#line 220 "../src/Views/FirewallPanel.vala"
		_tmp5_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp4_);
#line 220 "../src/Views/FirewallPanel.vala"
		_tmp6_ = _tmp5_;
#line 220 "../src/Views/FirewallPanel.vala"
		_tmp7_ = _tmp6_;
#line 220 "../src/Views/FirewallPanel.vala"
		_tmp8_ = gee_iterable_iterator ((GeeIterable*) _tmp7_);
#line 220 "../src/Views/FirewallPanel.vala"
		_tmp9_ = _tmp8_;
#line 220 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (_tmp7_);
#line 220 "../src/Views/FirewallPanel.vala"
		_existing_rule_it = _tmp9_;
#line 220 "../src/Views/FirewallPanel.vala"
		while (TRUE) {
#line 1088 "FirewallPanel.c"
			GeeIterator* _tmp10_;
			SecurityPrivacyUFWHelpersRule* existing_rule = NULL;
			GeeIterator* _tmp11_;
			gpointer _tmp12_;
			GVariantBuilder* _tmp13_;
			SecurityPrivacyUFWHelpersRule* _tmp14_;
			const gchar* _tmp15_;
			SecurityPrivacyUFWHelpersRule* _tmp16_;
			const gchar* _tmp17_;
			SecurityPrivacyUFWHelpersRule* _tmp18_;
			const gchar* _tmp19_;
			SecurityPrivacyUFWHelpersRule* _tmp20_;
			const gchar* _tmp21_;
			SecurityPrivacyUFWHelpersRule* _tmp22_;
			SecurityPrivacyUFWHelpersRule* _tmp23_;
			SecurityPrivacyUFWHelpersRule* _tmp24_;
			SecurityPrivacyUFWHelpersRule* _tmp25_;
#line 220 "../src/Views/FirewallPanel.vala"
			_tmp10_ = _existing_rule_it;
#line 220 "../src/Views/FirewallPanel.vala"
			if (!gee_iterator_next (_tmp10_)) {
#line 220 "../src/Views/FirewallPanel.vala"
				break;
#line 1112 "FirewallPanel.c"
			}
#line 220 "../src/Views/FirewallPanel.vala"
			_tmp11_ = _existing_rule_it;
#line 220 "../src/Views/FirewallPanel.vala"
			_tmp12_ = gee_iterator_get (_tmp11_);
#line 220 "../src/Views/FirewallPanel.vala"
			existing_rule = (SecurityPrivacyUFWHelpersRule*) _tmp12_;
#line 221 "../src/Views/FirewallPanel.vala"
			_tmp13_ = builder;
#line 221 "../src/Views/FirewallPanel.vala"
			_tmp14_ = existing_rule;
#line 221 "../src/Views/FirewallPanel.vala"
			_tmp15_ = _tmp14_->to;
#line 221 "../src/Views/FirewallPanel.vala"
			_tmp16_ = existing_rule;
#line 221 "../src/Views/FirewallPanel.vala"
			_tmp17_ = _tmp16_->to_ports;
#line 221 "../src/Views/FirewallPanel.vala"
			_tmp18_ = existing_rule;
#line 221 "../src/Views/FirewallPanel.vala"
			_tmp19_ = _tmp18_->from;
#line 221 "../src/Views/FirewallPanel.vala"
			_tmp20_ = existing_rule;
#line 221 "../src/Views/FirewallPanel.vala"
			_tmp21_ = _tmp20_->from_ports;
#line 221 "../src/Views/FirewallPanel.vala"
			_tmp22_ = existing_rule;
#line 221 "../src/Views/FirewallPanel.vala"
			_tmp23_ = existing_rule;
#line 221 "../src/Views/FirewallPanel.vala"
			_tmp24_ = existing_rule;
#line 221 "../src/Views/FirewallPanel.vala"
			_tmp25_ = existing_rule;
#line 221 "../src/Views/FirewallPanel.vala"
			g_variant_builder_add (_tmp13_, "(ssssiiii)", _tmp15_, _tmp17_, _tmp19_, _tmp21_, _tmp22_->action, _tmp23_->protocol, _tmp24_->direction, _tmp25_->version, NULL);
#line 220 "../src/Views/FirewallPanel.vala"
			_g_object_unref0 (existing_rule);
#line 1150 "FirewallPanel.c"
		}
#line 220 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (_existing_rule_it);
#line 1154 "FirewallPanel.c"
	}
#line 230 "../src/Views/FirewallPanel.vala"
	if (additional_rule != NULL) {
#line 1158 "FirewallPanel.c"
		GVariantBuilder* _tmp26_;
		const gchar* _tmp27_;
		const gchar* _tmp28_;
		const gchar* _tmp29_;
		const gchar* _tmp30_;
#line 231 "../src/Views/FirewallPanel.vala"
		_tmp26_ = builder;
#line 231 "../src/Views/FirewallPanel.vala"
		_tmp27_ = additional_rule->to;
#line 231 "../src/Views/FirewallPanel.vala"
		_tmp28_ = additional_rule->to_ports;
#line 231 "../src/Views/FirewallPanel.vala"
		_tmp29_ = additional_rule->from;
#line 231 "../src/Views/FirewallPanel.vala"
		_tmp30_ = additional_rule->from_ports;
#line 231 "../src/Views/FirewallPanel.vala"
		g_variant_builder_add (_tmp26_, "(ssssiiii)", _tmp27_, _tmp28_, _tmp29_, _tmp30_, additional_rule->action, additional_rule->protocol, additional_rule->direction, additional_rule->version, NULL);
#line 1176 "FirewallPanel.c"
	}
#line 240 "../src/Views/FirewallPanel.vala"
	_tmp31_ = self->priv->settings;
#line 240 "../src/Views/FirewallPanel.vala"
	_tmp32_ = builder;
#line 240 "../src/Views/FirewallPanel.vala"
	_tmp33_ = g_variant_builder_end (_tmp32_);
#line 240 "../src/Views/FirewallPanel.vala"
	g_variant_ref_sink (_tmp33_);
#line 240 "../src/Views/FirewallPanel.vala"
	_tmp34_ = _tmp33_;
#line 240 "../src/Views/FirewallPanel.vala"
	g_settings_set_value (_tmp31_, "disabled-firewall-rules", _tmp34_);
#line 240 "../src/Views/FirewallPanel.vala"
	_g_variant_unref0 (_tmp34_);
#line 241 "../src/Views/FirewallPanel.vala"
	security_privacy_firewall_panel_load_disabled_rules (self);
#line 218 "../src/Views/FirewallPanel.vala"
	_g_variant_builder_unref0 (builder);
#line 1196 "FirewallPanel.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 1215 "FirewallPanel.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1237 "FirewallPanel.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1241 "FirewallPanel.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1247 "FirewallPanel.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1251 "FirewallPanel.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1255 "FirewallPanel.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 1263 "FirewallPanel.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1291 "FirewallPanel.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 1300 "FirewallPanel.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1314 "FirewallPanel.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 1323 "FirewallPanel.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 1337 "FirewallPanel.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1346 "FirewallPanel.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 1355 "FirewallPanel.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 1376 "FirewallPanel.c"
}

void
security_privacy_firewall_panel_add_rule (SecurityPrivacyFirewallPanel* self,
                                          SecurityPrivacyUFWHelpersRule* rule,
                                          gboolean enabled,
                                          const gchar* hash)
{
	gchar* action = NULL;
	gchar* _tmp0_;
	gchar* protocol = NULL;
	gchar* _tmp5_;
	gchar* direction = NULL;
	gchar* _tmp9_;
	gchar* version = NULL;
	gchar* _tmp12_;
	gchar* from = NULL;
	gchar* _tmp15_;
	gchar* to = NULL;
	gchar* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp33_;
	GtkTreeIter iter = {0};
	GtkListStore* _tmp49_;
	GtkTreeIter _tmp50_ = {0};
	GtkListStore* _tmp51_;
	GtkTreeIter _tmp52_;
	const gchar* _tmp53_;
	const gchar* _tmp54_;
	const gchar* _tmp55_;
	const gchar* _tmp56_;
	const gchar* _tmp57_;
	gchar* _tmp58_;
	gchar* _tmp59_;
	const gchar* _tmp60_;
	gchar* _tmp61_;
	gchar* _tmp62_;
#line 244 "../src/Views/FirewallPanel.vala"
	g_return_if_fail (self != NULL);
#line 244 "../src/Views/FirewallPanel.vala"
	g_return_if_fail (rule != NULL);
#line 244 "../src/Views/FirewallPanel.vala"
	g_return_if_fail (hash != NULL);
#line 245 "../src/Views/FirewallPanel.vala"
	_tmp0_ = g_strdup (_ ("Unknown"));
#line 245 "../src/Views/FirewallPanel.vala"
	action = _tmp0_;
#line 246 "../src/Views/FirewallPanel.vala"
	switch (rule->action) {
#line 246 "../src/Views/FirewallPanel.vala"
		case SECURITY_PRIVACY_UFW_HELPERS_RULE_ACTION_ALLOW:
#line 1428 "FirewallPanel.c"
		{
			gchar* _tmp1_;
#line 248 "../src/Views/FirewallPanel.vala"
			_tmp1_ = g_strdup (_ ("Allow"));
#line 248 "../src/Views/FirewallPanel.vala"
			_g_free0 (action);
#line 248 "../src/Views/FirewallPanel.vala"
			action = _tmp1_;
#line 249 "../src/Views/FirewallPanel.vala"
			break;
#line 1439 "FirewallPanel.c"
		}
#line 246 "../src/Views/FirewallPanel.vala"
		case SECURITY_PRIVACY_UFW_HELPERS_RULE_ACTION_DENY:
#line 1443 "FirewallPanel.c"
		{
			gchar* _tmp2_;
#line 251 "../src/Views/FirewallPanel.vala"
			_tmp2_ = g_strdup (_ ("Deny"));
#line 251 "../src/Views/FirewallPanel.vala"
			_g_free0 (action);
#line 251 "../src/Views/FirewallPanel.vala"
			action = _tmp2_;
#line 252 "../src/Views/FirewallPanel.vala"
			break;
#line 1454 "FirewallPanel.c"
		}
#line 246 "../src/Views/FirewallPanel.vala"
		case SECURITY_PRIVACY_UFW_HELPERS_RULE_ACTION_REJECT:
#line 1458 "FirewallPanel.c"
		{
			gchar* _tmp3_;
#line 254 "../src/Views/FirewallPanel.vala"
			_tmp3_ = g_strdup (_ ("Reject"));
#line 254 "../src/Views/FirewallPanel.vala"
			_g_free0 (action);
#line 254 "../src/Views/FirewallPanel.vala"
			action = _tmp3_;
#line 255 "../src/Views/FirewallPanel.vala"
			break;
#line 1469 "FirewallPanel.c"
		}
#line 246 "../src/Views/FirewallPanel.vala"
		case SECURITY_PRIVACY_UFW_HELPERS_RULE_ACTION_LIMIT:
#line 1473 "FirewallPanel.c"
		{
			gchar* _tmp4_;
#line 257 "../src/Views/FirewallPanel.vala"
			_tmp4_ = g_strdup (_ ("Limit"));
#line 257 "../src/Views/FirewallPanel.vala"
			_g_free0 (action);
#line 257 "../src/Views/FirewallPanel.vala"
			action = _tmp4_;
#line 258 "../src/Views/FirewallPanel.vala"
			break;
#line 1484 "FirewallPanel.c"
		}
		default:
#line 246 "../src/Views/FirewallPanel.vala"
		break;
#line 1489 "FirewallPanel.c"
	}
#line 261 "../src/Views/FirewallPanel.vala"
	_tmp5_ = g_strdup (_ ("Unknown"));
#line 261 "../src/Views/FirewallPanel.vala"
	protocol = _tmp5_;
#line 262 "../src/Views/FirewallPanel.vala"
	switch (rule->protocol) {
#line 262 "../src/Views/FirewallPanel.vala"
		case SECURITY_PRIVACY_UFW_HELPERS_RULE_PROTOCOL_UDP:
#line 1499 "FirewallPanel.c"
		{
			gchar* _tmp6_;
#line 264 "../src/Views/FirewallPanel.vala"
			_tmp6_ = g_strdup ("UDP");
#line 264 "../src/Views/FirewallPanel.vala"
			_g_free0 (protocol);
#line 264 "../src/Views/FirewallPanel.vala"
			protocol = _tmp6_;
#line 265 "../src/Views/FirewallPanel.vala"
			break;
#line 1510 "FirewallPanel.c"
		}
#line 262 "../src/Views/FirewallPanel.vala"
		case SECURITY_PRIVACY_UFW_HELPERS_RULE_PROTOCOL_TCP:
#line 1514 "FirewallPanel.c"
		{
			gchar* _tmp7_;
#line 267 "../src/Views/FirewallPanel.vala"
			_tmp7_ = g_strdup ("TCP");
#line 267 "../src/Views/FirewallPanel.vala"
			_g_free0 (protocol);
#line 267 "../src/Views/FirewallPanel.vala"
			protocol = _tmp7_;
#line 268 "../src/Views/FirewallPanel.vala"
			break;
#line 1525 "FirewallPanel.c"
		}
#line 262 "../src/Views/FirewallPanel.vala"
		case SECURITY_PRIVACY_UFW_HELPERS_RULE_PROTOCOL_BOTH:
#line 1529 "FirewallPanel.c"
		{
			gchar* _tmp8_;
#line 270 "../src/Views/FirewallPanel.vala"
			_tmp8_ = g_strdup ("TCP/UDP");
#line 270 "../src/Views/FirewallPanel.vala"
			_g_free0 (protocol);
#line 270 "../src/Views/FirewallPanel.vala"
			protocol = _tmp8_;
#line 271 "../src/Views/FirewallPanel.vala"
			break;
#line 1540 "FirewallPanel.c"
		}
		default:
#line 262 "../src/Views/FirewallPanel.vala"
		break;
#line 1545 "FirewallPanel.c"
	}
#line 274 "../src/Views/FirewallPanel.vala"
	_tmp9_ = g_strdup (_ ("Unknown"));
#line 274 "../src/Views/FirewallPanel.vala"
	direction = _tmp9_;
#line 275 "../src/Views/FirewallPanel.vala"
	if (rule->direction == SECURITY_PRIVACY_UFW_HELPERS_RULE_DIRECTION_IN) {
#line 1553 "FirewallPanel.c"
		gchar* _tmp10_;
#line 276 "../src/Views/FirewallPanel.vala"
		_tmp10_ = g_strdup (_ ("In"));
#line 276 "../src/Views/FirewallPanel.vala"
		_g_free0 (direction);
#line 276 "../src/Views/FirewallPanel.vala"
		direction = _tmp10_;
#line 1561 "FirewallPanel.c"
	} else {
#line 277 "../src/Views/FirewallPanel.vala"
		if (rule->direction == SECURITY_PRIVACY_UFW_HELPERS_RULE_DIRECTION_OUT) {
#line 1565 "FirewallPanel.c"
			gchar* _tmp11_;
#line 278 "../src/Views/FirewallPanel.vala"
			_tmp11_ = g_strdup (_ ("Out"));
#line 278 "../src/Views/FirewallPanel.vala"
			_g_free0 (direction);
#line 278 "../src/Views/FirewallPanel.vala"
			direction = _tmp11_;
#line 1573 "FirewallPanel.c"
		}
	}
#line 281 "../src/Views/FirewallPanel.vala"
	_tmp12_ = g_strdup (_ ("Unknown"));
#line 281 "../src/Views/FirewallPanel.vala"
	version = _tmp12_;
#line 282 "../src/Views/FirewallPanel.vala"
	if (rule->version == SECURITY_PRIVACY_UFW_HELPERS_RULE_VERSION_IPV6) {
#line 1582 "FirewallPanel.c"
		gchar* _tmp13_;
#line 283 "../src/Views/FirewallPanel.vala"
		_tmp13_ = g_strdup ("IPv6");
#line 283 "../src/Views/FirewallPanel.vala"
		_g_free0 (version);
#line 283 "../src/Views/FirewallPanel.vala"
		version = _tmp13_;
#line 1590 "FirewallPanel.c"
	} else {
#line 284 "../src/Views/FirewallPanel.vala"
		if (rule->version == SECURITY_PRIVACY_UFW_HELPERS_RULE_VERSION_IPV4) {
#line 1594 "FirewallPanel.c"
			gchar* _tmp14_;
#line 285 "../src/Views/FirewallPanel.vala"
			_tmp14_ = g_strdup ("IPv4");
#line 285 "../src/Views/FirewallPanel.vala"
			_g_free0 (version);
#line 285 "../src/Views/FirewallPanel.vala"
			version = _tmp14_;
#line 1602 "FirewallPanel.c"
		}
	}
#line 288 "../src/Views/FirewallPanel.vala"
	_tmp15_ = g_strdup ("");
#line 288 "../src/Views/FirewallPanel.vala"
	from = _tmp15_;
#line 289 "../src/Views/FirewallPanel.vala"
	_tmp16_ = g_strdup ("");
#line 289 "../src/Views/FirewallPanel.vala"
	to = _tmp16_;
#line 290 "../src/Views/FirewallPanel.vala"
	_tmp17_ = rule->from_ports;
#line 290 "../src/Views/FirewallPanel.vala"
	if (g_strcmp0 (_tmp17_, "") != 0) {
#line 1617 "FirewallPanel.c"
		gboolean _tmp18_ = FALSE;
		const gchar* _tmp19_;
#line 291 "../src/Views/FirewallPanel.vala"
		_tmp19_ = rule->from_ports;
#line 291 "../src/Views/FirewallPanel.vala"
		if (string_contains (_tmp19_, ":")) {
#line 291 "../src/Views/FirewallPanel.vala"
			_tmp18_ = TRUE;
#line 1626 "FirewallPanel.c"
		} else {
			const gchar* _tmp20_;
#line 291 "../src/Views/FirewallPanel.vala"
			_tmp20_ = rule->from_ports;
#line 291 "../src/Views/FirewallPanel.vala"
			_tmp18_ = string_contains (_tmp20_, ",");
#line 1633 "FirewallPanel.c"
		}
#line 291 "../src/Views/FirewallPanel.vala"
		if (_tmp18_) {
#line 1637 "FirewallPanel.c"
			const gchar* _tmp21_;
			const gchar* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
			gchar* _tmp25_;
#line 292 "../src/Views/FirewallPanel.vala"
			_tmp21_ = rule->from;
#line 292 "../src/Views/FirewallPanel.vala"
			_tmp22_ = rule->from_ports;
#line 292 "../src/Views/FirewallPanel.vala"
			_tmp23_ = string_replace (_tmp22_, ":", "-");
#line 292 "../src/Views/FirewallPanel.vala"
			_tmp24_ = _tmp23_;
#line 292 "../src/Views/FirewallPanel.vala"
			_tmp25_ = g_strdup_printf (_ ("%s Ports %s"), _tmp21_, _tmp24_);
#line 292 "../src/Views/FirewallPanel.vala"
			_g_free0 (from);
#line 292 "../src/Views/FirewallPanel.vala"
			from = _tmp25_;
#line 292 "../src/Views/FirewallPanel.vala"
			_g_free0 (_tmp24_);
#line 1659 "FirewallPanel.c"
		} else {
			const gchar* _tmp26_;
			const gchar* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			gchar* _tmp30_;
#line 294 "../src/Views/FirewallPanel.vala"
			_tmp26_ = rule->from;
#line 294 "../src/Views/FirewallPanel.vala"
			_tmp27_ = rule->from_ports;
#line 294 "../src/Views/FirewallPanel.vala"
			_tmp28_ = string_replace (_tmp27_, ":", "-");
#line 294 "../src/Views/FirewallPanel.vala"
			_tmp29_ = _tmp28_;
#line 294 "../src/Views/FirewallPanel.vala"
			_tmp30_ = g_strdup_printf (_ ("%s Port %s"), _tmp26_, _tmp29_);
#line 294 "../src/Views/FirewallPanel.vala"
			_g_free0 (from);
#line 294 "../src/Views/FirewallPanel.vala"
			from = _tmp30_;
#line 294 "../src/Views/FirewallPanel.vala"
			_g_free0 (_tmp29_);
#line 1682 "FirewallPanel.c"
		}
	} else {
		const gchar* _tmp31_;
		gchar* _tmp32_;
#line 297 "../src/Views/FirewallPanel.vala"
		_tmp31_ = rule->from;
#line 297 "../src/Views/FirewallPanel.vala"
		_tmp32_ = g_strdup (_tmp31_);
#line 297 "../src/Views/FirewallPanel.vala"
		_g_free0 (from);
#line 297 "../src/Views/FirewallPanel.vala"
		from = _tmp32_;
#line 1695 "FirewallPanel.c"
	}
#line 300 "../src/Views/FirewallPanel.vala"
	_tmp33_ = rule->to_ports;
#line 300 "../src/Views/FirewallPanel.vala"
	if (g_strcmp0 (_tmp33_, "") != 0) {
#line 1701 "FirewallPanel.c"
		gboolean _tmp34_ = FALSE;
		const gchar* _tmp35_;
#line 301 "../src/Views/FirewallPanel.vala"
		_tmp35_ = rule->to_ports;
#line 301 "../src/Views/FirewallPanel.vala"
		if (string_contains (_tmp35_, ":")) {
#line 301 "../src/Views/FirewallPanel.vala"
			_tmp34_ = TRUE;
#line 1710 "FirewallPanel.c"
		} else {
			const gchar* _tmp36_;
#line 301 "../src/Views/FirewallPanel.vala"
			_tmp36_ = rule->to_ports;
#line 301 "../src/Views/FirewallPanel.vala"
			_tmp34_ = string_contains (_tmp36_, ",");
#line 1717 "FirewallPanel.c"
		}
#line 301 "../src/Views/FirewallPanel.vala"
		if (_tmp34_) {
#line 1721 "FirewallPanel.c"
			const gchar* _tmp37_;
			const gchar* _tmp38_;
			gchar* _tmp39_;
			gchar* _tmp40_;
			gchar* _tmp41_;
#line 302 "../src/Views/FirewallPanel.vala"
			_tmp37_ = rule->to;
#line 302 "../src/Views/FirewallPanel.vala"
			_tmp38_ = rule->to_ports;
#line 302 "../src/Views/FirewallPanel.vala"
			_tmp39_ = string_replace (_tmp38_, ":", "-");
#line 302 "../src/Views/FirewallPanel.vala"
			_tmp40_ = _tmp39_;
#line 302 "../src/Views/FirewallPanel.vala"
			_tmp41_ = g_strdup_printf (_ ("%s Ports %s"), _tmp37_, _tmp40_);
#line 302 "../src/Views/FirewallPanel.vala"
			_g_free0 (to);
#line 302 "../src/Views/FirewallPanel.vala"
			to = _tmp41_;
#line 302 "../src/Views/FirewallPanel.vala"
			_g_free0 (_tmp40_);
#line 1743 "FirewallPanel.c"
		} else {
			const gchar* _tmp42_;
			const gchar* _tmp43_;
			gchar* _tmp44_;
			gchar* _tmp45_;
			gchar* _tmp46_;
#line 304 "../src/Views/FirewallPanel.vala"
			_tmp42_ = rule->to;
#line 304 "../src/Views/FirewallPanel.vala"
			_tmp43_ = rule->to_ports;
#line 304 "../src/Views/FirewallPanel.vala"
			_tmp44_ = string_replace (_tmp43_, ":", "-");
#line 304 "../src/Views/FirewallPanel.vala"
			_tmp45_ = _tmp44_;
#line 304 "../src/Views/FirewallPanel.vala"
			_tmp46_ = g_strdup_printf (_ ("%s Port %s"), _tmp42_, _tmp45_);
#line 304 "../src/Views/FirewallPanel.vala"
			_g_free0 (to);
#line 304 "../src/Views/FirewallPanel.vala"
			to = _tmp46_;
#line 304 "../src/Views/FirewallPanel.vala"
			_g_free0 (_tmp45_);
#line 1766 "FirewallPanel.c"
		}
	} else {
		const gchar* _tmp47_;
		gchar* _tmp48_;
#line 307 "../src/Views/FirewallPanel.vala"
		_tmp47_ = rule->to;
#line 307 "../src/Views/FirewallPanel.vala"
		_tmp48_ = g_strdup (_tmp47_);
#line 307 "../src/Views/FirewallPanel.vala"
		_g_free0 (to);
#line 307 "../src/Views/FirewallPanel.vala"
		to = _tmp48_;
#line 1779 "FirewallPanel.c"
	}
#line 311 "../src/Views/FirewallPanel.vala"
	_tmp49_ = self->priv->list_store;
#line 311 "../src/Views/FirewallPanel.vala"
	gtk_list_store_append (_tmp49_, &_tmp50_);
#line 311 "../src/Views/FirewallPanel.vala"
	iter = _tmp50_;
#line 312 "../src/Views/FirewallPanel.vala"
	_tmp51_ = self->priv->list_store;
#line 312 "../src/Views/FirewallPanel.vala"
	_tmp52_ = iter;
#line 312 "../src/Views/FirewallPanel.vala"
	_tmp53_ = action;
#line 312 "../src/Views/FirewallPanel.vala"
	_tmp54_ = protocol;
#line 312 "../src/Views/FirewallPanel.vala"
	_tmp55_ = direction;
#line 312 "../src/Views/FirewallPanel.vala"
	_tmp56_ = version;
#line 312 "../src/Views/FirewallPanel.vala"
	_tmp57_ = to;
#line 312 "../src/Views/FirewallPanel.vala"
	_tmp58_ = string_strip (_tmp57_);
#line 312 "../src/Views/FirewallPanel.vala"
	_tmp59_ = _tmp58_;
#line 312 "../src/Views/FirewallPanel.vala"
	_tmp60_ = from;
#line 312 "../src/Views/FirewallPanel.vala"
	_tmp61_ = string_strip (_tmp60_);
#line 312 "../src/Views/FirewallPanel.vala"
	_tmp62_ = _tmp61_;
#line 312 "../src/Views/FirewallPanel.vala"
	gtk_list_store_set (_tmp51_, &_tmp52_, SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_ACTION, _tmp53_, SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_PROTOCOL, _tmp54_, SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_DIRECTION, _tmp55_, SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_V6, _tmp56_, SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_ENABLED, enabled, SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_RULE, rule, SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_TO, _tmp59_, SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_FROM, _tmp62_, -1);
#line 312 "../src/Views/FirewallPanel.vala"
	_g_free0 (_tmp62_);
#line 312 "../src/Views/FirewallPanel.vala"
	_g_free0 (_tmp59_);
#line 244 "../src/Views/FirewallPanel.vala"
	_g_free0 (to);
#line 244 "../src/Views/FirewallPanel.vala"
	_g_free0 (from);
#line 244 "../src/Views/FirewallPanel.vala"
	_g_free0 (version);
#line 244 "../src/Views/FirewallPanel.vala"
	_g_free0 (direction);
#line 244 "../src/Views/FirewallPanel.vala"
	_g_free0 (protocol);
#line 244 "../src/Views/FirewallPanel.vala"
	_g_free0 (action);
#line 1829 "FirewallPanel.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 317 "../src/Views/FirewallPanel.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 317 "../src/Views/FirewallPanel.vala"
	return _data2_;
#line 1839 "FirewallPanel.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 317 "../src/Views/FirewallPanel.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 1849 "FirewallPanel.c"
		SecurityPrivacyFirewallPanel* self;
#line 317 "../src/Views/FirewallPanel.vala"
		self = _data2_->self;
#line 317 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (_data2_->add_button);
#line 317 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (self);
#line 317 "../src/Views/FirewallPanel.vala"
		g_slice_free (Block2Data, _data2_);
#line 1859 "FirewallPanel.c"
	}
}

static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
#line 347 "../src/Views/FirewallPanel.vala"
	g_boxed_free (gtk_tree_path_get_type (), self);
#line 1868 "FirewallPanel.c"
}

static void
__lambda17_ (SecurityPrivacyFirewallPanel* self,
             const gchar* path)
{
	GValue active = {0};
	GtkTreeIter iter = {0};
	GtkListStore* _tmp0_;
	GtkTreePath* _tmp1_;
	GtkTreePath* _tmp2_;
	GtkTreeIter _tmp3_ = {0};
	GtkListStore* _tmp4_;
	GtkTreeIter _tmp5_;
	GValue _tmp6_ = {0};
	gboolean is_active = FALSE;
	GtkListStore* _tmp7_;
	GtkTreeIter _tmp8_;
	GValue rule_value = {0};
	GtkListStore* _tmp9_;
	GtkTreeIter _tmp10_;
	GValue _tmp11_ = {0};
	SecurityPrivacyUFWHelpersRule* rule = NULL;
	GObject* _tmp12_;
	SecurityPrivacyUFWHelpersRule* _tmp13_;
	gchar* gen_hash = NULL;
	SecurityPrivacyUFWHelpersRule* _tmp14_;
	gchar* _tmp15_;
#line 344 "../src/Views/FirewallPanel.vala"
	g_return_if_fail (path != NULL);
#line 347 "../src/Views/FirewallPanel.vala"
	_tmp0_ = self->priv->list_store;
#line 347 "../src/Views/FirewallPanel.vala"
	_tmp1_ = gtk_tree_path_new_from_string (path);
#line 347 "../src/Views/FirewallPanel.vala"
	_tmp2_ = _tmp1_;
#line 347 "../src/Views/FirewallPanel.vala"
	gtk_tree_model_get_iter ((GtkTreeModel*) _tmp0_, &_tmp3_, _tmp2_);
#line 347 "../src/Views/FirewallPanel.vala"
	iter = _tmp3_;
#line 347 "../src/Views/FirewallPanel.vala"
	__vala_GtkTreePath_free0 (_tmp2_);
#line 348 "../src/Views/FirewallPanel.vala"
	_tmp4_ = self->priv->list_store;
#line 348 "../src/Views/FirewallPanel.vala"
	_tmp5_ = iter;
#line 348 "../src/Views/FirewallPanel.vala"
	gtk_tree_model_get_value ((GtkTreeModel*) _tmp4_, &_tmp5_, (gint) SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_ENABLED, &_tmp6_);
#line 348 "../src/Views/FirewallPanel.vala"
	G_IS_VALUE (&active) ? (g_value_unset (&active), NULL) : NULL;
#line 348 "../src/Views/FirewallPanel.vala"
	active = _tmp6_;
#line 349 "../src/Views/FirewallPanel.vala"
	is_active = !g_value_get_boolean (&active);
#line 350 "../src/Views/FirewallPanel.vala"
	_tmp7_ = self->priv->list_store;
#line 350 "../src/Views/FirewallPanel.vala"
	_tmp8_ = iter;
#line 350 "../src/Views/FirewallPanel.vala"
	gtk_list_store_set (_tmp7_, &_tmp8_, SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_ENABLED, is_active, -1);
#line 353 "../src/Views/FirewallPanel.vala"
	_tmp9_ = self->priv->list_store;
#line 353 "../src/Views/FirewallPanel.vala"
	_tmp10_ = iter;
#line 353 "../src/Views/FirewallPanel.vala"
	gtk_tree_model_get_value ((GtkTreeModel*) _tmp9_, &_tmp10_, (gint) SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_RULE, &_tmp11_);
#line 353 "../src/Views/FirewallPanel.vala"
	G_IS_VALUE (&rule_value) ? (g_value_unset (&rule_value), NULL) : NULL;
#line 353 "../src/Views/FirewallPanel.vala"
	rule_value = _tmp11_;
#line 354 "../src/Views/FirewallPanel.vala"
	_tmp12_ = g_value_get_object (&rule_value);
#line 354 "../src/Views/FirewallPanel.vala"
	_tmp13_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, SECURITY_PRIVACY_UFW_HELPERS_TYPE_RULE, SecurityPrivacyUFWHelpersRule));
#line 354 "../src/Views/FirewallPanel.vala"
	rule = _tmp13_;
#line 355 "../src/Views/FirewallPanel.vala"
	_tmp14_ = rule;
#line 355 "../src/Views/FirewallPanel.vala"
	_tmp15_ = security_privacy_firewall_panel_generate_hash_for_rule (self, _tmp14_);
#line 355 "../src/Views/FirewallPanel.vala"
	gen_hash = _tmp15_;
#line 356 "../src/Views/FirewallPanel.vala"
	if (is_active == FALSE) {
#line 1953 "FirewallPanel.c"
		SecurityPrivacyUFWHelpersRule* _tmp16_;
#line 357 "../src/Views/FirewallPanel.vala"
		_tmp16_ = rule;
#line 357 "../src/Views/FirewallPanel.vala"
		security_privacy_firewall_panel_disable_rule (self, _tmp16_);
#line 1959 "FirewallPanel.c"
	} else {
		const gchar* _tmp17_;
#line 359 "../src/Views/FirewallPanel.vala"
		_tmp17_ = gen_hash;
#line 359 "../src/Views/FirewallPanel.vala"
		security_privacy_firewall_panel_enable_rule (self, _tmp17_);
#line 1966 "FirewallPanel.c"
	}
#line 362 "../src/Views/FirewallPanel.vala"
	security_privacy_firewall_panel_reload_rule_numbers (self);
#line 344 "../src/Views/FirewallPanel.vala"
	_g_free0 (gen_hash);
#line 344 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (rule);
#line 344 "../src/Views/FirewallPanel.vala"
	G_IS_VALUE (&rule_value) ? (g_value_unset (&rule_value), NULL) : NULL;
#line 344 "../src/Views/FirewallPanel.vala"
	G_IS_VALUE (&active) ? (g_value_unset (&active), NULL) : NULL;
#line 1978 "FirewallPanel.c"
}

static void
___lambda17__gtk_cell_renderer_toggle_toggled (GtkCellRendererToggle* _sender,
                                               const gchar* path,
                                               gpointer self)
{
#line 344 "../src/Views/FirewallPanel.vala"
	__lambda17_ ((SecurityPrivacyFirewallPanel*) self, path);
#line 1988 "FirewallPanel.c"
}

static void
__lambda18_ (SecurityPrivacyFirewallPanel* self)
{
	GtkButton* _tmp0_;
#line 393 "../src/Views/FirewallPanel.vala"
	_tmp0_ = self->priv->remove_button;
#line 393 "../src/Views/FirewallPanel.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, TRUE);
#line 1999 "FirewallPanel.c"
}

static void
___lambda18__gtk_tree_view_cursor_changed (GtkTreeView* _sender,
                                           gpointer self)
{
#line 392 "../src/Views/FirewallPanel.vala"
	__lambda18_ ((SecurityPrivacyFirewallPanel*) self);
#line 2008 "FirewallPanel.c"
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 396 "../src/Views/FirewallPanel.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 396 "../src/Views/FirewallPanel.vala"
	return _data3_;
#line 2018 "FirewallPanel.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 396 "../src/Views/FirewallPanel.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 2028 "FirewallPanel.c"
		SecurityPrivacyFirewallPanel* self;
#line 396 "../src/Views/FirewallPanel.vala"
		self = _data3_->_data2_->self;
#line 396 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (_data3_->add_popover);
#line 396 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (_data3_->ports_entry);
#line 396 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (_data3_->direction_combobox);
#line 396 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (_data3_->version_combobox);
#line 396 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (_data3_->protocol_combobox);
#line 396 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (_data3_->policy_combobox);
#line 396 "../src/Views/FirewallPanel.vala"
		block2_data_unref (_data3_->_data2_);
#line 396 "../src/Views/FirewallPanel.vala"
		_data3_->_data2_ = NULL;
#line 396 "../src/Views/FirewallPanel.vala"
		g_slice_free (Block3Data, _data3_);
#line 2050 "FirewallPanel.c"
	}
}

static void
__lambda20_ (Block3Data* _data3_)
{
	Block2Data* _data2_;
	SecurityPrivacyFirewallPanel* self;
	SecurityPrivacyUFWHelpersRule* rule = NULL;
	SecurityPrivacyUFWHelpersRule* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp15_;
	gint _tmp16_;
	SecurityPrivacyUFWHelpersRule* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	SecurityPrivacyUFWHelpersRule* _tmp24_;
#line 483 "../src/Views/FirewallPanel.vala"
	_data2_ = _data3_->_data2_;
#line 483 "../src/Views/FirewallPanel.vala"
	self = _data2_->self;
#line 484 "../src/Views/FirewallPanel.vala"
	_tmp0_ = security_privacy_ufw_helpers_rule_new ();
#line 484 "../src/Views/FirewallPanel.vala"
	rule = _tmp0_;
#line 486 "../src/Views/FirewallPanel.vala"
	_tmp1_ = gtk_combo_box_get_active ((GtkComboBox*) _data3_->direction_combobox);
#line 486 "../src/Views/FirewallPanel.vala"
	_tmp2_ = _tmp1_;
#line 486 "../src/Views/FirewallPanel.vala"
	if (_tmp2_ == 0) {
#line 2088 "FirewallPanel.c"
		SecurityPrivacyUFWHelpersRule* _tmp3_;
#line 487 "../src/Views/FirewallPanel.vala"
		_tmp3_ = rule;
#line 487 "../src/Views/FirewallPanel.vala"
		_tmp3_->direction = SECURITY_PRIVACY_UFW_HELPERS_RULE_DIRECTION_IN;
#line 2094 "FirewallPanel.c"
	} else {
		SecurityPrivacyUFWHelpersRule* _tmp4_;
#line 489 "../src/Views/FirewallPanel.vala"
		_tmp4_ = rule;
#line 489 "../src/Views/FirewallPanel.vala"
		_tmp4_->direction = SECURITY_PRIVACY_UFW_HELPERS_RULE_DIRECTION_OUT;
#line 2101 "FirewallPanel.c"
	}
#line 492 "../src/Views/FirewallPanel.vala"
	_tmp5_ = gtk_combo_box_get_active ((GtkComboBox*) _data3_->protocol_combobox);
#line 492 "../src/Views/FirewallPanel.vala"
	_tmp6_ = _tmp5_;
#line 492 "../src/Views/FirewallPanel.vala"
	if (_tmp6_ == 0) {
#line 2109 "FirewallPanel.c"
		SecurityPrivacyUFWHelpersRule* _tmp7_;
#line 493 "../src/Views/FirewallPanel.vala"
		_tmp7_ = rule;
#line 493 "../src/Views/FirewallPanel.vala"
		_tmp7_->protocol = SECURITY_PRIVACY_UFW_HELPERS_RULE_PROTOCOL_TCP;
#line 2115 "FirewallPanel.c"
	} else {
		SecurityPrivacyUFWHelpersRule* _tmp8_;
#line 495 "../src/Views/FirewallPanel.vala"
		_tmp8_ = rule;
#line 495 "../src/Views/FirewallPanel.vala"
		_tmp8_->protocol = SECURITY_PRIVACY_UFW_HELPERS_RULE_PROTOCOL_UDP;
#line 2122 "FirewallPanel.c"
	}
#line 498 "../src/Views/FirewallPanel.vala"
	_tmp9_ = gtk_combo_box_get_active ((GtkComboBox*) _data3_->policy_combobox);
#line 498 "../src/Views/FirewallPanel.vala"
	_tmp10_ = _tmp9_;
#line 498 "../src/Views/FirewallPanel.vala"
	switch (_tmp10_) {
#line 498 "../src/Views/FirewallPanel.vala"
		case 0:
#line 2132 "FirewallPanel.c"
		{
			SecurityPrivacyUFWHelpersRule* _tmp11_;
#line 500 "../src/Views/FirewallPanel.vala"
			_tmp11_ = rule;
#line 500 "../src/Views/FirewallPanel.vala"
			_tmp11_->action = SECURITY_PRIVACY_UFW_HELPERS_RULE_ACTION_ALLOW;
#line 501 "../src/Views/FirewallPanel.vala"
			break;
#line 2141 "FirewallPanel.c"
		}
#line 498 "../src/Views/FirewallPanel.vala"
		case 1:
#line 2145 "FirewallPanel.c"
		{
			SecurityPrivacyUFWHelpersRule* _tmp12_;
#line 503 "../src/Views/FirewallPanel.vala"
			_tmp12_ = rule;
#line 503 "../src/Views/FirewallPanel.vala"
			_tmp12_->action = SECURITY_PRIVACY_UFW_HELPERS_RULE_ACTION_DENY;
#line 504 "../src/Views/FirewallPanel.vala"
			break;
#line 2154 "FirewallPanel.c"
		}
#line 498 "../src/Views/FirewallPanel.vala"
		case 2:
#line 2158 "FirewallPanel.c"
		{
			SecurityPrivacyUFWHelpersRule* _tmp13_;
#line 506 "../src/Views/FirewallPanel.vala"
			_tmp13_ = rule;
#line 506 "../src/Views/FirewallPanel.vala"
			_tmp13_->action = SECURITY_PRIVACY_UFW_HELPERS_RULE_ACTION_REJECT;
#line 507 "../src/Views/FirewallPanel.vala"
			break;
#line 2167 "FirewallPanel.c"
		}
#line 498 "../src/Views/FirewallPanel.vala"
		case 3:
#line 2171 "FirewallPanel.c"
		{
			SecurityPrivacyUFWHelpersRule* _tmp14_;
#line 509 "../src/Views/FirewallPanel.vala"
			_tmp14_ = rule;
#line 509 "../src/Views/FirewallPanel.vala"
			_tmp14_->action = SECURITY_PRIVACY_UFW_HELPERS_RULE_ACTION_LIMIT;
#line 510 "../src/Views/FirewallPanel.vala"
			break;
#line 2180 "FirewallPanel.c"
		}
		default:
#line 498 "../src/Views/FirewallPanel.vala"
		break;
#line 2185 "FirewallPanel.c"
	}
#line 513 "../src/Views/FirewallPanel.vala"
	_tmp15_ = gtk_combo_box_get_active ((GtkComboBox*) _data3_->version_combobox);
#line 513 "../src/Views/FirewallPanel.vala"
	_tmp16_ = _tmp15_;
#line 513 "../src/Views/FirewallPanel.vala"
	switch (_tmp16_) {
#line 513 "../src/Views/FirewallPanel.vala"
		case 0:
#line 2195 "FirewallPanel.c"
		{
			SecurityPrivacyUFWHelpersRule* _tmp17_;
#line 515 "../src/Views/FirewallPanel.vala"
			_tmp17_ = rule;
#line 515 "../src/Views/FirewallPanel.vala"
			_tmp17_->version = SECURITY_PRIVACY_UFW_HELPERS_RULE_VERSION_IPV4;
#line 516 "../src/Views/FirewallPanel.vala"
			break;
#line 2204 "FirewallPanel.c"
		}
#line 513 "../src/Views/FirewallPanel.vala"
		case 1:
#line 2208 "FirewallPanel.c"
		{
			SecurityPrivacyUFWHelpersRule* _tmp18_;
#line 518 "../src/Views/FirewallPanel.vala"
			_tmp18_ = rule;
#line 518 "../src/Views/FirewallPanel.vala"
			_tmp18_->version = SECURITY_PRIVACY_UFW_HELPERS_RULE_VERSION_IPV6;
#line 519 "../src/Views/FirewallPanel.vala"
			break;
#line 2217 "FirewallPanel.c"
		}
#line 513 "../src/Views/FirewallPanel.vala"
		case 2:
#line 2221 "FirewallPanel.c"
		{
			SecurityPrivacyUFWHelpersRule* _tmp19_;
#line 521 "../src/Views/FirewallPanel.vala"
			_tmp19_ = rule;
#line 521 "../src/Views/FirewallPanel.vala"
			_tmp19_->version = SECURITY_PRIVACY_UFW_HELPERS_RULE_VERSION_BOTH;
#line 522 "../src/Views/FirewallPanel.vala"
			break;
#line 2230 "FirewallPanel.c"
		}
		default:
#line 513 "../src/Views/FirewallPanel.vala"
		break;
#line 2235 "FirewallPanel.c"
	}
#line 525 "../src/Views/FirewallPanel.vala"
	_tmp20_ = rule;
#line 525 "../src/Views/FirewallPanel.vala"
	_tmp21_ = gtk_editable_get_text ((GtkEditable*) _data3_->ports_entry);
#line 525 "../src/Views/FirewallPanel.vala"
	_tmp22_ = _tmp21_;
#line 525 "../src/Views/FirewallPanel.vala"
	_tmp23_ = string_replace (_tmp22_, "-", ":");
#line 525 "../src/Views/FirewallPanel.vala"
	_g_free0 (_tmp20_->to_ports);
#line 525 "../src/Views/FirewallPanel.vala"
	_tmp20_->to_ports = _tmp23_;
#line 526 "../src/Views/FirewallPanel.vala"
	_tmp24_ = rule;
#line 526 "../src/Views/FirewallPanel.vala"
	security_privacy_ufw_helpers_add_rule (_tmp24_);
#line 527 "../src/Views/FirewallPanel.vala"
	gtk_popover_popdown (_data3_->add_popover);
#line 528 "../src/Views/FirewallPanel.vala"
	security_privacy_firewall_panel_show_rules (self);
#line 483 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (rule);
#line 2259 "FirewallPanel.c"
}

static void
___lambda20__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
#line 483 "../src/Views/FirewallPanel.vala"
	__lambda20_ (self);
#line 2268 "FirewallPanel.c"
}

static void
__lambda19_ (Block2Data* _data2_)
{
	SecurityPrivacyFirewallPanel* self;
	Block3Data* _data3_;
	GtkComboBoxText* _tmp0_;
	GtkLabel* policy_label = NULL;
	GtkWidget* _tmp1_;
	GtkLabel* _tmp2_ = NULL;
	GtkComboBoxText* _tmp3_;
	GtkLabel* protocol_label = NULL;
	GtkWidget* _tmp4_;
	GtkLabel* _tmp5_ = NULL;
	GtkComboBoxText* _tmp6_;
	GtkLabel* version_label = NULL;
	GtkWidget* _tmp7_;
	GtkLabel* _tmp8_ = NULL;
	GtkComboBoxText* _tmp9_;
	GtkLabel* direction_label = NULL;
	GtkWidget* _tmp10_;
	GtkLabel* _tmp11_ = NULL;
	gchar* _tmp12_;
	GtkEntry* _tmp13_ = NULL;
	GtkLabel* ports_label = NULL;
	GtkWidget* _tmp14_;
	GtkLabel* _tmp15_ = NULL;
	GtkButton* do_add_button = NULL;
	GtkButton* _tmp16_ = NULL;
	GtkGrid* popover_grid = NULL;
	GtkGrid* _tmp17_ = NULL;
	GtkWidget* _tmp18_;
	GtkPopover* _tmp19_ = NULL;
	GtkButton* _tmp20_;
#line 396 "../src/Views/FirewallPanel.vala"
	self = _data2_->self;
#line 396 "../src/Views/FirewallPanel.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 396 "../src/Views/FirewallPanel.vala"
	_data3_->_ref_count_ = 1;
#line 396 "../src/Views/FirewallPanel.vala"
	_data3_->_data2_ = block2_data_ref (_data2_);
#line 397 "../src/Views/FirewallPanel.vala"
	_tmp0_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
#line 397 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp0_);
#line 397 "../src/Views/FirewallPanel.vala"
	_data3_->policy_combobox = _tmp0_;
#line 398 "../src/Views/FirewallPanel.vala"
	gtk_combo_box_text_append_text (_data3_->policy_combobox, _ ("Allow"));
#line 399 "../src/Views/FirewallPanel.vala"
	gtk_combo_box_text_append_text (_data3_->policy_combobox, _ ("Deny"));
#line 400 "../src/Views/FirewallPanel.vala"
	gtk_combo_box_text_append_text (_data3_->policy_combobox, _ ("Reject"));
#line 401 "../src/Views/FirewallPanel.vala"
	gtk_combo_box_text_append_text (_data3_->policy_combobox, _ ("Limit"));
#line 402 "../src/Views/FirewallPanel.vala"
	gtk_combo_box_set_active ((GtkComboBox*) _data3_->policy_combobox, 0);
#line 404 "../src/Views/FirewallPanel.vala"
	_tmp1_ = _g_object_ref0 ((GtkWidget*) _data3_->policy_combobox);
#line 404 "../src/Views/FirewallPanel.vala"
	_tmp2_ = (GtkLabel*) gtk_label_new (_ ("Action:"));
#line 404 "../src/Views/FirewallPanel.vala"
	gtk_label_set_mnemonic_widget (_tmp2_, _tmp1_);
#line 404 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (_tmp1_);
#line 404 "../src/Views/FirewallPanel.vala"
	gtk_label_set_xalign (_tmp2_, (gfloat) 1);
#line 404 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp2_);
#line 404 "../src/Views/FirewallPanel.vala"
	policy_label = _tmp2_;
#line 409 "../src/Views/FirewallPanel.vala"
	_tmp3_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
#line 409 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp3_);
#line 409 "../src/Views/FirewallPanel.vala"
	_data3_->protocol_combobox = _tmp3_;
#line 410 "../src/Views/FirewallPanel.vala"
	gtk_combo_box_text_append_text (_data3_->protocol_combobox, "TCP");
#line 411 "../src/Views/FirewallPanel.vala"
	gtk_combo_box_text_append_text (_data3_->protocol_combobox, "UDP");
#line 412 "../src/Views/FirewallPanel.vala"
	gtk_combo_box_set_active ((GtkComboBox*) _data3_->protocol_combobox, 0);
#line 414 "../src/Views/FirewallPanel.vala"
	_tmp4_ = _g_object_ref0 ((GtkWidget*) _data3_->protocol_combobox);
#line 414 "../src/Views/FirewallPanel.vala"
	_tmp5_ = (GtkLabel*) gtk_label_new (_ ("Protocol:"));
#line 414 "../src/Views/FirewallPanel.vala"
	gtk_label_set_mnemonic_widget (_tmp5_, _tmp4_);
#line 414 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (_tmp4_);
#line 414 "../src/Views/FirewallPanel.vala"
	gtk_label_set_xalign (_tmp5_, (gfloat) 1);
#line 414 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp5_);
#line 414 "../src/Views/FirewallPanel.vala"
	protocol_label = _tmp5_;
#line 419 "../src/Views/FirewallPanel.vala"
	_tmp6_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
#line 419 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp6_);
#line 419 "../src/Views/FirewallPanel.vala"
	_data3_->version_combobox = _tmp6_;
#line 420 "../src/Views/FirewallPanel.vala"
	gtk_combo_box_text_append_text (_data3_->version_combobox, "IPv4");
#line 421 "../src/Views/FirewallPanel.vala"
	gtk_combo_box_text_append_text (_data3_->version_combobox, "IPv6");
#line 422 "../src/Views/FirewallPanel.vala"
	gtk_combo_box_text_append_text (_data3_->version_combobox, _ ("Both"));
#line 423 "../src/Views/FirewallPanel.vala"
	gtk_combo_box_set_active ((GtkComboBox*) _data3_->version_combobox, 0);
#line 425 "../src/Views/FirewallPanel.vala"
	_tmp7_ = _g_object_ref0 ((GtkWidget*) _data3_->version_combobox);
#line 425 "../src/Views/FirewallPanel.vala"
	_tmp8_ = (GtkLabel*) gtk_label_new (_ ("Version:"));
#line 425 "../src/Views/FirewallPanel.vala"
	gtk_label_set_mnemonic_widget (_tmp8_, _tmp7_);
#line 425 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (_tmp7_);
#line 425 "../src/Views/FirewallPanel.vala"
	gtk_label_set_xalign (_tmp8_, (gfloat) 1);
#line 425 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp8_);
#line 425 "../src/Views/FirewallPanel.vala"
	version_label = _tmp8_;
#line 430 "../src/Views/FirewallPanel.vala"
	_tmp9_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
#line 430 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp9_);
#line 430 "../src/Views/FirewallPanel.vala"
	_data3_->direction_combobox = _tmp9_;
#line 431 "../src/Views/FirewallPanel.vala"
	gtk_combo_box_text_append_text (_data3_->direction_combobox, _ ("In"));
#line 432 "../src/Views/FirewallPanel.vala"
	gtk_combo_box_text_append_text (_data3_->direction_combobox, _ ("Out"));
#line 433 "../src/Views/FirewallPanel.vala"
	gtk_combo_box_set_active ((GtkComboBox*) _data3_->direction_combobox, 0);
#line 435 "../src/Views/FirewallPanel.vala"
	_tmp10_ = _g_object_ref0 ((GtkWidget*) _data3_->direction_combobox);
#line 435 "../src/Views/FirewallPanel.vala"
	_tmp11_ = (GtkLabel*) gtk_label_new (_ ("Direction:"));
#line 435 "../src/Views/FirewallPanel.vala"
	gtk_label_set_mnemonic_widget (_tmp11_, _tmp10_);
#line 435 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (_tmp10_);
#line 435 "../src/Views/FirewallPanel.vala"
	gtk_label_set_xalign (_tmp11_, (gfloat) 1);
#line 435 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp11_);
#line 435 "../src/Views/FirewallPanel.vala"
	direction_label = _tmp11_;
#line 440 "../src/Views/FirewallPanel.vala"
	_tmp12_ = g_strdup_printf (_ ("%d or %d-%d"), 80, 80, 85);
#line 440 "../src/Views/FirewallPanel.vala"
	_tmp13_ = (GtkEntry*) gtk_entry_new ();
#line 440 "../src/Views/FirewallPanel.vala"
	gtk_entry_set_input_purpose (_tmp13_, GTK_INPUT_PURPOSE_NUMBER);
#line 440 "../src/Views/FirewallPanel.vala"
	gtk_entry_set_placeholder_text (_tmp13_, _tmp12_);
#line 440 "../src/Views/FirewallPanel.vala"
	_g_free0 (_tmp12_);
#line 440 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp13_);
#line 440 "../src/Views/FirewallPanel.vala"
	_data3_->ports_entry = _tmp13_;
#line 445 "../src/Views/FirewallPanel.vala"
	_tmp14_ = _g_object_ref0 ((GtkWidget*) _data3_->ports_entry);
#line 445 "../src/Views/FirewallPanel.vala"
	_tmp15_ = (GtkLabel*) gtk_label_new (_ ("Ports:"));
#line 445 "../src/Views/FirewallPanel.vala"
	gtk_label_set_mnemonic_widget (_tmp15_, _tmp14_);
#line 445 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (_tmp14_);
#line 445 "../src/Views/FirewallPanel.vala"
	gtk_label_set_xalign (_tmp15_, (gfloat) 1);
#line 445 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp15_);
#line 445 "../src/Views/FirewallPanel.vala"
	ports_label = _tmp15_;
#line 450 "../src/Views/FirewallPanel.vala"
	_tmp16_ = (GtkButton*) gtk_button_new_with_label (_ ("Add Rule"));
#line 450 "../src/Views/FirewallPanel.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp16_, GTK_ALIGN_END);
#line 450 "../src/Views/FirewallPanel.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp16_, TRUE);
#line 450 "../src/Views/FirewallPanel.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp16_, 6);
#line 450 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp16_);
#line 450 "../src/Views/FirewallPanel.vala"
	do_add_button = _tmp16_;
#line 455 "../src/Views/FirewallPanel.vala"
	gtk_widget_add_css_class ((GtkWidget*) do_add_button, GRANITE_STYLE_CLASS_SUGGESTED_ACTION);
#line 457 "../src/Views/FirewallPanel.vala"
	_tmp17_ = (GtkGrid*) gtk_grid_new ();
#line 457 "../src/Views/FirewallPanel.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp17_, 12);
#line 457 "../src/Views/FirewallPanel.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp17_, 12);
#line 457 "../src/Views/FirewallPanel.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp17_, 12);
#line 457 "../src/Views/FirewallPanel.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp17_, 12);
#line 457 "../src/Views/FirewallPanel.vala"
	gtk_grid_set_column_spacing (_tmp17_, 12);
#line 457 "../src/Views/FirewallPanel.vala"
	gtk_grid_set_row_spacing (_tmp17_, 6);
#line 457 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp17_);
#line 457 "../src/Views/FirewallPanel.vala"
	popover_grid = _tmp17_;
#line 465 "../src/Views/FirewallPanel.vala"
	gtk_grid_attach (popover_grid, (GtkWidget*) policy_label, 0, 0, 1, 1);
#line 466 "../src/Views/FirewallPanel.vala"
	gtk_grid_attach (popover_grid, (GtkWidget*) _data3_->policy_combobox, 1, 0, 1, 1);
#line 467 "../src/Views/FirewallPanel.vala"
	gtk_grid_attach (popover_grid, (GtkWidget*) protocol_label, 0, 1, 1, 1);
#line 468 "../src/Views/FirewallPanel.vala"
	gtk_grid_attach (popover_grid, (GtkWidget*) _data3_->protocol_combobox, 1, 1, 1, 1);
#line 469 "../src/Views/FirewallPanel.vala"
	gtk_grid_attach (popover_grid, (GtkWidget*) version_label, 0, 2, 1, 1);
#line 470 "../src/Views/FirewallPanel.vala"
	gtk_grid_attach (popover_grid, (GtkWidget*) _data3_->version_combobox, 1, 2, 1, 1);
#line 471 "../src/Views/FirewallPanel.vala"
	gtk_grid_attach (popover_grid, (GtkWidget*) direction_label, 0, 3, 1, 1);
#line 472 "../src/Views/FirewallPanel.vala"
	gtk_grid_attach (popover_grid, (GtkWidget*) _data3_->direction_combobox, 1, 3, 1, 1);
#line 473 "../src/Views/FirewallPanel.vala"
	gtk_grid_attach (popover_grid, (GtkWidget*) ports_label, 0, 4, 1, 1);
#line 474 "../src/Views/FirewallPanel.vala"
	gtk_grid_attach (popover_grid, (GtkWidget*) _data3_->ports_entry, 1, 4, 1, 1);
#line 475 "../src/Views/FirewallPanel.vala"
	gtk_grid_attach (popover_grid, (GtkWidget*) do_add_button, 0, 5, 2, 1);
#line 477 "../src/Views/FirewallPanel.vala"
	_tmp18_ = _g_object_ref0 ((GtkWidget*) popover_grid);
#line 477 "../src/Views/FirewallPanel.vala"
	_tmp19_ = (GtkPopover*) gtk_popover_new ();
#line 477 "../src/Views/FirewallPanel.vala"
	gtk_popover_set_child (_tmp19_, _tmp18_);
#line 477 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (_tmp18_);
#line 477 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp19_);
#line 477 "../src/Views/FirewallPanel.vala"
	_data3_->add_popover = _tmp19_;
#line 480 "../src/Views/FirewallPanel.vala"
	_tmp20_ = _data2_->add_button;
#line 480 "../src/Views/FirewallPanel.vala"
	gtk_widget_set_parent ((GtkWidget*) _data3_->add_popover, (GtkWidget*) _tmp20_);
#line 481 "../src/Views/FirewallPanel.vala"
	gtk_popover_popup (_data3_->add_popover);
#line 483 "../src/Views/FirewallPanel.vala"
	g_signal_connect_data (do_add_button, "clicked", (GCallback) ___lambda20__gtk_button_clicked, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
#line 396 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (popover_grid);
#line 396 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (do_add_button);
#line 396 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (ports_label);
#line 396 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (direction_label);
#line 396 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (version_label);
#line 396 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (protocol_label);
#line 396 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (policy_label);
#line 396 "../src/Views/FirewallPanel.vala"
	block3_data_unref (_data3_);
#line 396 "../src/Views/FirewallPanel.vala"
	_data3_ = NULL;
#line 2542 "FirewallPanel.c"
}

static void
___lambda19__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
#line 396 "../src/Views/FirewallPanel.vala"
	__lambda19_ (self);
#line 2551 "FirewallPanel.c"
}

static void
__lambda21_ (SecurityPrivacyFirewallPanel* self)
{
	GtkTreePath* path = NULL;
	GtkTreeViewColumn* column = NULL;
	GtkTreeView* _tmp0_;
	GtkTreePath* _tmp1_ = NULL;
	GtkTreeViewColumn* _tmp2_ = NULL;
	GtkTreeViewColumn* _tmp3_;
	GtkTreeIter iter = {0};
	GtkListStore* _tmp4_;
	GtkTreePath* _tmp5_;
	GtkTreeIter _tmp6_ = {0};
	GValue val = {0};
	GtkListStore* _tmp7_;
	GtkTreeIter _tmp8_;
	GValue _tmp9_ = {0};
	SecurityPrivacyUFWHelpersRule* rule = NULL;
	GObject* _tmp10_;
	SecurityPrivacyUFWHelpersRule* _tmp11_;
	gchar* gen_hash = NULL;
	SecurityPrivacyUFWHelpersRule* _tmp12_;
	gchar* _tmp13_;
	GValue active = {0};
	GtkListStore* _tmp14_;
	GtkTreeIter _tmp15_;
	GValue _tmp16_ = {0};
#line 535 "../src/Views/FirewallPanel.vala"
	_tmp0_ = self->priv->view;
#line 535 "../src/Views/FirewallPanel.vala"
	gtk_tree_view_get_cursor (_tmp0_, &_tmp1_, &_tmp2_);
#line 535 "../src/Views/FirewallPanel.vala"
	__vala_GtkTreePath_free0 (path);
#line 535 "../src/Views/FirewallPanel.vala"
	path = _tmp1_;
#line 535 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (column);
#line 535 "../src/Views/FirewallPanel.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 535 "../src/Views/FirewallPanel.vala"
	column = _tmp3_;
#line 537 "../src/Views/FirewallPanel.vala"
	_tmp4_ = self->priv->list_store;
#line 537 "../src/Views/FirewallPanel.vala"
	_tmp5_ = path;
#line 537 "../src/Views/FirewallPanel.vala"
	gtk_tree_model_get_iter ((GtkTreeModel*) _tmp4_, &_tmp6_, _tmp5_);
#line 537 "../src/Views/FirewallPanel.vala"
	iter = _tmp6_;
#line 539 "../src/Views/FirewallPanel.vala"
	_tmp7_ = self->priv->list_store;
#line 539 "../src/Views/FirewallPanel.vala"
	_tmp8_ = iter;
#line 539 "../src/Views/FirewallPanel.vala"
	gtk_tree_model_get_value ((GtkTreeModel*) _tmp7_, &_tmp8_, (gint) SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_RULE, &_tmp9_);
#line 539 "../src/Views/FirewallPanel.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 539 "../src/Views/FirewallPanel.vala"
	val = _tmp9_;
#line 540 "../src/Views/FirewallPanel.vala"
	_tmp10_ = g_value_get_object (&val);
#line 540 "../src/Views/FirewallPanel.vala"
	_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, SECURITY_PRIVACY_UFW_HELPERS_TYPE_RULE, SecurityPrivacyUFWHelpersRule));
#line 540 "../src/Views/FirewallPanel.vala"
	rule = _tmp11_;
#line 541 "../src/Views/FirewallPanel.vala"
	_tmp12_ = rule;
#line 541 "../src/Views/FirewallPanel.vala"
	_tmp13_ = security_privacy_firewall_panel_generate_hash_for_rule (self, _tmp12_);
#line 541 "../src/Views/FirewallPanel.vala"
	gen_hash = _tmp13_;
#line 543 "../src/Views/FirewallPanel.vala"
	_tmp14_ = self->priv->list_store;
#line 543 "../src/Views/FirewallPanel.vala"
	_tmp15_ = iter;
#line 543 "../src/Views/FirewallPanel.vala"
	gtk_tree_model_get_value ((GtkTreeModel*) _tmp14_, &_tmp15_, (gint) SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_ENABLED, &_tmp16_);
#line 543 "../src/Views/FirewallPanel.vala"
	G_IS_VALUE (&active) ? (g_value_unset (&active), NULL) : NULL;
#line 543 "../src/Views/FirewallPanel.vala"
	active = _tmp16_;
#line 544 "../src/Views/FirewallPanel.vala"
	if (g_value_get_boolean (&active)) {
#line 2637 "FirewallPanel.c"
		SecurityPrivacyUFWHelpersRule* _tmp17_;
#line 545 "../src/Views/FirewallPanel.vala"
		_tmp17_ = rule;
#line 545 "../src/Views/FirewallPanel.vala"
		security_privacy_ufw_helpers_remove_rule (_tmp17_);
#line 2643 "FirewallPanel.c"
	} else {
		const gchar* _tmp18_;
#line 547 "../src/Views/FirewallPanel.vala"
		_tmp18_ = gen_hash;
#line 547 "../src/Views/FirewallPanel.vala"
		security_privacy_firewall_panel_delete_disabled_rule (self, _tmp18_);
#line 2650 "FirewallPanel.c"
	}
#line 549 "../src/Views/FirewallPanel.vala"
	security_privacy_firewall_panel_show_rules (self);
#line 532 "../src/Views/FirewallPanel.vala"
	G_IS_VALUE (&active) ? (g_value_unset (&active), NULL) : NULL;
#line 532 "../src/Views/FirewallPanel.vala"
	_g_free0 (gen_hash);
#line 532 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (rule);
#line 532 "../src/Views/FirewallPanel.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 532 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (column);
#line 532 "../src/Views/FirewallPanel.vala"
	__vala_GtkTreePath_free0 (path);
#line 2666 "FirewallPanel.c"
}

static void
___lambda21__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
#line 532 "../src/Views/FirewallPanel.vala"
	__lambda21_ ((SecurityPrivacyFirewallPanel*) self);
#line 2675 "FirewallPanel.c"
}

static void
security_privacy_firewall_panel_create_treeview (SecurityPrivacyFirewallPanel* self)
{
	Block2Data* _data2_;
	GtkListStore* _tmp0_;
	GtkListStore* _tmp1_;
	GtkTreeView* _tmp2_ = NULL;
	GtkCellRendererToggle* celltoggle = NULL;
	GtkCellRendererToggle* _tmp3_;
	GtkCellRendererText* cell = NULL;
	GtkCellRendererText* _tmp4_;
	GtkTreeView* _tmp5_;
	GtkCellRendererToggle* _tmp6_;
	GtkTreeView* _tmp7_;
	GtkCellRendererText* _tmp8_;
	GtkTreeView* _tmp9_;
	GtkCellRendererText* _tmp10_;
	GtkTreeView* _tmp11_;
	GtkCellRendererText* _tmp12_;
	GtkTreeView* _tmp13_;
	GtkCellRendererText* _tmp14_;
	GtkTreeView* _tmp15_;
	GtkCellRendererText* _tmp16_;
	GtkTreeView* _tmp17_;
	GtkCellRendererText* _tmp18_;
	GtkCellRendererToggle* _tmp19_;
	GtkButton* _tmp20_;
	GtkButton* _tmp21_ = NULL;
	GtkActionBar* actionbar = NULL;
	GtkActionBar* _tmp22_;
	GtkActionBar* _tmp23_;
	GtkActionBar* _tmp24_;
	GtkButton* _tmp25_;
	GtkActionBar* _tmp26_;
	GtkButton* _tmp27_;
	GtkScrolledWindow* scrolled = NULL;
	GtkTreeView* _tmp28_;
	GtkWidget* _tmp29_;
	GtkScrolledWindow* _tmp30_ = NULL;
	GtkBox* view_box = NULL;
	GtkBox* _tmp31_;
	GtkBox* _tmp32_;
	GtkScrolledWindow* _tmp33_;
	GtkBox* _tmp34_;
	GtkActionBar* _tmp35_;
	gboolean _tmp36_ = FALSE;
	GtkSwitch* _tmp37_;
	GtkSwitch* _tmp38_;
	gboolean _tmp39_;
	gboolean _tmp40_;
	GtkBox* _tmp44_;
	GtkWidget* _tmp45_;
	GtkFrame* _tmp46_ = NULL;
	GtkFrame* _tmp47_;
	GtkTreeView* _tmp48_;
	GtkButton* _tmp49_;
	GtkButton* _tmp50_;
#line 317 "../src/Views/FirewallPanel.vala"
	g_return_if_fail (self != NULL);
#line 317 "../src/Views/FirewallPanel.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 317 "../src/Views/FirewallPanel.vala"
	_data2_->_ref_count_ = 1;
#line 317 "../src/Views/FirewallPanel.vala"
	_data2_->self = g_object_ref (self);
#line 318 "../src/Views/FirewallPanel.vala"
	_tmp0_ = gtk_list_store_new ((gint) SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_N_COLUMNS, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_BOOLEAN, SECURITY_PRIVACY_UFW_HELPERS_TYPE_RULE, -1);
#line 318 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (self->priv->list_store);
#line 318 "../src/Views/FirewallPanel.vala"
	self->priv->list_store = _tmp0_;
#line 328 "../src/Views/FirewallPanel.vala"
	_tmp1_ = self->priv->list_store;
#line 328 "../src/Views/FirewallPanel.vala"
	_tmp2_ = (GtkTreeView*) gtk_tree_view_new_with_model ((GtkTreeModel*) _tmp1_);
#line 328 "../src/Views/FirewallPanel.vala"
	gtk_tree_view_set_activate_on_single_click (_tmp2_, TRUE);
#line 328 "../src/Views/FirewallPanel.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp2_, TRUE);
#line 328 "../src/Views/FirewallPanel.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp2_, TRUE);
#line 328 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp2_);
#line 328 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (self->priv->view);
#line 328 "../src/Views/FirewallPanel.vala"
	self->priv->view = _tmp2_;
#line 334 "../src/Views/FirewallPanel.vala"
	_tmp3_ = (GtkCellRendererToggle*) gtk_cell_renderer_toggle_new ();
#line 334 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp3_);
#line 334 "../src/Views/FirewallPanel.vala"
	celltoggle = _tmp3_;
#line 335 "../src/Views/FirewallPanel.vala"
	_tmp4_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 335 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp4_);
#line 335 "../src/Views/FirewallPanel.vala"
	cell = _tmp4_;
#line 336 "../src/Views/FirewallPanel.vala"
	_tmp5_ = self->priv->view;
#line 336 "../src/Views/FirewallPanel.vala"
	_tmp6_ = celltoggle;
#line 336 "../src/Views/FirewallPanel.vala"
	gtk_tree_view_insert_column_with_attributes (_tmp5_, -1, _ ("Enabled"), (GtkCellRenderer*) _tmp6_, "active", SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_ENABLED, NULL);
#line 337 "../src/Views/FirewallPanel.vala"
	_tmp7_ = self->priv->view;
#line 337 "../src/Views/FirewallPanel.vala"
	_tmp8_ = cell;
#line 337 "../src/Views/FirewallPanel.vala"
	gtk_tree_view_insert_column_with_attributes (_tmp7_, -1, _ ("Version"), (GtkCellRenderer*) _tmp8_, "text", SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_V6, NULL);
#line 338 "../src/Views/FirewallPanel.vala"
	_tmp9_ = self->priv->view;
#line 338 "../src/Views/FirewallPanel.vala"
	_tmp10_ = cell;
#line 338 "../src/Views/FirewallPanel.vala"
	gtk_tree_view_insert_column_with_attributes (_tmp9_, -1, _ ("Action"), (GtkCellRenderer*) _tmp10_, "text", SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_ACTION, NULL);
#line 339 "../src/Views/FirewallPanel.vala"
	_tmp11_ = self->priv->view;
#line 339 "../src/Views/FirewallPanel.vala"
	_tmp12_ = cell;
#line 339 "../src/Views/FirewallPanel.vala"
	gtk_tree_view_insert_column_with_attributes (_tmp11_, -1, _ ("Protocol"), (GtkCellRenderer*) _tmp12_, "text", SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_PROTOCOL, NULL);
#line 340 "../src/Views/FirewallPanel.vala"
	_tmp13_ = self->priv->view;
#line 340 "../src/Views/FirewallPanel.vala"
	_tmp14_ = cell;
#line 340 "../src/Views/FirewallPanel.vala"
	gtk_tree_view_insert_column_with_attributes (_tmp13_, -1, _ ("Direction"), (GtkCellRenderer*) _tmp14_, "text", SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_DIRECTION, NULL);
#line 341 "../src/Views/FirewallPanel.vala"
	_tmp15_ = self->priv->view;
#line 341 "../src/Views/FirewallPanel.vala"
	_tmp16_ = cell;
#line 341 "../src/Views/FirewallPanel.vala"
	gtk_tree_view_insert_column_with_attributes (_tmp15_, -1, _ ("To"), (GtkCellRenderer*) _tmp16_, "text", SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_TO, NULL);
#line 342 "../src/Views/FirewallPanel.vala"
	_tmp17_ = self->priv->view;
#line 342 "../src/Views/FirewallPanel.vala"
	_tmp18_ = cell;
#line 342 "../src/Views/FirewallPanel.vala"
	gtk_tree_view_insert_column_with_attributes (_tmp17_, -1, _ ("From"), (GtkCellRenderer*) _tmp18_, "text", SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_FROM, NULL);
#line 344 "../src/Views/FirewallPanel.vala"
	_tmp19_ = celltoggle;
#line 344 "../src/Views/FirewallPanel.vala"
	g_signal_connect_object (_tmp19_, "toggled", (GCallback) ___lambda17__gtk_cell_renderer_toggle_toggled, self, 0);
#line 365 "../src/Views/FirewallPanel.vala"
	_tmp20_ = (GtkButton*) gtk_button_new_from_icon_name ("list-add-symbolic");
#line 365 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp20_);
#line 365 "../src/Views/FirewallPanel.vala"
	_data2_->add_button = _tmp20_;
#line 367 "../src/Views/FirewallPanel.vala"
	_tmp21_ = (GtkButton*) gtk_button_new_from_icon_name ("list-remove-symbolic");
#line 367 "../src/Views/FirewallPanel.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp21_, FALSE);
#line 367 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp21_);
#line 367 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (self->priv->remove_button);
#line 367 "../src/Views/FirewallPanel.vala"
	self->priv->remove_button = _tmp21_;
#line 371 "../src/Views/FirewallPanel.vala"
	_tmp22_ = (GtkActionBar*) gtk_action_bar_new ();
#line 371 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp22_);
#line 371 "../src/Views/FirewallPanel.vala"
	actionbar = _tmp22_;
#line 372 "../src/Views/FirewallPanel.vala"
	_tmp23_ = actionbar;
#line 372 "../src/Views/FirewallPanel.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp23_, GRANITE_STYLE_CLASS_FLAT);
#line 373 "../src/Views/FirewallPanel.vala"
	_tmp24_ = actionbar;
#line 373 "../src/Views/FirewallPanel.vala"
	_tmp25_ = _data2_->add_button;
#line 373 "../src/Views/FirewallPanel.vala"
	gtk_action_bar_pack_start (_tmp24_, (GtkWidget*) _tmp25_);
#line 374 "../src/Views/FirewallPanel.vala"
	_tmp26_ = actionbar;
#line 374 "../src/Views/FirewallPanel.vala"
	_tmp27_ = self->priv->remove_button;
#line 374 "../src/Views/FirewallPanel.vala"
	gtk_action_bar_pack_start (_tmp26_, (GtkWidget*) _tmp27_);
#line 376 "../src/Views/FirewallPanel.vala"
	_tmp28_ = self->priv->view;
#line 376 "../src/Views/FirewallPanel.vala"
	_tmp29_ = _g_object_ref0 ((GtkWidget*) _tmp28_);
#line 376 "../src/Views/FirewallPanel.vala"
	_tmp30_ = (GtkScrolledWindow*) gtk_scrolled_window_new ();
#line 376 "../src/Views/FirewallPanel.vala"
	gtk_scrolled_window_set_child (_tmp30_, _tmp29_);
#line 376 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (_tmp29_);
#line 376 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp30_);
#line 376 "../src/Views/FirewallPanel.vala"
	scrolled = _tmp30_;
#line 380 "../src/Views/FirewallPanel.vala"
	_tmp31_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 380 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp31_);
#line 380 "../src/Views/FirewallPanel.vala"
	view_box = _tmp31_;
#line 381 "../src/Views/FirewallPanel.vala"
	_tmp32_ = view_box;
#line 381 "../src/Views/FirewallPanel.vala"
	_tmp33_ = scrolled;
#line 381 "../src/Views/FirewallPanel.vala"
	gtk_box_append (_tmp32_, (GtkWidget*) _tmp33_);
#line 382 "../src/Views/FirewallPanel.vala"
	_tmp34_ = view_box;
#line 382 "../src/Views/FirewallPanel.vala"
	_tmp35_ = actionbar;
#line 382 "../src/Views/FirewallPanel.vala"
	gtk_box_append (_tmp34_, (GtkWidget*) _tmp35_);
#line 386 "../src/Views/FirewallPanel.vala"
	_tmp37_ = switchboard_settings_page_get_status_switch ((SwitchboardSettingsPage*) self);
#line 386 "../src/Views/FirewallPanel.vala"
	_tmp38_ = _tmp37_;
#line 386 "../src/Views/FirewallPanel.vala"
	_tmp39_ = gtk_switch_get_active (_tmp38_);
#line 386 "../src/Views/FirewallPanel.vala"
	_tmp40_ = _tmp39_;
#line 386 "../src/Views/FirewallPanel.vala"
	if (_tmp40_) {
#line 2903 "FirewallPanel.c"
		PolkitPermission* _tmp41_;
		gboolean _tmp42_;
		gboolean _tmp43_;
#line 386 "../src/Views/FirewallPanel.vala"
		_tmp41_ = self->priv->permission;
#line 386 "../src/Views/FirewallPanel.vala"
		_tmp42_ = g_permission_get_allowed ((GPermission*) _tmp41_);
#line 386 "../src/Views/FirewallPanel.vala"
		_tmp43_ = _tmp42_;
#line 386 "../src/Views/FirewallPanel.vala"
		_tmp36_ = _tmp43_;
#line 2915 "FirewallPanel.c"
	} else {
#line 386 "../src/Views/FirewallPanel.vala"
		_tmp36_ = FALSE;
#line 2919 "FirewallPanel.c"
	}
#line 384 "../src/Views/FirewallPanel.vala"
	_tmp44_ = view_box;
#line 384 "../src/Views/FirewallPanel.vala"
	_tmp45_ = _g_object_ref0 ((GtkWidget*) _tmp44_);
#line 384 "../src/Views/FirewallPanel.vala"
	_tmp46_ = (GtkFrame*) gtk_frame_new (NULL);
#line 384 "../src/Views/FirewallPanel.vala"
	gtk_frame_set_child (_tmp46_, _tmp45_);
#line 384 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (_tmp45_);
#line 384 "../src/Views/FirewallPanel.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp46_, _tmp36_);
#line 384 "../src/Views/FirewallPanel.vala"
	g_object_ref_sink (_tmp46_);
#line 384 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (self->priv->frame);
#line 384 "../src/Views/FirewallPanel.vala"
	self->priv->frame = _tmp46_;
#line 389 "../src/Views/FirewallPanel.vala"
	_tmp47_ = self->priv->frame;
#line 389 "../src/Views/FirewallPanel.vala"
	switchboard_settings_page_set_child ((SwitchboardSettingsPage*) self, (GtkWidget*) _tmp47_);
#line 390 "../src/Views/FirewallPanel.vala"
	switchboard_settings_page_set_show_end_title_buttons ((SwitchboardSettingsPage*) self, TRUE);
#line 392 "../src/Views/FirewallPanel.vala"
	_tmp48_ = self->priv->view;
#line 392 "../src/Views/FirewallPanel.vala"
	g_signal_connect_object (_tmp48_, "cursor-changed", (GCallback) ___lambda18__gtk_tree_view_cursor_changed, self, 0);
#line 396 "../src/Views/FirewallPanel.vala"
	_tmp49_ = _data2_->add_button;
#line 396 "../src/Views/FirewallPanel.vala"
	g_signal_connect_data (_tmp49_, "clicked", (GCallback) ___lambda19__gtk_button_clicked, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 532 "../src/Views/FirewallPanel.vala"
	_tmp50_ = self->priv->remove_button;
#line 532 "../src/Views/FirewallPanel.vala"
	g_signal_connect_object (_tmp50_, "clicked", (GCallback) ___lambda21__gtk_button_clicked, self, 0);
#line 317 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (view_box);
#line 317 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (scrolled);
#line 317 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (actionbar);
#line 317 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (cell);
#line 317 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (celltoggle);
#line 317 "../src/Views/FirewallPanel.vala"
	block2_data_unref (_data2_);
#line 317 "../src/Views/FirewallPanel.vala"
	_data2_ = NULL;
#line 2971 "FirewallPanel.c"
}

static void
security_privacy_firewall_panel_update_status (SecurityPrivacyFirewallPanel* self)
{
	gboolean _tmp0_ = FALSE;
	GtkSwitch* _tmp1_;
	GtkSwitch* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GtkFrame* _tmp8_;
	GtkSwitch* _tmp9_;
	GtkSwitch* _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp12_;
#line 553 "../src/Views/FirewallPanel.vala"
	g_return_if_fail (self != NULL);
#line 554 "../src/Views/FirewallPanel.vala"
	_tmp1_ = switchboard_settings_page_get_status_switch ((SwitchboardSettingsPage*) self);
#line 554 "../src/Views/FirewallPanel.vala"
	_tmp2_ = _tmp1_;
#line 554 "../src/Views/FirewallPanel.vala"
	_tmp3_ = gtk_switch_get_active (_tmp2_);
#line 554 "../src/Views/FirewallPanel.vala"
	_tmp4_ = _tmp3_;
#line 554 "../src/Views/FirewallPanel.vala"
	if (_tmp4_) {
#line 2999 "FirewallPanel.c"
		PolkitPermission* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 554 "../src/Views/FirewallPanel.vala"
		_tmp5_ = self->priv->permission;
#line 554 "../src/Views/FirewallPanel.vala"
		_tmp6_ = g_permission_get_allowed ((GPermission*) _tmp5_);
#line 554 "../src/Views/FirewallPanel.vala"
		_tmp7_ = _tmp6_;
#line 554 "../src/Views/FirewallPanel.vala"
		_tmp0_ = _tmp7_;
#line 3011 "FirewallPanel.c"
	} else {
#line 554 "../src/Views/FirewallPanel.vala"
		_tmp0_ = FALSE;
#line 3015 "FirewallPanel.c"
	}
#line 554 "../src/Views/FirewallPanel.vala"
	_tmp8_ = self->priv->frame;
#line 554 "../src/Views/FirewallPanel.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, _tmp0_);
#line 556 "../src/Views/FirewallPanel.vala"
	_tmp9_ = switchboard_settings_page_get_status_switch ((SwitchboardSettingsPage*) self);
#line 556 "../src/Views/FirewallPanel.vala"
	_tmp10_ = _tmp9_;
#line 556 "../src/Views/FirewallPanel.vala"
	_tmp11_ = gtk_switch_get_active (_tmp10_);
#line 556 "../src/Views/FirewallPanel.vala"
	_tmp12_ = _tmp11_;
#line 556 "../src/Views/FirewallPanel.vala"
	if (_tmp12_) {
#line 557 "../src/Views/FirewallPanel.vala"
		switchboard_settings_page_set_status_type ((SwitchboardSettingsPage*) self, SWITCHBOARD_SETTINGS_PAGE_STATUS_TYPE_SUCCESS);
#line 558 "../src/Views/FirewallPanel.vala"
		switchboard_settings_page_set_status ((SwitchboardSettingsPage*) self, _ ("Enabled"));
#line 559 "../src/Views/FirewallPanel.vala"
		security_privacy_firewall_panel_show_rules (self);
#line 3037 "FirewallPanel.c"
	} else {
#line 561 "../src/Views/FirewallPanel.vala"
		switchboard_settings_page_set_status_type ((SwitchboardSettingsPage*) self, SWITCHBOARD_SETTINGS_PAGE_STATUS_TYPE_OFFLINE);
#line 562 "../src/Views/FirewallPanel.vala"
		switchboard_settings_page_set_status ((SwitchboardSettingsPage*) self, _ ("Disabled"));
#line 3043 "FirewallPanel.c"
	}
}

static void
_security_privacy_firewall_panel___lambda22_ (SecurityPrivacyFirewallPanel* self)
{
#line 59 "../src/Views/FirewallPanel.vala"
	if (self->priv->loading == FALSE) {
#line 3052 "FirewallPanel.c"
		GtkSwitch* _tmp0_;
		GtkSwitch* _tmp1_;
		gboolean _tmp2_;
		gboolean _tmp3_;
#line 60 "../src/Views/FirewallPanel.vala"
		_tmp0_ = switchboard_settings_page_get_status_switch ((SwitchboardSettingsPage*) self);
#line 60 "../src/Views/FirewallPanel.vala"
		_tmp1_ = _tmp0_;
#line 60 "../src/Views/FirewallPanel.vala"
		_tmp2_ = gtk_switch_get_active (_tmp1_);
#line 60 "../src/Views/FirewallPanel.vala"
		_tmp3_ = _tmp2_;
#line 60 "../src/Views/FirewallPanel.vala"
		security_privacy_ufw_helpers_set_status (_tmp3_);
#line 3067 "FirewallPanel.c"
	}
#line 62 "../src/Views/FirewallPanel.vala"
	security_privacy_firewall_panel_update_status (self);
#line 3071 "FirewallPanel.c"
}

static void
__security_privacy_firewall_panel___lambda22__g_object_notify (GObject* _sender,
                                                               GParamSpec* pspec,
                                                               gpointer self)
{
#line 58 "../src/Views/FirewallPanel.vala"
	_security_privacy_firewall_panel___lambda22_ ((SecurityPrivacyFirewallPanel*) self);
#line 3081 "FirewallPanel.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 67 "../src/Views/FirewallPanel.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 67 "../src/Views/FirewallPanel.vala"
	return _data4_;
#line 3091 "FirewallPanel.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 67 "../src/Views/FirewallPanel.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 3101 "FirewallPanel.c"
		SecurityPrivacyFirewallPanel* self;
#line 67 "../src/Views/FirewallPanel.vala"
		self = _data4_->self;
#line 67 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (_data4_->lock_button);
#line 67 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (self);
#line 67 "../src/Views/FirewallPanel.vala"
		g_slice_free (Block4Data, _data4_);
#line 3111 "FirewallPanel.c"
	}
}

static void
_security_privacy_firewall_panel____lambda23_ (Block4Data* _data4_)
{
	SecurityPrivacyFirewallPanel* self;
	PolkitPermission* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GtkSwitch* _tmp8_;
	GtkSwitch* _tmp9_;
	PolkitPermission* _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp12_;
	gboolean _tmp13_ = FALSE;
	GtkSwitch* _tmp14_;
	GtkSwitch* _tmp15_;
	gboolean _tmp16_;
	gboolean _tmp17_;
	GtkFrame* _tmp21_;
#line 77 "../src/Views/FirewallPanel.vala"
	self = _data4_->self;
#line 78 "../src/Views/FirewallPanel.vala"
	_tmp0_ = self->priv->permission;
#line 78 "../src/Views/FirewallPanel.vala"
	_tmp1_ = g_permission_get_allowed ((GPermission*) _tmp0_);
#line 78 "../src/Views/FirewallPanel.vala"
	_tmp2_ = _tmp1_;
#line 78 "../src/Views/FirewallPanel.vala"
	if (_tmp2_) {
#line 3143 "FirewallPanel.c"
		GtkSwitch* _tmp3_;
		GtkSwitch* _tmp4_;
		GtkButton* _tmp5_;
		GtkButton* _tmp6_;
#line 79 "../src/Views/FirewallPanel.vala"
		self->priv->loading = TRUE;
#line 80 "../src/Views/FirewallPanel.vala"
		_tmp3_ = switchboard_settings_page_get_status_switch ((SwitchboardSettingsPage*) self);
#line 80 "../src/Views/FirewallPanel.vala"
		_tmp4_ = _tmp3_;
#line 80 "../src/Views/FirewallPanel.vala"
		gtk_switch_set_active (_tmp4_, security_privacy_ufw_helpers_get_status ());
#line 81 "../src/Views/FirewallPanel.vala"
		_tmp5_ = self->priv->remove_button;
#line 81 "../src/Views/FirewallPanel.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp5_, FALSE);
#line 82 "../src/Views/FirewallPanel.vala"
		self->priv->loading = FALSE;
#line 83 "../src/Views/FirewallPanel.vala"
		_tmp6_ = _data4_->lock_button;
#line 83 "../src/Views/FirewallPanel.vala"
		gtk_button_set_label (_tmp6_, _ ("Lock"));
#line 3166 "FirewallPanel.c"
	} else {
		GtkButton* _tmp7_;
#line 85 "../src/Views/FirewallPanel.vala"
		_tmp7_ = _data4_->lock_button;
#line 85 "../src/Views/FirewallPanel.vala"
		gtk_button_set_label (_tmp7_, _ ("Unlock"));
#line 3173 "FirewallPanel.c"
	}
#line 88 "../src/Views/FirewallPanel.vala"
	_tmp8_ = switchboard_settings_page_get_status_switch ((SwitchboardSettingsPage*) self);
#line 88 "../src/Views/FirewallPanel.vala"
	_tmp9_ = _tmp8_;
#line 88 "../src/Views/FirewallPanel.vala"
	_tmp10_ = self->priv->permission;
#line 88 "../src/Views/FirewallPanel.vala"
	_tmp11_ = g_permission_get_allowed ((GPermission*) _tmp10_);
#line 88 "../src/Views/FirewallPanel.vala"
	_tmp12_ = _tmp11_;
#line 88 "../src/Views/FirewallPanel.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp9_, _tmp12_);
#line 89 "../src/Views/FirewallPanel.vala"
	_tmp14_ = switchboard_settings_page_get_status_switch ((SwitchboardSettingsPage*) self);
#line 89 "../src/Views/FirewallPanel.vala"
	_tmp15_ = _tmp14_;
#line 89 "../src/Views/FirewallPanel.vala"
	_tmp16_ = gtk_switch_get_active (_tmp15_);
#line 89 "../src/Views/FirewallPanel.vala"
	_tmp17_ = _tmp16_;
#line 89 "../src/Views/FirewallPanel.vala"
	if (_tmp17_) {
#line 3197 "FirewallPanel.c"
		PolkitPermission* _tmp18_;
		gboolean _tmp19_;
		gboolean _tmp20_;
#line 89 "../src/Views/FirewallPanel.vala"
		_tmp18_ = self->priv->permission;
#line 89 "../src/Views/FirewallPanel.vala"
		_tmp19_ = g_permission_get_allowed ((GPermission*) _tmp18_);
#line 89 "../src/Views/FirewallPanel.vala"
		_tmp20_ = _tmp19_;
#line 89 "../src/Views/FirewallPanel.vala"
		_tmp13_ = _tmp20_;
#line 3209 "FirewallPanel.c"
	} else {
#line 89 "../src/Views/FirewallPanel.vala"
		_tmp13_ = FALSE;
#line 3213 "FirewallPanel.c"
	}
#line 89 "../src/Views/FirewallPanel.vala"
	_tmp21_ = self->priv->frame;
#line 89 "../src/Views/FirewallPanel.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp21_, _tmp13_);
#line 3219 "FirewallPanel.c"
}

static void
__security_privacy_firewall_panel____lambda23__g_object_notify (GObject* _sender,
                                                                GParamSpec* pspec,
                                                                gpointer self)
{
#line 77 "../src/Views/FirewallPanel.vala"
	_security_privacy_firewall_panel____lambda23_ (self);
#line 3229 "FirewallPanel.c"
}

static void
_gtk_window_destroy_gtk_dialog_response (GtkDialog* _sender,
                                         gint response_id,
                                         gpointer self)
{
#line 115 "../src/Views/FirewallPanel.vala"
	gtk_window_destroy ((GtkWindow*) self);
#line 3239 "FirewallPanel.c"
}

static void
_security_privacy_firewall_panel____lambda24_ (SecurityPrivacyFirewallPanel* self)
{
	PolkitPermission* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GError* _inner_error0_ = NULL;
#line 93 "../src/Views/FirewallPanel.vala"
	_tmp0_ = self->priv->permission;
#line 93 "../src/Views/FirewallPanel.vala"
	_tmp1_ = g_permission_get_allowed ((GPermission*) _tmp0_);
#line 93 "../src/Views/FirewallPanel.vala"
	_tmp2_ = _tmp1_;
#line 93 "../src/Views/FirewallPanel.vala"
	if (_tmp2_) {
#line 3257 "FirewallPanel.c"
		{
			PolkitPermission* _tmp3_;
#line 95 "../src/Views/FirewallPanel.vala"
			_tmp3_ = self->priv->permission;
#line 95 "../src/Views/FirewallPanel.vala"
			g_permission_release ((GPermission*) _tmp3_, NULL, &_inner_error0_);
#line 95 "../src/Views/FirewallPanel.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3266 "FirewallPanel.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp4_;
			const gchar* _tmp5_;
#line 94 "../src/Views/FirewallPanel.vala"
			e = _inner_error0_;
#line 94 "../src/Views/FirewallPanel.vala"
			_inner_error0_ = NULL;
#line 97 "../src/Views/FirewallPanel.vala"
			_tmp4_ = e;
#line 97 "../src/Views/FirewallPanel.vala"
			_tmp5_ = _tmp4_->message;
#line 97 "../src/Views/FirewallPanel.vala"
			g_critical ("FirewallPanel.vala:97: Unable to release permission: %s", _tmp5_);
#line 94 "../src/Views/FirewallPanel.vala"
			_g_error_free0 (e);
#line 3288 "FirewallPanel.c"
		}
		__finally0:
#line 94 "../src/Views/FirewallPanel.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 94 "../src/Views/FirewallPanel.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 94 "../src/Views/FirewallPanel.vala"
			g_clear_error (&_inner_error0_);
#line 94 "../src/Views/FirewallPanel.vala"
			return;
#line 3299 "FirewallPanel.c"
		}
	} else {
		{
			PolkitPermission* _tmp6_;
#line 101 "../src/Views/FirewallPanel.vala"
			_tmp6_ = self->priv->permission;
#line 101 "../src/Views/FirewallPanel.vala"
			g_permission_acquire ((GPermission*) _tmp6_, NULL, &_inner_error0_);
#line 101 "../src/Views/FirewallPanel.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3310 "FirewallPanel.c"
				goto __catch1_g_error;
			}
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* e = NULL;
			GError* _tmp7_;
#line 100 "../src/Views/FirewallPanel.vala"
			e = _inner_error0_;
#line 100 "../src/Views/FirewallPanel.vala"
			_inner_error0_ = NULL;
#line 103 "../src/Views/FirewallPanel.vala"
			_tmp7_ = e;
#line 103 "../src/Views/FirewallPanel.vala"
			if (!g_error_matches (_tmp7_, g_io_error_quark (), G_IO_ERROR_CANCELLED)) {
#line 3327 "FirewallPanel.c"
				GraniteMessageDialog* message_dialog = NULL;
				GThemedIcon* _tmp8_;
				GThemedIcon* _tmp9_;
				GThemedIcon* _tmp10_;
				GtkRoot* _tmp11_;
				GtkWindow* _tmp12_;
				GraniteMessageDialog* _tmp13_ = NULL;
				GraniteMessageDialog* _tmp14_;
				GraniteMessageDialog* _tmp15_;
				GError* _tmp16_;
				const gchar* _tmp17_;
				GraniteMessageDialog* _tmp18_;
				GraniteMessageDialog* _tmp19_;
				GraniteMessageDialog* _tmp20_;
#line 104 "../src/Views/FirewallPanel.vala"
				_tmp8_ = (GThemedIcon*) g_themed_icon_new ("dialog-password");
#line 104 "../src/Views/FirewallPanel.vala"
				_tmp9_ = _tmp8_;
#line 104 "../src/Views/FirewallPanel.vala"
				_tmp10_ = (GThemedIcon*) g_themed_icon_new ("dialog-error");
#line 104 "../src/Views/FirewallPanel.vala"
				_tmp11_ = gtk_widget_get_root ((GtkWidget*) self);
#line 104 "../src/Views/FirewallPanel.vala"
				_tmp12_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, gtk_window_get_type (), GtkWindow));
#line 104 "../src/Views/FirewallPanel.vala"
				_tmp13_ = granite_message_dialog_new (_ ("Unable to acquire permission"), _ ("Firewall rules can't be changed without the required system permission" \
"."), (GIcon*) _tmp9_, GTK_BUTTONS_CLOSE);
#line 104 "../src/Views/FirewallPanel.vala"
				granite_message_dialog_set_badge_icon (_tmp13_, (GIcon*) _tmp10_);
#line 104 "../src/Views/FirewallPanel.vala"
				_g_object_unref0 (_tmp10_);
#line 104 "../src/Views/FirewallPanel.vala"
				gtk_window_set_modal ((GtkWindow*) _tmp13_, TRUE);
#line 104 "../src/Views/FirewallPanel.vala"
				gtk_window_set_transient_for ((GtkWindow*) _tmp13_, _tmp12_);
#line 104 "../src/Views/FirewallPanel.vala"
				_g_object_unref0 (_tmp12_);
#line 104 "../src/Views/FirewallPanel.vala"
				g_object_ref_sink (_tmp13_);
#line 104 "../src/Views/FirewallPanel.vala"
				_tmp14_ = _tmp13_;
#line 104 "../src/Views/FirewallPanel.vala"
				_g_object_unref0 (_tmp9_);
#line 104 "../src/Views/FirewallPanel.vala"
				message_dialog = _tmp14_;
#line 114 "../src/Views/FirewallPanel.vala"
				_tmp15_ = message_dialog;
#line 114 "../src/Views/FirewallPanel.vala"
				_tmp16_ = e;
#line 114 "../src/Views/FirewallPanel.vala"
				_tmp17_ = _tmp16_->message;
#line 114 "../src/Views/FirewallPanel.vala"
				granite_message_dialog_show_error_details (_tmp15_, _tmp17_);
#line 115 "../src/Views/FirewallPanel.vala"
				_tmp18_ = message_dialog;
#line 115 "../src/Views/FirewallPanel.vala"
				_tmp19_ = message_dialog;
#line 115 "../src/Views/FirewallPanel.vala"
				g_signal_connect_object ((GtkDialog*) _tmp18_, "response", (GCallback) _gtk_window_destroy_gtk_dialog_response, (GtkWindow*) _tmp19_, 0);
#line 116 "../src/Views/FirewallPanel.vala"
				_tmp20_ = message_dialog;
#line 116 "../src/Views/FirewallPanel.vala"
				gtk_window_present ((GtkWindow*) _tmp20_);
#line 103 "../src/Views/FirewallPanel.vala"
				_g_object_unref0 (message_dialog);
#line 3392 "FirewallPanel.c"
			}
#line 100 "../src/Views/FirewallPanel.vala"
			_g_error_free0 (e);
#line 3396 "FirewallPanel.c"
		}
		__finally1:
#line 100 "../src/Views/FirewallPanel.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 100 "../src/Views/FirewallPanel.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 100 "../src/Views/FirewallPanel.vala"
			g_clear_error (&_inner_error0_);
#line 100 "../src/Views/FirewallPanel.vala"
			return;
#line 3407 "FirewallPanel.c"
		}
	}
}

static void
__security_privacy_firewall_panel____lambda24__gtk_button_clicked (GtkButton* _sender,
                                                                   gpointer self)
{
#line 92 "../src/Views/FirewallPanel.vala"
	_security_privacy_firewall_panel____lambda24_ ((SecurityPrivacyFirewallPanel*) self);
#line 3418 "FirewallPanel.c"
}

static GObject *
security_privacy_firewall_panel_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SecurityPrivacyFirewallPanel * self;
	GSettings* _tmp0_;
	GeeHashMap* _tmp1_;
	GtkSwitch* _tmp2_;
	GtkSwitch* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 53 "../src/Views/FirewallPanel.vala"
	parent_class = G_OBJECT_CLASS (security_privacy_firewall_panel_parent_class);
#line 53 "../src/Views/FirewallPanel.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 53 "../src/Views/FirewallPanel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SECURITY_PRIVACY_TYPE_FIREWALL_PANEL, SecurityPrivacyFirewallPanel);
#line 54 "../src/Views/FirewallPanel.vala"
	_tmp0_ = g_settings_new ("io.elementary.settings.security-privacy");
#line 54 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (self->priv->settings);
#line 54 "../src/Views/FirewallPanel.vala"
	self->priv->settings = _tmp0_;
#line 55 "../src/Views/FirewallPanel.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, SECURITY_PRIVACY_UFW_HELPERS_TYPE_RULE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 55 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (self->priv->disabled_rules);
#line 55 "../src/Views/FirewallPanel.vala"
	self->priv->disabled_rules = _tmp1_;
#line 56 "../src/Views/FirewallPanel.vala"
	security_privacy_firewall_panel_load_disabled_rules (self);
#line 58 "../src/Views/FirewallPanel.vala"
	_tmp2_ = switchboard_settings_page_get_status_switch ((SwitchboardSettingsPage*) self);
#line 58 "../src/Views/FirewallPanel.vala"
	_tmp3_ = _tmp2_;
#line 58 "../src/Views/FirewallPanel.vala"
	g_signal_connect_object ((GObject*) _tmp3_, "notify::active", (GCallback) __security_privacy_firewall_panel___lambda22__g_object_notify, self, 0);
#line 65 "../src/Views/FirewallPanel.vala"
	security_privacy_firewall_panel_create_treeview (self);
#line 3462 "FirewallPanel.c"
	{
		Block4Data* _data4_;
		PolkitPermission* _tmp4_ = NULL;
		PolkitUnixProcess* _tmp5_;
		PolkitUnixProcess* _tmp6_;
		PolkitPermission* _tmp7_;
		PolkitPermission* _tmp8_;
		PolkitPermission* _tmp9_;
		GtkButton* _tmp10_;
		GtkSwitch* _tmp11_;
		GtkSwitch* _tmp12_;
		PolkitPermission* _tmp13_;
		gboolean _tmp14_;
		gboolean _tmp15_;
		PolkitPermission* _tmp16_;
		GtkButton* _tmp17_;
#line 67 "../src/Views/FirewallPanel.vala"
		_data4_ = g_slice_new0 (Block4Data);
#line 67 "../src/Views/FirewallPanel.vala"
		_data4_->_ref_count_ = 1;
#line 67 "../src/Views/FirewallPanel.vala"
		_data4_->self = g_object_ref (self);
#line 68 "../src/Views/FirewallPanel.vala"
		_tmp5_ = (PolkitUnixProcess*) polkit_unix_process_new ((gint) getpid ());
#line 68 "../src/Views/FirewallPanel.vala"
		_tmp6_ = _tmp5_;
#line 68 "../src/Views/FirewallPanel.vala"
		_tmp7_ = (PolkitPermission*) polkit_permission_new_sync ("io.elementary.settings.security-privacy", (PolkitSubject*) _tmp6_, NULL, &_inner_error0_);
#line 68 "../src/Views/FirewallPanel.vala"
		_tmp8_ = _tmp7_;
#line 68 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (_tmp6_);
#line 68 "../src/Views/FirewallPanel.vala"
		_tmp4_ = _tmp8_;
#line 68 "../src/Views/FirewallPanel.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 68 "../src/Views/FirewallPanel.vala"
			block4_data_unref (_data4_);
#line 68 "../src/Views/FirewallPanel.vala"
			_data4_ = NULL;
#line 3503 "FirewallPanel.c"
			goto __catch0_g_error;
		}
#line 68 "../src/Views/FirewallPanel.vala"
		_tmp9_ = _tmp4_;
#line 68 "../src/Views/FirewallPanel.vala"
		_tmp4_ = NULL;
#line 68 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (self->priv->permission);
#line 68 "../src/Views/FirewallPanel.vala"
		self->priv->permission = _tmp9_;
#line 73 "../src/Views/FirewallPanel.vala"
		_tmp10_ = switchboard_settings_page_add_button ((SwitchboardSettingsPage*) self, _ ("Unlock"));
#line 73 "../src/Views/FirewallPanel.vala"
		_data4_->lock_button = _tmp10_;
#line 75 "../src/Views/FirewallPanel.vala"
		_tmp11_ = switchboard_settings_page_get_status_switch ((SwitchboardSettingsPage*) self);
#line 75 "../src/Views/FirewallPanel.vala"
		_tmp12_ = _tmp11_;
#line 75 "../src/Views/FirewallPanel.vala"
		_tmp13_ = self->priv->permission;
#line 75 "../src/Views/FirewallPanel.vala"
		_tmp14_ = g_permission_get_allowed ((GPermission*) _tmp13_);
#line 75 "../src/Views/FirewallPanel.vala"
		_tmp15_ = _tmp14_;
#line 75 "../src/Views/FirewallPanel.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp12_, _tmp15_);
#line 77 "../src/Views/FirewallPanel.vala"
		_tmp16_ = self->priv->permission;
#line 77 "../src/Views/FirewallPanel.vala"
		g_signal_connect_data ((GObject*) _tmp16_, "notify::allowed", (GCallback) __security_privacy_firewall_panel____lambda23__g_object_notify, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
#line 92 "../src/Views/FirewallPanel.vala"
		_tmp17_ = _data4_->lock_button;
#line 92 "../src/Views/FirewallPanel.vala"
		g_signal_connect_object (_tmp17_, "clicked", (GCallback) __security_privacy_firewall_panel____lambda24__gtk_button_clicked, self, 0);
#line 67 "../src/Views/FirewallPanel.vala"
		_g_object_unref0 (_tmp4_);
#line 67 "../src/Views/FirewallPanel.vala"
		block4_data_unref (_data4_);
#line 67 "../src/Views/FirewallPanel.vala"
		_data4_ = NULL;
#line 3544 "FirewallPanel.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp18_;
		const gchar* _tmp19_;
#line 67 "../src/Views/FirewallPanel.vala"
		e = _inner_error0_;
#line 67 "../src/Views/FirewallPanel.vala"
		_inner_error0_ = NULL;
#line 123 "../src/Views/FirewallPanel.vala"
		_tmp18_ = e;
#line 123 "../src/Views/FirewallPanel.vala"
		_tmp19_ = _tmp18_->message;
#line 123 "../src/Views/FirewallPanel.vala"
		g_critical ("FirewallPanel.vala:123: %s", _tmp19_);
#line 67 "../src/Views/FirewallPanel.vala"
		_g_error_free0 (e);
#line 3564 "FirewallPanel.c"
	}
	__finally0:
#line 67 "../src/Views/FirewallPanel.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 67 "../src/Views/FirewallPanel.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 67 "../src/Views/FirewallPanel.vala"
		g_clear_error (&_inner_error0_);
#line 3573 "FirewallPanel.c"
	}
#line 53 "../src/Views/FirewallPanel.vala"
	return obj;
#line 3577 "FirewallPanel.c"
}

static void
security_privacy_firewall_panel_class_init (SecurityPrivacyFirewallPanelClass * klass,
                                            gpointer klass_data)
{
#line 23 "../src/Views/FirewallPanel.vala"
	security_privacy_firewall_panel_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/Views/FirewallPanel.vala"
	g_type_class_adjust_private_offset (klass, &SecurityPrivacyFirewallPanel_private_offset);
#line 23 "../src/Views/FirewallPanel.vala"
	G_OBJECT_CLASS (klass)->constructor = security_privacy_firewall_panel_constructor;
#line 23 "../src/Views/FirewallPanel.vala"
	G_OBJECT_CLASS (klass)->finalize = security_privacy_firewall_panel_finalize;
#line 3592 "FirewallPanel.c"
}

static void
security_privacy_firewall_panel_instance_init (SecurityPrivacyFirewallPanel * self,
                                               gpointer klass)
{
#line 23 "../src/Views/FirewallPanel.vala"
	self->priv = security_privacy_firewall_panel_get_instance_private (self);
#line 27 "../src/Views/FirewallPanel.vala"
	self->priv->loading = FALSE;
#line 3603 "FirewallPanel.c"
}

static void
security_privacy_firewall_panel_finalize (GObject * obj)
{
	SecurityPrivacyFirewallPanel * self;
#line 23 "../src/Views/FirewallPanel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SECURITY_PRIVACY_TYPE_FIREWALL_PANEL, SecurityPrivacyFirewallPanel);
#line 24 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (self->priv->frame);
#line 25 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (self->priv->list_store);
#line 26 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (self->priv->view);
#line 28 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (self->priv->remove_button);
#line 29 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (self->priv->settings);
#line 30 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (self->priv->disabled_rules);
#line 31 "../src/Views/FirewallPanel.vala"
	_g_object_unref0 (self->priv->permission);
#line 23 "../src/Views/FirewallPanel.vala"
	G_OBJECT_CLASS (security_privacy_firewall_panel_parent_class)->finalize (obj);
#line 3628 "FirewallPanel.c"
}

static GType
security_privacy_firewall_panel_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SecurityPrivacyFirewallPanelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) security_privacy_firewall_panel_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SecurityPrivacyFirewallPanel), 0, (GInstanceInitFunc) security_privacy_firewall_panel_instance_init, NULL };
	GType security_privacy_firewall_panel_type_id;
	security_privacy_firewall_panel_type_id = g_type_register_static (SWITCHBOARD_TYPE_SETTINGS_PAGE, "SecurityPrivacyFirewallPanel", &g_define_type_info, 0);
	SecurityPrivacyFirewallPanel_private_offset = g_type_add_instance_private (security_privacy_firewall_panel_type_id, sizeof (SecurityPrivacyFirewallPanelPrivate));
	return security_privacy_firewall_panel_type_id;
}

GType
security_privacy_firewall_panel_get_type (void)
{
	static volatile gsize security_privacy_firewall_panel_type_id__once = 0;
	if (g_once_init_enter (&security_privacy_firewall_panel_type_id__once)) {
		GType security_privacy_firewall_panel_type_id;
		security_privacy_firewall_panel_type_id = security_privacy_firewall_panel_get_type_once ();
		g_once_init_leave (&security_privacy_firewall_panel_type_id__once, security_privacy_firewall_panel_type_id);
	}
	return security_privacy_firewall_panel_type_id__once;
}

