/* LockPanel.c generated by valac 0.56.17, the Vala compiler
 * generated from LockPanel.vala, do not modify */

/*-
 * Copyright 2014-2020 elementary, Inc. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "security-privacy.h"
#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>
#include <switchboard.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SECURITY_PRIVACY_LOCK_PANEL_0_PROPERTY,
	SECURITY_PRIVACY_LOCK_PANEL_NUM_PROPERTIES
};
static GParamSpec* security_privacy_lock_panel_properties[SECURITY_PRIVACY_LOCK_PANEL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_settings_schema_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_unref (var), NULL)))

static gpointer security_privacy_lock_panel_parent_class = NULL;

static GObject * security_privacy_lock_panel_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties);
static GType security_privacy_lock_panel_get_type_once (void);

SecurityPrivacyLockPanel*
security_privacy_lock_panel_construct (GType object_type)
{
	SecurityPrivacyLockPanel * self = NULL;
	GThemedIcon* _tmp0_;
	GThemedIcon* _tmp1_;
#line 24 "../src/Views/LockPanel.vala"
	_tmp0_ = (GThemedIcon*) g_themed_icon_new ("system-lock-screen");
#line 24 "../src/Views/LockPanel.vala"
	_tmp1_ = _tmp0_;
#line 24 "../src/Views/LockPanel.vala"
	self = (SecurityPrivacyLockPanel*) g_object_new (object_type, "icon", _tmp1_, "title", _ ("Locking"), NULL);
#line 24 "../src/Views/LockPanel.vala"
	_g_object_unref0 (_tmp1_);
#line 23 "../src/Views/LockPanel.vala"
	return self;
#line 74 "LockPanel.c"
}

SecurityPrivacyLockPanel*
security_privacy_lock_panel_new (void)
{
#line 23 "../src/Views/LockPanel.vala"
	return security_privacy_lock_panel_construct (SECURITY_PRIVACY_TYPE_LOCK_PANEL);
#line 82 "LockPanel.c"
}

static GObject *
security_privacy_lock_panel_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SecurityPrivacyLockPanel * self;
	GtkLabel* lock_suspend_label = NULL;
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	GtkSwitch* lock_suspend_switch = NULL;
	GtkSwitch* _tmp2_;
	GtkSwitch* _tmp3_;
	GtkLabel* lock_sleep_label = NULL;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	GtkSwitch* lock_sleep_switch = NULL;
	GtkSwitch* _tmp6_;
	GtkSwitch* _tmp7_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp8_ = NULL;
	GtkGrid* _tmp9_;
	GtkLabel* _tmp10_;
	GtkGrid* _tmp11_;
	GtkSwitch* _tmp12_;
	GtkGrid* _tmp13_;
	GtkLabel* _tmp14_;
	GtkGrid* _tmp15_;
	GtkSwitch* _tmp16_;
	GtkGrid* _tmp17_;
	GSettings* gnome_screensaver_settings = NULL;
	GSettings* _tmp18_;
	GSettings* screensaver_settings = NULL;
	GSettings* _tmp19_;
	GSettingsSchema* schema = NULL;
	GSettingsSchemaSource* _tmp20_;
	GSettingsSchema* _tmp21_;
	GSettingsSchema* _tmp22_;
	GSettings* _tmp34_;
	GtkSwitch* _tmp35_;
	GSettings* _tmp36_;
	GtkSwitch* _tmp37_;
#line 30 "../src/Views/LockPanel.vala"
	parent_class = G_OBJECT_CLASS (security_privacy_lock_panel_parent_class);
#line 30 "../src/Views/LockPanel.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 30 "../src/Views/LockPanel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SECURITY_PRIVACY_TYPE_LOCK_PANEL, SecurityPrivacyLockPanel);
#line 31 "../src/Views/LockPanel.vala"
	_tmp0_ = (GtkLabel*) gtk_label_new (_ ("Lock on suspend:"));
#line 31 "../src/Views/LockPanel.vala"
	g_object_ref_sink (_tmp0_);
#line 31 "../src/Views/LockPanel.vala"
	lock_suspend_label = _tmp0_;
#line 32 "../src/Views/LockPanel.vala"
	_tmp1_ = lock_suspend_label;
#line 32 "../src/Views/LockPanel.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp1_, GTK_ALIGN_END);
#line 34 "../src/Views/LockPanel.vala"
	_tmp2_ = (GtkSwitch*) gtk_switch_new ();
#line 34 "../src/Views/LockPanel.vala"
	g_object_ref_sink (_tmp2_);
#line 34 "../src/Views/LockPanel.vala"
	lock_suspend_switch = _tmp2_;
#line 35 "../src/Views/LockPanel.vala"
	_tmp3_ = lock_suspend_switch;
#line 35 "../src/Views/LockPanel.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp3_, GTK_ALIGN_START);
#line 37 "../src/Views/LockPanel.vala"
	_tmp4_ = (GtkLabel*) gtk_label_new (_ ("Lock after screen turns off:"));
#line 37 "../src/Views/LockPanel.vala"
	g_object_ref_sink (_tmp4_);
#line 37 "../src/Views/LockPanel.vala"
	lock_sleep_label = _tmp4_;
#line 38 "../src/Views/LockPanel.vala"
	_tmp5_ = lock_sleep_label;
#line 38 "../src/Views/LockPanel.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp5_, GTK_ALIGN_END);
#line 40 "../src/Views/LockPanel.vala"
	_tmp6_ = (GtkSwitch*) gtk_switch_new ();
#line 40 "../src/Views/LockPanel.vala"
	g_object_ref_sink (_tmp6_);
#line 40 "../src/Views/LockPanel.vala"
	lock_sleep_switch = _tmp6_;
#line 41 "../src/Views/LockPanel.vala"
	_tmp7_ = lock_sleep_switch;
#line 41 "../src/Views/LockPanel.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp7_, GTK_ALIGN_START);
#line 43 "../src/Views/LockPanel.vala"
	_tmp8_ = (GtkGrid*) gtk_grid_new ();
#line 43 "../src/Views/LockPanel.vala"
	gtk_grid_set_column_spacing (_tmp8_, 6);
#line 43 "../src/Views/LockPanel.vala"
	gtk_grid_set_row_spacing (_tmp8_, 6);
#line 43 "../src/Views/LockPanel.vala"
	g_object_ref_sink (_tmp8_);
#line 43 "../src/Views/LockPanel.vala"
	grid = _tmp8_;
#line 47 "../src/Views/LockPanel.vala"
	_tmp9_ = grid;
#line 47 "../src/Views/LockPanel.vala"
	_tmp10_ = lock_suspend_label;
#line 47 "../src/Views/LockPanel.vala"
	gtk_grid_attach (_tmp9_, (GtkWidget*) _tmp10_, 0, 0, 1, 1);
#line 48 "../src/Views/LockPanel.vala"
	_tmp11_ = grid;
#line 48 "../src/Views/LockPanel.vala"
	_tmp12_ = lock_suspend_switch;
#line 48 "../src/Views/LockPanel.vala"
	gtk_grid_attach (_tmp11_, (GtkWidget*) _tmp12_, 1, 0, 1, 1);
#line 49 "../src/Views/LockPanel.vala"
	_tmp13_ = grid;
#line 49 "../src/Views/LockPanel.vala"
	_tmp14_ = lock_sleep_label;
#line 49 "../src/Views/LockPanel.vala"
	gtk_grid_attach (_tmp13_, (GtkWidget*) _tmp14_, 0, 1, 1, 1);
#line 50 "../src/Views/LockPanel.vala"
	_tmp15_ = grid;
#line 50 "../src/Views/LockPanel.vala"
	_tmp16_ = lock_sleep_switch;
#line 50 "../src/Views/LockPanel.vala"
	gtk_grid_attach (_tmp15_, (GtkWidget*) _tmp16_, 1, 1, 1, 1);
#line 52 "../src/Views/LockPanel.vala"
	_tmp17_ = grid;
#line 52 "../src/Views/LockPanel.vala"
	switchboard_settings_page_set_child ((SwitchboardSettingsPage*) self, (GtkWidget*) _tmp17_);
#line 53 "../src/Views/LockPanel.vala"
	switchboard_settings_page_set_show_end_title_buttons ((SwitchboardSettingsPage*) self, TRUE);
#line 55 "../src/Views/LockPanel.vala"
	_tmp18_ = g_settings_new ("org.gnome.desktop.screensaver");
#line 55 "../src/Views/LockPanel.vala"
	gnome_screensaver_settings = _tmp18_;
#line 56 "../src/Views/LockPanel.vala"
	_tmp19_ = g_settings_new ("io.elementary.desktop.screensaver");
#line 56 "../src/Views/LockPanel.vala"
	screensaver_settings = _tmp19_;
#line 58 "../src/Views/LockPanel.vala"
	_tmp20_ = g_settings_schema_source_get_default ();
#line 58 "../src/Views/LockPanel.vala"
	_tmp21_ = g_settings_schema_source_lookup (_tmp20_, "org.gnome.desktop.privacy", TRUE);
#line 58 "../src/Views/LockPanel.vala"
	schema = _tmp21_;
#line 59 "../src/Views/LockPanel.vala"
	_tmp22_ = schema;
#line 59 "../src/Views/LockPanel.vala"
	if (g_settings_schema_has_key (_tmp22_, "usb-protection")) {
#line 232 "LockPanel.c"
		GtkLabel* usb_lock_label = NULL;
		GtkLabel* _tmp23_;
		GtkLabel* _tmp24_;
		GtkSwitch* usb_lock_switch = NULL;
		GtkSwitch* _tmp25_;
		GtkSwitch* _tmp26_;
		GtkGrid* _tmp27_;
		GtkLabel* _tmp28_;
		GtkGrid* _tmp29_;
		GtkSwitch* _tmp30_;
		GSettings* gnome_privacy_settings = NULL;
		GSettings* _tmp31_;
		GSettings* _tmp32_;
		GtkSwitch* _tmp33_;
#line 60 "../src/Views/LockPanel.vala"
		_tmp23_ = (GtkLabel*) gtk_label_new (_ ("Forbid new USB devices when locked:"));
#line 60 "../src/Views/LockPanel.vala"
		g_object_ref_sink (_tmp23_);
#line 60 "../src/Views/LockPanel.vala"
		usb_lock_label = _tmp23_;
#line 61 "../src/Views/LockPanel.vala"
		_tmp24_ = usb_lock_label;
#line 61 "../src/Views/LockPanel.vala"
		gtk_widget_set_halign ((GtkWidget*) _tmp24_, GTK_ALIGN_END);
#line 63 "../src/Views/LockPanel.vala"
		_tmp25_ = (GtkSwitch*) gtk_switch_new ();
#line 63 "../src/Views/LockPanel.vala"
		g_object_ref_sink (_tmp25_);
#line 63 "../src/Views/LockPanel.vala"
		usb_lock_switch = _tmp25_;
#line 64 "../src/Views/LockPanel.vala"
		_tmp26_ = usb_lock_switch;
#line 64 "../src/Views/LockPanel.vala"
		gtk_widget_set_halign ((GtkWidget*) _tmp26_, GTK_ALIGN_START);
#line 66 "../src/Views/LockPanel.vala"
		_tmp27_ = grid;
#line 66 "../src/Views/LockPanel.vala"
		_tmp28_ = usb_lock_label;
#line 66 "../src/Views/LockPanel.vala"
		gtk_grid_attach (_tmp27_, (GtkWidget*) _tmp28_, 0, 2, 1, 1);
#line 67 "../src/Views/LockPanel.vala"
		_tmp29_ = grid;
#line 67 "../src/Views/LockPanel.vala"
		_tmp30_ = usb_lock_switch;
#line 67 "../src/Views/LockPanel.vala"
		gtk_grid_attach (_tmp29_, (GtkWidget*) _tmp30_, 1, 2, 1, 1);
#line 69 "../src/Views/LockPanel.vala"
		_tmp31_ = g_settings_new ("org.gnome.desktop.privacy");
#line 69 "../src/Views/LockPanel.vala"
		gnome_privacy_settings = _tmp31_;
#line 70 "../src/Views/LockPanel.vala"
		_tmp32_ = gnome_privacy_settings;
#line 70 "../src/Views/LockPanel.vala"
		_tmp33_ = usb_lock_switch;
#line 70 "../src/Views/LockPanel.vala"
		g_settings_bind (_tmp32_, "usb-protection", (GObject*) _tmp33_, "active", G_SETTINGS_BIND_DEFAULT);
#line 59 "../src/Views/LockPanel.vala"
		_g_object_unref0 (gnome_privacy_settings);
#line 59 "../src/Views/LockPanel.vala"
		_g_object_unref0 (usb_lock_switch);
#line 59 "../src/Views/LockPanel.vala"
		_g_object_unref0 (usb_lock_label);
#line 295 "LockPanel.c"
	}
#line 73 "../src/Views/LockPanel.vala"
	_tmp34_ = gnome_screensaver_settings;
#line 73 "../src/Views/LockPanel.vala"
	_tmp35_ = lock_sleep_switch;
#line 73 "../src/Views/LockPanel.vala"
	g_settings_bind (_tmp34_, "lock-enabled", (GObject*) _tmp35_, "active", G_SETTINGS_BIND_DEFAULT);
#line 74 "../src/Views/LockPanel.vala"
	_tmp36_ = screensaver_settings;
#line 74 "../src/Views/LockPanel.vala"
	_tmp37_ = lock_suspend_switch;
#line 74 "../src/Views/LockPanel.vala"
	g_settings_bind (_tmp36_, "lock-on-suspend", (GObject*) _tmp37_, "active", G_SETTINGS_BIND_DEFAULT);
#line 30 "../src/Views/LockPanel.vala"
	_g_settings_schema_unref0 (schema);
#line 30 "../src/Views/LockPanel.vala"
	_g_object_unref0 (screensaver_settings);
#line 30 "../src/Views/LockPanel.vala"
	_g_object_unref0 (gnome_screensaver_settings);
#line 30 "../src/Views/LockPanel.vala"
	_g_object_unref0 (grid);
#line 30 "../src/Views/LockPanel.vala"
	_g_object_unref0 (lock_sleep_switch);
#line 30 "../src/Views/LockPanel.vala"
	_g_object_unref0 (lock_sleep_label);
#line 30 "../src/Views/LockPanel.vala"
	_g_object_unref0 (lock_suspend_switch);
#line 30 "../src/Views/LockPanel.vala"
	_g_object_unref0 (lock_suspend_label);
#line 30 "../src/Views/LockPanel.vala"
	return obj;
#line 327 "LockPanel.c"
}

static void
security_privacy_lock_panel_class_init (SecurityPrivacyLockPanelClass * klass,
                                        gpointer klass_data)
{
#line 22 "../src/Views/LockPanel.vala"
	security_privacy_lock_panel_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Views/LockPanel.vala"
	G_OBJECT_CLASS (klass)->constructor = security_privacy_lock_panel_constructor;
#line 338 "LockPanel.c"
}

static void
security_privacy_lock_panel_instance_init (SecurityPrivacyLockPanel * self,
                                           gpointer klass)
{
}

static GType
security_privacy_lock_panel_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SecurityPrivacyLockPanelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) security_privacy_lock_panel_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SecurityPrivacyLockPanel), 0, (GInstanceInitFunc) security_privacy_lock_panel_instance_init, NULL };
	GType security_privacy_lock_panel_type_id;
	security_privacy_lock_panel_type_id = g_type_register_static (SWITCHBOARD_TYPE_SETTINGS_PAGE, "SecurityPrivacyLockPanel", &g_define_type_info, 0);
	return security_privacy_lock_panel_type_id;
}

GType
security_privacy_lock_panel_get_type (void)
{
	static volatile gsize security_privacy_lock_panel_type_id__once = 0;
	if (g_once_init_enter (&security_privacy_lock_panel_type_id__once)) {
		GType security_privacy_lock_panel_type_id;
		security_privacy_lock_panel_type_id = security_privacy_lock_panel_get_type_once ();
		g_once_init_leave (&security_privacy_lock_panel_type_id__once, security_privacy_lock_panel_type_id);
	}
	return security_privacy_lock_panel_type_id__once;
}

