/* TrackPanel.c generated by valac 0.56.17, the Vala compiler
 * generated from TrackPanel.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2014-2018 elementary LLC. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Corentin Noël <tintou@mailoo.org>
 */

#include "security-privacy.h"
#include <glib-object.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <switchboard.h>
#include <gtk/gtk.h>
#include <granite-7.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SECURITY_PRIVACY_TRACK_PANEL_0_PROPERTY,
	SECURITY_PRIVACY_TRACK_PANEL_NUM_PROPERTIES
};
static GParamSpec* security_privacy_track_panel_properties[SECURITY_PRIVACY_TRACK_PANEL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _security_privacy_blacklist_unref0(var) ((var == NULL) ? NULL : (var = (security_privacy_blacklist_unref (var), NULL)))
typedef struct _Block5Data Block5Data;

struct _Block5Data {
	int _ref_count_;
	SecurityPrivacyTrackPanel* self;
	GranitePlaceholder* alert;
	IncludeTreeView* include_treeview;
	ExcludeTreeView* exclude_treeview;
	GtkBox* content_box;
	GtkStack* stack;
};

static gpointer security_privacy_track_panel_parent_class = NULL;
static SecurityPrivacyBlacklist* security_privacy_track_panel__blacklist;
static SecurityPrivacyBlacklist* security_privacy_track_panel__blacklist = NULL;

static gchar* security_privacy_track_panel_get_operating_system_name (void);
static void security_privacy_track_panel_update_status_switch (SecurityPrivacyTrackPanel* self);
static void security_privacy_track_panel_set_blacklist (SecurityPrivacyBlacklist* value);
static GObject * security_privacy_track_panel_constructor (GType type,
                                                    guint n_construct_properties,
                                                    GObjectConstructParam * construct_properties);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void _security_privacy_track_panel___lambda13_ (Block5Data* _data5_);
static void __security_privacy_track_panel___lambda13__g_object_notify (GObject* _sender,
                                                                 GParamSpec* pspec,
                                                                 gpointer self);
static void _security_privacy_track_panel___lambda14_ (SecurityPrivacyTrackPanel* self);
static void __security_privacy_track_panel___lambda14__gtk_button_clicked (GtkButton* _sender,
                                                                    gpointer self);
static void security_privacy_track_panel_finalize (GObject * obj);
static GType security_privacy_track_panel_get_type_once (void);
static void _vala_security_privacy_track_panel_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec);
static void _vala_security_privacy_track_panel_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec);

SecurityPrivacyTrackPanel*
security_privacy_track_panel_construct (GType object_type)
{
	SecurityPrivacyTrackPanel * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GThemedIcon* _tmp4_;
	GThemedIcon* _tmp5_;
#line 27 "../src/Views/TrackPanel.vala"
	_tmp0_ = security_privacy_track_panel_get_operating_system_name ();
#line 27 "../src/Views/TrackPanel.vala"
	_tmp1_ = _tmp0_;
#line 27 "../src/Views/TrackPanel.vala"
	_tmp2_ = g_strdup_printf (_ ("%s can store local usage data to provide extra functionality like offe" \
"ring recently-used files and more relevant local search. Regardless of" \
" this setting, usage data is never transmitted off of this device or t" \
"o third parties."), _tmp1_);
#line 27 "../src/Views/TrackPanel.vala"
	_tmp3_ = _tmp2_;
#line 27 "../src/Views/TrackPanel.vala"
	_tmp4_ = (GThemedIcon*) g_themed_icon_new ("document-open-recent");
#line 27 "../src/Views/TrackPanel.vala"
	_tmp5_ = _tmp4_;
#line 27 "../src/Views/TrackPanel.vala"
	self = (SecurityPrivacyTrackPanel*) g_object_new (object_type, "activatable", TRUE, "description", _tmp3_, "icon", _tmp5_, "title", _ ("History"), NULL);
#line 27 "../src/Views/TrackPanel.vala"
	_g_object_unref0 (_tmp5_);
#line 27 "../src/Views/TrackPanel.vala"
	_g_free0 (_tmp3_);
#line 27 "../src/Views/TrackPanel.vala"
	_g_free0 (_tmp1_);
#line 26 "../src/Views/TrackPanel.vala"
	return self;
#line 129 "TrackPanel.c"
}

SecurityPrivacyTrackPanel*
security_privacy_track_panel_new (void)
{
#line 26 "../src/Views/TrackPanel.vala"
	return security_privacy_track_panel_construct (SECURITY_PRIVACY_TYPE_TRACK_PANEL);
#line 137 "TrackPanel.c"
}

static gchar*
security_privacy_track_panel_get_operating_system_name (void)
{
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp3_;
	gchar* result;
#line 104 "../src/Views/TrackPanel.vala"
	_tmp1_ = g_get_os_info (G_OS_INFO_KEY_NAME);
#line 104 "../src/Views/TrackPanel.vala"
	_tmp0_ = _tmp1_;
#line 104 "../src/Views/TrackPanel.vala"
	if (_tmp0_ == NULL) {
#line 153 "TrackPanel.c"
		gchar* _tmp2_;
#line 104 "../src/Views/TrackPanel.vala"
		_tmp2_ = g_strdup (_ ("Your system"));
#line 104 "../src/Views/TrackPanel.vala"
		_g_free0 (_tmp0_);
#line 104 "../src/Views/TrackPanel.vala"
		_tmp0_ = _tmp2_;
#line 161 "TrackPanel.c"
	}
#line 104 "../src/Views/TrackPanel.vala"
	_tmp3_ = _tmp0_;
#line 104 "../src/Views/TrackPanel.vala"
	_tmp0_ = NULL;
#line 104 "../src/Views/TrackPanel.vala"
	result = _tmp3_;
#line 104 "../src/Views/TrackPanel.vala"
	_g_free0 (_tmp0_);
#line 104 "../src/Views/TrackPanel.vala"
	return result;
#line 173 "TrackPanel.c"
}

static void
security_privacy_track_panel_update_status_switch (SecurityPrivacyTrackPanel* self)
{
	GtkSwitch* _tmp0_;
	GtkSwitch* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 107 "../src/Views/TrackPanel.vala"
	g_return_if_fail (self != NULL);
#line 108 "../src/Views/TrackPanel.vala"
	_tmp0_ = switchboard_settings_page_get_status_switch ((SwitchboardSettingsPage*) self);
#line 108 "../src/Views/TrackPanel.vala"
	_tmp1_ = _tmp0_;
#line 108 "../src/Views/TrackPanel.vala"
	_tmp2_ = gtk_switch_get_active (_tmp1_);
#line 108 "../src/Views/TrackPanel.vala"
	_tmp3_ = _tmp2_;
#line 108 "../src/Views/TrackPanel.vala"
	if (_tmp3_) {
#line 109 "../src/Views/TrackPanel.vala"
		switchboard_settings_page_set_status_type ((SwitchboardSettingsPage*) self, SWITCHBOARD_SETTINGS_PAGE_STATUS_TYPE_SUCCESS);
#line 110 "../src/Views/TrackPanel.vala"
		switchboard_settings_page_set_status ((SwitchboardSettingsPage*) self, _ ("Enabled"));
#line 199 "TrackPanel.c"
	} else {
#line 112 "../src/Views/TrackPanel.vala"
		g_warning ("TrackPanel.vala:112: Trying to set offline");
#line 113 "../src/Views/TrackPanel.vala"
		switchboard_settings_page_set_status_type ((SwitchboardSettingsPage*) self, SWITCHBOARD_SETTINGS_PAGE_STATUS_TYPE_OFFLINE);
#line 114 "../src/Views/TrackPanel.vala"
		switchboard_settings_page_set_status ((SwitchboardSettingsPage*) self, _ ("Disabled"));
#line 207 "TrackPanel.c"
	}
}

SecurityPrivacyBlacklist*
security_privacy_track_panel_get_blacklist (void)
{
	SecurityPrivacyBlacklist* result;
	SecurityPrivacyBlacklist* _tmp0_;
#line 24 "../src/Views/TrackPanel.vala"
	_tmp0_ = security_privacy_track_panel__blacklist;
#line 24 "../src/Views/TrackPanel.vala"
	result = _tmp0_;
#line 24 "../src/Views/TrackPanel.vala"
	return result;
#line 222 "TrackPanel.c"
}

static gpointer
_security_privacy_blacklist_ref0 (gpointer self)
{
#line 24 "../src/Views/TrackPanel.vala"
	return self ? security_privacy_blacklist_ref (self) : NULL;
#line 230 "TrackPanel.c"
}

static void
security_privacy_track_panel_set_blacklist (SecurityPrivacyBlacklist* value)
{
	SecurityPrivacyBlacklist* _tmp0_;
#line 24 "../src/Views/TrackPanel.vala"
	_tmp0_ = _security_privacy_blacklist_ref0 (value);
#line 24 "../src/Views/TrackPanel.vala"
	_security_privacy_blacklist_unref0 (security_privacy_track_panel__blacklist);
#line 24 "../src/Views/TrackPanel.vala"
	security_privacy_track_panel__blacklist = _tmp0_;
#line 243 "TrackPanel.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 39 "../src/Views/TrackPanel.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 39 "../src/Views/TrackPanel.vala"
	return _data5_;
#line 253 "TrackPanel.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 39 "../src/Views/TrackPanel.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 263 "TrackPanel.c"
		SecurityPrivacyTrackPanel* self;
#line 39 "../src/Views/TrackPanel.vala"
		self = _data5_->self;
#line 39 "../src/Views/TrackPanel.vala"
		_g_object_unref0 (_data5_->stack);
#line 39 "../src/Views/TrackPanel.vala"
		_g_object_unref0 (_data5_->content_box);
#line 39 "../src/Views/TrackPanel.vala"
		_g_object_unref0 (_data5_->exclude_treeview);
#line 39 "../src/Views/TrackPanel.vala"
		_g_object_unref0 (_data5_->include_treeview);
#line 39 "../src/Views/TrackPanel.vala"
		_g_object_unref0 (_data5_->alert);
#line 39 "../src/Views/TrackPanel.vala"
		_g_object_unref0 (self);
#line 39 "../src/Views/TrackPanel.vala"
		g_slice_free (Block5Data, _data5_);
#line 281 "TrackPanel.c"
	}
}

static void
_security_privacy_track_panel___lambda13_ (Block5Data* _data5_)
{
	SecurityPrivacyTrackPanel* self;
	gboolean privacy_mode = FALSE;
	GtkSwitch* _tmp0_;
	GtkSwitch* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	IncludeTreeView* _tmp4_;
	ExcludeTreeView* _tmp5_;
	SecurityPrivacyBlacklist* _tmp10_;
	SecurityPrivacyBlacklist* _tmp11_;
#line 68 "../src/Views/TrackPanel.vala"
	self = _data5_->self;
#line 69 "../src/Views/TrackPanel.vala"
	_tmp0_ = switchboard_settings_page_get_status_switch ((SwitchboardSettingsPage*) self);
#line 69 "../src/Views/TrackPanel.vala"
	_tmp1_ = _tmp0_;
#line 69 "../src/Views/TrackPanel.vala"
	_tmp2_ = gtk_switch_get_active (_tmp1_);
#line 69 "../src/Views/TrackPanel.vala"
	_tmp3_ = _tmp2_;
#line 69 "../src/Views/TrackPanel.vala"
	privacy_mode = !_tmp3_;
#line 70 "../src/Views/TrackPanel.vala"
	_tmp4_ = _data5_->include_treeview;
#line 70 "../src/Views/TrackPanel.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp4_, !privacy_mode);
#line 71 "../src/Views/TrackPanel.vala"
	_tmp5_ = _data5_->exclude_treeview;
#line 71 "../src/Views/TrackPanel.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp5_, !privacy_mode);
#line 73 "../src/Views/TrackPanel.vala"
	if (privacy_mode) {
#line 320 "TrackPanel.c"
		GtkStack* _tmp6_;
		GranitePlaceholder* _tmp7_;
#line 74 "../src/Views/TrackPanel.vala"
		_tmp6_ = _data5_->stack;
#line 74 "../src/Views/TrackPanel.vala"
		_tmp7_ = _data5_->alert;
#line 74 "../src/Views/TrackPanel.vala"
		gtk_stack_set_visible_child (_tmp6_, (GtkWidget*) _tmp7_);
#line 329 "TrackPanel.c"
	} else {
		GtkStack* _tmp8_;
		GtkBox* _tmp9_;
#line 76 "../src/Views/TrackPanel.vala"
		_tmp8_ = _data5_->stack;
#line 76 "../src/Views/TrackPanel.vala"
		_tmp9_ = _data5_->content_box;
#line 76 "../src/Views/TrackPanel.vala"
		gtk_stack_set_visible_child (_tmp8_, (GtkWidget*) _tmp9_);
#line 339 "TrackPanel.c"
	}
#line 79 "../src/Views/TrackPanel.vala"
	_tmp10_ = security_privacy_track_panel_get_blacklist ();
#line 79 "../src/Views/TrackPanel.vala"
	_tmp11_ = _tmp10_;
#line 79 "../src/Views/TrackPanel.vala"
	if (privacy_mode != security_privacy_blacklist_get_incognito (_tmp11_)) {
#line 347 "TrackPanel.c"
		SecurityPrivacyBlacklist* _tmp12_;
		SecurityPrivacyBlacklist* _tmp13_;
		GSettings* privacy_settings = NULL;
		GSettings* _tmp14_;
		GSettings* _tmp15_;
		GSettings* _tmp16_;
#line 80 "../src/Views/TrackPanel.vala"
		_tmp12_ = security_privacy_track_panel_get_blacklist ();
#line 80 "../src/Views/TrackPanel.vala"
		_tmp13_ = _tmp12_;
#line 80 "../src/Views/TrackPanel.vala"
		security_privacy_blacklist_set_incognito (_tmp13_, privacy_mode);
#line 82 "../src/Views/TrackPanel.vala"
		_tmp14_ = g_settings_new ("org.gnome.desktop.privacy");
#line 82 "../src/Views/TrackPanel.vala"
		privacy_settings = _tmp14_;
#line 83 "../src/Views/TrackPanel.vala"
		_tmp15_ = privacy_settings;
#line 83 "../src/Views/TrackPanel.vala"
		g_settings_set_boolean (_tmp15_, "remember-recent-files", !privacy_mode);
#line 84 "../src/Views/TrackPanel.vala"
		_tmp16_ = privacy_settings;
#line 84 "../src/Views/TrackPanel.vala"
		g_settings_set_boolean (_tmp16_, "remember-app-usage", !privacy_mode);
#line 79 "../src/Views/TrackPanel.vala"
		_g_object_unref0 (privacy_settings);
#line 374 "TrackPanel.c"
	}
#line 87 "../src/Views/TrackPanel.vala"
	security_privacy_track_panel_update_status_switch (self);
#line 378 "TrackPanel.c"
}

static void
__security_privacy_track_panel___lambda13__g_object_notify (GObject* _sender,
                                                            GParamSpec* pspec,
                                                            gpointer self)
{
#line 68 "../src/Views/TrackPanel.vala"
	_security_privacy_track_panel___lambda13_ (self);
#line 388 "TrackPanel.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 95 "../src/Views/TrackPanel.vala"
	return self ? g_object_ref (self) : NULL;
#line 396 "TrackPanel.c"
}

static void
_security_privacy_track_panel___lambda14_ (SecurityPrivacyTrackPanel* self)
{
	SecurityPrivacyWidgetsClearUsageDialog* clear_dialog = NULL;
	GtkRoot* _tmp0_;
	GtkWindow* _tmp1_;
	SecurityPrivacyWidgetsClearUsageDialog* _tmp2_ = NULL;
	SecurityPrivacyWidgetsClearUsageDialog* _tmp3_;
#line 95 "../src/Views/TrackPanel.vala"
	_tmp0_ = gtk_widget_get_root ((GtkWidget*) self);
#line 95 "../src/Views/TrackPanel.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_window_get_type (), GtkWindow));
#line 95 "../src/Views/TrackPanel.vala"
	_tmp2_ = security_privacy_widgets_clear_usage_dialog_new ();
#line 95 "../src/Views/TrackPanel.vala"
	gtk_window_set_modal ((GtkWindow*) _tmp2_, TRUE);
#line 95 "../src/Views/TrackPanel.vala"
	gtk_window_set_transient_for ((GtkWindow*) _tmp2_, _tmp1_);
#line 95 "../src/Views/TrackPanel.vala"
	_g_object_unref0 (_tmp1_);
#line 95 "../src/Views/TrackPanel.vala"
	g_object_ref_sink (_tmp2_);
#line 95 "../src/Views/TrackPanel.vala"
	clear_dialog = _tmp2_;
#line 99 "../src/Views/TrackPanel.vala"
	_tmp3_ = clear_dialog;
#line 99 "../src/Views/TrackPanel.vala"
	gtk_window_present ((GtkWindow*) _tmp3_);
#line 94 "../src/Views/TrackPanel.vala"
	_g_object_unref0 (clear_dialog);
#line 429 "TrackPanel.c"
}

static void
__security_privacy_track_panel___lambda14__gtk_button_clicked (GtkButton* _sender,
                                                               gpointer self)
{
#line 94 "../src/Views/TrackPanel.vala"
	_security_privacy_track_panel___lambda14_ ((SecurityPrivacyTrackPanel*) self);
#line 438 "TrackPanel.c"
}

static GObject *
security_privacy_track_panel_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SecurityPrivacyTrackPanel * self;
	Block5Data* _data5_;
	gchar* description = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	GranitePlaceholder* _tmp8_ = NULL;
	GtkSwitch* _tmp9_;
	GtkSwitch* _tmp10_;
	IncludeTreeView* _tmp11_;
	ExcludeTreeView* _tmp12_;
	GtkBox* _tmp13_;
	GtkBox* _tmp14_;
	IncludeTreeView* _tmp15_;
	GtkBox* _tmp16_;
	ExcludeTreeView* _tmp17_;
	GtkStack* _tmp18_;
	GtkStack* _tmp19_;
	GtkBox* _tmp20_;
	GtkStack* _tmp21_;
	GranitePlaceholder* _tmp22_;
	GtkStack* _tmp23_;
	GtkButton* clear_button = NULL;
	GtkButton* _tmp24_;
	GtkSwitch* _tmp25_;
	GtkSwitch* _tmp26_;
	GtkSwitch* _tmp27_;
	GtkSwitch* _tmp28_;
	SecurityPrivacyBlacklist* _tmp29_;
	SecurityPrivacyBlacklist* _tmp30_;
	GtkButton* _tmp31_;
#line 39 "../src/Views/TrackPanel.vala"
	parent_class = G_OBJECT_CLASS (security_privacy_track_panel_parent_class);
#line 39 "../src/Views/TrackPanel.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 39 "../src/Views/TrackPanel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SECURITY_PRIVACY_TYPE_TRACK_PANEL, SecurityPrivacyTrackPanel);
#line 39 "../src/Views/TrackPanel.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 39 "../src/Views/TrackPanel.vala"
	_data5_->_ref_count_ = 1;
#line 39 "../src/Views/TrackPanel.vala"
	_data5_->self = g_object_ref (self);
#line 40 "../src/Views/TrackPanel.vala"
	_tmp0_ = security_privacy_track_panel_get_operating_system_name ();
#line 40 "../src/Views/TrackPanel.vala"
	_tmp1_ = _tmp0_;
#line 40 "../src/Views/TrackPanel.vala"
	_tmp2_ = g_strdup_printf (_ ("%s won't retain any further usage data."), _tmp1_);
#line 40 "../src/Views/TrackPanel.vala"
	_tmp3_ = _tmp2_;
#line 40 "../src/Views/TrackPanel.vala"
	_tmp4_ = g_strdup_printf ("%s %s\n\n%s", _tmp3_, _ ("The additional functionality that this data provides will be affected."), _ ("This may not prevent apps from recording their own usage data, such as" \
" browser history."));
#line 40 "../src/Views/TrackPanel.vala"
	_tmp5_ = _tmp4_;
#line 40 "../src/Views/TrackPanel.vala"
	_g_free0 (_tmp3_);
#line 40 "../src/Views/TrackPanel.vala"
	_g_free0 (_tmp1_);
#line 40 "../src/Views/TrackPanel.vala"
	description = _tmp5_;
#line 46 "../src/Views/TrackPanel.vala"
	_tmp6_ = description;
#line 46 "../src/Views/TrackPanel.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 46 "../src/Views/TrackPanel.vala"
	_tmp8_ = granite_placeholder_new (_ ("History Is Disabled"));
#line 46 "../src/Views/TrackPanel.vala"
	granite_placeholder_set_description (_tmp8_, _tmp7_);
#line 46 "../src/Views/TrackPanel.vala"
	_g_free0 (_tmp7_);
#line 46 "../src/Views/TrackPanel.vala"
	g_object_ref_sink (_tmp8_);
#line 46 "../src/Views/TrackPanel.vala"
	_data5_->alert = _tmp8_;
#line 50 "../src/Views/TrackPanel.vala"
	_tmp9_ = switchboard_settings_page_get_status_switch ((SwitchboardSettingsPage*) self);
#line 50 "../src/Views/TrackPanel.vala"
	_tmp10_ = _tmp9_;
#line 50 "../src/Views/TrackPanel.vala"
	gtk_switch_set_active (_tmp10_, TRUE);
#line 52 "../src/Views/TrackPanel.vala"
	_tmp11_ = include_tree_view_new ();
#line 52 "../src/Views/TrackPanel.vala"
	g_object_ref_sink (_tmp11_);
#line 52 "../src/Views/TrackPanel.vala"
	_data5_->include_treeview = _tmp11_;
#line 53 "../src/Views/TrackPanel.vala"
	_tmp12_ = exclude_tree_view_new ();
#line 53 "../src/Views/TrackPanel.vala"
	g_object_ref_sink (_tmp12_);
#line 53 "../src/Views/TrackPanel.vala"
	_data5_->exclude_treeview = _tmp12_;
#line 55 "../src/Views/TrackPanel.vala"
	_tmp13_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 12);
#line 55 "../src/Views/TrackPanel.vala"
	g_object_ref_sink (_tmp13_);
#line 55 "../src/Views/TrackPanel.vala"
	_data5_->content_box = _tmp13_;
#line 56 "../src/Views/TrackPanel.vala"
	_tmp14_ = _data5_->content_box;
#line 56 "../src/Views/TrackPanel.vala"
	_tmp15_ = _data5_->include_treeview;
#line 56 "../src/Views/TrackPanel.vala"
	gtk_box_append (_tmp14_, (GtkWidget*) _tmp15_);
#line 57 "../src/Views/TrackPanel.vala"
	_tmp16_ = _data5_->content_box;
#line 57 "../src/Views/TrackPanel.vala"
	_tmp17_ = _data5_->exclude_treeview;
#line 57 "../src/Views/TrackPanel.vala"
	gtk_box_append (_tmp16_, (GtkWidget*) _tmp17_);
#line 59 "../src/Views/TrackPanel.vala"
	_tmp18_ = (GtkStack*) gtk_stack_new ();
#line 59 "../src/Views/TrackPanel.vala"
	g_object_ref_sink (_tmp18_);
#line 59 "../src/Views/TrackPanel.vala"
	_data5_->stack = _tmp18_;
#line 60 "../src/Views/TrackPanel.vala"
	_tmp19_ = _data5_->stack;
#line 60 "../src/Views/TrackPanel.vala"
	_tmp20_ = _data5_->content_box;
#line 60 "../src/Views/TrackPanel.vala"
	gtk_stack_add_child (_tmp19_, (GtkWidget*) _tmp20_);
#line 61 "../src/Views/TrackPanel.vala"
	_tmp21_ = _data5_->stack;
#line 61 "../src/Views/TrackPanel.vala"
	_tmp22_ = _data5_->alert;
#line 61 "../src/Views/TrackPanel.vala"
	gtk_stack_add_child (_tmp21_, (GtkWidget*) _tmp22_);
#line 63 "../src/Views/TrackPanel.vala"
	_tmp23_ = _data5_->stack;
#line 63 "../src/Views/TrackPanel.vala"
	switchboard_settings_page_set_child ((SwitchboardSettingsPage*) self, (GtkWidget*) _tmp23_);
#line 64 "../src/Views/TrackPanel.vala"
	switchboard_settings_page_set_show_end_title_buttons ((SwitchboardSettingsPage*) self, TRUE);
#line 66 "../src/Views/TrackPanel.vala"
	_tmp24_ = switchboard_settings_page_add_button ((SwitchboardSettingsPage*) self, _ ("Clear History…"));
#line 66 "../src/Views/TrackPanel.vala"
	clear_button = _tmp24_;
#line 68 "../src/Views/TrackPanel.vala"
	_tmp25_ = switchboard_settings_page_get_status_switch ((SwitchboardSettingsPage*) self);
#line 68 "../src/Views/TrackPanel.vala"
	_tmp26_ = _tmp25_;
#line 68 "../src/Views/TrackPanel.vala"
	g_signal_connect_data ((GObject*) _tmp26_, "notify::active", (GCallback) __security_privacy_track_panel___lambda13__g_object_notify, block5_data_ref (_data5_), (GClosureNotify) block5_data_unref, 0);
#line 90 "../src/Views/TrackPanel.vala"
	_tmp27_ = switchboard_settings_page_get_status_switch ((SwitchboardSettingsPage*) self);
#line 90 "../src/Views/TrackPanel.vala"
	_tmp28_ = _tmp27_;
#line 90 "../src/Views/TrackPanel.vala"
	_tmp29_ = security_privacy_track_panel_get_blacklist ();
#line 90 "../src/Views/TrackPanel.vala"
	_tmp30_ = _tmp29_;
#line 90 "../src/Views/TrackPanel.vala"
	gtk_switch_set_active (_tmp28_, !security_privacy_blacklist_get_incognito (_tmp30_));
#line 92 "../src/Views/TrackPanel.vala"
	security_privacy_track_panel_update_status_switch (self);
#line 94 "../src/Views/TrackPanel.vala"
	_tmp31_ = clear_button;
#line 94 "../src/Views/TrackPanel.vala"
	g_signal_connect_object (_tmp31_, "clicked", (GCallback) __security_privacy_track_panel___lambda14__gtk_button_clicked, self, 0);
#line 39 "../src/Views/TrackPanel.vala"
	_g_object_unref0 (clear_button);
#line 39 "../src/Views/TrackPanel.vala"
	_g_free0 (description);
#line 39 "../src/Views/TrackPanel.vala"
	block5_data_unref (_data5_);
#line 39 "../src/Views/TrackPanel.vala"
	_data5_ = NULL;
#line 39 "../src/Views/TrackPanel.vala"
	return obj;
#line 624 "TrackPanel.c"
}

static void
security_privacy_track_panel_class_init (SecurityPrivacyTrackPanelClass * klass,
                                         gpointer klass_data)
{
	SecurityPrivacyBlacklist* _tmp0_;
	SecurityPrivacyBlacklist* _tmp1_;
#line 23 "../src/Views/TrackPanel.vala"
	security_privacy_track_panel_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/Views/TrackPanel.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_security_privacy_track_panel_get_property;
#line 23 "../src/Views/TrackPanel.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_security_privacy_track_panel_set_property;
#line 23 "../src/Views/TrackPanel.vala"
	G_OBJECT_CLASS (klass)->constructor = security_privacy_track_panel_constructor;
#line 23 "../src/Views/TrackPanel.vala"
	G_OBJECT_CLASS (klass)->finalize = security_privacy_track_panel_finalize;
#line 36 "../src/Views/TrackPanel.vala"
	_tmp0_ = security_privacy_blacklist_new ();
#line 36 "../src/Views/TrackPanel.vala"
	_tmp1_ = _tmp0_;
#line 36 "../src/Views/TrackPanel.vala"
	security_privacy_track_panel_set_blacklist (_tmp1_);
#line 36 "../src/Views/TrackPanel.vala"
	_security_privacy_blacklist_unref0 (_tmp1_);
#line 651 "TrackPanel.c"
}

static void
security_privacy_track_panel_instance_init (SecurityPrivacyTrackPanel * self,
                                            gpointer klass)
{
}

static void
security_privacy_track_panel_finalize (GObject * obj)
{
	SecurityPrivacyTrackPanel * self;
#line 23 "../src/Views/TrackPanel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SECURITY_PRIVACY_TYPE_TRACK_PANEL, SecurityPrivacyTrackPanel);
#line 23 "../src/Views/TrackPanel.vala"
	G_OBJECT_CLASS (security_privacy_track_panel_parent_class)->finalize (obj);
#line 668 "TrackPanel.c"
}

static GType
security_privacy_track_panel_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SecurityPrivacyTrackPanelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) security_privacy_track_panel_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SecurityPrivacyTrackPanel), 0, (GInstanceInitFunc) security_privacy_track_panel_instance_init, NULL };
	GType security_privacy_track_panel_type_id;
	security_privacy_track_panel_type_id = g_type_register_static (SWITCHBOARD_TYPE_SETTINGS_PAGE, "SecurityPrivacyTrackPanel", &g_define_type_info, 0);
	return security_privacy_track_panel_type_id;
}

GType
security_privacy_track_panel_get_type (void)
{
	static volatile gsize security_privacy_track_panel_type_id__once = 0;
	if (g_once_init_enter (&security_privacy_track_panel_type_id__once)) {
		GType security_privacy_track_panel_type_id;
		security_privacy_track_panel_type_id = security_privacy_track_panel_get_type_once ();
		g_once_init_leave (&security_privacy_track_panel_type_id__once, security_privacy_track_panel_type_id);
	}
	return security_privacy_track_panel_type_id__once;
}

static void
_vala_security_privacy_track_panel_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec)
{
	SecurityPrivacyTrackPanel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SECURITY_PRIVACY_TYPE_TRACK_PANEL, SecurityPrivacyTrackPanel);
#line 23 "../src/Views/TrackPanel.vala"
	switch (property_id) {
#line 702 "TrackPanel.c"
		default:
#line 23 "../src/Views/TrackPanel.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/Views/TrackPanel.vala"
		break;
#line 708 "TrackPanel.c"
	}
}

static void
_vala_security_privacy_track_panel_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec)
{
	SecurityPrivacyTrackPanel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SECURITY_PRIVACY_TYPE_TRACK_PANEL, SecurityPrivacyTrackPanel);
#line 23 "../src/Views/TrackPanel.vala"
	switch (property_id) {
#line 722 "TrackPanel.c"
		default:
#line 23 "../src/Views/TrackPanel.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/Views/TrackPanel.vala"
		break;
#line 728 "TrackPanel.c"
	}
}

