/* AppRow.c generated by valac 0.56.17, the Vala compiler
 * generated from AppRow.vala, do not modify */

/*-
* Copyright (c) 2014-2017 elementary LLC. (http://launchpad.net/switchboard-plug-security-privacy)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Julien Spautz <spautz.julien@gmail.com>
*              Corentin Noël <corentin@elementaryos.org>
*/

#include "security-privacy.h"
#include <gio/gdesktopappinfo.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <granite-7.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	APP_ROW_0_PROPERTY,
	APP_ROW_APP_INFO_PROPERTY,
	APP_ROW_NUM_PROPERTIES
};
static GParamSpec* app_row_properties[APP_ROW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _AppRowPrivate {
	GDesktopAppInfo* _app_info;
};

static gint AppRow_private_offset;
static gpointer app_row_parent_class = NULL;

static gchar* app_row_get_app_comment (AppRow* self);
static gchar* app_row_get_app_name (AppRow* self);
static gchar* app_row_get_icon_name (AppRow* self);
static GObject * app_row_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties);
static void app_row_finalize (GObject * obj);
static GType app_row_get_type_once (void);
static void _vala_app_row_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec);
static void _vala_app_row_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec);

static inline gpointer
app_row_get_instance_private (AppRow* self)
{
	return G_STRUCT_MEMBER_P (self, AppRow_private_offset);
}

AppRow*
app_row_construct (GType object_type,
                   GDesktopAppInfo* app_info)
{
	AppRow * self = NULL;
#line 27 "../src/Widgets/AppRow.vala"
	g_return_val_if_fail (app_info != NULL, NULL);
#line 28 "../src/Widgets/AppRow.vala"
	self = (AppRow*) g_object_new (object_type, "app-info", app_info, NULL);
#line 27 "../src/Widgets/AppRow.vala"
	return self;
#line 100 "AppRow.c"
}

AppRow*
app_row_new (GDesktopAppInfo* app_info)
{
#line 27 "../src/Widgets/AppRow.vala"
	return app_row_construct (TYPE_APP_ROW, app_info);
#line 108 "AppRow.c"
}

static gchar*
app_row_get_app_comment (AppRow* self)
{
	gchar* comment = NULL;
	GDesktopAppInfo* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* result;
#line 60 "../src/Widgets/AppRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 61 "../src/Widgets/AppRow.vala"
	_tmp0_ = self->priv->_app_info;
#line 61 "../src/Widgets/AppRow.vala"
	_tmp1_ = g_app_info_get_description ((GAppInfo*) _tmp0_);
#line 61 "../src/Widgets/AppRow.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 61 "../src/Widgets/AppRow.vala"
	comment = _tmp2_;
#line 63 "../src/Widgets/AppRow.vala"
	_tmp3_ = comment;
#line 63 "../src/Widgets/AppRow.vala"
	if (_tmp3_ == NULL) {
#line 136 "AppRow.c"
		gchar* _tmp4_;
#line 64 "../src/Widgets/AppRow.vala"
		_tmp4_ = g_strdup ("");
#line 64 "../src/Widgets/AppRow.vala"
		_g_free0 (comment);
#line 64 "../src/Widgets/AppRow.vala"
		comment = _tmp4_;
#line 144 "AppRow.c"
	}
#line 67 "../src/Widgets/AppRow.vala"
	_tmp5_ = comment;
#line 67 "../src/Widgets/AppRow.vala"
	_tmp6_ = g_markup_escape_text (_tmp5_, (gssize) -1);
#line 67 "../src/Widgets/AppRow.vala"
	result = _tmp6_;
#line 67 "../src/Widgets/AppRow.vala"
	_g_free0 (comment);
#line 67 "../src/Widgets/AppRow.vala"
	return result;
#line 156 "AppRow.c"
}

static gchar*
app_row_get_app_name (AppRow* self)
{
	gchar* name = NULL;
	GDesktopAppInfo* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* result;
#line 70 "../src/Widgets/AppRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 71 "../src/Widgets/AppRow.vala"
	_tmp0_ = self->priv->_app_info;
#line 71 "../src/Widgets/AppRow.vala"
	_tmp1_ = g_app_info_get_display_name ((GAppInfo*) _tmp0_);
#line 71 "../src/Widgets/AppRow.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 71 "../src/Widgets/AppRow.vala"
	name = _tmp2_;
#line 73 "../src/Widgets/AppRow.vala"
	_tmp3_ = name;
#line 73 "../src/Widgets/AppRow.vala"
	if (_tmp3_ == NULL) {
#line 184 "AppRow.c"
		GDesktopAppInfo* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 74 "../src/Widgets/AppRow.vala"
		_tmp4_ = self->priv->_app_info;
#line 74 "../src/Widgets/AppRow.vala"
		_tmp5_ = g_app_info_get_name ((GAppInfo*) _tmp4_);
#line 74 "../src/Widgets/AppRow.vala"
		_tmp6_ = g_strdup (_tmp5_);
#line 74 "../src/Widgets/AppRow.vala"
		_g_free0 (name);
#line 74 "../src/Widgets/AppRow.vala"
		name = _tmp6_;
#line 198 "AppRow.c"
	}
#line 77 "../src/Widgets/AppRow.vala"
	_tmp7_ = name;
#line 77 "../src/Widgets/AppRow.vala"
	_tmp8_ = g_markup_escape_text (_tmp7_, (gssize) -1);
#line 77 "../src/Widgets/AppRow.vala"
	result = _tmp8_;
#line 77 "../src/Widgets/AppRow.vala"
	_g_free0 (name);
#line 77 "../src/Widgets/AppRow.vala"
	return result;
#line 210 "AppRow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 81 "../src/Widgets/AppRow.vala"
	return self ? g_object_ref (self) : NULL;
#line 218 "AppRow.c"
}

static gchar*
app_row_get_icon_name (AppRow* self)
{
	GtkIconTheme* icon_theme = NULL;
	GdkDisplay* _tmp0_;
	GtkIconTheme* _tmp1_;
	GtkIconTheme* _tmp2_;
	GtkIconTheme* _tmp3_;
	GDesktopAppInfo* _tmp4_;
	GIcon* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean _tmp8_;
	gchar* result;
#line 80 "../src/Widgets/AppRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 81 "../src/Widgets/AppRow.vala"
	_tmp0_ = gdk_display_get_default ();
#line 81 "../src/Widgets/AppRow.vala"
	_tmp1_ = gtk_icon_theme_get_for_display (_tmp0_);
#line 81 "../src/Widgets/AppRow.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 81 "../src/Widgets/AppRow.vala"
	icon_theme = _tmp2_;
#line 83 "../src/Widgets/AppRow.vala"
	_tmp3_ = icon_theme;
#line 83 "../src/Widgets/AppRow.vala"
	_tmp4_ = self->priv->_app_info;
#line 83 "../src/Widgets/AppRow.vala"
	_tmp5_ = g_app_info_get_icon ((GAppInfo*) _tmp4_);
#line 83 "../src/Widgets/AppRow.vala"
	_tmp6_ = g_icon_to_string (_tmp5_);
#line 83 "../src/Widgets/AppRow.vala"
	_tmp7_ = _tmp6_;
#line 83 "../src/Widgets/AppRow.vala"
	_tmp8_ = gtk_icon_theme_has_icon (_tmp3_, _tmp7_);
#line 83 "../src/Widgets/AppRow.vala"
	_g_free0 (_tmp7_);
#line 83 "../src/Widgets/AppRow.vala"
	if (_tmp8_) {
#line 261 "AppRow.c"
		GDesktopAppInfo* _tmp9_;
		GIcon* _tmp10_;
		gchar* _tmp11_;
#line 84 "../src/Widgets/AppRow.vala"
		_tmp9_ = self->priv->_app_info;
#line 84 "../src/Widgets/AppRow.vala"
		_tmp10_ = g_app_info_get_icon ((GAppInfo*) _tmp9_);
#line 84 "../src/Widgets/AppRow.vala"
		_tmp11_ = g_icon_to_string (_tmp10_);
#line 84 "../src/Widgets/AppRow.vala"
		result = _tmp11_;
#line 84 "../src/Widgets/AppRow.vala"
		_g_object_unref0 (icon_theme);
#line 84 "../src/Widgets/AppRow.vala"
		return result;
#line 277 "AppRow.c"
	} else {
		gchar* _tmp12_;
#line 86 "../src/Widgets/AppRow.vala"
		_tmp12_ = g_strdup ("application-default-icon");
#line 86 "../src/Widgets/AppRow.vala"
		result = _tmp12_;
#line 86 "../src/Widgets/AppRow.vala"
		_g_object_unref0 (icon_theme);
#line 86 "../src/Widgets/AppRow.vala"
		return result;
#line 288 "AppRow.c"
	}
}

GDesktopAppInfo*
app_row_get_app_info (AppRow* self)
{
	GDesktopAppInfo* result;
	GDesktopAppInfo* _tmp0_;
#line 24 "../src/Widgets/AppRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../src/Widgets/AppRow.vala"
	_tmp0_ = self->priv->_app_info;
#line 24 "../src/Widgets/AppRow.vala"
	result = _tmp0_;
#line 24 "../src/Widgets/AppRow.vala"
	return result;
#line 305 "AppRow.c"
}

static void
app_row_set_app_info (AppRow* self,
                      GDesktopAppInfo* value)
{
	GDesktopAppInfo* old_value;
#line 24 "../src/Widgets/AppRow.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/Widgets/AppRow.vala"
	old_value = app_row_get_app_info (self);
#line 24 "../src/Widgets/AppRow.vala"
	if (old_value != value) {
#line 319 "AppRow.c"
		GDesktopAppInfo* _tmp0_;
#line 24 "../src/Widgets/AppRow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 24 "../src/Widgets/AppRow.vala"
		_g_object_unref0 (self->priv->_app_info);
#line 24 "../src/Widgets/AppRow.vala"
		self->priv->_app_info = _tmp0_;
#line 24 "../src/Widgets/AppRow.vala"
		g_object_notify_by_pspec ((GObject *) self, app_row_properties[APP_ROW_APP_INFO_PROPERTY]);
#line 329 "AppRow.c"
	}
}

static GObject *
app_row_constructor (GType type,
                     guint n_construct_properties,
                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	AppRow * self;
	GtkImage* image = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GtkImage* _tmp2_ = NULL;
	GtkImage* _tmp3_;
	GtkLabel* app_name = NULL;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkLabel* app_comment = NULL;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	GtkLabel* _tmp17_;
	GtkLabel* _tmp18_;
	GtkLabel* _tmp19_;
	GtkLabel* _tmp20_;
	GtkLabel* _tmp21_;
	GtkGrid* _tmp22_ = NULL;
	GtkGrid* _tmp23_;
	GtkGrid* _tmp24_;
	GtkImage* _tmp25_;
	GtkGrid* _tmp26_;
	GtkLabel* _tmp27_;
	GtkGrid* _tmp28_;
	GtkLabel* _tmp29_;
	GtkGrid* _tmp30_;
#line 31 "../src/Widgets/AppRow.vala"
	parent_class = G_OBJECT_CLASS (app_row_parent_class);
#line 31 "../src/Widgets/AppRow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 31 "../src/Widgets/AppRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_APP_ROW, AppRow);
#line 32 "../src/Widgets/AppRow.vala"
	_tmp0_ = app_row_get_icon_name (self);
#line 32 "../src/Widgets/AppRow.vala"
	_tmp1_ = _tmp0_;
#line 32 "../src/Widgets/AppRow.vala"
	_tmp2_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp1_);
#line 32 "../src/Widgets/AppRow.vala"
	gtk_image_set_pixel_size (_tmp2_, 32);
#line 32 "../src/Widgets/AppRow.vala"
	g_object_ref_sink (_tmp2_);
#line 32 "../src/Widgets/AppRow.vala"
	_tmp3_ = _tmp2_;
#line 32 "../src/Widgets/AppRow.vala"
	_g_free0 (_tmp1_);
#line 32 "../src/Widgets/AppRow.vala"
	image = _tmp3_;
#line 36 "../src/Widgets/AppRow.vala"
	_tmp4_ = app_row_get_app_name (self);
#line 36 "../src/Widgets/AppRow.vala"
	_tmp5_ = _tmp4_;
#line 36 "../src/Widgets/AppRow.vala"
	_tmp6_ = (GtkLabel*) gtk_label_new (_tmp5_);
#line 36 "../src/Widgets/AppRow.vala"
	g_object_ref_sink (_tmp6_);
#line 36 "../src/Widgets/AppRow.vala"
	_tmp7_ = _tmp6_;
#line 36 "../src/Widgets/AppRow.vala"
	_g_free0 (_tmp5_);
#line 36 "../src/Widgets/AppRow.vala"
	app_name = _tmp7_;
#line 37 "../src/Widgets/AppRow.vala"
	_tmp8_ = app_name;
#line 37 "../src/Widgets/AppRow.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp8_, GRANITE_STYLE_CLASS_H3_LABEL);
#line 38 "../src/Widgets/AppRow.vala"
	_tmp9_ = app_name;
#line 38 "../src/Widgets/AppRow.vala"
	gtk_label_set_xalign (_tmp9_, (gfloat) 0);
#line 39 "../src/Widgets/AppRow.vala"
	_tmp10_ = app_name;
#line 39 "../src/Widgets/AppRow.vala"
	gtk_label_set_ellipsize (_tmp10_, PANGO_ELLIPSIZE_END);
#line 41 "../src/Widgets/AppRow.vala"
	_tmp11_ = app_row_get_app_comment (self);
#line 41 "../src/Widgets/AppRow.vala"
	_tmp12_ = _tmp11_;
#line 41 "../src/Widgets/AppRow.vala"
	_tmp13_ = g_strconcat ("<span font_size='small'>", _tmp12_, NULL);
#line 41 "../src/Widgets/AppRow.vala"
	_tmp14_ = _tmp13_;
#line 41 "../src/Widgets/AppRow.vala"
	_tmp15_ = g_strconcat (_tmp14_, "</span>", NULL);
#line 41 "../src/Widgets/AppRow.vala"
	_tmp16_ = _tmp15_;
#line 41 "../src/Widgets/AppRow.vala"
	_tmp17_ = (GtkLabel*) gtk_label_new (_tmp16_);
#line 41 "../src/Widgets/AppRow.vala"
	g_object_ref_sink (_tmp17_);
#line 41 "../src/Widgets/AppRow.vala"
	_tmp18_ = _tmp17_;
#line 41 "../src/Widgets/AppRow.vala"
	_g_free0 (_tmp16_);
#line 41 "../src/Widgets/AppRow.vala"
	_g_free0 (_tmp14_);
#line 41 "../src/Widgets/AppRow.vala"
	_g_free0 (_tmp12_);
#line 41 "../src/Widgets/AppRow.vala"
	app_comment = _tmp18_;
#line 42 "../src/Widgets/AppRow.vala"
	_tmp19_ = app_comment;
#line 42 "../src/Widgets/AppRow.vala"
	gtk_label_set_xalign (_tmp19_, (gfloat) 0);
#line 43 "../src/Widgets/AppRow.vala"
	_tmp20_ = app_comment;
#line 43 "../src/Widgets/AppRow.vala"
	gtk_label_set_use_markup (_tmp20_, TRUE);
#line 44 "../src/Widgets/AppRow.vala"
	_tmp21_ = app_comment;
#line 44 "../src/Widgets/AppRow.vala"
	gtk_label_set_ellipsize (_tmp21_, PANGO_ELLIPSIZE_END);
#line 46 "../src/Widgets/AppRow.vala"
	_tmp22_ = (GtkGrid*) gtk_grid_new ();
#line 46 "../src/Widgets/AppRow.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp22_, 6);
#line 46 "../src/Widgets/AppRow.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp22_, 12);
#line 46 "../src/Widgets/AppRow.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp22_, 6);
#line 46 "../src/Widgets/AppRow.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp22_, 10);
#line 46 "../src/Widgets/AppRow.vala"
	g_object_ref_sink (_tmp22_);
#line 46 "../src/Widgets/AppRow.vala"
	_g_object_unref0 (self->main_grid);
#line 46 "../src/Widgets/AppRow.vala"
	self->main_grid = _tmp22_;
#line 52 "../src/Widgets/AppRow.vala"
	_tmp23_ = self->main_grid;
#line 52 "../src/Widgets/AppRow.vala"
	gtk_grid_set_column_spacing (_tmp23_, 12);
#line 53 "../src/Widgets/AppRow.vala"
	_tmp24_ = self->main_grid;
#line 53 "../src/Widgets/AppRow.vala"
	_tmp25_ = image;
#line 53 "../src/Widgets/AppRow.vala"
	gtk_grid_attach (_tmp24_, (GtkWidget*) _tmp25_, 0, 0, 1, 2);
#line 54 "../src/Widgets/AppRow.vala"
	_tmp26_ = self->main_grid;
#line 54 "../src/Widgets/AppRow.vala"
	_tmp27_ = app_name;
#line 54 "../src/Widgets/AppRow.vala"
	gtk_grid_attach (_tmp26_, (GtkWidget*) _tmp27_, 1, 0, 1, 1);
#line 55 "../src/Widgets/AppRow.vala"
	_tmp28_ = self->main_grid;
#line 55 "../src/Widgets/AppRow.vala"
	_tmp29_ = app_comment;
#line 55 "../src/Widgets/AppRow.vala"
	gtk_grid_attach (_tmp28_, (GtkWidget*) _tmp29_, 1, 1, 1, 1);
#line 57 "../src/Widgets/AppRow.vala"
	_tmp30_ = self->main_grid;
#line 57 "../src/Widgets/AppRow.vala"
	gtk_list_box_row_set_child ((GtkListBoxRow*) self, (GtkWidget*) _tmp30_);
#line 31 "../src/Widgets/AppRow.vala"
	_g_object_unref0 (app_comment);
#line 31 "../src/Widgets/AppRow.vala"
	_g_object_unref0 (app_name);
#line 31 "../src/Widgets/AppRow.vala"
	_g_object_unref0 (image);
#line 31 "../src/Widgets/AppRow.vala"
	return obj;
#line 511 "AppRow.c"
}

static void
app_row_class_init (AppRowClass * klass,
                    gpointer klass_data)
{
#line 23 "../src/Widgets/AppRow.vala"
	app_row_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/Widgets/AppRow.vala"
	g_type_class_adjust_private_offset (klass, &AppRow_private_offset);
#line 23 "../src/Widgets/AppRow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_app_row_get_property;
#line 23 "../src/Widgets/AppRow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_app_row_set_property;
#line 23 "../src/Widgets/AppRow.vala"
	G_OBJECT_CLASS (klass)->constructor = app_row_constructor;
#line 23 "../src/Widgets/AppRow.vala"
	G_OBJECT_CLASS (klass)->finalize = app_row_finalize;
#line 23 "../src/Widgets/AppRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APP_ROW_APP_INFO_PROPERTY, app_row_properties[APP_ROW_APP_INFO_PROPERTY] = g_param_spec_object ("app-info", "app-info", "app-info", G_TYPE_DESKTOP_APP_INFO, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 532 "AppRow.c"
}

static void
app_row_instance_init (AppRow * self,
                       gpointer klass)
{
#line 23 "../src/Widgets/AppRow.vala"
	self->priv = app_row_get_instance_private (self);
#line 541 "AppRow.c"
}

static void
app_row_finalize (GObject * obj)
{
	AppRow * self;
#line 23 "../src/Widgets/AppRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_APP_ROW, AppRow);
#line 24 "../src/Widgets/AppRow.vala"
	_g_object_unref0 (self->priv->_app_info);
#line 25 "../src/Widgets/AppRow.vala"
	_g_object_unref0 (self->main_grid);
#line 23 "../src/Widgets/AppRow.vala"
	G_OBJECT_CLASS (app_row_parent_class)->finalize (obj);
#line 556 "AppRow.c"
}

static GType
app_row_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AppRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) app_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AppRow), 0, (GInstanceInitFunc) app_row_instance_init, NULL };
	GType app_row_type_id;
	app_row_type_id = g_type_register_static (gtk_list_box_row_get_type (), "AppRow", &g_define_type_info, 0);
	AppRow_private_offset = g_type_add_instance_private (app_row_type_id, sizeof (AppRowPrivate));
	return app_row_type_id;
}

GType
app_row_get_type (void)
{
	static volatile gsize app_row_type_id__once = 0;
	if (g_once_init_enter (&app_row_type_id__once)) {
		GType app_row_type_id;
		app_row_type_id = app_row_get_type_once ();
		g_once_init_leave (&app_row_type_id__once, app_row_type_id);
	}
	return app_row_type_id__once;
}

static void
_vala_app_row_get_property (GObject * object,
                            guint property_id,
                            GValue * value,
                            GParamSpec * pspec)
{
	AppRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_APP_ROW, AppRow);
#line 23 "../src/Widgets/AppRow.vala"
	switch (property_id) {
#line 23 "../src/Widgets/AppRow.vala"
		case APP_ROW_APP_INFO_PROPERTY:
#line 23 "../src/Widgets/AppRow.vala"
		g_value_set_object (value, app_row_get_app_info (self));
#line 23 "../src/Widgets/AppRow.vala"
		break;
#line 597 "AppRow.c"
		default:
#line 23 "../src/Widgets/AppRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/Widgets/AppRow.vala"
		break;
#line 603 "AppRow.c"
	}
}

static void
_vala_app_row_set_property (GObject * object,
                            guint property_id,
                            const GValue * value,
                            GParamSpec * pspec)
{
	AppRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_APP_ROW, AppRow);
#line 23 "../src/Widgets/AppRow.vala"
	switch (property_id) {
#line 23 "../src/Widgets/AppRow.vala"
		case APP_ROW_APP_INFO_PROPERTY:
#line 23 "../src/Widgets/AppRow.vala"
		app_row_set_app_info (self, g_value_get_object (value));
#line 23 "../src/Widgets/AppRow.vala"
		break;
#line 623 "AppRow.c"
		default:
#line 23 "../src/Widgets/AppRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/Widgets/AppRow.vala"
		break;
#line 629 "AppRow.c"
	}
}

