/* BlackList.c generated by valac 0.56.17, the Vala compiler
 * generated from BlackList.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2011 Collabora Ltd.
 * Copyright (c) 2012 Manish Sinha <manishsinha@ubuntu.com>
 * Copyright (c) 2014 elementary LLC. (http://launchpad.net/switchboard-plug-security-privacy)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Corentin Noël <tintou@mailoo.org>
 *              Siegfried-Angel Gevatter Pujals <siegfried@gevatter.com> (from Activity-Log-Manager)
 *              Seif Lotfy <seif@lotfy.com> (from Activity-Log-Manager)
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include "security-privacy.h"
#include <zeitgeist-datamodel.h>
#include <zeitgeist.h>
#include <gtk/gtk.h>
#include <gobject/gvaluecollector.h>
#include <gee.h>

#define SECURITY_PRIVACY_SIG_EVENT "asaasay"
#define SECURITY_PRIVACY_SIG_BLACKLIST "a{s(" SECURITY_PRIVACY_SIG_EVENT ")}"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define SECURITY_PRIVACY_TYPE_BLACKLIST_INTERFACE (security_privacy_blacklist_interface_get_type ())
#define SECURITY_PRIVACY_BLACKLIST_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SECURITY_PRIVACY_TYPE_BLACKLIST_INTERFACE, SecurityPrivacyBlacklistInterface))
#define SECURITY_PRIVACY_IS_BLACKLIST_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SECURITY_PRIVACY_TYPE_BLACKLIST_INTERFACE))
#define SECURITY_PRIVACY_BLACKLIST_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), SECURITY_PRIVACY_TYPE_BLACKLIST_INTERFACE, SecurityPrivacyBlacklistInterfaceIface))

typedef struct _SecurityPrivacyBlacklistInterface SecurityPrivacyBlacklistInterface;
typedef struct _SecurityPrivacyBlacklistInterfaceIface SecurityPrivacyBlacklistInterfaceIface;

#define SECURITY_PRIVACY_TYPE_BLACKLIST_INTERFACE_PROXY (security_privacy_blacklist_interface_proxy_get_type ())
enum  {
	SECURITY_PRIVACY_BLACKLIST_INTERFACE_TEMPLATE_ADDED_SIGNAL,
	SECURITY_PRIVACY_BLACKLIST_INTERFACE_TEMPLATE_REMOVED_SIGNAL,
	SECURITY_PRIVACY_BLACKLIST_INTERFACE_NUM_SIGNALS
};
static guint security_privacy_blacklist_interface_signals[SECURITY_PRIVACY_BLACKLIST_INTERFACE_NUM_SIGNALS] = {0};
typedef GDBusProxy SecurityPrivacyBlacklistInterfaceProxy;
typedef GDBusProxyClass SecurityPrivacyBlacklistInterfaceProxyClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _security_privacy_blacklist_unref0(var) ((var == NULL) ? NULL : (var = (security_privacy_blacklist_unref (var), NULL)))
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
typedef struct _SecurityPrivacyBlacklistFindEventsData SecurityPrivacyBlacklistFindEventsData;
typedef struct _SecurityPrivacyParamSpecBlacklist SecurityPrivacyParamSpecBlacklist;
enum  {
	SECURITY_PRIVACY_BLACKLIST_TEMPLATE_ADDED_SIGNAL,
	SECURITY_PRIVACY_BLACKLIST_TEMPLATE_REMOVED_SIGNAL,
	SECURITY_PRIVACY_BLACKLIST_INCOGNITO_TOGGLED_SIGNAL,
	SECURITY_PRIVACY_BLACKLIST_NUM_SIGNALS
};
static guint security_privacy_blacklist_signals[SECURITY_PRIVACY_BLACKLIST_NUM_SIGNALS] = {0};
typedef struct _SecurityPrivacyParamSpecFileTypeBlacklist SecurityPrivacyParamSpecFileTypeBlacklist;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _SecurityPrivacyParamSpecPathBlacklist SecurityPrivacyParamSpecPathBlacklist;
enum  {
	SECURITY_PRIVACY_PATH_BLACKLIST_FOLDER_ADDED_SIGNAL,
	SECURITY_PRIVACY_PATH_BLACKLIST_FOLDER_REMOVED_SIGNAL,
	SECURITY_PRIVACY_PATH_BLACKLIST_NUM_SIGNALS
};
static guint security_privacy_path_blacklist_signals[SECURITY_PRIVACY_PATH_BLACKLIST_NUM_SIGNALS] = {0};
typedef struct _SecurityPrivacyParamSpecApplicationBlacklist SecurityPrivacyParamSpecApplicationBlacklist;
enum  {
	SECURITY_PRIVACY_APPLICATION_BLACKLIST_APPLICATION_ADDED_SIGNAL,
	SECURITY_PRIVACY_APPLICATION_BLACKLIST_APPLICATION_REMOVED_SIGNAL,
	SECURITY_PRIVACY_APPLICATION_BLACKLIST_NUM_SIGNALS
};
static guint security_privacy_application_blacklist_signals[SECURITY_PRIVACY_APPLICATION_BLACKLIST_NUM_SIGNALS] = {0};

struct _SecurityPrivacyBlacklistInterfaceIface {
	GTypeInterface parent_iface;
	GVariant* (*get_templates) (SecurityPrivacyBlacklistInterface* self, GError** error);
	void (*add_template) (SecurityPrivacyBlacklistInterface* self, const gchar* blacklist_id, GVariant* blacklist_template, GError** error);
	void (*remove_template) (SecurityPrivacyBlacklistInterface* self, const gchar* blacklist_id, GError** error);
};

struct _SecurityPrivacyBlacklistPrivate {
	SecurityPrivacyBlacklistInterface* blacklist;
	GHashTable* blacklists;
	ZeitgeistLog* log;
	gchar* incognito_id;
	ZeitgeistEvent* incognito_event;
};

struct _SecurityPrivacyBlacklistFindEventsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SecurityPrivacyBlacklist* self;
	gchar* id;
	GtkTreeIter iter;
	GtkListStore* store;
	ZeitgeistEvent* event;
	ZeitgeistEvent* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GPtrArray* events;
	GPtrArray* _tmp3_;
	ZeitgeistEvent* _tmp4_;
	ZeitgeistEvent* event2;
	ZeitgeistEvent* _tmp5_;
	ZeitgeistSubject* subj;
	ZeitgeistSubject* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	ZeitgeistEvent* _tmp9_;
	guint32* results;
	ZeitgeistLog* _tmp10_;
	ZeitgeistTimeRange* _tmp11_;
	ZeitgeistTimeRange* _tmp12_;
	gint _tmp13_;
	guint32* _tmp14_;
	guint32* _tmp15_;
	gint _tmp15__length1;
	gint results_length1;
	gint _results_size_;
	gint counter;
	GtkTreeIter _tmp16_;
	GValue _tmp17_;
	GError* e;
	GError* _tmp18_;
	const gchar* _tmp19_;
	GError* _inner_error0_;
};

struct _SecurityPrivacyParamSpecBlacklist {
	GParamSpec parent_instance;
};

struct _SecurityPrivacyFileTypeBlacklistPrivate {
	SecurityPrivacyBlacklist* blacklist_interface;
	GeeHashSet* all_blocked_filetypes;
};

struct _SecurityPrivacyParamSpecFileTypeBlacklist {
	GParamSpec parent_instance;
};

struct _SecurityPrivacyPathBlacklistPrivate {
	SecurityPrivacyBlacklist* blacklist_interface;
	GeeHashSet* all_blocked_folder;
};

struct _SecurityPrivacyParamSpecPathBlacklist {
	GParamSpec parent_instance;
};

struct _SecurityPrivacyApplicationBlacklistPrivate {
	SecurityPrivacyBlacklist* blacklist_interface;
	GeeHashSet* all_blocked_apps;
};

struct _SecurityPrivacyParamSpecApplicationBlacklist {
	GParamSpec parent_instance;
};

static gint SecurityPrivacyBlacklist_private_offset;
static gpointer security_privacy_blacklist_parent_class = NULL;
static gint SecurityPrivacyFileTypeBlacklist_private_offset;
static gpointer security_privacy_file_type_blacklist_parent_class = NULL;
gchar* security_privacy_file_type_blacklist_interpretation_prefix = NULL;
static gint SecurityPrivacyPathBlacklist_private_offset;
static gpointer security_privacy_path_blacklist_parent_class = NULL;
gchar* security_privacy_path_blacklist_folder_prefix = NULL;
static gchar* security_privacy_path_blacklist_suffix;
static gchar* security_privacy_path_blacklist_suffix = NULL;
static gint SecurityPrivacyApplicationBlacklist_private_offset;
static gpointer security_privacy_application_blacklist_parent_class = NULL;
gchar* security_privacy_application_blacklist_interpretation_prefix = NULL;
gchar* security_privacy_application_blacklist_launcher_prefix = NULL;

VALA_EXTERN GType security_privacy_blacklist_interface_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint security_privacy_blacklist_interface_register_object (void* object,
                                                            GDBusConnection* connection,
                                                            const gchar* path,
                                                            GError** error);
VALA_EXTERN GType security_privacy_blacklist_interface_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GVariant* security_privacy_blacklist_interface_get_templates (SecurityPrivacyBlacklistInterface* self,
                                                              GError** error);
VALA_EXTERN void security_privacy_blacklist_interface_add_template (SecurityPrivacyBlacklistInterface* self,
                                                        const gchar* blacklist_id,
                                                        GVariant* blacklist_template,
                                                        GError** error);
VALA_EXTERN void security_privacy_blacklist_interface_remove_template (SecurityPrivacyBlacklistInterface* self,
                                                           const gchar* blacklist_id,
                                                           GError** error);
static void g_cclosure_user_marshal_VOID__STRING_VARIANT (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data);
static GType security_privacy_blacklist_interface_get_type_once (void);
static void security_privacy_blacklist_interface_proxy_g_signal (GDBusProxy* proxy,
                                                          const gchar* sender_name,
                                                          const gchar* signal_name,
                                                          GVariant* parameters);
static void _dbus_handle_security_privacy_blacklist_interface_template_added (SecurityPrivacyBlacklistInterface* self,
                                                                       GVariant* parameters);
static void _dbus_handle_security_privacy_blacklist_interface_template_removed (SecurityPrivacyBlacklistInterface* self,
                                                                         GVariant* parameters);
static GVariant* security_privacy_blacklist_interface_proxy_get_templates (SecurityPrivacyBlacklistInterface* self,
                                                                    GError** error);
static void security_privacy_blacklist_interface_proxy_add_template (SecurityPrivacyBlacklistInterface* self,
                                                              const gchar* blacklist_id,
                                                              GVariant* blacklist_template,
                                                              GError** error);
static void security_privacy_blacklist_interface_proxy_remove_template (SecurityPrivacyBlacklistInterface* self,
                                                                 const gchar* blacklist_id,
                                                                 GError** error);
static void security_privacy_blacklist_interface_proxy_security_privacy_blacklist_interface_interface_init (SecurityPrivacyBlacklistInterfaceIface* iface);
static void _dbus_security_privacy_blacklist_interface_get_templates (SecurityPrivacyBlacklistInterface* self,
                                                               GVariant* _parameters_,
                                                               GDBusMethodInvocation* invocation);
static void _dbus_security_privacy_blacklist_interface_add_template (SecurityPrivacyBlacklistInterface* self,
                                                              GVariant* _parameters_,
                                                              GDBusMethodInvocation* invocation);
static void _dbus_security_privacy_blacklist_interface_remove_template (SecurityPrivacyBlacklistInterface* self,
                                                                 GVariant* _parameters_,
                                                                 GDBusMethodInvocation* invocation);
static void security_privacy_blacklist_interface_dbus_interface_method_call (GDBusConnection* connection,
                                                                      const gchar* sender,
                                                                      const gchar* object_path,
                                                                      const gchar* interface_name,
                                                                      const gchar* method_name,
                                                                      GVariant* parameters,
                                                                      GDBusMethodInvocation* invocation,
                                                                      gpointer user_data);
static GVariant* security_privacy_blacklist_interface_dbus_interface_get_property (GDBusConnection* connection,
                                                                            const gchar* sender,
                                                                            const gchar* object_path,
                                                                            const gchar* interface_name,
                                                                            const gchar* property_name,
                                                                            GError** error,
                                                                            gpointer user_data);
static gboolean security_privacy_blacklist_interface_dbus_interface_set_property (GDBusConnection* connection,
                                                                           const gchar* sender,
                                                                           const gchar* object_path,
                                                                           const gchar* interface_name,
                                                                           const gchar* property_name,
                                                                           GVariant* value,
                                                                           GError** error,
                                                                           gpointer user_data);
static void _dbus_security_privacy_blacklist_interface_template_added (GObject* _sender,
                                                                const gchar* blacklist_id,
                                                                GVariant* blacklist_template,
                                                                gpointer* _data);
static void _dbus_security_privacy_blacklist_interface_template_removed (GObject* _sender,
                                                                  const gchar* blacklist_id,
                                                                  GVariant* blacklist_template,
                                                                  gpointer* _data);
static void _security_privacy_blacklist_interface_unregister_object (gpointer user_data);
static void security_privacy_blacklist_on_template_added (SecurityPrivacyBlacklist* self,
                                                   const gchar* blacklist_id,
                                                   GVariant* blacklist_template);
static void _security_privacy_blacklist_on_template_added_security_privacy_blacklist_interface_template_added (SecurityPrivacyBlacklistInterface* _sender,
                                                                                                        const gchar* blacklist_id,
                                                                                                        GVariant* blacklist_template,
                                                                                                        gpointer self);
static void security_privacy_blacklist_on_template_removed (SecurityPrivacyBlacklist* self,
                                                     const gchar* blacklist_id,
                                                     GVariant* blacklist_template);
static void _security_privacy_blacklist_on_template_removed_security_privacy_blacklist_interface_template_removed (SecurityPrivacyBlacklistInterface* _sender,
                                                                                                            const gchar* blacklist_id,
                                                                                                            GVariant* blacklist_template,
                                                                                                            gpointer self);
static void _g_free0_ (gpointer var);
static void _g_object_unref0_ (gpointer var);
static void security_privacy_blacklist_find_events_data_free (gpointer _data);
static gboolean security_privacy_blacklist_find_events_co (SecurityPrivacyBlacklistFindEventsData* _data_);
static void security_privacy_blacklist_find_events_ready (GObject* source_object,
                                                   GAsyncResult* _res_,
                                                   gpointer _user_data_);
static void g_cclosure_user_marshal_VOID__STRING_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void security_privacy_blacklist_finalize (SecurityPrivacyBlacklist * obj);
static GType security_privacy_blacklist_get_type_once (void);
static void security_privacy_file_type_blacklist_on_blacklist_added (SecurityPrivacyFileTypeBlacklist* self,
                                                              const gchar* blacklist_id,
                                                              ZeitgeistEvent* ev);
static void _security_privacy_file_type_blacklist_on_blacklist_added_security_privacy_blacklist_template_added (SecurityPrivacyBlacklist* _sender,
                                                                                                         const gchar* blacklist_id,
                                                                                                         ZeitgeistEvent* blacklist_template,
                                                                                                         gpointer self);
static void security_privacy_file_type_blacklist_on_blacklist_removed (SecurityPrivacyFileTypeBlacklist* self,
                                                                const gchar* blacklist_id,
                                                                ZeitgeistEvent* ev);
static void _security_privacy_file_type_blacklist_on_blacklist_removed_security_privacy_blacklist_template_removed (SecurityPrivacyBlacklist* _sender,
                                                                                                             const gchar* blacklist_id,
                                                                                                             ZeitgeistEvent* blacklist_template,
                                                                                                             gpointer self);
static void security_privacy_file_type_blacklist_populate_file_types (SecurityPrivacyFileTypeBlacklist* self);
static gchar* security_privacy_file_type_blacklist_get_name (SecurityPrivacyFileTypeBlacklist* self,
                                                      const gchar* interpretation);
static void security_privacy_file_type_blacklist_finalize (SecurityPrivacyFileTypeBlacklist * obj);
static GType security_privacy_file_type_blacklist_get_type_once (void);
static void security_privacy_path_blacklist_on_blacklist_added (SecurityPrivacyPathBlacklist* self,
                                                         const gchar* blacklist_id,
                                                         ZeitgeistEvent* ev);
static void _security_privacy_path_blacklist_on_blacklist_added_security_privacy_blacklist_template_added (SecurityPrivacyBlacklist* _sender,
                                                                                                    const gchar* blacklist_id,
                                                                                                    ZeitgeistEvent* blacklist_template,
                                                                                                    gpointer self);
static void security_privacy_path_blacklist_on_blacklist_removed (SecurityPrivacyPathBlacklist* self,
                                                           const gchar* blacklist_id,
                                                           ZeitgeistEvent* ev);
static void _security_privacy_path_blacklist_on_blacklist_removed_security_privacy_blacklist_template_removed (SecurityPrivacyBlacklist* _sender,
                                                                                                        const gchar* blacklist_id,
                                                                                                        ZeitgeistEvent* blacklist_template,
                                                                                                        gpointer self);
static void security_privacy_path_blacklist_get_blocked_folder (SecurityPrivacyPathBlacklist* self);
static gchar* security_privacy_path_blacklist_get_folder (SecurityPrivacyPathBlacklist* self,
                                                   ZeitgeistEvent* ev);
static void security_privacy_path_blacklist_finalize (SecurityPrivacyPathBlacklist * obj);
static GType security_privacy_path_blacklist_get_type_once (void);
static void security_privacy_application_blacklist_on_blacklist_added (SecurityPrivacyApplicationBlacklist* self,
                                                                const gchar* blacklist_id,
                                                                ZeitgeistEvent* ev);
static void _security_privacy_application_blacklist_on_blacklist_added_security_privacy_blacklist_template_added (SecurityPrivacyBlacklist* _sender,
                                                                                                           const gchar* blacklist_id,
                                                                                                           ZeitgeistEvent* blacklist_template,
                                                                                                           gpointer self);
static void security_privacy_application_blacklist_on_blacklist_removed (SecurityPrivacyApplicationBlacklist* self,
                                                                  const gchar* blacklist_id,
                                                                  ZeitgeistEvent* ev);
static void _security_privacy_application_blacklist_on_blacklist_removed_security_privacy_blacklist_template_removed (SecurityPrivacyBlacklist* _sender,
                                                                                                               const gchar* blacklist_id,
                                                                                                               ZeitgeistEvent* blacklist_template,
                                                                                                               gpointer self);
static GeeHashSet* security_privacy_application_blacklist_get_blocked_apps (SecurityPrivacyApplicationBlacklist* self);
static void security_privacy_application_blacklist_finalize (SecurityPrivacyApplicationBlacklist * obj);
static GType security_privacy_application_blacklist_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static const GDBusArgInfo _security_privacy_blacklist_interface_dbus_arg_info_get_templates_result = {-1, "result", "a{s(asaasay)}", NULL};
static const GDBusArgInfo * const _security_privacy_blacklist_interface_dbus_arg_info_get_templates_in[] = {NULL};
static const GDBusArgInfo * const _security_privacy_blacklist_interface_dbus_arg_info_get_templates_out[] = {&_security_privacy_blacklist_interface_dbus_arg_info_get_templates_result, NULL};
static const GDBusMethodInfo _security_privacy_blacklist_interface_dbus_method_info_get_templates = {-1, "GetTemplates", (GDBusArgInfo **) (&_security_privacy_blacklist_interface_dbus_arg_info_get_templates_in), (GDBusArgInfo **) (&_security_privacy_blacklist_interface_dbus_arg_info_get_templates_out), NULL};
static const GDBusArgInfo _security_privacy_blacklist_interface_dbus_arg_info_add_template_blacklist_id = {-1, "blacklist_id", "s", NULL};
static const GDBusArgInfo _security_privacy_blacklist_interface_dbus_arg_info_add_template_blacklist_template = {-1, "blacklist_template", "(asaasay)", NULL};
static const GDBusArgInfo * const _security_privacy_blacklist_interface_dbus_arg_info_add_template_in[] = {&_security_privacy_blacklist_interface_dbus_arg_info_add_template_blacklist_id, &_security_privacy_blacklist_interface_dbus_arg_info_add_template_blacklist_template, NULL};
static const GDBusArgInfo * const _security_privacy_blacklist_interface_dbus_arg_info_add_template_out[] = {NULL};
static const GDBusMethodInfo _security_privacy_blacklist_interface_dbus_method_info_add_template = {-1, "AddTemplate", (GDBusArgInfo **) (&_security_privacy_blacklist_interface_dbus_arg_info_add_template_in), (GDBusArgInfo **) (&_security_privacy_blacklist_interface_dbus_arg_info_add_template_out), NULL};
static const GDBusArgInfo _security_privacy_blacklist_interface_dbus_arg_info_remove_template_blacklist_id = {-1, "blacklist_id", "s", NULL};
static const GDBusArgInfo * const _security_privacy_blacklist_interface_dbus_arg_info_remove_template_in[] = {&_security_privacy_blacklist_interface_dbus_arg_info_remove_template_blacklist_id, NULL};
static const GDBusArgInfo * const _security_privacy_blacklist_interface_dbus_arg_info_remove_template_out[] = {NULL};
static const GDBusMethodInfo _security_privacy_blacklist_interface_dbus_method_info_remove_template = {-1, "RemoveTemplate", (GDBusArgInfo **) (&_security_privacy_blacklist_interface_dbus_arg_info_remove_template_in), (GDBusArgInfo **) (&_security_privacy_blacklist_interface_dbus_arg_info_remove_template_out), NULL};
static const GDBusMethodInfo * const _security_privacy_blacklist_interface_dbus_method_info[] = {&_security_privacy_blacklist_interface_dbus_method_info_get_templates, &_security_privacy_blacklist_interface_dbus_method_info_add_template, &_security_privacy_blacklist_interface_dbus_method_info_remove_template, NULL};
static const GDBusArgInfo _security_privacy_blacklist_interface_dbus_arg_info_template_added_blacklist_id = {-1, "blacklist_id", "s", NULL};
static const GDBusArgInfo _security_privacy_blacklist_interface_dbus_arg_info_template_added_blacklist_template = {-1, "blacklist_template", "(asaasay)", NULL};
static const GDBusArgInfo * const _security_privacy_blacklist_interface_dbus_arg_info_template_added[] = {&_security_privacy_blacklist_interface_dbus_arg_info_template_added_blacklist_id, &_security_privacy_blacklist_interface_dbus_arg_info_template_added_blacklist_template, NULL};
static const GDBusSignalInfo _security_privacy_blacklist_interface_dbus_signal_info_template_added = {-1, "TemplateAdded", (GDBusArgInfo **) (&_security_privacy_blacklist_interface_dbus_arg_info_template_added), NULL};
static const GDBusArgInfo _security_privacy_blacklist_interface_dbus_arg_info_template_removed_blacklist_id = {-1, "blacklist_id", "s", NULL};
static const GDBusArgInfo _security_privacy_blacklist_interface_dbus_arg_info_template_removed_blacklist_template = {-1, "blacklist_template", "(asaasay)", NULL};
static const GDBusArgInfo * const _security_privacy_blacklist_interface_dbus_arg_info_template_removed[] = {&_security_privacy_blacklist_interface_dbus_arg_info_template_removed_blacklist_id, &_security_privacy_blacklist_interface_dbus_arg_info_template_removed_blacklist_template, NULL};
static const GDBusSignalInfo _security_privacy_blacklist_interface_dbus_signal_info_template_removed = {-1, "TemplateRemoved", (GDBusArgInfo **) (&_security_privacy_blacklist_interface_dbus_arg_info_template_removed), NULL};
static const GDBusSignalInfo * const _security_privacy_blacklist_interface_dbus_signal_info[] = {&_security_privacy_blacklist_interface_dbus_signal_info_template_added, &_security_privacy_blacklist_interface_dbus_signal_info_template_removed, NULL};
static const GDBusPropertyInfo * const _security_privacy_blacklist_interface_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _security_privacy_blacklist_interface_dbus_interface_info = {-1, "org.gnome.zeitgeist.Blacklist", (GDBusMethodInfo **) (&_security_privacy_blacklist_interface_dbus_method_info), (GDBusSignalInfo **) (&_security_privacy_blacklist_interface_dbus_signal_info), (GDBusPropertyInfo **) (&_security_privacy_blacklist_interface_dbus_property_info), NULL};
static const GDBusInterfaceVTable _security_privacy_blacklist_interface_dbus_interface_vtable = {security_privacy_blacklist_interface_dbus_interface_method_call, security_privacy_blacklist_interface_dbus_interface_get_property, security_privacy_blacklist_interface_dbus_interface_set_property};

GVariant*
security_privacy_blacklist_interface_get_templates (SecurityPrivacyBlacklistInterface* self,
                                                    GError** error)
{
	SecurityPrivacyBlacklistInterfaceIface* _iface_;
#line 43 "../src/BlackList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 43 "../src/BlackList.vala"
	_iface_ = SECURITY_PRIVACY_BLACKLIST_INTERFACE_GET_INTERFACE (self);
#line 43 "../src/BlackList.vala"
	if (_iface_->get_templates) {
#line 43 "../src/BlackList.vala"
		return _iface_->get_templates (self, error);
#line 420 "BlackList.c"
	}
#line 43 "../src/BlackList.vala"
	return NULL;
#line 424 "BlackList.c"
}

void
security_privacy_blacklist_interface_add_template (SecurityPrivacyBlacklistInterface* self,
                                                   const gchar* blacklist_id,
                                                   GVariant* blacklist_template,
                                                   GError** error)
{
	SecurityPrivacyBlacklistInterfaceIface* _iface_;
#line 44 "../src/BlackList.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/BlackList.vala"
	_iface_ = SECURITY_PRIVACY_BLACKLIST_INTERFACE_GET_INTERFACE (self);
#line 44 "../src/BlackList.vala"
	if (_iface_->add_template) {
#line 44 "../src/BlackList.vala"
		_iface_->add_template (self, blacklist_id, blacklist_template, error);
#line 442 "BlackList.c"
	}
}

void
security_privacy_blacklist_interface_remove_template (SecurityPrivacyBlacklistInterface* self,
                                                      const gchar* blacklist_id,
                                                      GError** error)
{
	SecurityPrivacyBlacklistInterfaceIface* _iface_;
#line 48 "../src/BlackList.vala"
	g_return_if_fail (self != NULL);
#line 48 "../src/BlackList.vala"
	_iface_ = SECURITY_PRIVACY_BLACKLIST_INTERFACE_GET_INTERFACE (self);
#line 48 "../src/BlackList.vala"
	if (_iface_->remove_template) {
#line 48 "../src/BlackList.vala"
		_iface_->remove_template (self, blacklist_id, error);
#line 460 "BlackList.c"
	}
}

static void
g_cclosure_user_marshal_VOID__STRING_VARIANT (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_VARIANT) (gpointer data1, const char* arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_VARIANT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 32 "../src/BlackList.vala"
	g_return_if_fail (n_param_values == 3);
#line 32 "../src/BlackList.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 32 "../src/BlackList.vala"
		data1 = closure->data;
#line 32 "../src/BlackList.vala"
		data2 = param_values->data[0].v_pointer;
#line 486 "BlackList.c"
	} else {
#line 32 "../src/BlackList.vala"
		data1 = param_values->data[0].v_pointer;
#line 32 "../src/BlackList.vala"
		data2 = closure->data;
#line 492 "BlackList.c"
	}
#line 32 "../src/BlackList.vala"
	callback = (GMarshalFunc_VOID__STRING_VARIANT) (marshal_data ? marshal_data : cc->callback);
#line 32 "../src/BlackList.vala"
	callback (data1, g_value_get_string (param_values + 1), g_value_get_variant (param_values + 2), data2);
#line 498 "BlackList.c"
}

static void
security_privacy_blacklist_interface_default_init (SecurityPrivacyBlacklistInterfaceIface * iface,
                                                   gpointer iface_data)
{
#line 32 "../src/BlackList.vala"
	security_privacy_blacklist_interface_signals[SECURITY_PRIVACY_BLACKLIST_INTERFACE_TEMPLATE_ADDED_SIGNAL] = g_signal_new ("template-added", SECURITY_PRIVACY_TYPE_BLACKLIST_INTERFACE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_VARIANT, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_VARIANT);
#line 32 "../src/BlackList.vala"
	security_privacy_blacklist_interface_signals[SECURITY_PRIVACY_BLACKLIST_INTERFACE_TEMPLATE_REMOVED_SIGNAL] = g_signal_new ("template-removed", SECURITY_PRIVACY_TYPE_BLACKLIST_INTERFACE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_VARIANT, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_VARIANT);
#line 509 "BlackList.c"
}

static GType
security_privacy_blacklist_interface_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SecurityPrivacyBlacklistInterfaceIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) security_privacy_blacklist_interface_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType security_privacy_blacklist_interface_type_id;
	security_privacy_blacklist_interface_type_id = g_type_register_static (G_TYPE_INTERFACE, "SecurityPrivacyBlacklistInterface", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (security_privacy_blacklist_interface_type_id, G_TYPE_OBJECT);
	g_type_set_qdata (security_privacy_blacklist_interface_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) security_privacy_blacklist_interface_proxy_get_type);
	g_type_set_qdata (security_privacy_blacklist_interface_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.gnome.zeitgeist.Blacklist");
	g_type_set_qdata (security_privacy_blacklist_interface_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_security_privacy_blacklist_interface_dbus_interface_info));
	g_type_set_qdata (security_privacy_blacklist_interface_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) security_privacy_blacklist_interface_register_object);
	return security_privacy_blacklist_interface_type_id;
}

GType
security_privacy_blacklist_interface_get_type (void)
{
	static volatile gsize security_privacy_blacklist_interface_type_id__once = 0;
	if (g_once_init_enter (&security_privacy_blacklist_interface_type_id__once)) {
		GType security_privacy_blacklist_interface_type_id;
		security_privacy_blacklist_interface_type_id = security_privacy_blacklist_interface_get_type_once ();
		g_once_init_leave (&security_privacy_blacklist_interface_type_id__once, security_privacy_blacklist_interface_type_id);
	}
	return security_privacy_blacklist_interface_type_id__once;
}

G_DEFINE_TYPE_EXTENDED (SecurityPrivacyBlacklistInterfaceProxy, security_privacy_blacklist_interface_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (SECURITY_PRIVACY_TYPE_BLACKLIST_INTERFACE, security_privacy_blacklist_interface_proxy_security_privacy_blacklist_interface_interface_init) )
static void
security_privacy_blacklist_interface_proxy_class_init (SecurityPrivacyBlacklistInterfaceProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = security_privacy_blacklist_interface_proxy_g_signal;
}

static void
_dbus_handle_security_privacy_blacklist_interface_template_added (SecurityPrivacyBlacklistInterface* self,
                                                                  GVariant* parameters)
{
	GVariantIter _arguments_iter;
	gchar* blacklist_id = NULL;
	GVariant* _tmp0_;
	GVariant* blacklist_template = NULL;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp0_ = g_variant_iter_next_value (&_arguments_iter);
	blacklist_id = g_variant_dup_string (_tmp0_, NULL);
	g_variant_unref (_tmp0_);
	blacklist_template = g_variant_iter_next_value (&_arguments_iter);
	g_signal_emit_by_name (self, "template-added", blacklist_id, blacklist_template);
	_g_free0 (blacklist_id);
	_g_variant_unref0 (blacklist_template);
}

static void
_dbus_handle_security_privacy_blacklist_interface_template_removed (SecurityPrivacyBlacklistInterface* self,
                                                                    GVariant* parameters)
{
	GVariantIter _arguments_iter;
	gchar* blacklist_id = NULL;
	GVariant* _tmp1_;
	GVariant* blacklist_template = NULL;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp1_ = g_variant_iter_next_value (&_arguments_iter);
	blacklist_id = g_variant_dup_string (_tmp1_, NULL);
	g_variant_unref (_tmp1_);
	blacklist_template = g_variant_iter_next_value (&_arguments_iter);
	g_signal_emit_by_name (self, "template-removed", blacklist_id, blacklist_template);
	_g_free0 (blacklist_id);
	_g_variant_unref0 (blacklist_template);
}

static void
security_privacy_blacklist_interface_proxy_g_signal (GDBusProxy* proxy,
                                                     const gchar* sender_name,
                                                     const gchar* signal_name,
                                                     GVariant* parameters)
{
	if (strcmp (signal_name, "TemplateAdded") == 0) {
		_dbus_handle_security_privacy_blacklist_interface_template_added ((SecurityPrivacyBlacklistInterface*) proxy, parameters);
	} else if (strcmp (signal_name, "TemplateRemoved") == 0) {
		_dbus_handle_security_privacy_blacklist_interface_template_removed ((SecurityPrivacyBlacklistInterface*) proxy, parameters);
	}
}

static void
security_privacy_blacklist_interface_proxy_init (SecurityPrivacyBlacklistInterfaceProxy* self)
{
	g_dbus_proxy_set_interface_info (G_DBUS_PROXY (self), (GDBusInterfaceInfo *) (&_security_privacy_blacklist_interface_dbus_interface_info));
}

static GVariant*
security_privacy_blacklist_interface_proxy_get_templates (SecurityPrivacyBlacklistInterface* self,
                                                          GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	GVariant* _result = NULL;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.zeitgeist.Blacklist", "GetTemplates");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_result = g_variant_iter_next_value (&_reply_iter);
	g_object_unref (_reply_message);
	return _result;
}

static void
security_privacy_blacklist_interface_proxy_add_template (SecurityPrivacyBlacklistInterface* self,
                                                         const gchar* blacklist_id,
                                                         GVariant* blacklist_template,
                                                         GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.zeitgeist.Blacklist", "AddTemplate");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (blacklist_id));
	g_variant_builder_add_value (&_arguments_builder, blacklist_template);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
security_privacy_blacklist_interface_proxy_remove_template (SecurityPrivacyBlacklistInterface* self,
                                                            const gchar* blacklist_id,
                                                            GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.zeitgeist.Blacklist", "RemoveTemplate");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (blacklist_id));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
security_privacy_blacklist_interface_proxy_security_privacy_blacklist_interface_interface_init (SecurityPrivacyBlacklistInterfaceIface* iface)
{
	iface->get_templates = security_privacy_blacklist_interface_proxy_get_templates;
	iface->add_template = security_privacy_blacklist_interface_proxy_add_template;
	iface->remove_template = security_privacy_blacklist_interface_proxy_remove_template;
}

static void
_dbus_security_privacy_blacklist_interface_get_templates (SecurityPrivacyBlacklistInterface* self,
                                                          GVariant* _parameters_,
                                                          GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	GVariant* result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	result = security_privacy_blacklist_interface_get_templates (self, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, result);
	_g_variant_unref0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_security_privacy_blacklist_interface_add_template (SecurityPrivacyBlacklistInterface* self,
                                                         GVariant* _parameters_,
                                                         GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* blacklist_id = NULL;
	GVariant* _tmp2_;
	GVariant* blacklist_template = NULL;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp2_ = g_variant_iter_next_value (&_arguments_iter);
	blacklist_id = g_variant_dup_string (_tmp2_, NULL);
	g_variant_unref (_tmp2_);
	blacklist_template = g_variant_iter_next_value (&_arguments_iter);
	security_privacy_blacklist_interface_add_template (self, blacklist_id, blacklist_template, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (blacklist_id);
	_g_variant_unref0 (blacklist_template);
	;
}

static void
_dbus_security_privacy_blacklist_interface_remove_template (SecurityPrivacyBlacklistInterface* self,
                                                            GVariant* _parameters_,
                                                            GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* blacklist_id = NULL;
	GVariant* _tmp3_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp3_ = g_variant_iter_next_value (&_arguments_iter);
	blacklist_id = g_variant_dup_string (_tmp3_, NULL);
	g_variant_unref (_tmp3_);
	security_privacy_blacklist_interface_remove_template (self, blacklist_id, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (blacklist_id);
	;
}

static void
security_privacy_blacklist_interface_dbus_interface_method_call (GDBusConnection* connection,
                                                                 const gchar* sender,
                                                                 const gchar* object_path,
                                                                 const gchar* interface_name,
                                                                 const gchar* method_name,
                                                                 GVariant* parameters,
                                                                 GDBusMethodInvocation* invocation,
                                                                 gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "GetTemplates") == 0) {
		_dbus_security_privacy_blacklist_interface_get_templates (object, parameters, invocation);
	} else if (strcmp (method_name, "AddTemplate") == 0) {
		_dbus_security_privacy_blacklist_interface_add_template (object, parameters, invocation);
	} else if (strcmp (method_name, "RemoveTemplate") == 0) {
		_dbus_security_privacy_blacklist_interface_remove_template (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
security_privacy_blacklist_interface_dbus_interface_get_property (GDBusConnection* connection,
                                                                  const gchar* sender,
                                                                  const gchar* object_path,
                                                                  const gchar* interface_name,
                                                                  const gchar* property_name,
                                                                  GError** error,
                                                                  gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}

static gboolean
security_privacy_blacklist_interface_dbus_interface_set_property (GDBusConnection* connection,
                                                                  const gchar* sender,
                                                                  const gchar* object_path,
                                                                  const gchar* interface_name,
                                                                  const gchar* property_name,
                                                                  GVariant* value,
                                                                  GError** error,
                                                                  gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

static void
_dbus_security_privacy_blacklist_interface_template_added (GObject* _sender,
                                                           const gchar* blacklist_id,
                                                           GVariant* blacklist_template,
                                                           gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (blacklist_id));
	g_variant_builder_add_value (&_arguments_builder, blacklist_template);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.gnome.zeitgeist.Blacklist", "TemplateAdded", _arguments, NULL);
}

static void
_dbus_security_privacy_blacklist_interface_template_removed (GObject* _sender,
                                                             const gchar* blacklist_id,
                                                             GVariant* blacklist_template,
                                                             gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (blacklist_id));
	g_variant_builder_add_value (&_arguments_builder, blacklist_template);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.gnome.zeitgeist.Blacklist", "TemplateRemoved", _arguments, NULL);
}

guint
security_privacy_blacklist_interface_register_object (gpointer object,
                                                      GDBusConnection* connection,
                                                      const gchar* path,
                                                      GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_security_privacy_blacklist_interface_dbus_interface_info), &_security_privacy_blacklist_interface_dbus_interface_vtable, data, _security_privacy_blacklist_interface_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "template-added", (GCallback) _dbus_security_privacy_blacklist_interface_template_added, data);
	g_signal_connect (object, "template-removed", (GCallback) _dbus_security_privacy_blacklist_interface_template_removed, data);
	return result;
}

static void
_security_privacy_blacklist_interface_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_security_privacy_blacklist_interface_template_added, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_security_privacy_blacklist_interface_template_removed, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

static inline gpointer
security_privacy_blacklist_get_instance_private (SecurityPrivacyBlacklist* self)
{
	return G_STRUCT_MEMBER_P (self, SecurityPrivacyBlacklist_private_offset);
}

static void
_security_privacy_blacklist_on_template_added_security_privacy_blacklist_interface_template_added (SecurityPrivacyBlacklistInterface* _sender,
                                                                                                   const gchar* blacklist_id,
                                                                                                   GVariant* blacklist_template,
                                                                                                   gpointer self)
{
#line 68 "../src/BlackList.vala"
	security_privacy_blacklist_on_template_added ((SecurityPrivacyBlacklist*) self, blacklist_id, blacklist_template);
#line 937 "BlackList.c"
}

static void
_security_privacy_blacklist_on_template_removed_security_privacy_blacklist_interface_template_removed (SecurityPrivacyBlacklistInterface* _sender,
                                                                                                       const gchar* blacklist_id,
                                                                                                       GVariant* blacklist_template,
                                                                                                       gpointer self)
{
#line 69 "../src/BlackList.vala"
	security_privacy_blacklist_on_template_removed ((SecurityPrivacyBlacklist*) self, blacklist_id, blacklist_template);
#line 948 "BlackList.c"
}

SecurityPrivacyBlacklist*
security_privacy_blacklist_construct (GType object_type)
{
	SecurityPrivacyBlacklist* self = NULL;
	ZeitgeistLog* _tmp6_;
	ZeitgeistEvent* _tmp7_;
	GError* _inner_error0_ = NULL;
#line 61 "../src/BlackList.vala"
	self = (SecurityPrivacyBlacklist*) g_type_create_instance (object_type);
#line 960 "BlackList.c"
	{
		SecurityPrivacyBlacklistInterface* _tmp0_ = NULL;
		SecurityPrivacyBlacklistInterface* _tmp1_;
		SecurityPrivacyBlacklistInterface* _tmp2_;
		SecurityPrivacyBlacklistInterface* _tmp3_;
		SecurityPrivacyBlacklistInterface* _tmp4_;
#line 63 "../src/BlackList.vala"
		_tmp1_ = (SecurityPrivacyBlacklistInterface*) g_initable_new (SECURITY_PRIVACY_TYPE_BLACKLIST_INTERFACE_PROXY, NULL, &_inner_error0_, "g-flags", 0, "g-name", "org.gnome.zeitgeist.Engine", "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", "/org/gnome/zeitgeist/blacklist", "g-interface-name", "org.gnome.zeitgeist.Blacklist", NULL);
#line 63 "../src/BlackList.vala"
		_tmp0_ = (SecurityPrivacyBlacklistInterface*) _tmp1_;
#line 63 "../src/BlackList.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 973 "BlackList.c"
			goto __catch0_g_error;
		}
#line 63 "../src/BlackList.vala"
		_tmp2_ = _tmp0_;
#line 63 "../src/BlackList.vala"
		_tmp0_ = NULL;
#line 63 "../src/BlackList.vala"
		_g_object_unref0 (self->priv->blacklist);
#line 63 "../src/BlackList.vala"
		self->priv->blacklist = _tmp2_;
#line 68 "../src/BlackList.vala"
		_tmp3_ = self->priv->blacklist;
#line 68 "../src/BlackList.vala"
		g_signal_connect (_tmp3_, "template-added", (GCallback) _security_privacy_blacklist_on_template_added_security_privacy_blacklist_interface_template_added, self);
#line 69 "../src/BlackList.vala"
		_tmp4_ = self->priv->blacklist;
#line 69 "../src/BlackList.vala"
		g_signal_connect (_tmp4_, "template-removed", (GCallback) _security_privacy_blacklist_on_template_removed_security_privacy_blacklist_interface_template_removed, self);
#line 62 "../src/BlackList.vala"
		_g_object_unref0 (_tmp0_);
#line 994 "BlackList.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp5_;
#line 62 "../src/BlackList.vala"
		e = _inner_error0_;
#line 62 "../src/BlackList.vala"
		_inner_error0_ = NULL;
#line 71 "../src/BlackList.vala"
		_tmp5_ = e->message;
#line 71 "../src/BlackList.vala"
		g_error ("BlackList.vala:71: %s", _tmp5_);
#line 62 "../src/BlackList.vala"
		_g_error_free0 (e);
#line 1011 "BlackList.c"
	}
	__finally0:
#line 62 "../src/BlackList.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 62 "../src/BlackList.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 62 "../src/BlackList.vala"
		g_clear_error (&_inner_error0_);
#line 62 "../src/BlackList.vala"
		return NULL;
#line 1022 "BlackList.c"
	}
#line 73 "../src/BlackList.vala"
	_tmp6_ = zeitgeist_log_new ();
#line 73 "../src/BlackList.vala"
	_g_object_unref0 (self->priv->log);
#line 73 "../src/BlackList.vala"
	self->priv->log = _tmp6_;
#line 74 "../src/BlackList.vala"
	_tmp7_ = zeitgeist_event_new ();
#line 74 "../src/BlackList.vala"
	_g_object_unref0 (self->priv->incognito_event);
#line 74 "../src/BlackList.vala"
	self->priv->incognito_event = _tmp7_;
#line 61 "../src/BlackList.vala"
	return self;
#line 1038 "BlackList.c"
}

SecurityPrivacyBlacklist*
security_privacy_blacklist_new (void)
{
#line 61 "../src/BlackList.vala"
	return security_privacy_blacklist_construct (SECURITY_PRIVACY_TYPE_BLACKLIST);
#line 1046 "BlackList.c"
}

void
security_privacy_blacklist_add_template (SecurityPrivacyBlacklist* self,
                                         const gchar* blacklist_id,
                                         ZeitgeistEvent* blacklist_template)
{
	GError* _inner_error0_ = NULL;
#line 90 "../src/BlackList.vala"
	g_return_if_fail (self != NULL);
#line 90 "../src/BlackList.vala"
	g_return_if_fail (blacklist_id != NULL);
#line 90 "../src/BlackList.vala"
	g_return_if_fail (blacklist_template != NULL);
#line 1061 "BlackList.c"
	{
		SecurityPrivacyBlacklistInterface* _tmp0_;
		GVariant* _tmp1_;
		GVariant* _tmp2_;
#line 92 "../src/BlackList.vala"
		_tmp0_ = self->priv->blacklist;
#line 92 "../src/BlackList.vala"
		_tmp1_ = zeitgeist_event_to_variant (blacklist_template);
#line 92 "../src/BlackList.vala"
		_tmp2_ = _tmp1_;
#line 92 "../src/BlackList.vala"
		security_privacy_blacklist_interface_add_template (_tmp0_, blacklist_id, _tmp2_, &_inner_error0_);
#line 92 "../src/BlackList.vala"
		_g_variant_unref0 (_tmp2_);
#line 92 "../src/BlackList.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1078 "BlackList.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 91 "../src/BlackList.vala"
		e = _inner_error0_;
#line 91 "../src/BlackList.vala"
		_inner_error0_ = NULL;
#line 94 "../src/BlackList.vala"
		_tmp3_ = e;
#line 94 "../src/BlackList.vala"
		_tmp4_ = _tmp3_->message;
#line 94 "../src/BlackList.vala"
		g_critical ("BlackList.vala:94: %s", _tmp4_);
#line 91 "../src/BlackList.vala"
		_g_error_free0 (e);
#line 1100 "BlackList.c"
	}
	__finally0:
#line 91 "../src/BlackList.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 91 "../src/BlackList.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 91 "../src/BlackList.vala"
		g_clear_error (&_inner_error0_);
#line 91 "../src/BlackList.vala"
		return;
#line 1111 "BlackList.c"
	}
}

void
security_privacy_blacklist_remove_template (SecurityPrivacyBlacklist* self,
                                            const gchar* blacklist_id)
{
	GError* _inner_error0_ = NULL;
#line 98 "../src/BlackList.vala"
	g_return_if_fail (self != NULL);
#line 98 "../src/BlackList.vala"
	g_return_if_fail (blacklist_id != NULL);
#line 1124 "BlackList.c"
	{
		SecurityPrivacyBlacklistInterface* _tmp0_;
#line 100 "../src/BlackList.vala"
		_tmp0_ = self->priv->blacklist;
#line 100 "../src/BlackList.vala"
		security_privacy_blacklist_interface_remove_template (_tmp0_, blacklist_id, &_inner_error0_);
#line 100 "../src/BlackList.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1133 "BlackList.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 99 "../src/BlackList.vala"
		e = _inner_error0_;
#line 99 "../src/BlackList.vala"
		_inner_error0_ = NULL;
#line 102 "../src/BlackList.vala"
		_tmp1_ = e;
#line 102 "../src/BlackList.vala"
		_tmp2_ = _tmp1_->message;
#line 102 "../src/BlackList.vala"
		g_critical ("BlackList.vala:102: %s", _tmp2_);
#line 99 "../src/BlackList.vala"
		_g_error_free0 (e);
#line 1155 "BlackList.c"
	}
	__finally0:
#line 99 "../src/BlackList.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 99 "../src/BlackList.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 99 "../src/BlackList.vala"
		g_clear_error (&_inner_error0_);
#line 99 "../src/BlackList.vala"
		return;
#line 1166 "BlackList.c"
	}
}

void
security_privacy_blacklist_set_incognito (SecurityPrivacyBlacklist* self,
                                          gboolean status)
{
#line 107 "../src/BlackList.vala"
	g_return_if_fail (self != NULL);
#line 108 "../src/BlackList.vala"
	if (status) {
#line 1178 "BlackList.c"
		const gchar* _tmp0_;
		ZeitgeistEvent* _tmp1_;
#line 109 "../src/BlackList.vala"
		_tmp0_ = self->priv->incognito_id;
#line 109 "../src/BlackList.vala"
		_tmp1_ = self->priv->incognito_event;
#line 109 "../src/BlackList.vala"
		security_privacy_blacklist_add_template (self, _tmp0_, _tmp1_);
#line 1187 "BlackList.c"
	} else {
		const gchar* _tmp2_;
#line 111 "../src/BlackList.vala"
		_tmp2_ = self->priv->incognito_id;
#line 111 "../src/BlackList.vala"
		security_privacy_blacklist_remove_template (self, _tmp2_);
#line 1194 "BlackList.c"
	}
}

static gpointer
_g_hash_table_ref0 (gpointer self)
{
#line 119 "../src/BlackList.vala"
	return self ? g_hash_table_ref (self) : NULL;
#line 1203 "BlackList.c"
}

static void
_g_free0_ (gpointer var)
{
#line 122 "../src/BlackList.vala"
	var = (g_free (var), NULL);
#line 1211 "BlackList.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 122 "../src/BlackList.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 1219 "BlackList.c"
}

GHashTable*
security_privacy_blacklist_get_templates (SecurityPrivacyBlacklist* self)
{
	GError* _inner_error0_ = NULL;
	GHashTable* result;
#line 115 "../src/BlackList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1229 "BlackList.c"
	{
		GVariant* var_blacklists = NULL;
		SecurityPrivacyBlacklistInterface* _tmp0_;
		GVariant* _tmp1_;
		GHashTable* _tmp2_;
		GHashTable* _tmp3_;
		GHashTable* _tmp4_;
#line 117 "../src/BlackList.vala"
		_tmp0_ = self->priv->blacklist;
#line 117 "../src/BlackList.vala"
		_tmp1_ = security_privacy_blacklist_interface_get_templates (_tmp0_, &_inner_error0_);
#line 117 "../src/BlackList.vala"
		var_blacklists = _tmp1_;
#line 117 "../src/BlackList.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1245 "BlackList.c"
			goto __catch0_g_error;
		}
#line 118 "../src/BlackList.vala"
		_tmp2_ = security_privacy_utilities_from_variant (var_blacklists);
#line 118 "../src/BlackList.vala"
		_g_hash_table_unref0 (self->priv->blacklists);
#line 118 "../src/BlackList.vala"
		self->priv->blacklists = _tmp2_;
#line 119 "../src/BlackList.vala"
		_tmp3_ = self->priv->blacklists;
#line 119 "../src/BlackList.vala"
		_tmp4_ = _g_hash_table_ref0 (_tmp3_);
#line 119 "../src/BlackList.vala"
		result = _tmp4_;
#line 119 "../src/BlackList.vala"
		_g_variant_unref0 (var_blacklists);
#line 119 "../src/BlackList.vala"
		return result;
#line 1264 "BlackList.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
		GHashTable* _tmp7_;
#line 116 "../src/BlackList.vala"
		e = _inner_error0_;
#line 116 "../src/BlackList.vala"
		_inner_error0_ = NULL;
#line 121 "../src/BlackList.vala"
		_tmp5_ = e;
#line 121 "../src/BlackList.vala"
		_tmp6_ = _tmp5_->message;
#line 121 "../src/BlackList.vala"
		g_critical ("BlackList.vala:121: %s", _tmp6_);
#line 122 "../src/BlackList.vala"
		_tmp7_ = g_hash_table_new_full (NULL, NULL, _g_free0_, _g_object_unref0_);
#line 122 "../src/BlackList.vala"
		result = _tmp7_;
#line 122 "../src/BlackList.vala"
		_g_error_free0 (e);
#line 122 "../src/BlackList.vala"
		return result;
#line 1291 "BlackList.c"
	}
	__finally0:
#line 116 "../src/BlackList.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 116 "../src/BlackList.vala"
	g_clear_error (&_inner_error0_);
#line 116 "../src/BlackList.vala"
	return NULL;
#line 1300 "BlackList.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 134 "../src/BlackList.vala"
	return self ? g_object_ref (self) : NULL;
#line 1308 "BlackList.c"
}

static void
security_privacy_blacklist_on_template_added (SecurityPrivacyBlacklist* self,
                                              const gchar* blacklist_id,
                                              GVariant* blacklist_template)
{
	GError* _inner_error0_ = NULL;
#line 126 "../src/BlackList.vala"
	g_return_if_fail (self != NULL);
#line 126 "../src/BlackList.vala"
	g_return_if_fail (blacklist_id != NULL);
#line 126 "../src/BlackList.vala"
	g_return_if_fail (blacklist_template != NULL);
#line 1323 "BlackList.c"
	{
		ZeitgeistEvent* ev = NULL;
		ZeitgeistEvent* _tmp0_;
		const gchar* _tmp1_;
		GHashTable* _tmp2_;
		gchar* _tmp3_;
		ZeitgeistEvent* _tmp4_;
#line 128 "../src/BlackList.vala"
		_tmp0_ = zeitgeist_event_new_from_variant (blacklist_template, &_inner_error0_);
#line 128 "../src/BlackList.vala"
		ev = _tmp0_;
#line 128 "../src/BlackList.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1337 "BlackList.c"
			goto __catch0_g_error;
		}
#line 129 "../src/BlackList.vala"
		g_signal_emit (self, security_privacy_blacklist_signals[SECURITY_PRIVACY_BLACKLIST_TEMPLATE_ADDED_SIGNAL], 0, blacklist_id, ev);
#line 130 "../src/BlackList.vala"
		_tmp1_ = self->priv->incognito_id;
#line 130 "../src/BlackList.vala"
		if (g_strcmp0 (blacklist_id, _tmp1_) == 0) {
#line 131 "../src/BlackList.vala"
			g_signal_emit (self, security_privacy_blacklist_signals[SECURITY_PRIVACY_BLACKLIST_INCOGNITO_TOGGLED_SIGNAL], 0, TRUE);
#line 1348 "BlackList.c"
		}
#line 134 "../src/BlackList.vala"
		_tmp2_ = self->priv->blacklists;
#line 134 "../src/BlackList.vala"
		_tmp3_ = g_strdup (blacklist_id);
#line 134 "../src/BlackList.vala"
		_tmp4_ = _g_object_ref0 (ev);
#line 134 "../src/BlackList.vala"
		g_hash_table_insert (_tmp2_, _tmp3_, _tmp4_);
#line 127 "../src/BlackList.vala"
		_g_object_unref0 (ev);
#line 1360 "BlackList.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 127 "../src/BlackList.vala"
		e = _inner_error0_;
#line 127 "../src/BlackList.vala"
		_inner_error0_ = NULL;
#line 136 "../src/BlackList.vala"
		_tmp5_ = e;
#line 136 "../src/BlackList.vala"
		_tmp6_ = _tmp5_->message;
#line 136 "../src/BlackList.vala"
		g_critical ("BlackList.vala:136: %s", _tmp6_);
#line 127 "../src/BlackList.vala"
		_g_error_free0 (e);
#line 1380 "BlackList.c"
	}
	__finally0:
#line 127 "../src/BlackList.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 127 "../src/BlackList.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 127 "../src/BlackList.vala"
		g_clear_error (&_inner_error0_);
#line 127 "../src/BlackList.vala"
		return;
#line 1391 "BlackList.c"
	}
}

static void
security_privacy_blacklist_on_template_removed (SecurityPrivacyBlacklist* self,
                                                const gchar* blacklist_id,
                                                GVariant* blacklist_template)
{
	const gchar* _tmp3_;
	GHashTable* _tmp4_;
	gconstpointer _tmp5_;
	GError* _inner_error0_ = NULL;
#line 140 "../src/BlackList.vala"
	g_return_if_fail (self != NULL);
#line 140 "../src/BlackList.vala"
	g_return_if_fail (blacklist_id != NULL);
#line 140 "../src/BlackList.vala"
	g_return_if_fail (blacklist_template != NULL);
#line 1410 "BlackList.c"
	{
		ZeitgeistEvent* ev = NULL;
		ZeitgeistEvent* _tmp0_;
#line 142 "../src/BlackList.vala"
		_tmp0_ = zeitgeist_event_new_from_variant (blacklist_template, &_inner_error0_);
#line 142 "../src/BlackList.vala"
		ev = _tmp0_;
#line 142 "../src/BlackList.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1420 "BlackList.c"
			goto __catch0_g_error;
		}
#line 143 "../src/BlackList.vala"
		g_signal_emit (self, security_privacy_blacklist_signals[SECURITY_PRIVACY_BLACKLIST_TEMPLATE_REMOVED_SIGNAL], 0, blacklist_id, ev);
#line 141 "../src/BlackList.vala"
		_g_object_unref0 (ev);
#line 1427 "BlackList.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 141 "../src/BlackList.vala"
		e = _inner_error0_;
#line 141 "../src/BlackList.vala"
		_inner_error0_ = NULL;
#line 145 "../src/BlackList.vala"
		_tmp1_ = e;
#line 145 "../src/BlackList.vala"
		_tmp2_ = _tmp1_->message;
#line 145 "../src/BlackList.vala"
		g_critical ("BlackList.vala:145: %s", _tmp2_);
#line 141 "../src/BlackList.vala"
		_g_error_free0 (e);
#line 1447 "BlackList.c"
	}
	__finally0:
#line 141 "../src/BlackList.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 141 "../src/BlackList.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 141 "../src/BlackList.vala"
		g_clear_error (&_inner_error0_);
#line 141 "../src/BlackList.vala"
		return;
#line 1458 "BlackList.c"
	}
#line 148 "../src/BlackList.vala"
	_tmp3_ = self->priv->incognito_id;
#line 148 "../src/BlackList.vala"
	if (g_strcmp0 (blacklist_id, _tmp3_) == 0) {
#line 149 "../src/BlackList.vala"
		g_signal_emit (self, security_privacy_blacklist_signals[SECURITY_PRIVACY_BLACKLIST_INCOGNITO_TOGGLED_SIGNAL], 0, FALSE);
#line 1466 "BlackList.c"
	}
#line 152 "../src/BlackList.vala"
	_tmp4_ = self->priv->blacklists;
#line 152 "../src/BlackList.vala"
	_tmp5_ = g_hash_table_lookup (_tmp4_, blacklist_id);
#line 152 "../src/BlackList.vala"
	if (((ZeitgeistEvent*) _tmp5_) != NULL) {
#line 1474 "BlackList.c"
		GHashTable* _tmp6_;
#line 153 "../src/BlackList.vala"
		_tmp6_ = self->priv->blacklists;
#line 153 "../src/BlackList.vala"
		g_hash_table_remove (_tmp6_, blacklist_id);
#line 1480 "BlackList.c"
	}
}

gboolean
security_privacy_blacklist_get_incognito (SecurityPrivacyBlacklist* self)
{
	GHashTable* _tmp0_;
	GHashTable* _tmp3_;
	GHashTable* _tmp4_;
	GList* _tmp5_;
	gboolean result;
#line 157 "../src/BlackList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 158 "../src/BlackList.vala"
	_tmp0_ = self->priv->blacklists;
#line 158 "../src/BlackList.vala"
	if (_tmp0_ == NULL) {
#line 1498 "BlackList.c"
		GHashTable* _tmp1_;
		GHashTable* _tmp2_;
#line 159 "../src/BlackList.vala"
		_tmp1_ = security_privacy_blacklist_get_templates (self);
#line 159 "../src/BlackList.vala"
		_tmp2_ = _tmp1_;
#line 159 "../src/BlackList.vala"
		_g_hash_table_unref0 (_tmp2_);
#line 1507 "BlackList.c"
	}
#line 162 "../src/BlackList.vala"
	_tmp3_ = security_privacy_blacklist_get_all_templates (self);
#line 162 "../src/BlackList.vala"
	_tmp4_ = _tmp3_;
#line 162 "../src/BlackList.vala"
	_tmp5_ = g_hash_table_get_values (_tmp4_);
#line 1515 "BlackList.c"
	{
		GList* ev_collection = NULL;
		GList* ev_it = NULL;
#line 162 "../src/BlackList.vala"
		ev_collection = _tmp5_;
#line 162 "../src/BlackList.vala"
		for (ev_it = ev_collection; ev_it != NULL; ev_it = ev_it->next) {
#line 1523 "BlackList.c"
			ZeitgeistEvent* ev = NULL;
#line 162 "../src/BlackList.vala"
			ev = (ZeitgeistEvent*) ev_it->data;
#line 1527 "BlackList.c"
			{
				ZeitgeistEvent* _tmp6_;
				ZeitgeistEvent* _tmp7_;
#line 163 "../src/BlackList.vala"
				_tmp6_ = ev;
#line 163 "../src/BlackList.vala"
				_tmp7_ = self->priv->incognito_event;
#line 163 "../src/BlackList.vala"
				if (security_privacy_utilities_matches_event_template (_tmp6_, _tmp7_)) {
#line 164 "../src/BlackList.vala"
					result = TRUE;
#line 164 "../src/BlackList.vala"
					(ev_collection == NULL) ? NULL : (ev_collection = (g_list_free (ev_collection), NULL));
#line 164 "../src/BlackList.vala"
					return result;
#line 1543 "BlackList.c"
				}
			}
		}
#line 162 "../src/BlackList.vala"
		(ev_collection == NULL) ? NULL : (ev_collection = (g_list_free (ev_collection), NULL));
#line 1549 "BlackList.c"
	}
#line 168 "../src/BlackList.vala"
	result = FALSE;
#line 168 "../src/BlackList.vala"
	return result;
#line 1555 "BlackList.c"
}

static void
security_privacy_blacklist_find_events_data_free (gpointer _data)
{
	SecurityPrivacyBlacklistFindEventsData* _data_;
	_data_ = _data;
#line 51 "../src/BlackList.vala"
	_g_free0 (_data_->id);
#line 51 "../src/BlackList.vala"
	_g_object_unref0 (_data_->store);
#line 51 "../src/BlackList.vala"
	_security_privacy_blacklist_unref0 (_data_->self);
#line 51 "../src/BlackList.vala"
	g_slice_free (SecurityPrivacyBlacklistFindEventsData, _data_);
#line 1571 "BlackList.c"
}

static gpointer
_security_privacy_blacklist_ref0 (gpointer self)
{
#line 51 "../src/BlackList.vala"
	return self ? security_privacy_blacklist_ref (self) : NULL;
#line 1579 "BlackList.c"
}

void
security_privacy_blacklist_find_events (SecurityPrivacyBlacklist* self,
                                        const gchar* id,
                                        GtkTreeIter* iter,
                                        GtkListStore* store,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_)
{
	SecurityPrivacyBlacklistFindEventsData* _data_;
	SecurityPrivacyBlacklist* _tmp0_;
	gchar* _tmp1_;
	GtkTreeIter _tmp2_;
	GtkListStore* _tmp3_;
#line 51 "../src/BlackList.vala"
	g_return_if_fail (self != NULL);
#line 51 "../src/BlackList.vala"
	g_return_if_fail (id != NULL);
#line 51 "../src/BlackList.vala"
	g_return_if_fail (iter != NULL);
#line 51 "../src/BlackList.vala"
	g_return_if_fail (store != NULL);
#line 51 "../src/BlackList.vala"
	_data_ = g_slice_new0 (SecurityPrivacyBlacklistFindEventsData);
#line 51 "../src/BlackList.vala"
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
#line 51 "../src/BlackList.vala"
	g_task_set_task_data (_data_->_async_result, _data_, security_privacy_blacklist_find_events_data_free);
#line 51 "../src/BlackList.vala"
	_tmp0_ = _security_privacy_blacklist_ref0 (self);
#line 51 "../src/BlackList.vala"
	_data_->self = _tmp0_;
#line 51 "../src/BlackList.vala"
	_tmp1_ = g_strdup (id);
#line 51 "../src/BlackList.vala"
	_g_free0 (_data_->id);
#line 51 "../src/BlackList.vala"
	_data_->id = _tmp1_;
#line 51 "../src/BlackList.vala"
	_tmp2_ = *iter;
#line 51 "../src/BlackList.vala"
	_data_->iter = _tmp2_;
#line 51 "../src/BlackList.vala"
	_tmp3_ = _g_object_ref0 (store);
#line 51 "../src/BlackList.vala"
	_g_object_unref0 (_data_->store);
#line 51 "../src/BlackList.vala"
	_data_->store = _tmp3_;
#line 51 "../src/BlackList.vala"
	security_privacy_blacklist_find_events_co (_data_);
#line 1631 "BlackList.c"
}

void
security_privacy_blacklist_find_events_finish (SecurityPrivacyBlacklist* self,
                                               GAsyncResult* _res_)
{
	SecurityPrivacyBlacklistFindEventsData* _data_;
#line 51 "../src/BlackList.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1641 "BlackList.c"
}

static void
security_privacy_blacklist_find_events_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_)
{
	SecurityPrivacyBlacklistFindEventsData* _data_;
#line 188 "../src/BlackList.vala"
	_data_ = _user_data_;
#line 188 "../src/BlackList.vala"
	_data_->_source_object_ = source_object;
#line 188 "../src/BlackList.vala"
	_data_->_res_ = _res_;
#line 188 "../src/BlackList.vala"
	security_privacy_blacklist_find_events_co (_data_);
#line 1658 "BlackList.c"
}

static gboolean
security_privacy_blacklist_find_events_co (SecurityPrivacyBlacklistFindEventsData* _data_)
{
#line 171 "../src/BlackList.vala"
	switch (_data_->_state_) {
#line 171 "../src/BlackList.vala"
		case 0:
#line 1668 "BlackList.c"
		goto _state_0;
#line 171 "../src/BlackList.vala"
		case 1:
#line 1672 "BlackList.c"
		goto _state_1;
		default:
#line 171 "../src/BlackList.vala"
		g_assert_not_reached ();
#line 1677 "BlackList.c"
	}
	_state_0:
#line 172 "../src/BlackList.vala"
	_data_->_tmp0_ = zeitgeist_event_new ();
#line 172 "../src/BlackList.vala"
	_data_->event = _data_->_tmp0_;
#line 173 "../src/BlackList.vala"
	zeitgeist_event_set_manifestation (_data_->event, ZEITGEIST_ZG_USER_ACTIVITY);
#line 174 "../src/BlackList.vala"
	_data_->_tmp1_ = g_strdup_printf ("application://%s", _data_->id);
#line 174 "../src/BlackList.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 174 "../src/BlackList.vala"
	zeitgeist_event_set_actor (_data_->event, _data_->_tmp2_);
#line 174 "../src/BlackList.vala"
	_g_free0 (_data_->_tmp2_);
#line 176 "../src/BlackList.vala"
	_data_->_tmp3_ = g_ptr_array_new_full ((guint) 0, _g_object_unref0_);
#line 176 "../src/BlackList.vala"
	_data_->events = _data_->_tmp3_;
#line 177 "../src/BlackList.vala"
	_data_->_tmp4_ = _g_object_ref0 (_data_->event);
#line 177 "../src/BlackList.vala"
	g_ptr_array_add (_data_->events, _data_->_tmp4_);
#line 179 "../src/BlackList.vala"
	_data_->_tmp5_ = zeitgeist_event_new ();
#line 179 "../src/BlackList.vala"
	_data_->event2 = _data_->_tmp5_;
#line 180 "../src/BlackList.vala"
	zeitgeist_event_set_manifestation (_data_->event2, ZEITGEIST_ZG_USER_ACTIVITY);
#line 181 "../src/BlackList.vala"
	_data_->_tmp6_ = zeitgeist_subject_new ();
#line 181 "../src/BlackList.vala"
	_data_->subj = _data_->_tmp6_;
#line 182 "../src/BlackList.vala"
	_data_->_tmp7_ = g_strdup_printf ("application://%s", _data_->id);
#line 182 "../src/BlackList.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 182 "../src/BlackList.vala"
	zeitgeist_subject_set_uri (_data_->subj, _data_->_tmp8_);
#line 182 "../src/BlackList.vala"
	_g_free0 (_data_->_tmp8_);
#line 183 "../src/BlackList.vala"
	zeitgeist_event_add_subject (_data_->event2, _data_->subj);
#line 185 "../src/BlackList.vala"
	_data_->_tmp9_ = _g_object_ref0 (_data_->event2);
#line 185 "../src/BlackList.vala"
	g_ptr_array_add (_data_->events, _data_->_tmp9_);
#line 1726 "BlackList.c"
	{
#line 188 "../src/BlackList.vala"
		_data_->_tmp10_ = _data_->self->priv->log;
#line 188 "../src/BlackList.vala"
		_data_->_tmp11_ = zeitgeist_time_range_new_anytime ();
#line 188 "../src/BlackList.vala"
		_data_->_tmp12_ = _data_->_tmp11_;
#line 188 "../src/BlackList.vala"
		_data_->_tmp13_ = 0;
#line 188 "../src/BlackList.vala"
		_data_->_state_ = 1;
#line 188 "../src/BlackList.vala"
		zeitgeist_log_find_event_ids (_data_->_tmp10_, _data_->_tmp12_, _data_->events, ZEITGEIST_STORAGE_STATE_ANY, (guint32) 0, ZEITGEIST_RESULT_TYPE_MOST_RECENT_EVENTS, NULL, security_privacy_blacklist_find_events_ready, _data_);
#line 188 "../src/BlackList.vala"
		return FALSE;
#line 1742 "BlackList.c"
		_state_1:
#line 188 "../src/BlackList.vala"
		_data_->_tmp14_ = zeitgeist_log_find_event_ids_finish (_data_->_tmp10_, _data_->_res_, &_data_->_tmp13_, &_data_->_inner_error0_);
#line 188 "../src/BlackList.vala"
		_data_->_tmp15_ = _data_->_tmp14_;
#line 188 "../src/BlackList.vala"
		_data_->_tmp15__length1 = _data_->_tmp13_;
#line 188 "../src/BlackList.vala"
		_g_object_unref0 (_data_->_tmp12_);
#line 188 "../src/BlackList.vala"
		_data_->results = _data_->_tmp15_;
#line 188 "../src/BlackList.vala"
		_data_->results_length1 = _data_->_tmp15__length1;
#line 188 "../src/BlackList.vala"
		_data_->_results_size_ = _data_->results_length1;
#line 188 "../src/BlackList.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1760 "BlackList.c"
			goto __catch0_g_error;
		}
#line 195 "../src/BlackList.vala"
		_data_->counter = _data_->results_length1 / 100;
#line 196 "../src/BlackList.vala"
		_data_->_tmp16_ = _data_->iter;
#line 196 "../src/BlackList.vala"
		memset (&_data_->_tmp17_, 0, sizeof (GValue));
#line 196 "../src/BlackList.vala"
		g_value_init (&_data_->_tmp17_, G_TYPE_INT);
#line 196 "../src/BlackList.vala"
		g_value_set_int (&_data_->_tmp17_, _data_->counter);
#line 196 "../src/BlackList.vala"
		gtk_list_store_set_value (_data_->store, &_data_->_tmp16_, 5, &_data_->_tmp17_);
#line 196 "../src/BlackList.vala"
		G_IS_VALUE (&_data_->_tmp17_) ? (g_value_unset (&_data_->_tmp17_), NULL) : NULL;
#line 187 "../src/BlackList.vala"
		_data_->results = (g_free (_data_->results), NULL);
#line 1779 "BlackList.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 187 "../src/BlackList.vala"
		_data_->e = _data_->_inner_error0_;
#line 187 "../src/BlackList.vala"
		_data_->_inner_error0_ = NULL;
#line 198 "../src/BlackList.vala"
		_data_->_tmp18_ = _data_->e;
#line 198 "../src/BlackList.vala"
		_data_->_tmp19_ = _data_->_tmp18_->message;
#line 198 "../src/BlackList.vala"
		g_warning ("BlackList.vala:198: %s", _data_->_tmp19_);
#line 187 "../src/BlackList.vala"
		_g_error_free0 (_data_->e);
#line 1796 "BlackList.c"
	}
	__finally0:
#line 187 "../src/BlackList.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 187 "../src/BlackList.vala"
		_g_object_unref0 (_data_->subj);
#line 187 "../src/BlackList.vala"
		_g_object_unref0 (_data_->event2);
#line 187 "../src/BlackList.vala"
		_g_ptr_array_unref0 (_data_->events);
#line 187 "../src/BlackList.vala"
		_g_object_unref0 (_data_->event);
#line 187 "../src/BlackList.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 187 "../src/BlackList.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 187 "../src/BlackList.vala"
		g_object_unref (_data_->_async_result);
#line 187 "../src/BlackList.vala"
		return FALSE;
#line 1817 "BlackList.c"
	}
#line 171 "../src/BlackList.vala"
	_g_object_unref0 (_data_->subj);
#line 171 "../src/BlackList.vala"
	_g_object_unref0 (_data_->event2);
#line 171 "../src/BlackList.vala"
	_g_ptr_array_unref0 (_data_->events);
#line 171 "../src/BlackList.vala"
	_g_object_unref0 (_data_->event);
#line 171 "../src/BlackList.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 171 "../src/BlackList.vala"
	if (_data_->_state_ != 0) {
#line 171 "../src/BlackList.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 171 "../src/BlackList.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1835 "BlackList.c"
		}
	}
#line 171 "../src/BlackList.vala"
	g_object_unref (_data_->_async_result);
#line 171 "../src/BlackList.vala"
	return FALSE;
#line 1842 "BlackList.c"
}

void
security_privacy_blacklist_get_count_for_app (SecurityPrivacyBlacklist* self,
                                              const gchar* app_id,
                                              GtkTreeIter* iter,
                                              GtkListStore* store)
{
	GtkTreeIter _tmp0_;
#line 202 "../src/BlackList.vala"
	g_return_if_fail (self != NULL);
#line 202 "../src/BlackList.vala"
	g_return_if_fail (app_id != NULL);
#line 202 "../src/BlackList.vala"
	g_return_if_fail (iter != NULL);
#line 202 "../src/BlackList.vala"
	g_return_if_fail (store != NULL);
#line 203 "../src/BlackList.vala"
	_tmp0_ = *iter;
#line 203 "../src/BlackList.vala"
	security_privacy_blacklist_find_events (self, app_id, &_tmp0_, store, NULL, NULL);
#line 1864 "BlackList.c"
}

GHashTable*
security_privacy_blacklist_get_all_templates (SecurityPrivacyBlacklist* self)
{
	GHashTable* result;
	GHashTable* _tmp0_;
	GHashTable* _tmp3_;
#line 78 "../src/BlackList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 79 "../src/BlackList.vala"
	_tmp0_ = self->priv->blacklists;
#line 79 "../src/BlackList.vala"
	if (_tmp0_ == NULL) {
#line 1879 "BlackList.c"
		GHashTable* _tmp1_;
		GHashTable* _tmp2_;
#line 80 "../src/BlackList.vala"
		_tmp1_ = security_privacy_blacklist_get_templates (self);
#line 80 "../src/BlackList.vala"
		_tmp2_ = _tmp1_;
#line 80 "../src/BlackList.vala"
		_g_hash_table_unref0 (_tmp2_);
#line 1888 "BlackList.c"
	}
#line 82 "../src/BlackList.vala"
	_tmp3_ = self->priv->blacklists;
#line 82 "../src/BlackList.vala"
	result = _tmp3_;
#line 82 "../src/BlackList.vala"
	return result;
#line 1896 "BlackList.c"
}

static void
g_cclosure_user_marshal_VOID__STRING_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_OBJECT) (gpointer data1, const char* arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 51 "../src/BlackList.vala"
	g_return_if_fail (n_param_values == 3);
#line 51 "../src/BlackList.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 51 "../src/BlackList.vala"
		data1 = closure->data;
#line 51 "../src/BlackList.vala"
		data2 = param_values->data[0].v_pointer;
#line 1921 "BlackList.c"
	} else {
#line 51 "../src/BlackList.vala"
		data1 = param_values->data[0].v_pointer;
#line 51 "../src/BlackList.vala"
		data2 = closure->data;
#line 1927 "BlackList.c"
	}
#line 51 "../src/BlackList.vala"
	callback = (GMarshalFunc_VOID__STRING_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 51 "../src/BlackList.vala"
	callback (data1, g_value_get_string (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 1933 "BlackList.c"
}

static void
security_privacy_value_blacklist_init (GValue* value)
{
#line 51 "../src/BlackList.vala"
	value->data[0].v_pointer = NULL;
#line 1941 "BlackList.c"
}

static void
security_privacy_value_blacklist_free_value (GValue* value)
{
#line 51 "../src/BlackList.vala"
	if (value->data[0].v_pointer) {
#line 51 "../src/BlackList.vala"
		security_privacy_blacklist_unref (value->data[0].v_pointer);
#line 1951 "BlackList.c"
	}
}

static void
security_privacy_value_blacklist_copy_value (const GValue* src_value,
                                             GValue* dest_value)
{
#line 51 "../src/BlackList.vala"
	if (src_value->data[0].v_pointer) {
#line 51 "../src/BlackList.vala"
		dest_value->data[0].v_pointer = security_privacy_blacklist_ref (src_value->data[0].v_pointer);
#line 1963 "BlackList.c"
	} else {
#line 51 "../src/BlackList.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1967 "BlackList.c"
	}
}

static gpointer
security_privacy_value_blacklist_peek_pointer (const GValue* value)
{
#line 51 "../src/BlackList.vala"
	return value->data[0].v_pointer;
#line 1976 "BlackList.c"
}

static gchar*
security_privacy_value_blacklist_collect_value (GValue* value,
                                                guint n_collect_values,
                                                GTypeCValue* collect_values,
                                                guint collect_flags)
{
#line 51 "../src/BlackList.vala"
	if (collect_values[0].v_pointer) {
#line 1987 "BlackList.c"
		SecurityPrivacyBlacklist * object;
		object = collect_values[0].v_pointer;
#line 51 "../src/BlackList.vala"
		if (object->parent_instance.g_class == NULL) {
#line 51 "../src/BlackList.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1994 "BlackList.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 51 "../src/BlackList.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1998 "BlackList.c"
		}
#line 51 "../src/BlackList.vala"
		value->data[0].v_pointer = security_privacy_blacklist_ref (object);
#line 2002 "BlackList.c"
	} else {
#line 51 "../src/BlackList.vala"
		value->data[0].v_pointer = NULL;
#line 2006 "BlackList.c"
	}
#line 51 "../src/BlackList.vala"
	return NULL;
#line 2010 "BlackList.c"
}

static gchar*
security_privacy_value_blacklist_lcopy_value (const GValue* value,
                                              guint n_collect_values,
                                              GTypeCValue* collect_values,
                                              guint collect_flags)
{
	SecurityPrivacyBlacklist ** object_p;
	object_p = collect_values[0].v_pointer;
#line 51 "../src/BlackList.vala"
	if (!object_p) {
#line 51 "../src/BlackList.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2025 "BlackList.c"
	}
#line 51 "../src/BlackList.vala"
	if (!value->data[0].v_pointer) {
#line 51 "../src/BlackList.vala"
		*object_p = NULL;
#line 2031 "BlackList.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 51 "../src/BlackList.vala"
		*object_p = value->data[0].v_pointer;
#line 2035 "BlackList.c"
	} else {
#line 51 "../src/BlackList.vala"
		*object_p = security_privacy_blacklist_ref (value->data[0].v_pointer);
#line 2039 "BlackList.c"
	}
#line 51 "../src/BlackList.vala"
	return NULL;
#line 2043 "BlackList.c"
}

GParamSpec*
security_privacy_param_spec_blacklist (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags)
{
	SecurityPrivacyParamSpecBlacklist* spec;
#line 51 "../src/BlackList.vala"
	g_return_val_if_fail (g_type_is_a (object_type, SECURITY_PRIVACY_TYPE_BLACKLIST), NULL);
#line 51 "../src/BlackList.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 51 "../src/BlackList.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 51 "../src/BlackList.vala"
	return G_PARAM_SPEC (spec);
#line 2062 "BlackList.c"
}

gpointer
security_privacy_value_get_blacklist (const GValue* value)
{
#line 51 "../src/BlackList.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SECURITY_PRIVACY_TYPE_BLACKLIST), NULL);
#line 51 "../src/BlackList.vala"
	return value->data[0].v_pointer;
#line 2072 "BlackList.c"
}

void
security_privacy_value_set_blacklist (GValue* value,
                                      gpointer v_object)
{
	SecurityPrivacyBlacklist * old;
#line 51 "../src/BlackList.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SECURITY_PRIVACY_TYPE_BLACKLIST));
#line 51 "../src/BlackList.vala"
	old = value->data[0].v_pointer;
#line 51 "../src/BlackList.vala"
	if (v_object) {
#line 51 "../src/BlackList.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, SECURITY_PRIVACY_TYPE_BLACKLIST));
#line 51 "../src/BlackList.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 51 "../src/BlackList.vala"
		value->data[0].v_pointer = v_object;
#line 51 "../src/BlackList.vala"
		security_privacy_blacklist_ref (value->data[0].v_pointer);
#line 2094 "BlackList.c"
	} else {
#line 51 "../src/BlackList.vala"
		value->data[0].v_pointer = NULL;
#line 2098 "BlackList.c"
	}
#line 51 "../src/BlackList.vala"
	if (old) {
#line 51 "../src/BlackList.vala"
		security_privacy_blacklist_unref (old);
#line 2104 "BlackList.c"
	}
}

void
security_privacy_value_take_blacklist (GValue* value,
                                       gpointer v_object)
{
	SecurityPrivacyBlacklist * old;
#line 51 "../src/BlackList.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SECURITY_PRIVACY_TYPE_BLACKLIST));
#line 51 "../src/BlackList.vala"
	old = value->data[0].v_pointer;
#line 51 "../src/BlackList.vala"
	if (v_object) {
#line 51 "../src/BlackList.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, SECURITY_PRIVACY_TYPE_BLACKLIST));
#line 51 "../src/BlackList.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 51 "../src/BlackList.vala"
		value->data[0].v_pointer = v_object;
#line 2125 "BlackList.c"
	} else {
#line 51 "../src/BlackList.vala"
		value->data[0].v_pointer = NULL;
#line 2129 "BlackList.c"
	}
#line 51 "../src/BlackList.vala"
	if (old) {
#line 51 "../src/BlackList.vala"
		security_privacy_blacklist_unref (old);
#line 2135 "BlackList.c"
	}
}

static void
security_privacy_blacklist_class_init (SecurityPrivacyBlacklistClass * klass,
                                       gpointer klass_data)
{
#line 51 "../src/BlackList.vala"
	security_privacy_blacklist_parent_class = g_type_class_peek_parent (klass);
#line 51 "../src/BlackList.vala"
	((SecurityPrivacyBlacklistClass *) klass)->finalize = security_privacy_blacklist_finalize;
#line 51 "../src/BlackList.vala"
	g_type_class_adjust_private_offset (klass, &SecurityPrivacyBlacklist_private_offset);
#line 51 "../src/BlackList.vala"
	security_privacy_blacklist_signals[SECURITY_PRIVACY_BLACKLIST_TEMPLATE_ADDED_SIGNAL] = g_signal_new ("template-added", SECURITY_PRIVACY_TYPE_BLACKLIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_OBJECT, G_TYPE_NONE, 2, G_TYPE_STRING, ZEITGEIST_TYPE_EVENT);
#line 51 "../src/BlackList.vala"
	security_privacy_blacklist_signals[SECURITY_PRIVACY_BLACKLIST_TEMPLATE_REMOVED_SIGNAL] = g_signal_new ("template-removed", SECURITY_PRIVACY_TYPE_BLACKLIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_OBJECT, G_TYPE_NONE, 2, G_TYPE_STRING, ZEITGEIST_TYPE_EVENT);
#line 51 "../src/BlackList.vala"
	security_privacy_blacklist_signals[SECURITY_PRIVACY_BLACKLIST_INCOGNITO_TOGGLED_SIGNAL] = g_signal_new ("incognito-toggled", SECURITY_PRIVACY_TYPE_BLACKLIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 2155 "BlackList.c"
}

static void
security_privacy_blacklist_instance_init (SecurityPrivacyBlacklist * self,
                                          gpointer klass)
{
	gchar* _tmp0_;
#line 51 "../src/BlackList.vala"
	self->priv = security_privacy_blacklist_get_instance_private (self);
#line 58 "../src/BlackList.vala"
	_tmp0_ = g_strdup ("block-all");
#line 58 "../src/BlackList.vala"
	self->priv->incognito_id = _tmp0_;
#line 51 "../src/BlackList.vala"
	self->ref_count = 1;
#line 2171 "BlackList.c"
}

static void
security_privacy_blacklist_finalize (SecurityPrivacyBlacklist * obj)
{
	SecurityPrivacyBlacklist * self;
#line 51 "../src/BlackList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SECURITY_PRIVACY_TYPE_BLACKLIST, SecurityPrivacyBlacklist);
#line 51 "../src/BlackList.vala"
	g_signal_handlers_destroy (self);
#line 53 "../src/BlackList.vala"
	_g_object_unref0 (self->priv->blacklist);
#line 54 "../src/BlackList.vala"
	_g_hash_table_unref0 (self->priv->blacklists);
#line 55 "../src/BlackList.vala"
	_g_object_unref0 (self->priv->log);
#line 58 "../src/BlackList.vala"
	_g_free0 (self->priv->incognito_id);
#line 59 "../src/BlackList.vala"
	_g_object_unref0 (self->priv->incognito_event);
#line 2192 "BlackList.c"
}

static GType
security_privacy_blacklist_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { security_privacy_value_blacklist_init, security_privacy_value_blacklist_free_value, security_privacy_value_blacklist_copy_value, security_privacy_value_blacklist_peek_pointer, "p", security_privacy_value_blacklist_collect_value, "p", security_privacy_value_blacklist_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (SecurityPrivacyBlacklistClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) security_privacy_blacklist_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SecurityPrivacyBlacklist), 0, (GInstanceInitFunc) security_privacy_blacklist_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType security_privacy_blacklist_type_id;
	security_privacy_blacklist_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SecurityPrivacyBlacklist", &g_define_type_info, &g_define_type_fundamental_info, 0);
	SecurityPrivacyBlacklist_private_offset = g_type_add_instance_private (security_privacy_blacklist_type_id, sizeof (SecurityPrivacyBlacklistPrivate));
	return security_privacy_blacklist_type_id;
}

GType
security_privacy_blacklist_get_type (void)
{
	static volatile gsize security_privacy_blacklist_type_id__once = 0;
	if (g_once_init_enter (&security_privacy_blacklist_type_id__once)) {
		GType security_privacy_blacklist_type_id;
		security_privacy_blacklist_type_id = security_privacy_blacklist_get_type_once ();
		g_once_init_leave (&security_privacy_blacklist_type_id__once, security_privacy_blacklist_type_id);
	}
	return security_privacy_blacklist_type_id__once;
}

gpointer
security_privacy_blacklist_ref (gpointer instance)
{
	SecurityPrivacyBlacklist * self;
	self = instance;
#line 51 "../src/BlackList.vala"
	g_atomic_int_inc (&self->ref_count);
#line 51 "../src/BlackList.vala"
	return instance;
#line 2228 "BlackList.c"
}

void
security_privacy_blacklist_unref (gpointer instance)
{
	SecurityPrivacyBlacklist * self;
	self = instance;
#line 51 "../src/BlackList.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 51 "../src/BlackList.vala"
		SECURITY_PRIVACY_BLACKLIST_GET_CLASS (self)->finalize (self);
#line 51 "../src/BlackList.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2242 "BlackList.c"
	}
}

static inline gpointer
security_privacy_file_type_blacklist_get_instance_private (SecurityPrivacyFileTypeBlacklist* self)
{
	return G_STRUCT_MEMBER_P (self, SecurityPrivacyFileTypeBlacklist_private_offset);
}

static void
_security_privacy_file_type_blacklist_on_blacklist_added_security_privacy_blacklist_template_added (SecurityPrivacyBlacklist* _sender,
                                                                                                    const gchar* blacklist_id,
                                                                                                    ZeitgeistEvent* blacklist_template,
                                                                                                    gpointer self)
{
#line 221 "../src/BlackList.vala"
	security_privacy_file_type_blacklist_on_blacklist_added ((SecurityPrivacyFileTypeBlacklist*) self, blacklist_id, blacklist_template);
#line 2260 "BlackList.c"
}

static void
_security_privacy_file_type_blacklist_on_blacklist_removed_security_privacy_blacklist_template_removed (SecurityPrivacyBlacklist* _sender,
                                                                                                        const gchar* blacklist_id,
                                                                                                        ZeitgeistEvent* blacklist_template,
                                                                                                        gpointer self)
{
#line 222 "../src/BlackList.vala"
	security_privacy_file_type_blacklist_on_blacklist_removed ((SecurityPrivacyFileTypeBlacklist*) self, blacklist_id, blacklist_template);
#line 2271 "BlackList.c"
}

SecurityPrivacyFileTypeBlacklist*
security_privacy_file_type_blacklist_construct (GType object_type,
                                                SecurityPrivacyBlacklist* blacklist_inter)
{
	SecurityPrivacyFileTypeBlacklist* self = NULL;
	SecurityPrivacyBlacklist* _tmp0_;
	SecurityPrivacyBlacklist* _tmp1_;
	SecurityPrivacyBlacklist* _tmp2_;
	GeeHashSet* _tmp3_;
#line 219 "../src/BlackList.vala"
	g_return_val_if_fail (blacklist_inter != NULL, NULL);
#line 219 "../src/BlackList.vala"
	self = (SecurityPrivacyFileTypeBlacklist*) g_type_create_instance (object_type);
#line 220 "../src/BlackList.vala"
	_tmp0_ = _security_privacy_blacklist_ref0 (blacklist_inter);
#line 220 "../src/BlackList.vala"
	_security_privacy_blacklist_unref0 (self->priv->blacklist_interface);
#line 220 "../src/BlackList.vala"
	self->priv->blacklist_interface = _tmp0_;
#line 221 "../src/BlackList.vala"
	_tmp1_ = self->priv->blacklist_interface;
#line 221 "../src/BlackList.vala"
	g_signal_connect (_tmp1_, "template-added", (GCallback) _security_privacy_file_type_blacklist_on_blacklist_added_security_privacy_blacklist_template_added, self);
#line 222 "../src/BlackList.vala"
	_tmp2_ = self->priv->blacklist_interface;
#line 222 "../src/BlackList.vala"
	g_signal_connect (_tmp2_, "template-removed", (GCallback) _security_privacy_file_type_blacklist_on_blacklist_removed_security_privacy_blacklist_template_removed, self);
#line 223 "../src/BlackList.vala"
	_tmp3_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 223 "../src/BlackList.vala"
	_g_object_unref0 (self->priv->all_blocked_filetypes);
#line 223 "../src/BlackList.vala"
	self->priv->all_blocked_filetypes = _tmp3_;
#line 224 "../src/BlackList.vala"
	security_privacy_file_type_blacklist_populate_file_types (self);
#line 219 "../src/BlackList.vala"
	return self;
#line 2311 "BlackList.c"
}

SecurityPrivacyFileTypeBlacklist*
security_privacy_file_type_blacklist_new (SecurityPrivacyBlacklist* blacklist_inter)
{
#line 219 "../src/BlackList.vala"
	return security_privacy_file_type_blacklist_construct (SECURITY_PRIVACY_TYPE_FILE_TYPE_BLACKLIST, blacklist_inter);
#line 2319 "BlackList.c"
}

static gchar*
security_privacy_file_type_blacklist_get_name (SecurityPrivacyFileTypeBlacklist* self,
                                               const gchar* interpretation)
{
	gchar** names = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint names_length1;
	gint _names_size_;
	gchar* name = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* result;
#line 227 "../src/BlackList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 227 "../src/BlackList.vala"
	g_return_val_if_fail (interpretation != NULL, NULL);
#line 228 "../src/BlackList.vala"
	_tmp1_ = _tmp0_ = g_strsplit (interpretation, "#", 0);
#line 228 "../src/BlackList.vala"
	names = _tmp1_;
#line 228 "../src/BlackList.vala"
	names_length1 = _vala_array_length (_tmp0_);
#line 228 "../src/BlackList.vala"
	_names_size_ = names_length1;
#line 229 "../src/BlackList.vala"
	_tmp2_ = names[names_length1 - 1];
#line 229 "../src/BlackList.vala"
	_tmp3_ = g_utf8_strdown (_tmp2_, (gssize) -1);
#line 229 "../src/BlackList.vala"
	name = _tmp3_;
#line 230 "../src/BlackList.vala"
	_tmp4_ = security_privacy_file_type_blacklist_interpretation_prefix;
#line 230 "../src/BlackList.vala"
	_tmp5_ = g_strdup_printf ("%s%s", _tmp4_, name);
#line 230 "../src/BlackList.vala"
	result = _tmp5_;
#line 230 "../src/BlackList.vala"
	_g_free0 (name);
#line 230 "../src/BlackList.vala"
	names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
#line 230 "../src/BlackList.vala"
	return result;
#line 2367 "BlackList.c"
}

static void
security_privacy_file_type_blacklist_populate_file_types (SecurityPrivacyFileTypeBlacklist* self)
{
	SecurityPrivacyBlacklist* _tmp0_;
	GHashTable* _tmp1_;
	GHashTable* _tmp2_;
	GList* _tmp3_;
#line 233 "../src/BlackList.vala"
	g_return_if_fail (self != NULL);
#line 234 "../src/BlackList.vala"
	_tmp0_ = self->priv->blacklist_interface;
#line 234 "../src/BlackList.vala"
	_tmp1_ = security_privacy_blacklist_get_all_templates (_tmp0_);
#line 234 "../src/BlackList.vala"
	_tmp2_ = _tmp1_;
#line 234 "../src/BlackList.vala"
	_tmp3_ = g_hash_table_get_keys (_tmp2_);
#line 2387 "BlackList.c"
	{
		GList* key_collection = NULL;
		GList* key_it = NULL;
#line 234 "../src/BlackList.vala"
		key_collection = _tmp3_;
#line 234 "../src/BlackList.vala"
		for (key_it = key_collection; key_it != NULL; key_it = key_it->next) {
#line 2395 "BlackList.c"
			gchar* _tmp4_;
			gchar* key = NULL;
#line 234 "../src/BlackList.vala"
			_tmp4_ = g_strdup ((const gchar*) key_it->data);
#line 234 "../src/BlackList.vala"
			key = _tmp4_;
#line 2402 "BlackList.c"
			{
				const gchar* _tmp5_;
				const gchar* _tmp6_;
#line 235 "../src/BlackList.vala"
				_tmp5_ = key;
#line 235 "../src/BlackList.vala"
				_tmp6_ = security_privacy_file_type_blacklist_interpretation_prefix;
#line 235 "../src/BlackList.vala"
				if (g_str_has_prefix (_tmp5_, _tmp6_)) {
#line 2412 "BlackList.c"
					gchar* inter = NULL;
					SecurityPrivacyBlacklist* _tmp7_;
					GHashTable* _tmp8_;
					GHashTable* _tmp9_;
					const gchar* _tmp10_;
					gconstpointer _tmp11_;
					ZeitgeistSubject* _tmp12_;
					ZeitgeistSubject* _tmp13_;
					const gchar* _tmp14_;
					const gchar* _tmp15_;
					gchar* _tmp16_;
					gchar* _tmp17_;
					GeeHashSet* _tmp18_;
					const gchar* _tmp19_;
#line 236 "../src/BlackList.vala"
					_tmp7_ = self->priv->blacklist_interface;
#line 236 "../src/BlackList.vala"
					_tmp8_ = security_privacy_blacklist_get_all_templates (_tmp7_);
#line 236 "../src/BlackList.vala"
					_tmp9_ = _tmp8_;
#line 236 "../src/BlackList.vala"
					_tmp10_ = key;
#line 236 "../src/BlackList.vala"
					_tmp11_ = g_hash_table_lookup (_tmp9_, _tmp10_);
#line 236 "../src/BlackList.vala"
					_tmp12_ = zeitgeist_event_get_subject ((ZeitgeistEvent*) _tmp11_, 0);
#line 236 "../src/BlackList.vala"
					_tmp13_ = _tmp12_;
#line 236 "../src/BlackList.vala"
					_tmp14_ = zeitgeist_subject_get_interpretation (_tmp13_);
#line 236 "../src/BlackList.vala"
					_tmp15_ = _tmp14_;
#line 236 "../src/BlackList.vala"
					_tmp16_ = g_strdup (_tmp15_);
#line 236 "../src/BlackList.vala"
					_tmp17_ = _tmp16_;
#line 236 "../src/BlackList.vala"
					_g_object_unref0 (_tmp13_);
#line 236 "../src/BlackList.vala"
					inter = _tmp17_;
#line 237 "../src/BlackList.vala"
					_tmp18_ = self->priv->all_blocked_filetypes;
#line 237 "../src/BlackList.vala"
					_tmp19_ = inter;
#line 237 "../src/BlackList.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp18_, _tmp19_);
#line 235 "../src/BlackList.vala"
					_g_free0 (inter);
#line 2461 "BlackList.c"
				}
#line 234 "../src/BlackList.vala"
				_g_free0 (key);
#line 2465 "BlackList.c"
			}
		}
#line 234 "../src/BlackList.vala"
		(key_collection == NULL) ? NULL : (key_collection = (g_list_free (key_collection), NULL));
#line 2470 "BlackList.c"
	}
}

void
security_privacy_file_type_blacklist_block (SecurityPrivacyFileTypeBlacklist* self,
                                            const gchar* interpretation)
{
	ZeitgeistEvent* ev = NULL;
	ZeitgeistEvent* _tmp0_;
	ZeitgeistSubject* sub = NULL;
	ZeitgeistSubject* _tmp1_;
	SecurityPrivacyBlacklist* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 242 "../src/BlackList.vala"
	g_return_if_fail (self != NULL);
#line 242 "../src/BlackList.vala"
	g_return_if_fail (interpretation != NULL);
#line 243 "../src/BlackList.vala"
	_tmp0_ = zeitgeist_event_new ();
#line 243 "../src/BlackList.vala"
	ev = _tmp0_;
#line 244 "../src/BlackList.vala"
	_tmp1_ = zeitgeist_subject_new ();
#line 244 "../src/BlackList.vala"
	sub = _tmp1_;
#line 245 "../src/BlackList.vala"
	zeitgeist_subject_set_interpretation (sub, interpretation);
#line 246 "../src/BlackList.vala"
	zeitgeist_event_add_subject (ev, sub);
#line 247 "../src/BlackList.vala"
	_tmp2_ = self->priv->blacklist_interface;
#line 247 "../src/BlackList.vala"
	_tmp3_ = security_privacy_file_type_blacklist_get_name (self, interpretation);
#line 247 "../src/BlackList.vala"
	_tmp4_ = _tmp3_;
#line 247 "../src/BlackList.vala"
	security_privacy_blacklist_add_template (_tmp2_, _tmp4_, ev);
#line 247 "../src/BlackList.vala"
	_g_free0 (_tmp4_);
#line 242 "../src/BlackList.vala"
	_g_object_unref0 (sub);
#line 242 "../src/BlackList.vala"
	_g_object_unref0 (ev);
#line 2515 "BlackList.c"
}

void
security_privacy_file_type_blacklist_unblock (SecurityPrivacyFileTypeBlacklist* self,
                                              const gchar* interpretation)
{
	SecurityPrivacyBlacklist* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 250 "../src/BlackList.vala"
	g_return_if_fail (self != NULL);
#line 250 "../src/BlackList.vala"
	g_return_if_fail (interpretation != NULL);
#line 251 "../src/BlackList.vala"
	_tmp0_ = self->priv->blacklist_interface;
#line 251 "../src/BlackList.vala"
	_tmp1_ = security_privacy_file_type_blacklist_get_name (self, interpretation);
#line 251 "../src/BlackList.vala"
	_tmp2_ = _tmp1_;
#line 251 "../src/BlackList.vala"
	security_privacy_blacklist_remove_template (_tmp0_, _tmp2_);
#line 251 "../src/BlackList.vala"
	_g_free0 (_tmp2_);
#line 2539 "BlackList.c"
}

static void
security_privacy_file_type_blacklist_on_blacklist_added (SecurityPrivacyFileTypeBlacklist* self,
                                                         const gchar* blacklist_id,
                                                         ZeitgeistEvent* ev)
{
	const gchar* _tmp0_;
#line 254 "../src/BlackList.vala"
	g_return_if_fail (self != NULL);
#line 254 "../src/BlackList.vala"
	g_return_if_fail (blacklist_id != NULL);
#line 254 "../src/BlackList.vala"
	g_return_if_fail (ev != NULL);
#line 255 "../src/BlackList.vala"
	_tmp0_ = security_privacy_file_type_blacklist_interpretation_prefix;
#line 255 "../src/BlackList.vala"
	if (g_str_has_prefix (blacklist_id, _tmp0_)) {
#line 2558 "BlackList.c"
		GeeHashSet* _tmp1_;
		ZeitgeistSubject* _tmp2_;
		ZeitgeistSubject* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
#line 256 "../src/BlackList.vala"
		_tmp1_ = self->priv->all_blocked_filetypes;
#line 256 "../src/BlackList.vala"
		_tmp2_ = zeitgeist_event_get_subject (ev, 0);
#line 256 "../src/BlackList.vala"
		_tmp3_ = _tmp2_;
#line 256 "../src/BlackList.vala"
		_tmp4_ = zeitgeist_subject_get_interpretation (_tmp3_);
#line 256 "../src/BlackList.vala"
		_tmp5_ = _tmp4_;
#line 256 "../src/BlackList.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, _tmp5_);
#line 256 "../src/BlackList.vala"
		_g_object_unref0 (_tmp3_);
#line 2578 "BlackList.c"
	}
}

static void
security_privacy_file_type_blacklist_on_blacklist_removed (SecurityPrivacyFileTypeBlacklist* self,
                                                           const gchar* blacklist_id,
                                                           ZeitgeistEvent* ev)
{
	const gchar* _tmp0_;
#line 260 "../src/BlackList.vala"
	g_return_if_fail (self != NULL);
#line 260 "../src/BlackList.vala"
	g_return_if_fail (blacklist_id != NULL);
#line 260 "../src/BlackList.vala"
	g_return_if_fail (ev != NULL);
#line 261 "../src/BlackList.vala"
	_tmp0_ = security_privacy_file_type_blacklist_interpretation_prefix;
#line 261 "../src/BlackList.vala"
	if (g_str_has_prefix (blacklist_id, _tmp0_)) {
#line 2598 "BlackList.c"
		gchar* inter = NULL;
		ZeitgeistSubject* _tmp1_;
		ZeitgeistSubject* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		GeeHashSet* _tmp7_;
		const gchar* _tmp8_;
#line 262 "../src/BlackList.vala"
		_tmp1_ = zeitgeist_event_get_subject (ev, 0);
#line 262 "../src/BlackList.vala"
		_tmp2_ = _tmp1_;
#line 262 "../src/BlackList.vala"
		_tmp3_ = zeitgeist_subject_get_interpretation (_tmp2_);
#line 262 "../src/BlackList.vala"
		_tmp4_ = _tmp3_;
#line 262 "../src/BlackList.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 262 "../src/BlackList.vala"
		_tmp6_ = _tmp5_;
#line 262 "../src/BlackList.vala"
		_g_object_unref0 (_tmp2_);
#line 262 "../src/BlackList.vala"
		inter = _tmp6_;
#line 263 "../src/BlackList.vala"
		_tmp7_ = self->priv->all_blocked_filetypes;
#line 263 "../src/BlackList.vala"
		_tmp8_ = inter;
#line 263 "../src/BlackList.vala"
		if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp7_, _tmp8_) == TRUE) {
#line 2630 "BlackList.c"
			GeeHashSet* _tmp9_;
			ZeitgeistSubject* _tmp10_;
			ZeitgeistSubject* _tmp11_;
			const gchar* _tmp12_;
			const gchar* _tmp13_;
#line 264 "../src/BlackList.vala"
			_tmp9_ = self->priv->all_blocked_filetypes;
#line 264 "../src/BlackList.vala"
			_tmp10_ = zeitgeist_event_get_subject (ev, 0);
#line 264 "../src/BlackList.vala"
			_tmp11_ = _tmp10_;
#line 264 "../src/BlackList.vala"
			_tmp12_ = zeitgeist_subject_get_interpretation (_tmp11_);
#line 264 "../src/BlackList.vala"
			_tmp13_ = _tmp12_;
#line 264 "../src/BlackList.vala"
			gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp9_, _tmp13_);
#line 264 "../src/BlackList.vala"
			_g_object_unref0 (_tmp11_);
#line 2650 "BlackList.c"
		}
#line 261 "../src/BlackList.vala"
		_g_free0 (inter);
#line 2654 "BlackList.c"
	}
}

GeeHashSet*
security_privacy_file_type_blacklist_get_all_filetypes (SecurityPrivacyFileTypeBlacklist* self)
{
	GeeHashSet* result;
	GeeHashSet* _tmp0_;
#line 214 "../src/BlackList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 215 "../src/BlackList.vala"
	_tmp0_ = self->priv->all_blocked_filetypes;
#line 215 "../src/BlackList.vala"
	result = _tmp0_;
#line 215 "../src/BlackList.vala"
	return result;
#line 2671 "BlackList.c"
}

static void
security_privacy_value_file_type_blacklist_init (GValue* value)
{
#line 207 "../src/BlackList.vala"
	value->data[0].v_pointer = NULL;
#line 2679 "BlackList.c"
}

static void
security_privacy_value_file_type_blacklist_free_value (GValue* value)
{
#line 207 "../src/BlackList.vala"
	if (value->data[0].v_pointer) {
#line 207 "../src/BlackList.vala"
		security_privacy_file_type_blacklist_unref (value->data[0].v_pointer);
#line 2689 "BlackList.c"
	}
}

static void
security_privacy_value_file_type_blacklist_copy_value (const GValue* src_value,
                                                       GValue* dest_value)
{
#line 207 "../src/BlackList.vala"
	if (src_value->data[0].v_pointer) {
#line 207 "../src/BlackList.vala"
		dest_value->data[0].v_pointer = security_privacy_file_type_blacklist_ref (src_value->data[0].v_pointer);
#line 2701 "BlackList.c"
	} else {
#line 207 "../src/BlackList.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2705 "BlackList.c"
	}
}

static gpointer
security_privacy_value_file_type_blacklist_peek_pointer (const GValue* value)
{
#line 207 "../src/BlackList.vala"
	return value->data[0].v_pointer;
#line 2714 "BlackList.c"
}

static gchar*
security_privacy_value_file_type_blacklist_collect_value (GValue* value,
                                                          guint n_collect_values,
                                                          GTypeCValue* collect_values,
                                                          guint collect_flags)
{
#line 207 "../src/BlackList.vala"
	if (collect_values[0].v_pointer) {
#line 2725 "BlackList.c"
		SecurityPrivacyFileTypeBlacklist * object;
		object = collect_values[0].v_pointer;
#line 207 "../src/BlackList.vala"
		if (object->parent_instance.g_class == NULL) {
#line 207 "../src/BlackList.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2732 "BlackList.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 207 "../src/BlackList.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2736 "BlackList.c"
		}
#line 207 "../src/BlackList.vala"
		value->data[0].v_pointer = security_privacy_file_type_blacklist_ref (object);
#line 2740 "BlackList.c"
	} else {
#line 207 "../src/BlackList.vala"
		value->data[0].v_pointer = NULL;
#line 2744 "BlackList.c"
	}
#line 207 "../src/BlackList.vala"
	return NULL;
#line 2748 "BlackList.c"
}

static gchar*
security_privacy_value_file_type_blacklist_lcopy_value (const GValue* value,
                                                        guint n_collect_values,
                                                        GTypeCValue* collect_values,
                                                        guint collect_flags)
{
	SecurityPrivacyFileTypeBlacklist ** object_p;
	object_p = collect_values[0].v_pointer;
#line 207 "../src/BlackList.vala"
	if (!object_p) {
#line 207 "../src/BlackList.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2763 "BlackList.c"
	}
#line 207 "../src/BlackList.vala"
	if (!value->data[0].v_pointer) {
#line 207 "../src/BlackList.vala"
		*object_p = NULL;
#line 2769 "BlackList.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 207 "../src/BlackList.vala"
		*object_p = value->data[0].v_pointer;
#line 2773 "BlackList.c"
	} else {
#line 207 "../src/BlackList.vala"
		*object_p = security_privacy_file_type_blacklist_ref (value->data[0].v_pointer);
#line 2777 "BlackList.c"
	}
#line 207 "../src/BlackList.vala"
	return NULL;
#line 2781 "BlackList.c"
}

GParamSpec*
security_privacy_param_spec_file_type_blacklist (const gchar* name,
                                                 const gchar* nick,
                                                 const gchar* blurb,
                                                 GType object_type,
                                                 GParamFlags flags)
{
	SecurityPrivacyParamSpecFileTypeBlacklist* spec;
#line 207 "../src/BlackList.vala"
	g_return_val_if_fail (g_type_is_a (object_type, SECURITY_PRIVACY_TYPE_FILE_TYPE_BLACKLIST), NULL);
#line 207 "../src/BlackList.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 207 "../src/BlackList.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 207 "../src/BlackList.vala"
	return G_PARAM_SPEC (spec);
#line 2800 "BlackList.c"
}

gpointer
security_privacy_value_get_file_type_blacklist (const GValue* value)
{
#line 207 "../src/BlackList.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SECURITY_PRIVACY_TYPE_FILE_TYPE_BLACKLIST), NULL);
#line 207 "../src/BlackList.vala"
	return value->data[0].v_pointer;
#line 2810 "BlackList.c"
}

void
security_privacy_value_set_file_type_blacklist (GValue* value,
                                                gpointer v_object)
{
	SecurityPrivacyFileTypeBlacklist * old;
#line 207 "../src/BlackList.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SECURITY_PRIVACY_TYPE_FILE_TYPE_BLACKLIST));
#line 207 "../src/BlackList.vala"
	old = value->data[0].v_pointer;
#line 207 "../src/BlackList.vala"
	if (v_object) {
#line 207 "../src/BlackList.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, SECURITY_PRIVACY_TYPE_FILE_TYPE_BLACKLIST));
#line 207 "../src/BlackList.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 207 "../src/BlackList.vala"
		value->data[0].v_pointer = v_object;
#line 207 "../src/BlackList.vala"
		security_privacy_file_type_blacklist_ref (value->data[0].v_pointer);
#line 2832 "BlackList.c"
	} else {
#line 207 "../src/BlackList.vala"
		value->data[0].v_pointer = NULL;
#line 2836 "BlackList.c"
	}
#line 207 "../src/BlackList.vala"
	if (old) {
#line 207 "../src/BlackList.vala"
		security_privacy_file_type_blacklist_unref (old);
#line 2842 "BlackList.c"
	}
}

void
security_privacy_value_take_file_type_blacklist (GValue* value,
                                                 gpointer v_object)
{
	SecurityPrivacyFileTypeBlacklist * old;
#line 207 "../src/BlackList.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SECURITY_PRIVACY_TYPE_FILE_TYPE_BLACKLIST));
#line 207 "../src/BlackList.vala"
	old = value->data[0].v_pointer;
#line 207 "../src/BlackList.vala"
	if (v_object) {
#line 207 "../src/BlackList.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, SECURITY_PRIVACY_TYPE_FILE_TYPE_BLACKLIST));
#line 207 "../src/BlackList.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 207 "../src/BlackList.vala"
		value->data[0].v_pointer = v_object;
#line 2863 "BlackList.c"
	} else {
#line 207 "../src/BlackList.vala"
		value->data[0].v_pointer = NULL;
#line 2867 "BlackList.c"
	}
#line 207 "../src/BlackList.vala"
	if (old) {
#line 207 "../src/BlackList.vala"
		security_privacy_file_type_blacklist_unref (old);
#line 2873 "BlackList.c"
	}
}

static void
security_privacy_file_type_blacklist_class_init (SecurityPrivacyFileTypeBlacklistClass * klass,
                                                 gpointer klass_data)
{
	gchar* _tmp0_;
#line 207 "../src/BlackList.vala"
	security_privacy_file_type_blacklist_parent_class = g_type_class_peek_parent (klass);
#line 207 "../src/BlackList.vala"
	((SecurityPrivacyFileTypeBlacklistClass *) klass)->finalize = security_privacy_file_type_blacklist_finalize;
#line 207 "../src/BlackList.vala"
	g_type_class_adjust_private_offset (klass, &SecurityPrivacyFileTypeBlacklist_private_offset);
#line 208 "../src/BlackList.vala"
	_tmp0_ = g_strdup ("interpretation-");
#line 208 "../src/BlackList.vala"
	security_privacy_file_type_blacklist_interpretation_prefix = _tmp0_;
#line 2892 "BlackList.c"
}

static void
security_privacy_file_type_blacklist_instance_init (SecurityPrivacyFileTypeBlacklist * self,
                                                    gpointer klass)
{
#line 207 "../src/BlackList.vala"
	self->priv = security_privacy_file_type_blacklist_get_instance_private (self);
#line 207 "../src/BlackList.vala"
	self->ref_count = 1;
#line 2903 "BlackList.c"
}

static void
security_privacy_file_type_blacklist_finalize (SecurityPrivacyFileTypeBlacklist * obj)
{
	SecurityPrivacyFileTypeBlacklist * self;
#line 207 "../src/BlackList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SECURITY_PRIVACY_TYPE_FILE_TYPE_BLACKLIST, SecurityPrivacyFileTypeBlacklist);
#line 207 "../src/BlackList.vala"
	g_signal_handlers_destroy (self);
#line 210 "../src/BlackList.vala"
	_security_privacy_blacklist_unref0 (self->priv->blacklist_interface);
#line 211 "../src/BlackList.vala"
	_g_object_unref0 (self->priv->all_blocked_filetypes);
#line 2918 "BlackList.c"
}

static GType
security_privacy_file_type_blacklist_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { security_privacy_value_file_type_blacklist_init, security_privacy_value_file_type_blacklist_free_value, security_privacy_value_file_type_blacklist_copy_value, security_privacy_value_file_type_blacklist_peek_pointer, "p", security_privacy_value_file_type_blacklist_collect_value, "p", security_privacy_value_file_type_blacklist_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (SecurityPrivacyFileTypeBlacklistClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) security_privacy_file_type_blacklist_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SecurityPrivacyFileTypeBlacklist), 0, (GInstanceInitFunc) security_privacy_file_type_blacklist_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType security_privacy_file_type_blacklist_type_id;
	security_privacy_file_type_blacklist_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SecurityPrivacyFileTypeBlacklist", &g_define_type_info, &g_define_type_fundamental_info, 0);
	SecurityPrivacyFileTypeBlacklist_private_offset = g_type_add_instance_private (security_privacy_file_type_blacklist_type_id, sizeof (SecurityPrivacyFileTypeBlacklistPrivate));
	return security_privacy_file_type_blacklist_type_id;
}

GType
security_privacy_file_type_blacklist_get_type (void)
{
	static volatile gsize security_privacy_file_type_blacklist_type_id__once = 0;
	if (g_once_init_enter (&security_privacy_file_type_blacklist_type_id__once)) {
		GType security_privacy_file_type_blacklist_type_id;
		security_privacy_file_type_blacklist_type_id = security_privacy_file_type_blacklist_get_type_once ();
		g_once_init_leave (&security_privacy_file_type_blacklist_type_id__once, security_privacy_file_type_blacklist_type_id);
	}
	return security_privacy_file_type_blacklist_type_id__once;
}

gpointer
security_privacy_file_type_blacklist_ref (gpointer instance)
{
	SecurityPrivacyFileTypeBlacklist * self;
	self = instance;
#line 207 "../src/BlackList.vala"
	g_atomic_int_inc (&self->ref_count);
#line 207 "../src/BlackList.vala"
	return instance;
#line 2954 "BlackList.c"
}

void
security_privacy_file_type_blacklist_unref (gpointer instance)
{
	SecurityPrivacyFileTypeBlacklist * self;
	self = instance;
#line 207 "../src/BlackList.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 207 "../src/BlackList.vala"
		SECURITY_PRIVACY_FILE_TYPE_BLACKLIST_GET_CLASS (self)->finalize (self);
#line 207 "../src/BlackList.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2968 "BlackList.c"
	}
}

static inline gpointer
security_privacy_path_blacklist_get_instance_private (SecurityPrivacyPathBlacklist* self)
{
	return G_STRUCT_MEMBER_P (self, SecurityPrivacyPathBlacklist_private_offset);
}

static void
_security_privacy_path_blacklist_on_blacklist_added_security_privacy_blacklist_template_added (SecurityPrivacyBlacklist* _sender,
                                                                                               const gchar* blacklist_id,
                                                                                               ZeitgeistEvent* blacklist_template,
                                                                                               gpointer self)
{
#line 282 "../src/BlackList.vala"
	security_privacy_path_blacklist_on_blacklist_added ((SecurityPrivacyPathBlacklist*) self, blacklist_id, blacklist_template);
#line 2986 "BlackList.c"
}

static void
_security_privacy_path_blacklist_on_blacklist_removed_security_privacy_blacklist_template_removed (SecurityPrivacyBlacklist* _sender,
                                                                                                   const gchar* blacklist_id,
                                                                                                   ZeitgeistEvent* blacklist_template,
                                                                                                   gpointer self)
{
#line 283 "../src/BlackList.vala"
	security_privacy_path_blacklist_on_blacklist_removed ((SecurityPrivacyPathBlacklist*) self, blacklist_id, blacklist_template);
#line 2997 "BlackList.c"
}

SecurityPrivacyPathBlacklist*
security_privacy_path_blacklist_construct (GType object_type,
                                           SecurityPrivacyBlacklist* blacklist_inter)
{
	SecurityPrivacyPathBlacklist* self = NULL;
	SecurityPrivacyBlacklist* _tmp0_;
	SecurityPrivacyBlacklist* _tmp1_;
	SecurityPrivacyBlacklist* _tmp2_;
#line 280 "../src/BlackList.vala"
	g_return_val_if_fail (blacklist_inter != NULL, NULL);
#line 280 "../src/BlackList.vala"
	self = (SecurityPrivacyPathBlacklist*) g_type_create_instance (object_type);
#line 281 "../src/BlackList.vala"
	_tmp0_ = _security_privacy_blacklist_ref0 (blacklist_inter);
#line 281 "../src/BlackList.vala"
	_security_privacy_blacklist_unref0 (self->priv->blacklist_interface);
#line 281 "../src/BlackList.vala"
	self->priv->blacklist_interface = _tmp0_;
#line 282 "../src/BlackList.vala"
	_tmp1_ = self->priv->blacklist_interface;
#line 282 "../src/BlackList.vala"
	g_signal_connect (_tmp1_, "template-added", (GCallback) _security_privacy_path_blacklist_on_blacklist_added_security_privacy_blacklist_template_added, self);
#line 283 "../src/BlackList.vala"
	_tmp2_ = self->priv->blacklist_interface;
#line 283 "../src/BlackList.vala"
	g_signal_connect (_tmp2_, "template-removed", (GCallback) _security_privacy_path_blacklist_on_blacklist_removed_security_privacy_blacklist_template_removed, self);
#line 284 "../src/BlackList.vala"
	security_privacy_path_blacklist_get_blocked_folder (self);
#line 280 "../src/BlackList.vala"
	return self;
#line 3030 "BlackList.c"
}

SecurityPrivacyPathBlacklist*
security_privacy_path_blacklist_new (SecurityPrivacyBlacklist* blacklist_inter)
{
#line 280 "../src/BlackList.vala"
	return security_privacy_path_blacklist_construct (SECURITY_PRIVACY_TYPE_PATH_BLACKLIST, blacklist_inter);
#line 3038 "BlackList.c"
}

gboolean
security_privacy_path_blacklist_is_duplicate (SecurityPrivacyPathBlacklist* self,
                                              const gchar* path)
{
	GeeHashSet* _tmp0_;
	gboolean result;
#line 293 "../src/BlackList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 293 "../src/BlackList.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 294 "../src/BlackList.vala"
	_tmp0_ = self->priv->all_blocked_folder;
#line 294 "../src/BlackList.vala"
	result = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, path);
#line 294 "../src/BlackList.vala"
	return result;
#line 3057 "BlackList.c"
}

static void
security_privacy_path_blacklist_get_blocked_folder (SecurityPrivacyPathBlacklist* self)
{
	GeeHashSet* _tmp0_;
	SecurityPrivacyBlacklist* _tmp1_;
	GHashTable* _tmp2_;
	GHashTable* _tmp3_;
	GList* _tmp4_;
#line 297 "../src/BlackList.vala"
	g_return_if_fail (self != NULL);
#line 298 "../src/BlackList.vala"
	_tmp0_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 298 "../src/BlackList.vala"
	_g_object_unref0 (self->priv->all_blocked_folder);
#line 298 "../src/BlackList.vala"
	self->priv->all_blocked_folder = _tmp0_;
#line 299 "../src/BlackList.vala"
	_tmp1_ = self->priv->blacklist_interface;
#line 299 "../src/BlackList.vala"
	_tmp2_ = security_privacy_blacklist_get_all_templates (_tmp1_);
#line 299 "../src/BlackList.vala"
	_tmp3_ = _tmp2_;
#line 299 "../src/BlackList.vala"
	_tmp4_ = g_hash_table_get_keys (_tmp3_);
#line 3084 "BlackList.c"
	{
		GList* key_collection = NULL;
		GList* key_it = NULL;
#line 299 "../src/BlackList.vala"
		key_collection = _tmp4_;
#line 299 "../src/BlackList.vala"
		for (key_it = key_collection; key_it != NULL; key_it = key_it->next) {
#line 3092 "BlackList.c"
			gchar* _tmp5_;
			gchar* key = NULL;
#line 299 "../src/BlackList.vala"
			_tmp5_ = g_strdup ((const gchar*) key_it->data);
#line 299 "../src/BlackList.vala"
			key = _tmp5_;
#line 3099 "BlackList.c"
			{
				const gchar* _tmp6_;
				const gchar* _tmp7_;
#line 300 "../src/BlackList.vala"
				_tmp6_ = key;
#line 300 "../src/BlackList.vala"
				_tmp7_ = security_privacy_path_blacklist_folder_prefix;
#line 300 "../src/BlackList.vala"
				if (g_str_has_prefix (_tmp6_, _tmp7_) == TRUE) {
#line 3109 "BlackList.c"
					gchar* folder = NULL;
					SecurityPrivacyBlacklist* _tmp8_;
					GHashTable* _tmp9_;
					GHashTable* _tmp10_;
					const gchar* _tmp11_;
					gconstpointer _tmp12_;
					gchar* _tmp13_;
					const gchar* _tmp14_;
#line 301 "../src/BlackList.vala"
					_tmp8_ = self->priv->blacklist_interface;
#line 301 "../src/BlackList.vala"
					_tmp9_ = security_privacy_blacklist_get_all_templates (_tmp8_);
#line 301 "../src/BlackList.vala"
					_tmp10_ = _tmp9_;
#line 301 "../src/BlackList.vala"
					_tmp11_ = key;
#line 301 "../src/BlackList.vala"
					_tmp12_ = g_hash_table_lookup (_tmp10_, _tmp11_);
#line 301 "../src/BlackList.vala"
					_tmp13_ = security_privacy_path_blacklist_get_folder (self, (ZeitgeistEvent*) _tmp12_);
#line 301 "../src/BlackList.vala"
					folder = _tmp13_;
#line 302 "../src/BlackList.vala"
					_tmp14_ = folder;
#line 302 "../src/BlackList.vala"
					if (_tmp14_ != NULL) {
#line 3136 "BlackList.c"
						GeeHashSet* _tmp15_;
						const gchar* _tmp16_;
#line 303 "../src/BlackList.vala"
						_tmp15_ = self->priv->all_blocked_folder;
#line 303 "../src/BlackList.vala"
						_tmp16_ = folder;
#line 303 "../src/BlackList.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, _tmp16_);
#line 3145 "BlackList.c"
					}
#line 300 "../src/BlackList.vala"
					_g_free0 (folder);
#line 3149 "BlackList.c"
				}
#line 299 "../src/BlackList.vala"
				_g_free0 (key);
#line 3153 "BlackList.c"
			}
		}
#line 299 "../src/BlackList.vala"
		(key_collection == NULL) ? NULL : (key_collection = (g_list_free (key_collection), NULL));
#line 3158 "BlackList.c"
	}
}

static void
security_privacy_path_blacklist_on_blacklist_added (SecurityPrivacyPathBlacklist* self,
                                                    const gchar* blacklist_id,
                                                    ZeitgeistEvent* ev)
{
	const gchar* _tmp0_;
#line 309 "../src/BlackList.vala"
	g_return_if_fail (self != NULL);
#line 309 "../src/BlackList.vala"
	g_return_if_fail (blacklist_id != NULL);
#line 309 "../src/BlackList.vala"
	g_return_if_fail (ev != NULL);
#line 310 "../src/BlackList.vala"
	_tmp0_ = security_privacy_path_blacklist_folder_prefix;
#line 310 "../src/BlackList.vala"
	if (g_str_has_prefix (blacklist_id, _tmp0_)) {
#line 3178 "BlackList.c"
		gchar* uri = NULL;
		gchar* _tmp1_;
		const gchar* _tmp2_;
#line 311 "../src/BlackList.vala"
		_tmp1_ = security_privacy_path_blacklist_get_folder (self, ev);
#line 311 "../src/BlackList.vala"
		uri = _tmp1_;
#line 312 "../src/BlackList.vala"
		_tmp2_ = uri;
#line 312 "../src/BlackList.vala"
		if (_tmp2_ != NULL) {
#line 3190 "BlackList.c"
			const gchar* _tmp3_;
			GeeHashSet* _tmp4_;
			const gchar* _tmp5_;
#line 313 "../src/BlackList.vala"
			_tmp3_ = uri;
#line 313 "../src/BlackList.vala"
			g_signal_emit (self, security_privacy_path_blacklist_signals[SECURITY_PRIVACY_PATH_BLACKLIST_FOLDER_ADDED_SIGNAL], 0, _tmp3_);
#line 314 "../src/BlackList.vala"
			_tmp4_ = self->priv->all_blocked_folder;
#line 314 "../src/BlackList.vala"
			_tmp5_ = uri;
#line 314 "../src/BlackList.vala"
			if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp4_, _tmp5_) == FALSE) {
#line 3204 "BlackList.c"
				GeeHashSet* _tmp6_;
				const gchar* _tmp7_;
#line 315 "../src/BlackList.vala"
				_tmp6_ = self->priv->all_blocked_folder;
#line 315 "../src/BlackList.vala"
				_tmp7_ = uri;
#line 315 "../src/BlackList.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp6_, _tmp7_);
#line 3213 "BlackList.c"
			}
		}
#line 310 "../src/BlackList.vala"
		_g_free0 (uri);
#line 3218 "BlackList.c"
	}
}

static void
security_privacy_path_blacklist_on_blacklist_removed (SecurityPrivacyPathBlacklist* self,
                                                      const gchar* blacklist_id,
                                                      ZeitgeistEvent* ev)
{
	const gchar* _tmp0_;
#line 321 "../src/BlackList.vala"
	g_return_if_fail (self != NULL);
#line 321 "../src/BlackList.vala"
	g_return_if_fail (blacklist_id != NULL);
#line 321 "../src/BlackList.vala"
	g_return_if_fail (ev != NULL);
#line 322 "../src/BlackList.vala"
	_tmp0_ = security_privacy_path_blacklist_folder_prefix;
#line 322 "../src/BlackList.vala"
	if (g_str_has_prefix (blacklist_id, _tmp0_)) {
#line 3238 "BlackList.c"
		gchar* uri = NULL;
		gchar* _tmp1_;
		const gchar* _tmp2_;
#line 323 "../src/BlackList.vala"
		_tmp1_ = security_privacy_path_blacklist_get_folder (self, ev);
#line 323 "../src/BlackList.vala"
		uri = _tmp1_;
#line 324 "../src/BlackList.vala"
		_tmp2_ = uri;
#line 324 "../src/BlackList.vala"
		if (_tmp2_ != NULL) {
#line 3250 "BlackList.c"
			const gchar* _tmp3_;
			GeeHashSet* _tmp4_;
			const gchar* _tmp5_;
#line 325 "../src/BlackList.vala"
			_tmp3_ = uri;
#line 325 "../src/BlackList.vala"
			g_signal_emit (self, security_privacy_path_blacklist_signals[SECURITY_PRIVACY_PATH_BLACKLIST_FOLDER_REMOVED_SIGNAL], 0, _tmp3_);
#line 326 "../src/BlackList.vala"
			_tmp4_ = self->priv->all_blocked_folder;
#line 326 "../src/BlackList.vala"
			_tmp5_ = uri;
#line 326 "../src/BlackList.vala"
			if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp4_, _tmp5_) == TRUE) {
#line 3264 "BlackList.c"
				GeeHashSet* _tmp6_;
				const gchar* _tmp7_;
#line 327 "../src/BlackList.vala"
				_tmp6_ = self->priv->all_blocked_folder;
#line 327 "../src/BlackList.vala"
				_tmp7_ = uri;
#line 327 "../src/BlackList.vala"
				gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp6_, _tmp7_);
#line 3273 "BlackList.c"
			}
		}
#line 322 "../src/BlackList.vala"
		_g_free0 (uri);
#line 3278 "BlackList.c"
	}
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 3301 "BlackList.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 3305 "BlackList.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 3311 "BlackList.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 3315 "BlackList.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 3319 "BlackList.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 3327 "BlackList.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 3355 "BlackList.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 3364 "BlackList.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 3378 "BlackList.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 3387 "BlackList.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 3401 "BlackList.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 3410 "BlackList.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 3419 "BlackList.c"
}

static gchar*
security_privacy_path_blacklist_get_folder (SecurityPrivacyPathBlacklist* self,
                                            ZeitgeistEvent* ev)
{
	ZeitgeistSubject* sub = NULL;
	ZeitgeistSubject* _tmp0_;
	gchar* uri = NULL;
	ZeitgeistSubject* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	GFile* blocked_uri = NULL;
	const gchar* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp8_;
	gchar* result;
#line 333 "../src/BlackList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 333 "../src/BlackList.vala"
	g_return_val_if_fail (ev != NULL, NULL);
#line 334 "../src/BlackList.vala"
	_tmp0_ = zeitgeist_event_get_subject (ev, 0);
#line 334 "../src/BlackList.vala"
	sub = _tmp0_;
#line 335 "../src/BlackList.vala"
	_tmp1_ = sub;
#line 335 "../src/BlackList.vala"
	_tmp2_ = zeitgeist_subject_get_uri (_tmp1_);
#line 335 "../src/BlackList.vala"
	_tmp3_ = _tmp2_;
#line 335 "../src/BlackList.vala"
	_tmp4_ = security_privacy_path_blacklist_suffix;
#line 335 "../src/BlackList.vala"
	_tmp5_ = string_replace (_tmp3_, _tmp4_, "");
#line 335 "../src/BlackList.vala"
	uri = _tmp5_;
#line 336 "../src/BlackList.vala"
	_tmp6_ = uri;
#line 336 "../src/BlackList.vala"
	_tmp7_ = g_file_new_for_uri (_tmp6_);
#line 336 "../src/BlackList.vala"
	blocked_uri = _tmp7_;
#line 337 "../src/BlackList.vala"
	_tmp8_ = blocked_uri;
#line 337 "../src/BlackList.vala"
	if (g_file_query_exists (_tmp8_, NULL) == TRUE) {
#line 3469 "BlackList.c"
		GFile* _tmp9_;
		gchar* _tmp10_;
#line 338 "../src/BlackList.vala"
		_tmp9_ = blocked_uri;
#line 338 "../src/BlackList.vala"
		_tmp10_ = g_file_get_path (_tmp9_);
#line 338 "../src/BlackList.vala"
		result = _tmp10_;
#line 338 "../src/BlackList.vala"
		_g_object_unref0 (blocked_uri);
#line 338 "../src/BlackList.vala"
		_g_free0 (uri);
#line 338 "../src/BlackList.vala"
		_g_object_unref0 (sub);
#line 338 "../src/BlackList.vala"
		return result;
#line 3486 "BlackList.c"
	}
#line 341 "../src/BlackList.vala"
	result = NULL;
#line 341 "../src/BlackList.vala"
	_g_object_unref0 (blocked_uri);
#line 341 "../src/BlackList.vala"
	_g_free0 (uri);
#line 341 "../src/BlackList.vala"
	_g_object_unref0 (sub);
#line 341 "../src/BlackList.vala"
	return result;
#line 3498 "BlackList.c"
}

void
security_privacy_path_blacklist_block (SecurityPrivacyPathBlacklist* self,
                                       const gchar* folder)
{
	ZeitgeistEvent* ev = NULL;
	ZeitgeistEvent* _tmp0_;
	ZeitgeistSubject* sub = NULL;
	ZeitgeistSubject* _tmp1_;
	GFile* block_path = NULL;
	GFile* _tmp2_;
	gchar* uri = NULL;
	GFile* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	ZeitgeistSubject* _tmp9_;
	const gchar* _tmp10_;
	ZeitgeistEvent* _tmp11_;
	ZeitgeistSubject* _tmp12_;
	SecurityPrivacyBlacklist* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	ZeitgeistEvent* _tmp17_;
	GeeHashSet* _tmp18_;
#line 344 "../src/BlackList.vala"
	g_return_if_fail (self != NULL);
#line 344 "../src/BlackList.vala"
	g_return_if_fail (folder != NULL);
#line 345 "../src/BlackList.vala"
	_tmp0_ = zeitgeist_event_new ();
#line 345 "../src/BlackList.vala"
	ev = _tmp0_;
#line 346 "../src/BlackList.vala"
	_tmp1_ = zeitgeist_subject_new ();
#line 346 "../src/BlackList.vala"
	sub = _tmp1_;
#line 348 "../src/BlackList.vala"
	_tmp2_ = g_file_new_for_path (folder);
#line 348 "../src/BlackList.vala"
	block_path = _tmp2_;
#line 349 "../src/BlackList.vala"
	_tmp3_ = block_path;
#line 349 "../src/BlackList.vala"
	_tmp4_ = g_file_get_uri (_tmp3_);
#line 349 "../src/BlackList.vala"
	_tmp5_ = _tmp4_;
#line 349 "../src/BlackList.vala"
	_tmp6_ = security_privacy_path_blacklist_suffix;
#line 349 "../src/BlackList.vala"
	_tmp7_ = g_strdup_printf ("%s%s", _tmp5_, _tmp6_);
#line 349 "../src/BlackList.vala"
	_tmp8_ = _tmp7_;
#line 349 "../src/BlackList.vala"
	_g_free0 (_tmp5_);
#line 349 "../src/BlackList.vala"
	uri = _tmp8_;
#line 350 "../src/BlackList.vala"
	_tmp9_ = sub;
#line 350 "../src/BlackList.vala"
	_tmp10_ = uri;
#line 350 "../src/BlackList.vala"
	zeitgeist_subject_set_uri (_tmp9_, _tmp10_);
#line 351 "../src/BlackList.vala"
	_tmp11_ = ev;
#line 351 "../src/BlackList.vala"
	_tmp12_ = sub;
#line 351 "../src/BlackList.vala"
	zeitgeist_event_add_subject (_tmp11_, _tmp12_);
#line 353 "../src/BlackList.vala"
	_tmp13_ = self->priv->blacklist_interface;
#line 353 "../src/BlackList.vala"
	_tmp14_ = security_privacy_path_blacklist_folder_prefix;
#line 353 "../src/BlackList.vala"
	_tmp15_ = g_strdup_printf ("%s%s", _tmp14_, folder);
#line 353 "../src/BlackList.vala"
	_tmp16_ = _tmp15_;
#line 353 "../src/BlackList.vala"
	_tmp17_ = ev;
#line 353 "../src/BlackList.vala"
	security_privacy_blacklist_add_template (_tmp13_, _tmp16_, _tmp17_);
#line 353 "../src/BlackList.vala"
	_g_free0 (_tmp16_);
#line 355 "../src/BlackList.vala"
	_tmp18_ = self->priv->all_blocked_folder;
#line 355 "../src/BlackList.vala"
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp18_, folder) == FALSE) {
#line 3590 "BlackList.c"
		GeeHashSet* _tmp19_;
#line 356 "../src/BlackList.vala"
		_tmp19_ = self->priv->all_blocked_folder;
#line 356 "../src/BlackList.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp19_, folder);
#line 3596 "BlackList.c"
	}
#line 344 "../src/BlackList.vala"
	_g_free0 (uri);
#line 344 "../src/BlackList.vala"
	_g_object_unref0 (block_path);
#line 344 "../src/BlackList.vala"
	_g_object_unref0 (sub);
#line 344 "../src/BlackList.vala"
	_g_object_unref0 (ev);
#line 3606 "BlackList.c"
}

void
security_privacy_path_blacklist_unblock (SecurityPrivacyPathBlacklist* self,
                                         const gchar* folder)
{
	SecurityPrivacyBlacklist* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GeeHashSet* _tmp4_;
#line 360 "../src/BlackList.vala"
	g_return_if_fail (self != NULL);
#line 360 "../src/BlackList.vala"
	g_return_if_fail (folder != NULL);
#line 361 "../src/BlackList.vala"
	_tmp0_ = self->priv->blacklist_interface;
#line 361 "../src/BlackList.vala"
	_tmp1_ = security_privacy_path_blacklist_folder_prefix;
#line 361 "../src/BlackList.vala"
	_tmp2_ = g_strdup_printf ("%s%s", _tmp1_, folder);
#line 361 "../src/BlackList.vala"
	_tmp3_ = _tmp2_;
#line 361 "../src/BlackList.vala"
	security_privacy_blacklist_remove_template (_tmp0_, _tmp3_);
#line 361 "../src/BlackList.vala"
	_g_free0 (_tmp3_);
#line 362 "../src/BlackList.vala"
	_tmp4_ = self->priv->all_blocked_folder;
#line 362 "../src/BlackList.vala"
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp4_, folder) == TRUE) {
#line 3638 "BlackList.c"
		GeeHashSet* _tmp5_;
#line 363 "../src/BlackList.vala"
		_tmp5_ = self->priv->all_blocked_folder;
#line 363 "../src/BlackList.vala"
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp5_, folder);
#line 3644 "BlackList.c"
	}
}

GeeHashSet*
security_privacy_path_blacklist_get_all_folders (SecurityPrivacyPathBlacklist* self)
{
	GeeHashSet* result;
	GeeHashSet* _tmp0_;
#line 288 "../src/BlackList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 289 "../src/BlackList.vala"
	_tmp0_ = self->priv->all_blocked_folder;
#line 289 "../src/BlackList.vala"
	result = _tmp0_;
#line 289 "../src/BlackList.vala"
	return result;
#line 3661 "BlackList.c"
}

static void
security_privacy_value_path_blacklist_init (GValue* value)
{
#line 270 "../src/BlackList.vala"
	value->data[0].v_pointer = NULL;
#line 3669 "BlackList.c"
}

static void
security_privacy_value_path_blacklist_free_value (GValue* value)
{
#line 270 "../src/BlackList.vala"
	if (value->data[0].v_pointer) {
#line 270 "../src/BlackList.vala"
		security_privacy_path_blacklist_unref (value->data[0].v_pointer);
#line 3679 "BlackList.c"
	}
}

static void
security_privacy_value_path_blacklist_copy_value (const GValue* src_value,
                                                  GValue* dest_value)
{
#line 270 "../src/BlackList.vala"
	if (src_value->data[0].v_pointer) {
#line 270 "../src/BlackList.vala"
		dest_value->data[0].v_pointer = security_privacy_path_blacklist_ref (src_value->data[0].v_pointer);
#line 3691 "BlackList.c"
	} else {
#line 270 "../src/BlackList.vala"
		dest_value->data[0].v_pointer = NULL;
#line 3695 "BlackList.c"
	}
}

static gpointer
security_privacy_value_path_blacklist_peek_pointer (const GValue* value)
{
#line 270 "../src/BlackList.vala"
	return value->data[0].v_pointer;
#line 3704 "BlackList.c"
}

static gchar*
security_privacy_value_path_blacklist_collect_value (GValue* value,
                                                     guint n_collect_values,
                                                     GTypeCValue* collect_values,
                                                     guint collect_flags)
{
#line 270 "../src/BlackList.vala"
	if (collect_values[0].v_pointer) {
#line 3715 "BlackList.c"
		SecurityPrivacyPathBlacklist * object;
		object = collect_values[0].v_pointer;
#line 270 "../src/BlackList.vala"
		if (object->parent_instance.g_class == NULL) {
#line 270 "../src/BlackList.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3722 "BlackList.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 270 "../src/BlackList.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3726 "BlackList.c"
		}
#line 270 "../src/BlackList.vala"
		value->data[0].v_pointer = security_privacy_path_blacklist_ref (object);
#line 3730 "BlackList.c"
	} else {
#line 270 "../src/BlackList.vala"
		value->data[0].v_pointer = NULL;
#line 3734 "BlackList.c"
	}
#line 270 "../src/BlackList.vala"
	return NULL;
#line 3738 "BlackList.c"
}

static gchar*
security_privacy_value_path_blacklist_lcopy_value (const GValue* value,
                                                   guint n_collect_values,
                                                   GTypeCValue* collect_values,
                                                   guint collect_flags)
{
	SecurityPrivacyPathBlacklist ** object_p;
	object_p = collect_values[0].v_pointer;
#line 270 "../src/BlackList.vala"
	if (!object_p) {
#line 270 "../src/BlackList.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 3753 "BlackList.c"
	}
#line 270 "../src/BlackList.vala"
	if (!value->data[0].v_pointer) {
#line 270 "../src/BlackList.vala"
		*object_p = NULL;
#line 3759 "BlackList.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 270 "../src/BlackList.vala"
		*object_p = value->data[0].v_pointer;
#line 3763 "BlackList.c"
	} else {
#line 270 "../src/BlackList.vala"
		*object_p = security_privacy_path_blacklist_ref (value->data[0].v_pointer);
#line 3767 "BlackList.c"
	}
#line 270 "../src/BlackList.vala"
	return NULL;
#line 3771 "BlackList.c"
}

GParamSpec*
security_privacy_param_spec_path_blacklist (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags)
{
	SecurityPrivacyParamSpecPathBlacklist* spec;
#line 270 "../src/BlackList.vala"
	g_return_val_if_fail (g_type_is_a (object_type, SECURITY_PRIVACY_TYPE_PATH_BLACKLIST), NULL);
#line 270 "../src/BlackList.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 270 "../src/BlackList.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 270 "../src/BlackList.vala"
	return G_PARAM_SPEC (spec);
#line 3790 "BlackList.c"
}

gpointer
security_privacy_value_get_path_blacklist (const GValue* value)
{
#line 270 "../src/BlackList.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SECURITY_PRIVACY_TYPE_PATH_BLACKLIST), NULL);
#line 270 "../src/BlackList.vala"
	return value->data[0].v_pointer;
#line 3800 "BlackList.c"
}

void
security_privacy_value_set_path_blacklist (GValue* value,
                                           gpointer v_object)
{
	SecurityPrivacyPathBlacklist * old;
#line 270 "../src/BlackList.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SECURITY_PRIVACY_TYPE_PATH_BLACKLIST));
#line 270 "../src/BlackList.vala"
	old = value->data[0].v_pointer;
#line 270 "../src/BlackList.vala"
	if (v_object) {
#line 270 "../src/BlackList.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, SECURITY_PRIVACY_TYPE_PATH_BLACKLIST));
#line 270 "../src/BlackList.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 270 "../src/BlackList.vala"
		value->data[0].v_pointer = v_object;
#line 270 "../src/BlackList.vala"
		security_privacy_path_blacklist_ref (value->data[0].v_pointer);
#line 3822 "BlackList.c"
	} else {
#line 270 "../src/BlackList.vala"
		value->data[0].v_pointer = NULL;
#line 3826 "BlackList.c"
	}
#line 270 "../src/BlackList.vala"
	if (old) {
#line 270 "../src/BlackList.vala"
		security_privacy_path_blacklist_unref (old);
#line 3832 "BlackList.c"
	}
}

void
security_privacy_value_take_path_blacklist (GValue* value,
                                            gpointer v_object)
{
	SecurityPrivacyPathBlacklist * old;
#line 270 "../src/BlackList.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SECURITY_PRIVACY_TYPE_PATH_BLACKLIST));
#line 270 "../src/BlackList.vala"
	old = value->data[0].v_pointer;
#line 270 "../src/BlackList.vala"
	if (v_object) {
#line 270 "../src/BlackList.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, SECURITY_PRIVACY_TYPE_PATH_BLACKLIST));
#line 270 "../src/BlackList.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 270 "../src/BlackList.vala"
		value->data[0].v_pointer = v_object;
#line 3853 "BlackList.c"
	} else {
#line 270 "../src/BlackList.vala"
		value->data[0].v_pointer = NULL;
#line 3857 "BlackList.c"
	}
#line 270 "../src/BlackList.vala"
	if (old) {
#line 270 "../src/BlackList.vala"
		security_privacy_path_blacklist_unref (old);
#line 3863 "BlackList.c"
	}
}

static void
security_privacy_path_blacklist_class_init (SecurityPrivacyPathBlacklistClass * klass,
                                            gpointer klass_data)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 270 "../src/BlackList.vala"
	security_privacy_path_blacklist_parent_class = g_type_class_peek_parent (klass);
#line 270 "../src/BlackList.vala"
	((SecurityPrivacyPathBlacklistClass *) klass)->finalize = security_privacy_path_blacklist_finalize;
#line 270 "../src/BlackList.vala"
	g_type_class_adjust_private_offset (klass, &SecurityPrivacyPathBlacklist_private_offset);
#line 270 "../src/BlackList.vala"
	security_privacy_path_blacklist_signals[SECURITY_PRIVACY_PATH_BLACKLIST_FOLDER_ADDED_SIGNAL] = g_signal_new ("folder-added", SECURITY_PRIVACY_TYPE_PATH_BLACKLIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 270 "../src/BlackList.vala"
	security_privacy_path_blacklist_signals[SECURITY_PRIVACY_PATH_BLACKLIST_FOLDER_REMOVED_SIGNAL] = g_signal_new ("folder-removed", SECURITY_PRIVACY_TYPE_PATH_BLACKLIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 274 "../src/BlackList.vala"
	_tmp0_ = g_strdup ("dir-");
#line 274 "../src/BlackList.vala"
	security_privacy_path_blacklist_folder_prefix = _tmp0_;
#line 275 "../src/BlackList.vala"
	_tmp1_ = g_strdup ("/*");
#line 275 "../src/BlackList.vala"
	security_privacy_path_blacklist_suffix = _tmp1_;
#line 3891 "BlackList.c"
}

static void
security_privacy_path_blacklist_instance_init (SecurityPrivacyPathBlacklist * self,
                                               gpointer klass)
{
#line 270 "../src/BlackList.vala"
	self->priv = security_privacy_path_blacklist_get_instance_private (self);
#line 270 "../src/BlackList.vala"
	self->ref_count = 1;
#line 3902 "BlackList.c"
}

static void
security_privacy_path_blacklist_finalize (SecurityPrivacyPathBlacklist * obj)
{
	SecurityPrivacyPathBlacklist * self;
#line 270 "../src/BlackList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SECURITY_PRIVACY_TYPE_PATH_BLACKLIST, SecurityPrivacyPathBlacklist);
#line 270 "../src/BlackList.vala"
	g_signal_handlers_destroy (self);
#line 277 "../src/BlackList.vala"
	_security_privacy_blacklist_unref0 (self->priv->blacklist_interface);
#line 278 "../src/BlackList.vala"
	_g_object_unref0 (self->priv->all_blocked_folder);
#line 3917 "BlackList.c"
}

static GType
security_privacy_path_blacklist_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { security_privacy_value_path_blacklist_init, security_privacy_value_path_blacklist_free_value, security_privacy_value_path_blacklist_copy_value, security_privacy_value_path_blacklist_peek_pointer, "p", security_privacy_value_path_blacklist_collect_value, "p", security_privacy_value_path_blacklist_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (SecurityPrivacyPathBlacklistClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) security_privacy_path_blacklist_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SecurityPrivacyPathBlacklist), 0, (GInstanceInitFunc) security_privacy_path_blacklist_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType security_privacy_path_blacklist_type_id;
	security_privacy_path_blacklist_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SecurityPrivacyPathBlacklist", &g_define_type_info, &g_define_type_fundamental_info, 0);
	SecurityPrivacyPathBlacklist_private_offset = g_type_add_instance_private (security_privacy_path_blacklist_type_id, sizeof (SecurityPrivacyPathBlacklistPrivate));
	return security_privacy_path_blacklist_type_id;
}

GType
security_privacy_path_blacklist_get_type (void)
{
	static volatile gsize security_privacy_path_blacklist_type_id__once = 0;
	if (g_once_init_enter (&security_privacy_path_blacklist_type_id__once)) {
		GType security_privacy_path_blacklist_type_id;
		security_privacy_path_blacklist_type_id = security_privacy_path_blacklist_get_type_once ();
		g_once_init_leave (&security_privacy_path_blacklist_type_id__once, security_privacy_path_blacklist_type_id);
	}
	return security_privacy_path_blacklist_type_id__once;
}

gpointer
security_privacy_path_blacklist_ref (gpointer instance)
{
	SecurityPrivacyPathBlacklist * self;
	self = instance;
#line 270 "../src/BlackList.vala"
	g_atomic_int_inc (&self->ref_count);
#line 270 "../src/BlackList.vala"
	return instance;
#line 3953 "BlackList.c"
}

void
security_privacy_path_blacklist_unref (gpointer instance)
{
	SecurityPrivacyPathBlacklist * self;
	self = instance;
#line 270 "../src/BlackList.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 270 "../src/BlackList.vala"
		SECURITY_PRIVACY_PATH_BLACKLIST_GET_CLASS (self)->finalize (self);
#line 270 "../src/BlackList.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 3967 "BlackList.c"
	}
}

static inline gpointer
security_privacy_application_blacklist_get_instance_private (SecurityPrivacyApplicationBlacklist* self)
{
	return G_STRUCT_MEMBER_P (self, SecurityPrivacyApplicationBlacklist_private_offset);
}

static void
_security_privacy_application_blacklist_on_blacklist_added_security_privacy_blacklist_template_added (SecurityPrivacyBlacklist* _sender,
                                                                                                      const gchar* blacklist_id,
                                                                                                      ZeitgeistEvent* blacklist_template,
                                                                                                      gpointer self)
{
#line 380 "../src/BlackList.vala"
	security_privacy_application_blacklist_on_blacklist_added ((SecurityPrivacyApplicationBlacklist*) self, blacklist_id, blacklist_template);
#line 3985 "BlackList.c"
}

static void
_security_privacy_application_blacklist_on_blacklist_removed_security_privacy_blacklist_template_removed (SecurityPrivacyBlacklist* _sender,
                                                                                                          const gchar* blacklist_id,
                                                                                                          ZeitgeistEvent* blacklist_template,
                                                                                                          gpointer self)
{
#line 381 "../src/BlackList.vala"
	security_privacy_application_blacklist_on_blacklist_removed ((SecurityPrivacyApplicationBlacklist*) self, blacklist_id, blacklist_template);
#line 3996 "BlackList.c"
}

SecurityPrivacyApplicationBlacklist*
security_privacy_application_blacklist_construct (GType object_type,
                                                  SecurityPrivacyBlacklist* blacklist)
{
	SecurityPrivacyApplicationBlacklist* self = NULL;
	SecurityPrivacyBlacklist* _tmp0_;
	SecurityPrivacyBlacklist* _tmp1_;
	SecurityPrivacyBlacklist* _tmp2_;
	GeeHashSet* _tmp3_;
	GeeHashSet* _tmp4_;
#line 378 "../src/BlackList.vala"
	g_return_val_if_fail (blacklist != NULL, NULL);
#line 378 "../src/BlackList.vala"
	self = (SecurityPrivacyApplicationBlacklist*) g_type_create_instance (object_type);
#line 379 "../src/BlackList.vala"
	_tmp0_ = _security_privacy_blacklist_ref0 (blacklist);
#line 379 "../src/BlackList.vala"
	_security_privacy_blacklist_unref0 (self->priv->blacklist_interface);
#line 379 "../src/BlackList.vala"
	self->priv->blacklist_interface = _tmp0_;
#line 380 "../src/BlackList.vala"
	_tmp1_ = self->priv->blacklist_interface;
#line 380 "../src/BlackList.vala"
	g_signal_connect (_tmp1_, "template-added", (GCallback) _security_privacy_application_blacklist_on_blacklist_added_security_privacy_blacklist_template_added, self);
#line 381 "../src/BlackList.vala"
	_tmp2_ = self->priv->blacklist_interface;
#line 381 "../src/BlackList.vala"
	g_signal_connect (_tmp2_, "template-removed", (GCallback) _security_privacy_application_blacklist_on_blacklist_removed_security_privacy_blacklist_template_removed, self);
#line 382 "../src/BlackList.vala"
	_tmp3_ = security_privacy_application_blacklist_get_blocked_apps (self);
#line 382 "../src/BlackList.vala"
	_tmp4_ = _tmp3_;
#line 382 "../src/BlackList.vala"
	_g_object_unref0 (_tmp4_);
#line 378 "../src/BlackList.vala"
	return self;
#line 4035 "BlackList.c"
}

SecurityPrivacyApplicationBlacklist*
security_privacy_application_blacklist_new (SecurityPrivacyBlacklist* blacklist)
{
#line 378 "../src/BlackList.vala"
	return security_privacy_application_blacklist_construct (SECURITY_PRIVACY_TYPE_APPLICATION_BLACKLIST, blacklist);
#line 4043 "BlackList.c"
}

void
security_privacy_application_blacklist_get_count_for_app (SecurityPrivacyApplicationBlacklist* self,
                                                          const gchar* id,
                                                          GtkTreeIter* iter,
                                                          GtkListStore* store)
{
	SecurityPrivacyBlacklist* _tmp0_;
	GtkTreeIter _tmp1_;
#line 391 "../src/BlackList.vala"
	g_return_if_fail (self != NULL);
#line 391 "../src/BlackList.vala"
	g_return_if_fail (id != NULL);
#line 391 "../src/BlackList.vala"
	g_return_if_fail (iter != NULL);
#line 391 "../src/BlackList.vala"
	g_return_if_fail (store != NULL);
#line 392 "../src/BlackList.vala"
	_tmp0_ = self->priv->blacklist_interface;
#line 392 "../src/BlackList.vala"
	_tmp1_ = *iter;
#line 392 "../src/BlackList.vala"
	security_privacy_blacklist_get_count_for_app (_tmp0_, id, &_tmp1_, store);
#line 4068 "BlackList.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 4091 "BlackList.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 4100 "BlackList.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 4119 "BlackList.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 4123 "BlackList.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 4129 "BlackList.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 4139 "BlackList.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 4147 "BlackList.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 4151 "BlackList.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 4157 "BlackList.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 4167 "BlackList.c"
}

static GeeHashSet*
security_privacy_application_blacklist_get_blocked_apps (SecurityPrivacyApplicationBlacklist* self)
{
	GeeHashSet* _tmp0_;
	SecurityPrivacyBlacklist* _tmp1_;
	GHashTable* _tmp2_;
	GHashTable* _tmp3_;
	GList* _tmp4_;
	GeeHashSet* _tmp12_;
	GeeHashSet* _tmp13_;
	GeeHashSet* result;
#line 395 "../src/BlackList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 396 "../src/BlackList.vala"
	_tmp0_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 396 "../src/BlackList.vala"
	_g_object_unref0 (self->priv->all_blocked_apps);
#line 396 "../src/BlackList.vala"
	self->priv->all_blocked_apps = _tmp0_;
#line 397 "../src/BlackList.vala"
	_tmp1_ = self->priv->blacklist_interface;
#line 397 "../src/BlackList.vala"
	_tmp2_ = security_privacy_blacklist_get_all_templates (_tmp1_);
#line 397 "../src/BlackList.vala"
	_tmp3_ = _tmp2_;
#line 397 "../src/BlackList.vala"
	_tmp4_ = g_hash_table_get_keys (_tmp3_);
#line 4197 "BlackList.c"
	{
		GList* key_collection = NULL;
		GList* key_it = NULL;
#line 397 "../src/BlackList.vala"
		key_collection = _tmp4_;
#line 397 "../src/BlackList.vala"
		for (key_it = key_collection; key_it != NULL; key_it = key_it->next) {
#line 4205 "BlackList.c"
			gchar* _tmp5_;
			gchar* key = NULL;
#line 397 "../src/BlackList.vala"
			_tmp5_ = g_strdup ((const gchar*) key_it->data);
#line 397 "../src/BlackList.vala"
			key = _tmp5_;
#line 4212 "BlackList.c"
			{
				const gchar* _tmp6_;
				const gchar* _tmp7_;
#line 398 "../src/BlackList.vala"
				_tmp6_ = key;
#line 398 "../src/BlackList.vala"
				_tmp7_ = security_privacy_application_blacklist_interpretation_prefix;
#line 398 "../src/BlackList.vala"
				if (g_str_has_prefix (_tmp6_, _tmp7_) == TRUE) {
#line 4222 "BlackList.c"
					gchar* app = NULL;
					const gchar* _tmp8_;
					gchar* _tmp9_;
					GeeHashSet* _tmp10_;
					const gchar* _tmp11_;
#line 399 "../src/BlackList.vala"
					_tmp8_ = key;
#line 399 "../src/BlackList.vala"
					_tmp9_ = string_substring (_tmp8_, (glong) 4, (glong) -1);
#line 399 "../src/BlackList.vala"
					app = _tmp9_;
#line 400 "../src/BlackList.vala"
					_tmp10_ = self->priv->all_blocked_apps;
#line 400 "../src/BlackList.vala"
					_tmp11_ = app;
#line 400 "../src/BlackList.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp11_);
#line 398 "../src/BlackList.vala"
					_g_free0 (app);
#line 4242 "BlackList.c"
				}
#line 397 "../src/BlackList.vala"
				_g_free0 (key);
#line 4246 "BlackList.c"
			}
		}
#line 397 "../src/BlackList.vala"
		(key_collection == NULL) ? NULL : (key_collection = (g_list_free (key_collection), NULL));
#line 4251 "BlackList.c"
	}
#line 404 "../src/BlackList.vala"
	_tmp12_ = self->priv->all_blocked_apps;
#line 404 "../src/BlackList.vala"
	_tmp13_ = _g_object_ref0 (_tmp12_);
#line 404 "../src/BlackList.vala"
	result = _tmp13_;
#line 404 "../src/BlackList.vala"
	return result;
#line 4261 "BlackList.c"
}

static void
security_privacy_application_blacklist_on_blacklist_added (SecurityPrivacyApplicationBlacklist* self,
                                                           const gchar* blacklist_id,
                                                           ZeitgeistEvent* ev)
{
	const gchar* _tmp0_;
#line 407 "../src/BlackList.vala"
	g_return_if_fail (self != NULL);
#line 407 "../src/BlackList.vala"
	g_return_if_fail (blacklist_id != NULL);
#line 407 "../src/BlackList.vala"
	g_return_if_fail (ev != NULL);
#line 408 "../src/BlackList.vala"
	_tmp0_ = security_privacy_application_blacklist_interpretation_prefix;
#line 408 "../src/BlackList.vala"
	if (g_str_has_prefix (blacklist_id, _tmp0_) == TRUE) {
#line 4280 "BlackList.c"
		gchar* app = NULL;
		gchar* _tmp1_;
		const gchar* _tmp2_;
		GeeHashSet* _tmp3_;
		GeeHashSet* _tmp4_;
		const gchar* _tmp5_;
#line 409 "../src/BlackList.vala"
		_tmp1_ = string_substring (blacklist_id, (glong) 4, (glong) -1);
#line 409 "../src/BlackList.vala"
		app = _tmp1_;
#line 410 "../src/BlackList.vala"
		_tmp2_ = app;
#line 410 "../src/BlackList.vala"
		g_signal_emit (self, security_privacy_application_blacklist_signals[SECURITY_PRIVACY_APPLICATION_BLACKLIST_APPLICATION_ADDED_SIGNAL], 0, _tmp2_, ev);
#line 411 "../src/BlackList.vala"
		_tmp3_ = security_privacy_application_blacklist_get_all_apps (self);
#line 411 "../src/BlackList.vala"
		_tmp4_ = _tmp3_;
#line 411 "../src/BlackList.vala"
		_tmp5_ = app;
#line 411 "../src/BlackList.vala"
		if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp4_, _tmp5_) == FALSE) {
#line 4303 "BlackList.c"
			GeeHashSet* _tmp6_;
			GeeHashSet* _tmp7_;
			const gchar* _tmp8_;
#line 412 "../src/BlackList.vala"
			_tmp6_ = security_privacy_application_blacklist_get_all_apps (self);
#line 412 "../src/BlackList.vala"
			_tmp7_ = _tmp6_;
#line 412 "../src/BlackList.vala"
			_tmp8_ = app;
#line 412 "../src/BlackList.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp7_, _tmp8_);
#line 4315 "BlackList.c"
		}
#line 408 "../src/BlackList.vala"
		_g_free0 (app);
#line 4319 "BlackList.c"
	}
}

static void
security_privacy_application_blacklist_on_blacklist_removed (SecurityPrivacyApplicationBlacklist* self,
                                                             const gchar* blacklist_id,
                                                             ZeitgeistEvent* ev)
{
	const gchar* _tmp0_;
#line 417 "../src/BlackList.vala"
	g_return_if_fail (self != NULL);
#line 417 "../src/BlackList.vala"
	g_return_if_fail (blacklist_id != NULL);
#line 417 "../src/BlackList.vala"
	g_return_if_fail (ev != NULL);
#line 418 "../src/BlackList.vala"
	_tmp0_ = security_privacy_application_blacklist_interpretation_prefix;
#line 418 "../src/BlackList.vala"
	if (g_str_has_prefix (blacklist_id, _tmp0_) == TRUE) {
#line 4339 "BlackList.c"
		gchar* app = NULL;
		gchar* _tmp1_;
		const gchar* _tmp2_;
		GeeHashSet* _tmp3_;
		GeeHashSet* _tmp4_;
		const gchar* _tmp5_;
#line 419 "../src/BlackList.vala"
		_tmp1_ = string_substring (blacklist_id, (glong) 4, (glong) -1);
#line 419 "../src/BlackList.vala"
		app = _tmp1_;
#line 420 "../src/BlackList.vala"
		_tmp2_ = app;
#line 420 "../src/BlackList.vala"
		g_signal_emit (self, security_privacy_application_blacklist_signals[SECURITY_PRIVACY_APPLICATION_BLACKLIST_APPLICATION_REMOVED_SIGNAL], 0, _tmp2_, ev);
#line 421 "../src/BlackList.vala"
		_tmp3_ = security_privacy_application_blacklist_get_all_apps (self);
#line 421 "../src/BlackList.vala"
		_tmp4_ = _tmp3_;
#line 421 "../src/BlackList.vala"
		_tmp5_ = app;
#line 421 "../src/BlackList.vala"
		if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp4_, _tmp5_) == TRUE) {
#line 4362 "BlackList.c"
			GeeHashSet* _tmp6_;
			GeeHashSet* _tmp7_;
			const gchar* _tmp8_;
#line 422 "../src/BlackList.vala"
			_tmp6_ = security_privacy_application_blacklist_get_all_apps (self);
#line 422 "../src/BlackList.vala"
			_tmp7_ = _tmp6_;
#line 422 "../src/BlackList.vala"
			_tmp8_ = app;
#line 422 "../src/BlackList.vala"
			gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp7_, _tmp8_);
#line 4374 "BlackList.c"
		}
#line 418 "../src/BlackList.vala"
		_g_free0 (app);
#line 4378 "BlackList.c"
	}
}

void
security_privacy_application_blacklist_block (SecurityPrivacyApplicationBlacklist* self,
                                              const gchar* application)
{
	ZeitgeistEvent* ev = NULL;
	ZeitgeistEvent* _tmp0_;
	ZeitgeistEvent* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	ZeitgeistSubject* sub = NULL;
	ZeitgeistSubject* _tmp4_;
	ZeitgeistEvent* _tmp5_;
	ZeitgeistSubject* _tmp6_;
	ZeitgeistEvent* launch_ev = NULL;
	ZeitgeistEvent* _tmp7_;
	ZeitgeistSubject* launch_sub = NULL;
	ZeitgeistSubject* _tmp8_;
	ZeitgeistSubject* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	ZeitgeistEvent* _tmp12_;
	ZeitgeistSubject* _tmp13_;
	SecurityPrivacyBlacklist* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	ZeitgeistEvent* _tmp18_;
	SecurityPrivacyBlacklist* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	ZeitgeistEvent* _tmp23_;
	GeeHashSet* _tmp24_;
	GeeHashSet* _tmp25_;
#line 427 "../src/BlackList.vala"
	g_return_if_fail (self != NULL);
#line 427 "../src/BlackList.vala"
	g_return_if_fail (application != NULL);
#line 428 "../src/BlackList.vala"
	_tmp0_ = zeitgeist_event_new ();
#line 428 "../src/BlackList.vala"
	ev = _tmp0_;
#line 429 "../src/BlackList.vala"
	_tmp1_ = ev;
#line 429 "../src/BlackList.vala"
	_tmp2_ = g_strdup_printf ("application://%s", application);
#line 429 "../src/BlackList.vala"
	_tmp3_ = _tmp2_;
#line 429 "../src/BlackList.vala"
	zeitgeist_event_set_actor (_tmp1_, _tmp3_);
#line 429 "../src/BlackList.vala"
	_g_free0 (_tmp3_);
#line 430 "../src/BlackList.vala"
	_tmp4_ = zeitgeist_subject_new ();
#line 430 "../src/BlackList.vala"
	sub = _tmp4_;
#line 431 "../src/BlackList.vala"
	_tmp5_ = ev;
#line 431 "../src/BlackList.vala"
	_tmp6_ = sub;
#line 431 "../src/BlackList.vala"
	zeitgeist_event_add_subject (_tmp5_, _tmp6_);
#line 433 "../src/BlackList.vala"
	_tmp7_ = zeitgeist_event_new ();
#line 433 "../src/BlackList.vala"
	launch_ev = _tmp7_;
#line 434 "../src/BlackList.vala"
	_tmp8_ = zeitgeist_subject_new ();
#line 434 "../src/BlackList.vala"
	launch_sub = _tmp8_;
#line 435 "../src/BlackList.vala"
	_tmp9_ = launch_sub;
#line 435 "../src/BlackList.vala"
	_tmp10_ = g_strdup_printf ("application://%s", application);
#line 435 "../src/BlackList.vala"
	_tmp11_ = _tmp10_;
#line 435 "../src/BlackList.vala"
	zeitgeist_subject_set_uri (_tmp9_, _tmp11_);
#line 435 "../src/BlackList.vala"
	_g_free0 (_tmp11_);
#line 436 "../src/BlackList.vala"
	_tmp12_ = launch_ev;
#line 436 "../src/BlackList.vala"
	_tmp13_ = launch_sub;
#line 436 "../src/BlackList.vala"
	zeitgeist_event_add_subject (_tmp12_, _tmp13_);
#line 438 "../src/BlackList.vala"
	_tmp14_ = self->priv->blacklist_interface;
#line 438 "../src/BlackList.vala"
	_tmp15_ = security_privacy_application_blacklist_interpretation_prefix;
#line 438 "../src/BlackList.vala"
	_tmp16_ = g_strdup_printf ("%s%s", _tmp15_, application);
#line 438 "../src/BlackList.vala"
	_tmp17_ = _tmp16_;
#line 438 "../src/BlackList.vala"
	_tmp18_ = ev;
#line 438 "../src/BlackList.vala"
	security_privacy_blacklist_add_template (_tmp14_, _tmp17_, _tmp18_);
#line 438 "../src/BlackList.vala"
	_g_free0 (_tmp17_);
#line 439 "../src/BlackList.vala"
	_tmp19_ = self->priv->blacklist_interface;
#line 439 "../src/BlackList.vala"
	_tmp20_ = security_privacy_application_blacklist_launcher_prefix;
#line 439 "../src/BlackList.vala"
	_tmp21_ = g_strdup_printf ("%s%s", _tmp20_, application);
#line 439 "../src/BlackList.vala"
	_tmp22_ = _tmp21_;
#line 439 "../src/BlackList.vala"
	_tmp23_ = launch_ev;
#line 439 "../src/BlackList.vala"
	security_privacy_blacklist_add_template (_tmp19_, _tmp22_, _tmp23_);
#line 439 "../src/BlackList.vala"
	_g_free0 (_tmp22_);
#line 440 "../src/BlackList.vala"
	_tmp24_ = security_privacy_application_blacklist_get_all_apps (self);
#line 440 "../src/BlackList.vala"
	_tmp25_ = _tmp24_;
#line 440 "../src/BlackList.vala"
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp25_, application) == FALSE) {
#line 4502 "BlackList.c"
		GeeHashSet* _tmp26_;
		GeeHashSet* _tmp27_;
#line 441 "../src/BlackList.vala"
		_tmp26_ = security_privacy_application_blacklist_get_all_apps (self);
#line 441 "../src/BlackList.vala"
		_tmp27_ = _tmp26_;
#line 441 "../src/BlackList.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp27_, application);
#line 4511 "BlackList.c"
	}
#line 427 "../src/BlackList.vala"
	_g_object_unref0 (launch_sub);
#line 427 "../src/BlackList.vala"
	_g_object_unref0 (launch_ev);
#line 427 "../src/BlackList.vala"
	_g_object_unref0 (sub);
#line 427 "../src/BlackList.vala"
	_g_object_unref0 (ev);
#line 4521 "BlackList.c"
}

void
security_privacy_application_blacklist_unblock (SecurityPrivacyApplicationBlacklist* self,
                                                const gchar* application)
{
	SecurityPrivacyBlacklist* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	SecurityPrivacyBlacklist* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GeeHashSet* _tmp8_;
	GeeHashSet* _tmp9_;
#line 445 "../src/BlackList.vala"
	g_return_if_fail (self != NULL);
#line 445 "../src/BlackList.vala"
	g_return_if_fail (application != NULL);
#line 446 "../src/BlackList.vala"
	_tmp0_ = self->priv->blacklist_interface;
#line 446 "../src/BlackList.vala"
	_tmp1_ = security_privacy_application_blacklist_interpretation_prefix;
#line 446 "../src/BlackList.vala"
	_tmp2_ = g_strdup_printf ("%s%s", _tmp1_, application);
#line 446 "../src/BlackList.vala"
	_tmp3_ = _tmp2_;
#line 446 "../src/BlackList.vala"
	security_privacy_blacklist_remove_template (_tmp0_, _tmp3_);
#line 446 "../src/BlackList.vala"
	_g_free0 (_tmp3_);
#line 447 "../src/BlackList.vala"
	_tmp4_ = self->priv->blacklist_interface;
#line 447 "../src/BlackList.vala"
	_tmp5_ = security_privacy_application_blacklist_launcher_prefix;
#line 447 "../src/BlackList.vala"
	_tmp6_ = g_strdup_printf ("%s%s", _tmp5_, application);
#line 447 "../src/BlackList.vala"
	_tmp7_ = _tmp6_;
#line 447 "../src/BlackList.vala"
	security_privacy_blacklist_remove_template (_tmp4_, _tmp7_);
#line 447 "../src/BlackList.vala"
	_g_free0 (_tmp7_);
#line 449 "../src/BlackList.vala"
	_tmp8_ = security_privacy_application_blacklist_get_all_apps (self);
#line 449 "../src/BlackList.vala"
	_tmp9_ = _tmp8_;
#line 449 "../src/BlackList.vala"
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp9_, application) == TRUE) {
#line 4572 "BlackList.c"
		GeeHashSet* _tmp10_;
		GeeHashSet* _tmp11_;
#line 450 "../src/BlackList.vala"
		_tmp10_ = security_privacy_application_blacklist_get_all_apps (self);
#line 450 "../src/BlackList.vala"
		_tmp11_ = _tmp10_;
#line 450 "../src/BlackList.vala"
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp11_, application);
#line 4581 "BlackList.c"
	}
}

GeeHashSet*
security_privacy_application_blacklist_get_all_apps (SecurityPrivacyApplicationBlacklist* self)
{
	GeeHashSet* result;
	GeeHashSet* _tmp0_;
#line 386 "../src/BlackList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 387 "../src/BlackList.vala"
	_tmp0_ = self->priv->all_blocked_apps;
#line 387 "../src/BlackList.vala"
	result = _tmp0_;
#line 387 "../src/BlackList.vala"
	return result;
#line 4598 "BlackList.c"
}

static void
security_privacy_value_application_blacklist_init (GValue* value)
{
#line 368 "../src/BlackList.vala"
	value->data[0].v_pointer = NULL;
#line 4606 "BlackList.c"
}

static void
security_privacy_value_application_blacklist_free_value (GValue* value)
{
#line 368 "../src/BlackList.vala"
	if (value->data[0].v_pointer) {
#line 368 "../src/BlackList.vala"
		security_privacy_application_blacklist_unref (value->data[0].v_pointer);
#line 4616 "BlackList.c"
	}
}

static void
security_privacy_value_application_blacklist_copy_value (const GValue* src_value,
                                                         GValue* dest_value)
{
#line 368 "../src/BlackList.vala"
	if (src_value->data[0].v_pointer) {
#line 368 "../src/BlackList.vala"
		dest_value->data[0].v_pointer = security_privacy_application_blacklist_ref (src_value->data[0].v_pointer);
#line 4628 "BlackList.c"
	} else {
#line 368 "../src/BlackList.vala"
		dest_value->data[0].v_pointer = NULL;
#line 4632 "BlackList.c"
	}
}

static gpointer
security_privacy_value_application_blacklist_peek_pointer (const GValue* value)
{
#line 368 "../src/BlackList.vala"
	return value->data[0].v_pointer;
#line 4641 "BlackList.c"
}

static gchar*
security_privacy_value_application_blacklist_collect_value (GValue* value,
                                                            guint n_collect_values,
                                                            GTypeCValue* collect_values,
                                                            guint collect_flags)
{
#line 368 "../src/BlackList.vala"
	if (collect_values[0].v_pointer) {
#line 4652 "BlackList.c"
		SecurityPrivacyApplicationBlacklist * object;
		object = collect_values[0].v_pointer;
#line 368 "../src/BlackList.vala"
		if (object->parent_instance.g_class == NULL) {
#line 368 "../src/BlackList.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4659 "BlackList.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 368 "../src/BlackList.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4663 "BlackList.c"
		}
#line 368 "../src/BlackList.vala"
		value->data[0].v_pointer = security_privacy_application_blacklist_ref (object);
#line 4667 "BlackList.c"
	} else {
#line 368 "../src/BlackList.vala"
		value->data[0].v_pointer = NULL;
#line 4671 "BlackList.c"
	}
#line 368 "../src/BlackList.vala"
	return NULL;
#line 4675 "BlackList.c"
}

static gchar*
security_privacy_value_application_blacklist_lcopy_value (const GValue* value,
                                                          guint n_collect_values,
                                                          GTypeCValue* collect_values,
                                                          guint collect_flags)
{
	SecurityPrivacyApplicationBlacklist ** object_p;
	object_p = collect_values[0].v_pointer;
#line 368 "../src/BlackList.vala"
	if (!object_p) {
#line 368 "../src/BlackList.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 4690 "BlackList.c"
	}
#line 368 "../src/BlackList.vala"
	if (!value->data[0].v_pointer) {
#line 368 "../src/BlackList.vala"
		*object_p = NULL;
#line 4696 "BlackList.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 368 "../src/BlackList.vala"
		*object_p = value->data[0].v_pointer;
#line 4700 "BlackList.c"
	} else {
#line 368 "../src/BlackList.vala"
		*object_p = security_privacy_application_blacklist_ref (value->data[0].v_pointer);
#line 4704 "BlackList.c"
	}
#line 368 "../src/BlackList.vala"
	return NULL;
#line 4708 "BlackList.c"
}

GParamSpec*
security_privacy_param_spec_application_blacklist (const gchar* name,
                                                   const gchar* nick,
                                                   const gchar* blurb,
                                                   GType object_type,
                                                   GParamFlags flags)
{
	SecurityPrivacyParamSpecApplicationBlacklist* spec;
#line 368 "../src/BlackList.vala"
	g_return_val_if_fail (g_type_is_a (object_type, SECURITY_PRIVACY_TYPE_APPLICATION_BLACKLIST), NULL);
#line 368 "../src/BlackList.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 368 "../src/BlackList.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 368 "../src/BlackList.vala"
	return G_PARAM_SPEC (spec);
#line 4727 "BlackList.c"
}

gpointer
security_privacy_value_get_application_blacklist (const GValue* value)
{
#line 368 "../src/BlackList.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SECURITY_PRIVACY_TYPE_APPLICATION_BLACKLIST), NULL);
#line 368 "../src/BlackList.vala"
	return value->data[0].v_pointer;
#line 4737 "BlackList.c"
}

void
security_privacy_value_set_application_blacklist (GValue* value,
                                                  gpointer v_object)
{
	SecurityPrivacyApplicationBlacklist * old;
#line 368 "../src/BlackList.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SECURITY_PRIVACY_TYPE_APPLICATION_BLACKLIST));
#line 368 "../src/BlackList.vala"
	old = value->data[0].v_pointer;
#line 368 "../src/BlackList.vala"
	if (v_object) {
#line 368 "../src/BlackList.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, SECURITY_PRIVACY_TYPE_APPLICATION_BLACKLIST));
#line 368 "../src/BlackList.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 368 "../src/BlackList.vala"
		value->data[0].v_pointer = v_object;
#line 368 "../src/BlackList.vala"
		security_privacy_application_blacklist_ref (value->data[0].v_pointer);
#line 4759 "BlackList.c"
	} else {
#line 368 "../src/BlackList.vala"
		value->data[0].v_pointer = NULL;
#line 4763 "BlackList.c"
	}
#line 368 "../src/BlackList.vala"
	if (old) {
#line 368 "../src/BlackList.vala"
		security_privacy_application_blacklist_unref (old);
#line 4769 "BlackList.c"
	}
}

void
security_privacy_value_take_application_blacklist (GValue* value,
                                                   gpointer v_object)
{
	SecurityPrivacyApplicationBlacklist * old;
#line 368 "../src/BlackList.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SECURITY_PRIVACY_TYPE_APPLICATION_BLACKLIST));
#line 368 "../src/BlackList.vala"
	old = value->data[0].v_pointer;
#line 368 "../src/BlackList.vala"
	if (v_object) {
#line 368 "../src/BlackList.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, SECURITY_PRIVACY_TYPE_APPLICATION_BLACKLIST));
#line 368 "../src/BlackList.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 368 "../src/BlackList.vala"
		value->data[0].v_pointer = v_object;
#line 4790 "BlackList.c"
	} else {
#line 368 "../src/BlackList.vala"
		value->data[0].v_pointer = NULL;
#line 4794 "BlackList.c"
	}
#line 368 "../src/BlackList.vala"
	if (old) {
#line 368 "../src/BlackList.vala"
		security_privacy_application_blacklist_unref (old);
#line 4800 "BlackList.c"
	}
}

static void
security_privacy_application_blacklist_class_init (SecurityPrivacyApplicationBlacklistClass * klass,
                                                   gpointer klass_data)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 368 "../src/BlackList.vala"
	security_privacy_application_blacklist_parent_class = g_type_class_peek_parent (klass);
#line 368 "../src/BlackList.vala"
	((SecurityPrivacyApplicationBlacklistClass *) klass)->finalize = security_privacy_application_blacklist_finalize;
#line 368 "../src/BlackList.vala"
	g_type_class_adjust_private_offset (klass, &SecurityPrivacyApplicationBlacklist_private_offset);
#line 368 "../src/BlackList.vala"
	security_privacy_application_blacklist_signals[SECURITY_PRIVACY_APPLICATION_BLACKLIST_APPLICATION_ADDED_SIGNAL] = g_signal_new ("application-added", SECURITY_PRIVACY_TYPE_APPLICATION_BLACKLIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_OBJECT, G_TYPE_NONE, 2, G_TYPE_STRING, ZEITGEIST_TYPE_EVENT);
#line 368 "../src/BlackList.vala"
	security_privacy_application_blacklist_signals[SECURITY_PRIVACY_APPLICATION_BLACKLIST_APPLICATION_REMOVED_SIGNAL] = g_signal_new ("application-removed", SECURITY_PRIVACY_TYPE_APPLICATION_BLACKLIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_OBJECT, G_TYPE_NONE, 2, G_TYPE_STRING, ZEITGEIST_TYPE_EVENT);
#line 369 "../src/BlackList.vala"
	_tmp0_ = g_strdup ("app-");
#line 369 "../src/BlackList.vala"
	security_privacy_application_blacklist_interpretation_prefix = _tmp0_;
#line 370 "../src/BlackList.vala"
	_tmp1_ = g_strdup ("launch-");
#line 370 "../src/BlackList.vala"
	security_privacy_application_blacklist_launcher_prefix = _tmp1_;
#line 4828 "BlackList.c"
}

static void
security_privacy_application_blacklist_instance_init (SecurityPrivacyApplicationBlacklist * self,
                                                      gpointer klass)
{
#line 368 "../src/BlackList.vala"
	self->priv = security_privacy_application_blacklist_get_instance_private (self);
#line 368 "../src/BlackList.vala"
	self->ref_count = 1;
#line 4839 "BlackList.c"
}

static void
security_privacy_application_blacklist_finalize (SecurityPrivacyApplicationBlacklist * obj)
{
	SecurityPrivacyApplicationBlacklist * self;
#line 368 "../src/BlackList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SECURITY_PRIVACY_TYPE_APPLICATION_BLACKLIST, SecurityPrivacyApplicationBlacklist);
#line 368 "../src/BlackList.vala"
	g_signal_handlers_destroy (self);
#line 375 "../src/BlackList.vala"
	_security_privacy_blacklist_unref0 (self->priv->blacklist_interface);
#line 376 "../src/BlackList.vala"
	_g_object_unref0 (self->priv->all_blocked_apps);
#line 4854 "BlackList.c"
}

static GType
security_privacy_application_blacklist_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { security_privacy_value_application_blacklist_init, security_privacy_value_application_blacklist_free_value, security_privacy_value_application_blacklist_copy_value, security_privacy_value_application_blacklist_peek_pointer, "p", security_privacy_value_application_blacklist_collect_value, "p", security_privacy_value_application_blacklist_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (SecurityPrivacyApplicationBlacklistClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) security_privacy_application_blacklist_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SecurityPrivacyApplicationBlacklist), 0, (GInstanceInitFunc) security_privacy_application_blacklist_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType security_privacy_application_blacklist_type_id;
	security_privacy_application_blacklist_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SecurityPrivacyApplicationBlacklist", &g_define_type_info, &g_define_type_fundamental_info, 0);
	SecurityPrivacyApplicationBlacklist_private_offset = g_type_add_instance_private (security_privacy_application_blacklist_type_id, sizeof (SecurityPrivacyApplicationBlacklistPrivate));
	return security_privacy_application_blacklist_type_id;
}

GType
security_privacy_application_blacklist_get_type (void)
{
	static volatile gsize security_privacy_application_blacklist_type_id__once = 0;
	if (g_once_init_enter (&security_privacy_application_blacklist_type_id__once)) {
		GType security_privacy_application_blacklist_type_id;
		security_privacy_application_blacklist_type_id = security_privacy_application_blacklist_get_type_once ();
		g_once_init_leave (&security_privacy_application_blacklist_type_id__once, security_privacy_application_blacklist_type_id);
	}
	return security_privacy_application_blacklist_type_id__once;
}

gpointer
security_privacy_application_blacklist_ref (gpointer instance)
{
	SecurityPrivacyApplicationBlacklist * self;
	self = instance;
#line 368 "../src/BlackList.vala"
	g_atomic_int_inc (&self->ref_count);
#line 368 "../src/BlackList.vala"
	return instance;
#line 4890 "BlackList.c"
}

void
security_privacy_application_blacklist_unref (gpointer instance)
{
	SecurityPrivacyApplicationBlacklist * self;
	self = instance;
#line 368 "../src/BlackList.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 368 "../src/BlackList.vala"
		SECURITY_PRIVACY_APPLICATION_BLACKLIST_GET_CLASS (self)->finalize (self);
#line 368 "../src/BlackList.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 4904 "BlackList.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

